/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { Point_$type, enumGetBox, typeCast, runOn, delegateCombine, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
export let AnchoredCategorySeries = /*@__PURE__*/ (() => {
    class AnchoredCategorySeries extends CategorySeries {
        get aav() {
            if (this.aau == null) {
                this.aau = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.dq.n);
            }
            return this.aau;
        }
        getHostReferenceValue() {
            return this.ix();
        }
        md() {
            return AnchoredCategorySeries.$$p[5];
        }
        cr() {
            let a = new AnchoredCategorySeriesView(this);
            return a;
        }
        qz(a) {
            super.qz(a);
            this.aaq = a;
        }
        constructor() {
            super();
            this.aau = null;
            this.aa1 = false;
            this.aaw = null;
            this.aar = null;
            this.aa8 = null;
            this.aa7 = null;
            this.aay = true;
            this.aa2 = 0;
            this.aa3 = 0;
            this.yu = new CategoryFramePreparer(1, this, this.yy, this, this, this.yy.cw);
        }
        kp(a, b) {
            let c = this.nc(b);
            if (c == AnchoredCategorySeries.$$p[5]) {
                return this.kq(a, b, this.abi);
            }
            if (c == AnchoredCategorySeries.$$p[1]) {
                return this.kq(a, b, this.aba);
            }
            return super.kp(a, b);
        }
        mc(a) {
            let b = this.nc(a);
            if (b == AnchoredCategorySeries.$$p[5]) {
                return this.abi;
            }
            if (b == AnchoredCategorySeries.$$p[1]) {
                return this.aba;
            }
            return super.mc(a);
        }
        get valueColumn() {
            return this.aaw;
        }
        set valueColumn(a) {
            if (this.aaw != a) {
                let b = this.aaw;
                this.aaw = a;
                if (!this.aa1) {
                    this.raisePropertyChanged("ValueColumn", b, this.aaw);
                }
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = new DataLegendSeriesValueInfo();
            c.a = 0;
            c.l = this.i4({ $type: Point_$type, x: a, y: b }, false, false);
            c.r = this.abi != null ? this.abi : "Value";
            c.q = "Value";
            c.s = this.abe != null ? this.abe : "V:";
            c.t = this.abg != null ? this.abg : "";
            let d = new DataLegendSeriesContext();
            d.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(c);
                return $ret;
            })());
            d.h = this.mb();
            return d;
        }
        get ab5() {
            return this.c(AnchoredCategorySeries.abr);
        }
        set ab5(a) {
            this.h(AnchoredCategorySeries.abr, a);
        }
        gc(a) {
            let b = new Rect(0, 0, 0, 1, 1);
            let c = this.fetchXAxis();
            let d = this.fetchYAxis();
            let e = this.wh(this.cu);
            let f = c != null ? this.yu.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
            return this.aav.c$a(this, this.valueColumn, c, d, f, a);
        }
        aan(a, b, c) {
            if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cn;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.dm.item(g);
            }
            return d;
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            if (this.aaq.c8 && this.aaq.c7.g$b(a, b, c, d)) {
                let e = false;
                if (b == "FastItemsSource") {
                    e = this.gf && c != null;
                }
                this.rp(e);
                this.qj();
            }
            switch (b) {
                case AnchoredCategorySeries.$$p[3]:
                case AnchoredCategorySeries.$$p[4]:
                    this.qd();
                    break;
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.valueColumn);
                        this.valueColumn = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.valueColumn = this.dj(this.abi);
                    }
                    let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (f != null && !f.c1()) {
                        this.aaq.cw.g(this.ic);
                        this.rp(this.gf && c != null);
                    }
                    break;
                case AnchoredCategorySeries.$$p[5]:
                    if (this.dm != null) {
                        this.dm.deregisterColumn(this.valueColumn);
                        this.valueColumn = this.dj(this.abi);
                    }
                    this.aa8 = this.abi;
                    break;
                case AnchoredCategorySeries.$$p[1]:
                    this.aa7 = this.aba;
                    this.rp(true);
                    break;
                case "ValueColumn":
                    if (this.aaq.c8) {
                        this.aaq.c7.g$i();
                    }
                    let g = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (g != null && !g.c1()) {
                        this.aaq.cw.g(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    this.abq();
                    this.sj();
                    break;
                case "TrendLineBrush":
                    this.rd(b);
                    break;
                case "ErrorBarSettings":
                    this.rp(false);
                    break;
                case "TrendLineType":
                    this.qj();
                    break;
                case AnchoredCategorySeries.$$p[2]:
                    this.rp(false);
                    break;
            }
        }
        ay(a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        }
        pa(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.aaq.cw.g(this.ic);
                    break;
            }
            if (this.aaq.c8) {
                this.aaq.c7.g$e(a, b, c, d);
            }
            this.abq();
            this.sj();
            if (a == 0 || a == 2 || a == 3 || a == 4) {
                this.aay = true;
            }
            else if (a == 1) {
                for (let e = b; e < b + c; e++) {
                    this.aa2 += this.valueColumn.item(e);
                }
                this.aa3 = this.aa2 / this.valueColumn.count;
            }
        }
        zp() {
            return this.aa4(this.yy);
        }
        aa4(a) {
            let b = 0;
            let c = a.by;
            let d = a.bx;
            let e = this.getEffectiveViewport1(a);
            let f = typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!c.isEmpty && !d.isEmpty && f != null) {
                let g = new ScalerParams(0, c, d, f.ch, e);
                if (f.cp) {
                    g.b = this.ix();
                }
                b = f.ek(f.mc, g);
            }
            return b;
        }
        abo(a, b, c) {
            let d = this.aa4(c);
            if (a.count > 0) {
                let e = d;
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
            }
        }
        aao(a, b, c, d) {
            return this.aap(a, b, c, d, false);
        }
        aap(a, b, c, d, e) {
            return CategorySeries.yi(a, b, c, d, e);
        }
        ga() {
            return this.highlightedItemsSource != null || this.aba != null;
        }
        hs() {
            let a = super.hs();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "ValueMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedValueMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.abk));
                a.add(b);
            }
            return a;
        }
        abk(a, b) {
            if (this.aba != null) {
                b.value = this.aba;
                return;
            }
            b.value = this.abi;
        }
        hd(a, b, c) {
            let d = super.hd(a, b, c);
            let e = c;
            if (this.valueColumn == null || this.valueColumn.count == 0 || e.cw.d < 1) {
                d = false;
            }
            return d;
        }
        o4(a, b) {
            super.o4(a, b);
            let c = b;
            c.c2();
            if (c.c8) {
                c.c7.g$d();
            }
        }
        aac(a, b) {
            super.aac(a, b);
            this.yv(b).d(a, b);
        }
        aaf(a, b) {
            super.aaf(a, b);
            let c = typeCast(AnchoredCategorySeriesView.$, b);
            c.b7 = true;
            if (c.c8) {
                c.c7.g$g(a.q);
            }
            if (this.xb()) {
                CategoryMarkerManager.e(this, a.n, b.cz, this.xd);
                this.z4(b, a);
                b.cr();
            }
            this.abl(a, b);
        }
        ro(a, b, c, d, e) {
            super.ro(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            let g = f;
            g.cw.g(this.ic);
            f.a3(c);
            if (this.d4(g)) {
                return;
            }
            if (this.aar == null) {
                this.aar = new CategoryFrame(3);
            }
            this.aar.v();
            this.aac(this.aar, g);
            this.aaf(this.aar, g);
        }
        abl(a, b) {
        }
        sd() {
            super.sd();
            if (this.index < 0) {
                return;
            }
            this.aaq.dc();
            if (this.trendLineBrush != null) {
                this.aaq.da();
            }
            else {
                this.aaq.c9();
            }
        }
        kw(a, b) {
            if (this.aaq.c8 && a == this.aaq.c7.g$j) {
                return null;
            }
            return super.kw(a, b);
        }
        get currentCategoryMode() {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.yn()));
        }
        get scaler() {
            return typeCast(ICategoryScaler_$type, this.yn());
        }
        get yScaler() {
            return typeCast(IScaler_$type, this.y4());
        }
        get bucketizer() {
            return this.aaq.cw;
        }
        get currentMode2Index() {
            return this.zt();
        }
        provideCollisionDetector() {
            if (this.aas == 1) {
                return new CollisionAvoider();
            }
            return NonCollisionAvoider.b;
        }
        get trendlinePreparer() {
            return this.aaq.c8 ? this.aaq.c7 : null;
        }
        pw(a) {
            super.pw(a);
            if (this.aaq.c8) {
                this.bc.exportTrendlineData(this, a, this.aaq.c7.g$j);
            }
        }
        km(a) {
            let b = this.fetchXAxis();
            let c = this.fetchYAxis();
            return this.aav.c$b(this, a, this.zq(this.cu), this.valueColumn, b, c, this.aat == 1, (d) => super.km(d));
        }
        get mayContainUnknowns() {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        }
        ix() {
            return Series.iy(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
        }
        get_aa6() {
            return 0;
        }
        get aa6() {
            return this.get_aa6();
        }
        az(a) {
            if (a.isEmpty && this.da != null) {
                a = this.da.vx;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.wf(this.cu);
            let c = this.yn();
            let d = new ScalerParams(0, a, this.da.wc, c.ch, this.getEffectiveViewport());
            let e = (c.en(b.left, d));
            let f = (c.en(b.right, d));
            if (c.ch) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.aa6;
            f += this.aa6;
            let h = null;
            if (c.cn) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.ax(n, this.y4(), a);
            return n;
        }
        abq() {
            this.il = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
        }
        abp() {
            if (this.aay) {
                this.aa2 = 0;
                for (let a = 0; a < this.valueColumn.count; a++) {
                    this.aa2 += this.valueColumn.item(a);
                }
                this.aa3 = this.aa2 / this.valueColumn.count;
                this.aay = false;
            }
        }
        i7(a, b) {
            if (b == null || !b.cj) {
                return NaN;
            }
            let c = this.y4();
            if (b != c) {
                return NaN;
            }
            let d = this.aq(a);
            if (c.cp) {
                return d[1];
            }
            else {
                return d[0];
            }
        }
        aq(a) {
            let b = NaN;
            switch (a) {
                case 5:
                case 2:
                    b = this.valueColumn.maximum;
                    break;
                case 4:
                case 1:
                    b = this.valueColumn.minimum;
                    break;
                case 6:
                case 3:
                    if (this.aay) {
                        this.abp();
                    }
                    b = this.aa3;
                    break;
            }
            let c = this.y4();
            if (c.cp) {
                return [NaN, b];
            }
            else {
                return [b, NaN];
            }
        }
        wb(a) {
            let b = NaN;
            switch (a) {
                case 5:
                case 2:
                    b = this.valueColumn.maximum;
                    break;
                case 4:
                case 1:
                    b = this.valueColumn.minimum;
                    break;
                case 6:
                case 3:
                    if (this.aay) {
                        this.abp();
                    }
                    b = this.aa3;
                    break;
            }
            if (isNaN_(b)) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let c = this.y4();
            let d = this.getEffectiveViewport1(this.cu);
            let e = new ScalerParams(0, this.cu.by, this.cu.bx, c.ch, d);
            if (c.cp) {
                e.b = this.ix();
            }
            e.c = d;
            if (c.cp) {
                return { $type: Point_$type, x: NaN, y: c.ek(b, e) };
            }
            else {
                return { $type: Point_$type, x: c.ek(b, e), y: NaN };
            }
        }
        wc(a) {
            let b = this.y4();
            let c = this.getEffectiveViewport1(this.cu);
            let d = new ScalerParams(0, this.cu.by, this.cu.bx, b.ch, c);
            if (b.cp) {
                d.b = this.ix();
            }
            d.c = c;
            if (b.cp) {
                return { $type: Point_$type, x: NaN, y: b.ek(a[1], d) };
            }
            else {
                return { $type: Point_$type, x: b.ek(a[0], d), y: NaN };
            }
        }
        z8(a, b, c, d, e, f, g) {
            if (c < 0 || d < 0) {
                return;
            }
            for (let h = c; h <= d; h++) {
                if (a == 1) {
                    if (this.aaz(e, f, h)) {
                        if (g == 7 || g == 6) {
                            b.add(((() => {
                                let $ret = new ChartSelection();
                                $ret.series = this;
                                return $ret;
                            })()));
                            return;
                        }
                        this.z2(b, h, g);
                    }
                }
                else {
                    if (this.aa0(e, f, h)) {
                        if (g == 7 || g == 6) {
                            b.add(((() => {
                                let $ret = new ChartSelection();
                                $ret.series = this;
                                return $ret;
                            })()));
                            return;
                        }
                        this.z2(b, h, g);
                    }
                }
            }
        }
        aa0(a, b, c) {
            return this.valueColumn.item(c) < b && a < this.valueColumn.item(c);
        }
        aaz(a, b, c) {
            return 0 < b && a < this.valueColumn.item(c);
        }
        z2(a, b, c) {
            if (c == 2 || c == 1) {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.item = this.dm.item(b);
                    return $ret;
                })()));
            }
            else {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.item = this.dm.item(b);
                    $ret.series = this;
                    return $ret;
                })()));
            }
        }
        get useHighMarkerFidelity() {
            return this.zl;
        }
    }
    AnchoredCategorySeries.$t = /*@__PURE__*/ markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.abr = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:aat:abs', [ConsolidatedItemHitTestBehavior_$type, /*@__PURE__*/ enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'HighlightedValueMemberPath:aba:abt', [2, null], 'MarkerCollisionAvoidance:aas:abu', [CategorySeriesMarkerCollisionAvoidance_$type, /*@__PURE__*/ enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberAsLegendLabel:abe:ab2', [2, null], 'ValueMemberAsLegendUnit:abg:ab3', [2, null], 'ValueMemberPath:abi:ab4', [2, null], 'TrendLineType::ab0', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::abz', [1, 1.5], 'TrendLinePeriod::aby', [1, 7], 'TrendLineBrush::abv', [Brush.$, null], 'TrendLineZIndex:aa5:ab1', [1, 1001], 'TrendLineDashArray:ab6:abw', [DoubleCollection.$], 'TrendLineDashCap:ab7:abx', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
})();
/**
 * @hidden
 */
export let AnchoredCategoryBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.i = null;
            this.h = null;
            this.j = 0;
            this.i = a;
        }
        getBucketWithoutUnknowns(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 1.7976931348623157E+308;
            let h = -1.7976931348623157E+308;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        getBucket(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                if (!i) {
                    if (!isNaN_(k)) {
                        g = g < k ? g : k;
                        h = h > k ? h : k;
                    }
                }
                else {
                    if (!isNaN_(k)) {
                        g = k;
                        h = k;
                        i = false;
                    }
                }
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        cacheValues() {
            this.j = this.i.c5.valueColumn.count;
            this.h = this.i.c5.valueColumn.asArray();
        }
        unCacheValues() {
            this.h = null;
        }
    }
    AnchoredCategoryBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredCategorySeriesView = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesView extends CategorySeriesView {
        constructor(a) {
            super(a);
            this.c5 = null;
            this.c6 = null;
            this.c5 = a;
        }
        get c7() {
            if (this.c6 == null) {
                this.c6 = CategoryTrendLineManagerFactory.a(this.c6, this.e.a0(), this.e.sr, this.e, this.e.dq);
            }
            return this.c6;
        }
        set c7(a) {
            this.c6 = a;
        }
        get c8() {
            return this.c6 != null;
        }
        dc() {
            this.c5.ab5 = null;
        }
        da() {
            this.c5.ab5 = this.c5.trendLineBrush;
        }
        c9() {
            this.c5.ab5 = this.c5.u5;
        }
        cx() {
            return new AnchoredCategoryBucketCalculator(this);
        }
        db() {
            this.cw.cacheValues();
        }
        dd() {
            this.cw.unCacheValues();
        }
        de(a) {
            let b = this.cz.item(a);
            return this.cu(b);
        }
        a7(a, b) {
            if (a.d) {
                if (this.c5.trendLineType != 0 && !b) {
                    let c = this.c7.g$j;
                    c.ad = this.c5.trendLineThickness;
                    c._stroke = this.c5.ab5;
                    c.ai = this.c5.ab6;
                    c.aj = this.c5.ab7;
                    a.v(c);
                }
            }
            super.a7(a, b);
        }
        getDefaultTooltipTemplate() {
            return this.c5.aav.c$c(this.e, this.c5.abi);
        }
    }
    AnchoredCategorySeriesView.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
})();
