/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, typeCast, Point_$type, runOn, delegateCombine, enumGetBox, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { FastItemCoalescingColumn } from "./FastItemCoalescingColumn";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { RadialBaseView } from "./RadialBaseView";
import { ChartSelection } from "./ChartSelection";
import { CollisionRect } from "igniteui-react-core";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let AnchoredRadialBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = this.f.c1.ab3;
            let c = Math.min(a * this.b, b.count - 1);
            let d = Math.min(c + this.b - 1, b.count - 1);
            let e = NaN;
            let f = NaN;
            for (let g = c; g <= d; ++g) {
                let h = b.item(g);
                if (!isNaN_(e)) {
                    if (!isNaN_(h)) {
                        e = Math.min(e, h);
                        f = Math.max(f, h);
                    }
                }
                else {
                    e = h;
                    f = h;
                }
            }
            if (!isNaN_(e)) {
                return [0.5 * (c + d), e, f, 0];
            }
            return [0.5 * (c + d), NaN, NaN, 0];
        }
    }
    AnchoredRadialBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeries = /*@__PURE__*/ (() => {
    class AnchoredRadialSeries extends RadialBase {
        cr() {
            return new AnchoredRadialSeriesView(this);
        }
        o1() {
            super.o1();
            this.yu = null;
            this.y0 = null;
        }
        md() {
            return AnchoredRadialSeries.$$p[4];
        }
        kp(a, b) {
            let c = this.nc(b);
            if (c == AnchoredRadialSeries.$$p[4]) {
                return this.kq(a, b, this.acs);
            }
            if (c == AnchoredRadialSeries.$$p[0]) {
                return this.kq(a, b, this.ack);
            }
            return super.kp(a, b);
        }
        mc(a) {
            let b = this.nc(a);
            if (b == AnchoredRadialSeries.$$p[4]) {
                return this.acs;
            }
            if (b == AnchoredRadialSeries.$$p[0]) {
                return this.ack;
            }
            return super.mc(a);
        }
        jb(a) {
            if (a == this.y2) {
                return this.z4(this.ab3.count - 1, this.ab3.item(this.ab3.count - 1));
            }
            return super.jb(a);
        }
        ks(a) {
            if (this.yu != null && this.yu.cl) {
                if (a == this.yu.othersIndex) {
                    return this.y2;
                }
            }
            return super.ks(a);
        }
        qz(a) {
            super.qz(a);
            this.abx = a;
        }
        constructor() {
            super();
            this.aby = null;
            this.ab8 = false;
            this.ab2 = null;
            this.adj = { $type: Point_$type, x: 0, y: 0 };
            this.ab0 = null;
            this.abz = null;
            this.ab4 = false;
            this.ab0 = new RadialFrame(3);
            this.aby = new CategoryLineRasterizer();
        }
        j9(a, b) {
            return this.ka(a, b, this.yu, null, this.ab3);
        }
        j7(a, b) {
            return this.j8(a, b, this.yu, null, this.ab3);
        }
        io(a, b, c, d, e) {
            if (this.ab3 == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.ip(a, b, this.yu, d, e, this.ab3.count, null);
        }
        i4(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ace(this.yu, this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.yu.ch, d);
            f.c = this.da.wc;
            let g = this.ab3;
            if (this.ab8 && typeCast(FastItemCoalescingColumn.$, g) !== null) {
                g = new FastItemCoalescingColumn(this.yu, g.c, false);
            }
            return this.i6(g, a, this.yu, f, e, null, b, c);
        }
        v8(a, b, c) {
            if (this.y0 == null || this.yu == null || this.cu == null || this.cu.by.isEmpty || this.cu.bx.isEmpty) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.getEffectiveViewport1(this.cu);
            let e = new ScalerParams(0, this.cu.by, this.cu.bx, this.y0.ch, d);
            e.c = this.getEffectiveViewport1(this.cu);
            let f = this.i4(a, b, c);
            f = this.y0.ek(f, e);
            let g = this.y3.c(a, this.cu.by, this.cu.bx, d);
            if (!b && this.yu != null) {
                let h = this.j9(a, c);
                let i = this.j7(a, c);
                let j = this.ace(this.yu, this.cu.by, this.cu.bx, d);
                let k = new ScalerParams(0, this.cu.by, this.cu.bx, this.yu.ch, d);
                k.c = this.da.wc;
                let l = this.io(a, h, this.yu, k, j);
                let m = this.io(a, i, this.yu, k, j);
                if (this.yu.cl) {
                    if (m <= l) {
                        j = this.acd(i, this.yu, this.cu.by, this.cu.bx, d);
                        if (isNaN_(j)) {
                            j = 0;
                        }
                        g = this.yu.ek(i, k) + j;
                    }
                    else {
                        j = this.acd(h, this.yu, this.cu.by, this.cu.bx, d);
                        if (isNaN_(j)) {
                            j = 0;
                        }
                        g = this.yu.ek(h, k) + j;
                    }
                }
                else {
                    if (m <= l) {
                        g = this.yu.ek(i, k) + j;
                    }
                    else {
                        g = this.yu.ek(h, k) + j;
                    }
                }
            }
            let n = this.y3.d(g, f, this.cu.by, this.cu.bx, this.cu.getEffectiveViewport());
            let o = this.y3.e(g, f, this.cu.by, this.cu.bx, this.cu.getEffectiveViewport());
            return { $type: Point_$type, x: n, y: o };
        }
        ga() {
            return this.highlightedItemsSource != null || this.ack != null;
        }
        hs() {
            let a = super.hs();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "ValueMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedValueMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.acy));
                a.add(b);
            }
            return a;
        }
        acy(a, b) {
            if (this.ack != null) {
                b.value = this.ack;
                return;
            }
            b.value = this.acs;
        }
        get ab3() {
            return this.ab2;
        }
        set ab3(a) {
            if (this.ab2 != a) {
                let b = this.ab2;
                this.ab2 = a;
                this.raisePropertyChanged("ValueColumn", b, this.ab2);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = new DataLegendSeriesValueInfo();
            c.a = 0;
            this.ab8 = true;
            c.l = this.i4({ $type: Point_$type, x: a, y: b }, false, false);
            this.ab8 = false;
            c.q = "Value";
            c.r = this.acs != null ? this.acs : "Value";
            c.s = this.aco != null ? this.aco : "V:";
            c.t = this.acq != null ? this.acq : "";
            let d = new DataLegendSeriesContext();
            d.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(c);
                return $ret;
            })());
            d.h = this.mb();
            return d;
        }
        get adf() {
            return this.c(AnchoredRadialSeries.ac2);
        }
        set adf(a) {
            this.h(AnchoredRadialSeries.ac2, a);
        }
        ay(a) {
            if (a != null && a == this.yu && this.ab3 != null && this.ab3.count > 0) {
                return new AxisRange(0, this.ab3.count - 1);
            }
            if (a != null && a == this.y0 && this.ab3 != null && this.ab3.count > 0) {
                return new AxisRange(this.ab3.minimum, this.ab3.maximum);
            }
            return null;
        }
        z4(a, b) {
            if (this.acc) {
                let c = this.ab3.c;
                if (a < 0) {
                    return super.z4(a, b);
                }
                if (a > c.count - 1) {
                    if (typeCast(ProportionalCategoryAngleAxis.$, this.yu) !== null) {
                        let d = this.ab3;
                        return d.f;
                    }
                    return super.z4(a, b);
                }
                return c.item(a);
            }
            else {
                return super.z4(a, b);
            }
        }
        dj(a) {
            let b = super.dj(a);
            this.ab4 = false;
            if (this.yu != null && this.yu.cl) {
                this.ab4 = true;
                b = new FastItemCoalescingColumn(this.yu, b, this.acc);
            }
            return b;
        }
        acw(a, b) {
            if (this.ab4) {
                let c = b;
                let d = c.c;
                a.deregisterColumn(d);
            }
            else {
                a.deregisterColumn(b);
            }
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            if (this.abx.c2.g$b(a, b, c, d)) {
                this.rp(false);
                this.qj();
            }
            let e = typeCast(NumericAxisBase.$, this.y0);
            switch (b) {
                case AnchoredRadialSeries.$$p[2]:
                case AnchoredRadialSeries.$$p[3]:
                    this.qd();
                    break;
                case AnchoredRadialSeries.$$p[1]:
                case RadialBase.$$p[0]:
                    if (this.ab3 != null) {
                        this.acw(this.dm, this.ab3);
                        this.ab3 = this.dj(this.acs);
                    }
                    break;
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) !== null) {
                        this.acw(c, this.ab3);
                        this.ab3 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) !== null) {
                        this.ab3 = this.dj(this.acs);
                        this.abx.cx.e(this.ic);
                    }
                    if (e != null && !e.c1()) {
                        this.abx.cx.e(this.ic);
                        this.rp(this.gf && c != null);
                    }
                    break;
                case AnchoredRadialSeries.$$p[4]:
                    if (this.dm != null) {
                        this.acw(this.dm, this.ab3);
                        this.ab3 = this.dj(this.acs);
                    }
                    break;
                case "ValueColumn":
                    if (e != null && !e.c1()) {
                        this.abx.cx.e(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    break;
                case "TrendLineBrush":
                    this.rd(b);
                    break;
                case "TrendLineType":
                    this.qj();
                    break;
            }
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.abx.cx.e(this.ic);
                    break;
            }
            this.abx.c2.g$e(a, b, c, d);
            switch (a) {
                case 4:
                    if (this.y0 != null && !this.y0.c1()) {
                        this.rp(true);
                    }
                    break;
                case 1:
                    if (this.y0 != null && !this.y0.c1()) {
                        this.rp(true);
                    }
                    break;
                case 0:
                    if (this.y0 != null && !this.y0.c1()) {
                        this.rp(true);
                    }
                    break;
                case 2:
                    if (this.acs != null && this.abx.cx.b > 0 && this.y0 != null && !this.y0.c1()) {
                        this.rp(true);
                    }
                    break;
                case 3:
                    if (d == this.acs) {
                        if (this.y0 != null && !this.y0.c1()) {
                            this.rp(true);
                        }
                    }
                    break;
            }
        }
        hd(a, b, c) {
            let d = super.hd(a, b, c);
            let e = c;
            if (this.dm == null || this.dm.count == 0 || this.yu == null || this.ab3 == null || this.yu.lh == 0 || this.y0 == null || isInfinity(this.y0.l2) || isInfinity(this.y0.l1) || e.cx.b < 1) {
                d = false;
            }
            return d;
        }
        getOffsetValue() {
            return this.ace(this.yu, this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
        }
        getCategoryWidth() {
            return this.yu.getCategorySize(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
        }
        get_ab9() {
            return false;
        }
        get ab9() {
            return this.get_ab9();
        }
        get_ej() {
            return true;
        }
        get_f4() {
            return this.y0 != null && this.y0.ch;
        }
        ace(a, b, c, d) {
            let e = 0;
            let f = this.preferredCategoryMode(a);
            if (f == 0 && a.categoryMode != 0) {
                f = 1;
            }
            switch (f) {
                case 0:
                    e = 0;
                    break;
                case 1:
                    e = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    e = a.getGroupCenter(this.z3(), b, c, d);
                    break;
            }
            if (a.ch) {
                e = -e;
            }
            return e;
        }
        acd(a, b, c, d, e) {
            let f = 0;
            let g = this.preferredCategoryMode(b);
            if (g == 0 && b.categoryMode != 0) {
                g = 1;
            }
            switch (g) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * b.m5(a, c, d, e);
                    break;
                case 2:
                    f = b.m4(a, this.z3(), c, d, e);
                    break;
            }
            if (b.ch) {
                f = -f;
            }
            return f;
        }
        acx(a, b, c, d) {
            if (d == 0) {
                this.p1(a, b, c);
                return;
            }
            let e = this.cu.by;
            let f = this.cu.bx;
            let g = this.getEffectiveViewport1(this.cu);
            let h = this.wf(this.cu);
            let i = this.y0.k3(f, e, g, h);
            let j = this.yu != null && this.yu.cl;
            let k = new CollisionRect(0, a);
            for (let l = 0; l < this.dm.count; l++) {
                let m = typeCast(RadialBaseView.$, this.cu);
                let n = m.cx.getBucket(l);
                let o = this.ace(this.yu, e, f, g);
                if (j) {
                    o = this.acd(l, this.yu, e, f, g);
                    if (isNaN_(o)) {
                        o = 0;
                    }
                }
                n[0] = this.yu.getScaledAngle(n[0]) + o;
                let p = Math.min(this.y3.b.oc(n[2]), i.maxLength);
                let q = this.y3.d(n[0], p, e, f, g);
                let r = this.y3.e(n[0], p, e, f, g);
                if (k.containsLocation(q, r)) {
                    if (c == 7 || c == 6) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.series = this;
                            return $ret;
                        })()));
                        return;
                    }
                    else if (c == 2 || c == 1) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.item = this.dm.item(l);
                            return $ret;
                        })()));
                    }
                    else {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.item = this.dm.item(l);
                            $ret.series = this;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        get_acb() {
            return false;
        }
        get acb() {
            return this.get_acb();
        }
        get_ab5() {
            return false;
        }
        get ab5() {
            return this.get_ab5();
        }
        aa4(a, b) {
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.yu;
            let g = this.y0;
            let h = g.l2;
            let i = g.l1;
            a.f.clear();
            a.n.clear();
            a.q.clear();
            let j = this.xb();
            let k = 0;
            let l = b;
            let m = f.cl;
            let n = new CollisionAvoider();
            let o = 0;
            let p = 0;
            let q = b.cx.d;
            o = this.ace(f, c, d, e);
            l.c2.i = this.y0.n6;
            l.c2.h = this.y0.n5;
            l.c2.j = (r, s) => this.acf(r, s, c, d, e);
            l.c2.k = (r, s) => this.acg(r, s, c, d, e);
            let r = ((() => {
                let $ret = new Clipper(0, d, false);
                $ret.i = a.q;
                return $ret;
            })());
            let s = ((() => {
                let $ret = new TrendResolutionParams();
                $ret.e = b.cx.b;
                $ret.f = b.cx.c;
                $ret.g = q;
                $ret.a = o;
                $ret.d = this.ic;
                $ret.i = d;
                $ret.h = e;
                $ret.j = c;
                return $ret;
            })());
            l.c2.l(a.q, this.ab1, this.ab3, this.aci, (t) => this.yu.getScaledAngle(t), (t) => this.y0.oc(t), s, r);
            let t = true;
            if (this.aca(b)) {
                q--;
            }
            for (let u = b.cx.c; u <= q; ++u) {
                let v = u;
                if (v * b.cx.b >= this.yu.lh) {
                    v -= intDivide((this.yu.lh), b.cx.b);
                }
                let w = b.cx.getBucket(v);
                p = 0;
                if (m) {
                    p = this.zv(v, c, d, e);
                }
                w[3] = p;
                if (!isNaN_(w[0])) {
                    let x = false;
                    if (m) {
                        o = this.acd(v, f, c, d, e);
                        if (isNaN_(o)) {
                            o = 0;
                            x = true;
                        }
                    }
                    w[0] = f.getScaledAngle(w[0]) + o;
                    if (w[1] < h || w[1] > i) {
                        if (this.acb) {
                            if (w[1] > i && this.ab5) {
                            }
                            else {
                                x = true;
                            }
                        }
                        else {
                            if (w[1] > i && this.ab5) {
                            }
                            else {
                                continue;
                            }
                        }
                    }
                    if (x) {
                        w[1] = NaN;
                        w[2] = NaN;
                    }
                    w[1] = g.oc(w[1]);
                    if (b.cx.b > 1) {
                        if (w[2] < h || w[2] > i) {
                            continue;
                        }
                        w[2] = g.oc(w[2]);
                    }
                    else {
                        w[2] = w[1];
                    }
                    if ((isNaN_(w[1]) || isNaN_(w[2])) && t && this.ab9 && this.ab7()) {
                        q++;
                    }
                    else {
                        t = false;
                    }
                    a.f.add(w);
                    if (j) {
                        let y = Math.min(v * b.cx.b, this.dm.count - 1);
                        let z = false;
                        if (this.yu.cl) {
                            let aa = this.yu;
                            let ab = aa.hasOthersCategory && (v * b.cx.b) == this.yu.lh - 1;
                            z = ab;
                        }
                        let ac = this.y3.d(w[0], w[1], c, d, e);
                        let ad = this.y3.e(w[0], w[1], c, d, e);
                        let ae = new Rect(0, ac - 5, ad - 5, 11, 11);
                        if (!isNaN_(ac) && !isNaN_(ad) && !isInfinity(ac) && !isInfinity(ad) && n.tryAdd(ae)) {
                            a.n.add({ $type: Point_$type, x: w[0], y: w[1] });
                            let af = b.cy.item(k);
                            af.al = v;
                            af.ak = y;
                            af.content.item = this.dm.item(y);
                            if (z) {
                                af.ak = this.dm.count;
                                let ag = this.yu;
                                af.content.item = this.y2;
                            }
                            ++k;
                        }
                    }
                }
                else {
                    if (t && this.ab9 && this.ab7()) {
                        q++;
                    }
                }
            }
            b.cy.count = k;
            return;
        }
        acf(a, b, c, d, e) {
            return this.y3.d(a, b, c, d, e);
        }
        acg(a, b, c, d, e) {
            return this.y3.e(a, b, c, d, e);
        }
        aca(a) {
            let b = a;
            return !this.ab9 && b.cx.c == 0 && b.cx.d == this.yu.lh;
        }
        abw(a, b, c) {
            let d = null;
            let e = c.by;
            let f = c.bx;
            if (b > -1 && !e.isEmpty && !f.isEmpty) {
                let g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
                let h = f.bottom + 10;
                let i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
                let j = f.top - 10;
                d = new Clipper(1, g, h, i, j, false);
            }
            return d;
        }
        ac1(a, b, c, d, e) {
            if (a.count > 0 && d.count > 0) {
                if (!e || this.ab6()) {
                    a.add(this.adj);
                    a.add(a._inner[0]);
                    d.add(this.adj);
                    d.add(d._inner[0]);
                }
            }
        }
        ab7() {
            return !this.ab6();
        }
        ab6() {
            let a = this.cu.by;
            return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
        }
        o4(a, b) {
            super.o4(a, b);
            let c = b;
            if (a) {
                c.cy.clear();
            }
            c.c2.g$d();
        }
        aa7(a, b) {
            this.qv();
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.wf(b);
            let g = b;
            g.c2.g$g(a.q);
            let h = new List$1(Point_$type, 0);
            for (let i = 0; i < a.n.count; i++) {
                let j = a.n._inner[i];
                let k = this.y3.d(j.x, j.y, c, d, e);
                let l = this.y3.e(j.x, j.y, c, d, e);
                let m = { $type: Point_$type, x: k, y: l };
                h.add(m);
            }
            CategoryMarkerManager.e(this, h, g.cy, this.xd);
            this.acv(b, a);
            g.cr();
            this.acu(d, c, e, f, g);
        }
        abv(a, b, c) {
            if (b < a || a < 0 || a > this.ab3.count || b < 0 || b > this.ab3.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cn;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.dm.item(g);
            }
            return d;
        }
        acz(a, b, c, d, e, f) {
            let g = this.bw != 1;
            let h = this.co != 1;
            let i = this.cn != 1;
            let j = this.d1;
            this.zb.a3(this.zb.d, d.cn, a, b, c, d, e, f, true);
            this.zb.aa(this.ia);
            let k = this.zb.ax;
            let l = null;
            let m = null;
            let n = null;
            let o = this.dm;
            let p = null;
            let q = null;
            let r = null;
            if (j && this.da != null && !k.e) {
                let s = this.vk(k.z);
                let t = this.vl(k.z);
                this.zb.ag = s;
                this.zb.ah = t;
                k.aa = s;
                k.ab = t;
            }
            if (g && this.da != null) {
                l = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, true);
                if (this.da.dk.isCrossContextHighlight(this)) {
                    p = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, true);
                }
                k.c = l;
            }
            if (h && this.da != null) {
                m = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, true);
                if (m == null && this.bm != null) {
                    m = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, k.z, k.y, true);
                }
                if (this.da.dl.isCrossContextHighlight(this)) {
                    q = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, true);
                }
                k.d = m;
            }
            if (i && this.da != null) {
                n = this.da.dj.getHighlightingInfo(this, o, k.z, k.y, true);
                if (this.da.dj.isCrossContextHighlight(this)) {
                    r = this.da.dj.getHighlightingInfo(this, o, k.z, k.y, true);
                }
                k.b = n;
            }
            k.h = f;
            this.aa5(k);
            this.zb.y(this, l, m, n, f, g, h, i, k.v, this.da.dk.totalHighWaterMark, k.x, this.da.dl.totalHighWaterMark, k.t, this.da.dj.totalHighWaterMark);
        }
        ac0(a, b, c, d, e, f) {
            let g = this.bw != 1;
            let h = this.co != 1;
            let i = this.co != 1;
            let j = this.d1;
            this.zb.a3(this.zb.b, d.cn, a, b, c, d, e, f, false);
            this.zb.ab(this.ia);
            let k = this.zb.ay;
            let l = null;
            let m = null;
            let n = null;
            let o = this.dm;
            if (j && this.da != null && !k.e) {
                let p = this.vj(k.z);
                let q = this.vm(k.z);
                this.zb.ag = p;
                this.zb.ah = q;
                k.aa = p;
                k.ab = q;
            }
            if (g && this.da != null) {
                l = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, false);
                k.c = l;
            }
            if (h && this.da != null) {
                m = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, false);
                if (m == null && this.bm != null) {
                    m = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, k.z, k.y, false);
                }
                k.d = m;
            }
            k.h = f;
            this.aa6(k);
            this.zb.z(this, l, m, n, f, g, h, i, b < 0);
        }
        acv(a, b) {
            a.b7 = true;
            this.zb.a1(this, this.zr(), runOn(this, this.yi), this.z1(a), this.z2(a));
            let c = this.zb.d;
            let d = c != null;
            let e = this.yu;
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.by, a.bx, e.ch, f);
            let h = this.dm == null ? 0 : this.dm.count;
            let i = a;
            let j = b.f;
            let k = i.cx.c;
            let l = i.cx.d;
            let m = i.cx.b;
            let n = k * m;
            for (let o = 0; o < a.cy.count; o++) {
                let p = a.cy.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.acz(j, r, h, e, g, a.q);
                }
                this.zb.ac(p, q);
            }
        }
        acu(a, b, c, d, e) {
            e.c3(a, b, c, d);
        }
        sd() {
            super.sd();
            if (this.index < 0) {
                return;
            }
            this.abx.c4();
        }
        kw(a, b) {
            if (a == this.abx.c2.g$j) {
                return null;
            }
            return super.kw(a, b);
        }
        gc(a) {
            let b = this.cu.by;
            b = b.copy();
            let c = this.cu.bx;
            let d = !b.isEmpty && !c.isEmpty && this.dm != null ? this.dm.indexOf(a) : -1;
            if (this.yu == null || this.ab3 == null || this.y0 == null) {
                return false;
            }
            if (d < 0 || d > this.ab3.count - 1) {
                return false;
            }
            let e = this.yu.getScaledAngle(d);
            let f = this.y0.oc(this.ab3.item(d));
            if (isNaN_(f)) {
                f = (this.y0.n5 + this.y0.n6) / 2;
            }
            let g = 0.5 + (Math.cos(e) * f);
            let h = 0.5 + (Math.sin(e) * f);
            if (!isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.c2 != null) {
                this.c2.au(this.da, b, true);
            }
            return d >= 0;
        }
        rr(a, b) {
            super.rr(a, b);
            if (!this.gz) {
                this.cu.a4(b);
                return;
            }
            this.cu.a4(b);
            let c = typeCast(AnchoredRadialSeriesView.$, this.ct);
            c.cx.e(this.ic);
            if (this.d4(this.ct)) {
                return;
            }
            if (!this.gr) {
                this.ab0 = new RadialFrame(3);
                this.aa4(this.ab0, c);
            }
            this.gr = false;
            this.aa7(this.ab0, c);
            this.gz = false;
        }
        ro(a, b, c, d, e) {
            super.ro(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            let g = f;
            g.cx.e(this.ic);
            f.a3(c);
            if (this.d4(g)) {
                return;
            }
            if (this.abz == null) {
                this.abz = new RadialFrame(3);
            }
            this.abz.v();
            this.aa4(this.abz, g);
            this.aa7(this.abz, g);
        }
        pw(a) {
            super.pw(a);
            this.bc.exportTrendlineData(this, a, this.abx.c2.g$j);
        }
    }
    AnchoredRadialSeries.$t = /*@__PURE__*/ markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.ac2 = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredRadialSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['HighlightedValueMemberPath:ack:ac3', [2, null], 'UseCategoryNormalizedValues:acc:adb', [0, false], 'ValueMemberAsLegendLabel:aco:adc', [2, null], 'ValueMemberAsLegendUnit:acq:add', [2, null], 'ValueMemberPath:acs:ade', [2, null], 'TrendLineType:ab1:ac9', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:ach:ac8', [1, 1.5], 'TrendLinePeriod:aci:ac7', [1, 7], 'TrendLineZIndex:acj:ada', [1, 1], 'TrendLineBrush:adg:ac4', [Brush.$, null], 'TrendLineDashArray:adh:ac5', [DoubleCollection.$], 'TrendLineDashCap:adi:ac6', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeriesView = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesView extends RadialBaseView {
        constructor(a) {
            super(a);
            this.c1 = null;
            this.c2 = null;
            this.cx = new AnchoredRadialBucketCalculator(this);
            this.c1 = a;
            this.c2 = new RadialTrendLineManager();
        }
        c3(a, b, c, d) {
        }
        c4() {
            this.c1.adf = null;
            if (this.c1.adg != null) {
                this.c1.adf = this.c1.adg;
            }
            else {
                this.c1.adf = this.c1.u5;
            }
        }
        a7(a, b) {
            if (a.d) {
                if (!b) {
                }
                if (this.c1.ab1 != 0 && !b) {
                    let c = this.c2.g$j;
                    c.ad = this.c1.ach;
                    c._stroke = this.c1.adf;
                    c.ai = this.c1.adh;
                    c.aj = this.c1.adi;
                    a.v(c);
                }
            }
            super.a7(a, b);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.c1.yu.f1 != null) {
                a += "<span>${item." + this.c1.yu.f1 + "}</span><br/>";
            }
            a += "<span";
            let b = this.e.ba.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.c1.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.c1.acs + "}</span></div>";
            return a;
        }
    }
    AnchoredRadialSeriesView.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
})();
