/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
import { IAnnotationLayerProxy_$type } from "./IAnnotationLayerProxy";
import { CrosshairLayer } from "./CrosshairLayer";
import { ValueLayer } from "./ValueLayer";
import { CalloutLayer } from "./CalloutLayer";
import { FinalValueLayer } from "./FinalValueLayer";
import { DataToolTipLayer } from "./DataToolTipLayer";
import { DoubleCollection } from "igniteui-react-core";
/**
 * @hidden
 */
export let AnnotationLayerProxy = /*@__PURE__*/ (() => {
    class AnnotationLayerProxy extends Base {
        constructor() {
            super(...arguments);
            this._container = null;
        }
        get container() {
            return this._container;
        }
        set container(a) {
            this._container = a;
        }
        matchesType(a) {
            if (!a.er) {
                return false;
            }
            return true;
        }
        createCrosshairLayer() {
            let a = new CrosshairLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createValueLayer() {
            let a = new ValueLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createCalloutLayer() {
            let a = new CalloutLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createFinalValueLayer() {
            let a = new FinalValueLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        setCrosshairHorizontalLineVisibility(a, b) {
            a.acj = b;
        }
        setCrosshairVerticalLineVisibility(a, b) {
            a.ack = b;
        }
        setCrosshairHorizontalLineStroke(a, b) {
            a.ab7 = b;
        }
        setCrosshairVerticalLineStroke(a, b) {
            a.ab8 = b;
        }
        setCrosshairXAxisForeground(a, b) {
            a.acb = b;
        }
        setCrosshairYAxisForeground(a, b) {
            a.ace = b;
        }
        setCrosshairXAxisBackground(a, b) {
            a.ab9 = b;
        }
        setCrosshairYAxisBackground(a, b) {
            a.acc = b;
        }
        setCrosshairYAxisPrecision(a, b) {
            a.aag = b;
        }
        setCrosshairXAxisPrecision(a, b) {
            a.aaf = b;
        }
        setCrosshairOnAxesEnabled(a, b) {
            a.zy = b;
        }
        setCrosshairUseInterpolation(a, b) {
            a.z0 = b;
        }
        setCrosshairThickness(a, b) {
            a.jo = b;
        }
        isCrosshairLayer(a) {
            return typeCast(CrosshairLayer.$, a) !== null;
        }
        setFinalValuePrecision(a, b) {
            a.z5 = b;
        }
        setFinalValueBackground(a, b) {
            a.aaz = b;
        }
        setFinalValueForeground(a, b) {
            a.aa1 = b;
        }
        setContentMemberPath(a, b) {
            a.acg = b;
        }
        setCalloutsAllowedPositions(a, b) {
            a.z5 = b;
        }
        setLabelMemberPath(a, b) {
            a.acu = b;
        }
        setXMemberPath(a, b) {
            a.ac8 = b;
        }
        setYMemberPath(a, b) {
            a.adb = b;
        }
        setTargetSeries(a, b) {
            a.aaa = b;
        }
        setCollisionChannel(a, b) {
            a.acd = b;
        }
        setIsAutoCalloutBehaviorEnabled(a, b) {
            a.aay = b;
        }
        setGreedyCollisionMode(a, b) {
            a.z0 = b ? 2 : 0;
        }
        setCollisionMode(a, b) {
            a.z0 = b;
        }
        setUseItemColorForFill(a, b) {
            a.aa4 = b;
        }
        setUseItemColorForOutline(a, b) {
            a.aa5 = b;
        }
        setCalloutStrokeThickness(a, b) {
            a.abn = b;
        }
        setUseAutoContrastingLabelColors(a, b) {
            a.aa2 = b;
        }
        setCalloutBackground(a, b) {
            a.aew = b;
        }
        setAutoCalloutLabelPrecision(a, b) {
            a.abq = b;
        }
        setCalloutLightColor(a, b) {
            a.aez = b;
        }
        setCalloutDarkColor(a, b) {
            a.aex = b;
        }
        setUseDedicatedLanes(a, b) {
            a.zy = b ? 2 : 0;
        }
        isCalloutLayer(a) {
            if (typeCast(CalloutLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isDataToolTipLayer(a) {
            if (typeCast(DataToolTipLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isFinalValueLayer(a) {
            if (typeCast(FinalValueLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        addCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateCombine(c.calloutStyleUpdating, b);
        }
        removeCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateRemove(c.calloutStyleUpdating, b);
        }
        addCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateCombine(c.calloutRenderStyleUpdating, b);
        }
        removeCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateRemove(c.calloutRenderStyleUpdating, b);
        }
        setCalloutStyleUpdatingEventEnabled(a, b) {
            a.aa1 = b;
        }
        setUseValueForAutoCalloutLabels(a, b) {
            a.aa7 = b;
        }
        setCalloutRenderStyleUpdatingEventEnabled(a, b) {
            a.aa0 = b;
        }
        updateDataToolTipPropertyByName(a, b, c) {
            a.aff(b, c);
        }
        getIsAutoCalloutBehaviorEnabled(a) {
            return a.aay;
        }
        setValueMode(a, b) {
            a.zx = b;
        }
        setValueAxisAnnotationEnabled(a, b) {
            a.zz = b;
        }
        getValueMode(a) {
            return a.zx;
        }
        isValueLayer(a) {
            return typeCast(ValueLayer.$, a) !== null;
        }
        setBrush(a, b) {
            a.vb = b;
        }
        setDashArray(a, b) {
            let c = new DoubleCollection();
            for (let d = 0; d < b.length; d++) {
                c.add(b[d]);
            }
            a.vy = c;
        }
    }
    AnnotationLayerProxy.$t = /*@__PURE__*/ markType(AnnotationLayerProxy, 'AnnotationLayerProxy', Base.$, [IAnnotationLayerProxy_$type]);
    return AnnotationLayerProxy;
})();
