/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-react-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-react-core";
import { IChartScaleLegend_$type } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { FastItemsSource } from "igniteui-react-core";
import { FastItemColumn } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, logBase } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let BubbleSeries = /*@__PURE__*/ (() => {
    class BubbleSeries extends ScatterBase {
        bj() {
            return new BubbleSeries();
        }
        get_eh() {
            return true;
        }
        cr() {
            return new BubbleSeriesView(this);
        }
        qz(a) {
            super.qz(a);
            this.acl = a;
        }
        jk() {
            return 0.7;
        }
        ww() {
            if (this.wv == 0) {
                return 2;
            }
            return super.ww();
        }
        constructor() {
            super();
            this.aec = null;
            this.aeb = null;
            this.acz = null;
            this.acq = null;
            this.acp = null;
            this.aco = null;
            this.acm = null;
            this.ab = BubbleSeries.$;
            this.yx = new ScatterFrame();
            this.yz = new ScatterFrame();
            this.yv = new ScatterFrame();
        }
        isAttachedTo(a) {
            return this.a5 == a;
        }
        eg() {
            return true;
        }
        pz(a) {
            super.pz(a);
            if (this.acu != null && this.acz != null && this.acz.count > 0) {
                for (let b = 0; b < this.acz.count; b++) {
                    a(this.acz._inner[b]);
                }
            }
        }
        get act() {
            return this.acv;
        }
        get_isColoredItemwise() {
            return this.acr != null && this.acr.count > 0;
        }
        aea(a) {
            let b = typeCast(CustomPaletteBrushScale.$, this.ack);
            let c = typeCast(ValueBrushScale.$, this.ack);
            let d = this.ack;
            if (b != null && this.dm != null) {
                return b.getBrush1(a, this.dm.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.acr);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        }
        get legendReady() {
            return this.acv != null && this.acv.count != 0;
        }
        get minScaleText() {
            let a = this.acj(this.acn).b;
            return (Math.round(a * 1000) / 1000).toString();
        }
        get maxScaleText() {
            let a = this.acj(this.acn).a;
            return (Math.round(a * 1000) / 1000).toString();
        }
        forScaleColors(a) {
            for (let b = 0; b < this.acv.count; b++) {
                if (this.ack == null || !this.ack.isReady) {
                    return false;
                }
                let c = NaN;
                if (this.acr != null) {
                    c = (this.acr.item(b) - this.acr.minimum) / (this.acr.maximum - this.acr.minimum);
                }
                let d = (this.acv.item(b) - this.acv.minimum) / (this.acv.maximum - this.acv.minimum);
                if (isNaN_(c)) {
                    c = 0;
                }
                if (isNaN_(d)) {
                    d = c;
                }
                let e = this.yc;
                let f = this.aea(b);
                let g = f != null ? f : e;
                a(g, d);
            }
            return true;
        }
        kp(a, b) {
            let c = this.nc(b);
            if (c == BubbleSeries.$$p[5]) {
                return this.kq(a, b, this.ade);
            }
            if (c == BubbleSeries.$$p[11]) {
                return this.kq(a, b, this.ado);
            }
            if (c == ScatterBase.$$p[12]) {
                return this.kq(a, b, this.aao);
            }
            if (c == ScatterBase.$$p[16]) {
                return this.kq(a, b, this.aaw);
            }
            if (c == BubbleSeries.$$p[2]) {
                return this.kq(a, b, this.ac9);
            }
            return super.kp(a, b);
        }
        mc(a) {
            let b = this.nc(a);
            if (b == BubbleSeries.$$p[5]) {
                return this.ade;
            }
            if (b == BubbleSeries.$$p[11]) {
                return this.ado;
            }
            if (b == ScatterBase.$$p[12]) {
                return this.aao;
            }
            if (b == ScatterBase.$$p[16]) {
                return this.aaw;
            }
            if (b == BubbleSeries.$$p[2]) {
                return this.ac9;
            }
            return super.mc(a);
        }
        get acv() {
            return this.acq;
        }
        set acv(a) {
            if (this.acq != a) {
                let b = this.acv;
                this.acq = a;
                this.raisePropertyChanged("RadiusColumn", b, this.acv);
            }
        }
        get acu() {
            return this.acp;
        }
        set acu(a) {
            if (this.acp != a) {
                let b = this.acu;
                this.acp = a;
                this.raisePropertyChanged("LabelColumn", b, this.acu);
            }
        }
        get acr() {
            return this.aco;
        }
        set acr(a) {
            if (this.aco != a) {
                let b = this.acr;
                this.aco = a;
                this.raisePropertyChanged("FillColumn", b, this.acr);
            }
        }
        aaz(a, b, c, d, e) {
            if (c <= this.z4) {
                b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            }
            let f = this.z4;
            let g = this.dm;
            let h;
            let i;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(0, d, e, this.yr.d, j);
            let l = new ScalerParams(0, d, e, this.yr.e, j);
            let m = false;
            let n = 0;
            if (this.da != null) {
                if (this.da.f2()) {
                    let o = this.da.mz(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            for (let p = 0; p < c; p++) {
                h = this.zc.item(p);
                i = this.zd.item(p);
                let q = { $type: Point_$type, x: this.yr.a.ek(h, k), y: this.yr.b.ek(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!isInfinity(q.x) && !isInfinity(q.y)) {
                    let r = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r)) {
                            let s = { $type: Point_$type, x: h, y: i };
                            b.g.addItem(r, ((() => {
                                let $ret = new OwnedPoint();
                                $ret.a = r;
                                $ret.b = s;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            }
        }
        aba(a, b) {
            let c = typeCast(BubbleSeriesView.$, b);
            let d = c.c0;
            d.m = this.acv;
            super.aba(a, b);
            let e = Math.min(this.zc != null ? this.zc.count : 0, this.zd != null ? this.zd.count : 0);
            if (e < 1) {
                return;
            }
            c.dm();
            c.dn();
        }
        adt() {
            if (this.da == null) {
                return;
            }
            if (this.a5 == null) {
                return;
            }
            if (this.a5.isItemwise) {
                let a = this.a5;
                this.a5.clearLegendItemsForSeries(this);
                this.ads();
                a.renderItemwiseContent(this);
            }
            if (this.a5.isScale) {
                let b = this.a5;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        }
        static ac0(a, b, c, d, e) {
            if (e <= a || isNaN_(e) || isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            let f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        }
        static ac1(a, b, c, d, logBase_, e) {
            let f = logBase(e, logBase_);
            let g = logBase(a, logBase_);
            let h = logBase(b, logBase_);
            return BubbleSeries.ac0(g, h, c, d, f);
        }
        hd(a, b, c) {
            let d = super.hd(a, b, c);
            if (this.acv == null || this.dm == null || this.acv.count == 0 || this.dm.count != this.acv.count) {
                d = false;
            }
            return d;
        }
        zm(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.aao == a || this.aaw == a || this.ado == a) {
                return true;
            }
            return false;
        }
        ads() {
            let a = typeCast(IChartLegend_$type, this.a5);
            if (a == null || this.dm == null) {
                return;
            }
            this.acz = new List$1(UIElement.$, 0);
            let b = typeCast(CustomPaletteBrushScale.$, this.ack);
            let c = typeCast(ValueBrushScale.$, this.ack);
            let d = this.ack;
            let e = this.aci();
            let f = e.b;
            let g = e.a;
            let h = this.dm;
            for (let i = 0; i < h.count; i++) {
                let j = null;
                if (c != null && this.acr != null) {
                    let k = this.acr.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                let l = new ContentControl();
                let m = this.acu != null && this.acu.item(i) != null ? this.acu.item(i).toString() : "";
                l.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    $ret.legendLabel = m;
                    return $ret;
                })());
                let n = this.st;
                if (n == null) {
                    n = this.cu.bn(this.cz);
                }
                l.ah = n;
                this.acz.add(l);
            }
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            if (this.acn != null) {
                this.acn.aa();
            }
            if (this.ack != null) {
                this.ack.x();
            }
            this.adt();
        }
        qb() {
            super.qb();
            this.adt();
        }
        qi() {
            super.qi();
            this.adt();
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            switch (b) {
                case ScatterBase.$$p[10]:
                case ScatterBase.$$p[14]:
                case ScatterBase.$$p[11]:
                case ScatterBase.$$p[15]:
                case BubbleSeries.$$p[9]:
                case BubbleSeries.$$p[10]:
                    this.qd();
                    break;
                case "FastItemsSource":
                    if (this.acn != null) {
                        this.acn.aa();
                    }
                    if (this.ack != null) {
                        this.ack.x();
                    }
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.acv);
                        c.deregisterColumn(this.acr);
                        c.deregisterColumn(this.acu);
                        this.acv = null;
                        this.acr = null;
                        this.acu = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.acv = this.dj(this.ado);
                        if (!stringIsNullOrEmpty(this.ac9)) {
                            this.acr = this.dj(this.ac9);
                        }
                        this.acu = this.dl(this.ade);
                    }
                    this.rp(false);
                    this.adt();
                    break;
                case BubbleSeries.$$p[11]:
                    if (this.acn != null) {
                        this.acn.aa();
                    }
                    if (this.dm != null) {
                        this.dm.deregisterColumn(this.acv);
                        this.acv = this.dj(this.ado);
                        this.adt();
                    }
                    break;
                case "RadiusColumn":
                    if (this.acn != null) {
                        this.acn.aa();
                    }
                    this.ys.c2.g$i();
                    this.rp(this.gf && this.d6);
                    this.qk();
                    break;
                case BubbleSeries.$$p[12]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.rp(false);
                    this.qj();
                    break;
                case BubbleSeries.$$p[13]:
                    this.rp(false);
                    this.qj();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.adt();
                    break;
                case BubbleSeries.$$p[3]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.rp(false);
                    this.adt();
                    this.qj();
                    break;
                case BubbleSeries.$$p[4]:
                case BubbleSeries.$$p[8]:
                case BubbleSeries.$$p[7]:
                case BubbleSeries.$$p[6]:
                    this.rp(false);
                    this.adt();
                    this.qj();
                    break;
                case "FillColumn":
                    this.rp(this.gf && this.d6);
                    this.qj();
                    break;
                case BubbleSeries.$$p[2]:
                    if (this.ack != null) {
                        this.ack.x();
                    }
                    if (this.dm != null) {
                        this.dm.deregisterColumn(this.acr);
                        this.acr = this.dj(this.ac9);
                        this.adt();
                    }
                    break;
                case BubbleSeries.$$p[5]:
                    if (this.dm != null) {
                        this.dm.deregisterColumn(this.acu);
                        this.acu = this.dl(this.ade);
                        this.adt();
                    }
                    break;
                case "ActualLegend":
                    let e = typeCast(IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        let f = typeCast(IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        let g = typeCast(IChartScaleLegend_$type, e);
                        let h = true;
                        let i = null;
                        if (this.da != null) {
                            for (let j of fromEnum(this.da.series)) {
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                        }
                    }
                    this.adt();
                    break;
                case "SeriesViewer":
                    this.adt();
                    break;
            }
        }
        updateSizeScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.acv != null) {
                a.b = this.acv.minimum;
                a.a = this.acv.maximum;
            }
            if (this.acn != null) {
                this.acn.ab(a.b, a.a);
            }
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.acr != null) {
                a.b = this.acr.minimum;
                a.a = this.acr.maximum;
            }
            if (this.ack != null) {
                this.ack.z(a.b, a.a);
            }
        }
        acj(a) {
            let b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.acv != null) {
                b.b = this.acv.minimum;
                b.a = this.acv.maximum;
            }
            if (a != null) {
                a.x();
                if (this.acy) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        }
        aci() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.acr != null) {
                a.b = this.acr.minimum;
                a.a = this.acr.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.ack);
            if (b != null) {
                b.s();
                if (this.acw && this.ack.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        adv(a, b, c, d) {
            let e = c.width;
            if (!this.cu.bx.isEmpty) {
                e = this.cu.bx.width;
            }
            else if (this.da != null && !this.da.wc.isEmpty) {
                e = this.da.wc.width;
            }
            let f = DeviceUtils.c(e);
            this.acm = this.acn || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (this.acm != null) {
                let g = this.acm.minimumValue;
                let h = this.acm.maximumValue;
                let i = this.acm.logarithmBase;
                let j = this.acj(this.acm);
                let k = j.b;
                let l = j.a;
                if (this.acm.isLogarithmic) {
                    for (let m = 0; m < b.count; m++) {
                        b._inner[m] = BubbleSeries.ac1(k, l, g, h, i, b._inner[m]);
                    }
                }
                else {
                    for (let n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.ac0(k, l, g, h, b._inner[n]);
                    }
                }
            }
            let o = 1;
            o = DeviceUtils.d();
            let p = this.acn == null;
            if (d) {
                let q = c.width / e;
                for (let r = 0; r < b.count; r++) {
                    if (p) {
                        b._inner[r] = b._inner[r] / o;
                    }
                    b._inner[r] = b._inner[r] * q;
                }
            }
            for (let s = 0; s < a.count; s++) {
                let t = a._inner[s];
                if (p && !d) {
                    t.width = Math.max(0, b._inner[s] / o);
                    t.height = Math.max(0, b._inner[s] / o);
                }
                else {
                    t.width = Math.max(0, b._inner[s]);
                    t.height = Math.max(0, b._inner[s]);
                }
            }
        }
        adu(a) {
            let b = typeCast(BubbleSeriesView.$, this.ct);
            this.acl.b7 = false;
            if (b != null) {
                b.b7 = false;
            }
            let c = typeCast(CustomPaletteBrushScale.$, this.ack);
            let d = typeCast(ValueBrushScale.$, this.ack);
            let e = this.ack;
            let f = this.aci();
            let g = f.b;
            let h = f.a;
            let i = this.ack == null || !this.ack.isReady || (d != null && this.ac9 == null);
            if (i) {
                this.acl.dl();
                if (b != null) {
                    b.dl();
                }
                return;
            }
            this.acl.b7 = true;
            if (b != null) {
                b.b7 = true;
            }
            let j = a.count;
            let k = this.dm;
            for (let l = 0; l < j; l++) {
                let m = a._inner[l];
                let n = typeCast(DataContext.$, m.content);
                if (n != null) {
                    let o = null;
                    let p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.acr != null) {
                        let q = this.acr.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.ye == null) {
                            o = this.yc;
                        }
                        else {
                            o = this.ye;
                        }
                    }
                    let r = null;
                    if (this.yf == null) {
                        r = this.yd;
                    }
                    else {
                        r = this.yf;
                    }
                    if (this.acx && o != null) {
                        r = o;
                    }
                    if (r != null && !isNaN_(this.ac3)) {
                        r = BrushUtil.m(r, this.ac3);
                    }
                    if (o != null && !isNaN_(this.ac2)) {
                        o = BrushUtil.m(o, this.ac2);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.p1(a, c, b);
            return c.toArray();
        }
        p1(a, b, c) {
            let d = 1;
            if (d == 1) {
                let e = this.acs();
                this.aa2(a, b, c, d, e);
            }
            else {
                super.p1(a, b, c);
            }
        }
        acs() {
            let a = new FastItemColumn(typeCast(FastItemsSource.$, this.dm), "RadiusColumn", null, false);
            let b = this.cu.bx;
            let c = b.width;
            if (!this.cu.bx.isEmpty) {
                c = this.cu.bx.width;
            }
            else if (this.da != null && !this.da.wc.isEmpty) {
                c = this.da.wc.width;
            }
            let d = DeviceUtils.c(c);
            this.acm = this.acn || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = d / 10;
                $ret.maximumValue = d / 5;
                return $ret;
            })());
            if (this.acm != null) {
                let e = this.acm.minimumValue;
                let f = this.acm.maximumValue;
                let g = this.acm.logarithmBase;
                let h = this.acj(this.acm);
                let i = h.b;
                let j = h.a;
                if (this.acm.isLogarithmic) {
                    for (let k = 0; k < a.count; k++) {
                        a.item(k, BubbleSeries.ac1(i, j, e, f, g, a.item(k)));
                    }
                }
                else {
                    for (let l = 0; l < a.count; l++) {
                        a.item(l, BubbleSeries.ac0(i, j, e, f, a.item(l)));
                    }
                }
            }
            let m = DeviceUtils.d();
            let n = this.acn == null;
            let o = this.cu == this.ct;
            if (o) {
                let p = b.width / c;
                for (let q = 0; q < a.count; q++) {
                    if (n) {
                        a.item(q, a.item(q) / m);
                    }
                    a.item(q, a.item(q) * p);
                }
            }
            for (let r = 0; r < a.count; r++) {
                let s;
                if (n && !o) {
                    a.item(r, Math.max(0, a.item(r) / m));
                }
                else {
                    a.item(r, Math.max(0, a.item(r)));
                }
            }
            return a;
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.km(c);
            let e = d == null ? NaN : this.iw(d, "XMemberPath");
            let f = d == null ? NaN : this.iw(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.a = 13;
            g.l = e;
            g.q = "X";
            g.r = this.aao != null ? this.aao : "X";
            g.s = this.aak != null ? this.aak : "X:";
            g.t = this.aam != null ? this.aam : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.q = "Y";
            h.r = this.aaw != null ? this.aaw : "Y";
            h.s = this.aas != null ? this.aas : "Y:";
            h.t = this.aau != null ? this.aau : "";
            let i = new DataLegendSeriesContext();
            i.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.h = this.mb();
            if (!stringIsNullOrEmpty(this.ado)) {
                let j = d == null ? NaN : this.iw(d, "RadiusMemberPath");
                let k = new DataLegendSeriesValueInfo();
                k.l = j;
                k.a = 11;
                k.q = "Radius";
                k.r = this.ado != null ? this.ado : "Radius";
                k.s = this.adk != null ? this.adk : "R:";
                k.t = this.adm != null ? this.adm : "";
                i.e.add(k);
            }
            else if (this.acm != null) {
                let l = new DataLegendSeriesValueInfo();
                l.l = this.acm.maximumValue;
                l.a = 11;
                l.q = "Radius";
                l.r = this.ado != null ? this.ado : "Radius";
                l.s = this.adk != null ? this.adk : "R:";
                l.t = this.adm != null ? this.adm : "";
                i.e.add(l);
            }
            if (!stringIsNullOrEmpty(this.ac9)) {
                let m = d == null ? NaN : this.iw(d, "FillMemberPath");
                let n = new DataLegendSeriesValueInfo();
                n.l = m;
                n.a = 12;
                n.q = "Fill";
                n.r = this.ac9 != null ? this.ac9 : "Fill";
                n.s = this.ac5 != null ? this.ac5 : "F:";
                n.t = this.ac7 != null ? this.ac7 : "";
                i.e.add(n);
            }
            return i;
        }
        get actualMarkerBrush() {
            return this.yc;
        }
    }
    BubbleSeries.$t = /*@__PURE__*/ markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:ac5:adw', [2, null], 'FillMemberAsLegendUnit:ac7:adx', [2, null], 'FillMemberPath:ac9:ady', [2], 'FillScale:ack:adz', [BrushScale.$], 'FillScaleUseGlobalValues:acw:ad0', [0, false], 'LabelMemberPath:ade:ad1', [2], 'MarkerBrushBrightness:ac2:ad2', [1, NaN], 'MarkerOutlineBrightness:ac3:ad3', [1, NaN], 'MarkerOutlineUsesFillScale:acx:ad4', [0, false], 'RadiusMemberAsLegendLabel:adk:ad5', [2, null], 'RadiusMemberAsLegendUnit:adm:ad6', [2, null], 'RadiusMemberPath:ado:ad7', [2, null], 'RadiusScale:acn:ad8', [SizeScale.$], 'RadiusScaleUseGlobalValues:acy:ad9', [0, false]]);
    return BubbleSeries;
})();
/**
 * @hidden
 */
export let CustomPaletteBrushScale = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScale extends BrushScale {
        constructor() {
            super();
        }
        getBrush1(a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return super.getBrush(a % this.brushes.count);
            }
            let c = BubbleSeries.ac0(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        }
        get_isReady() {
            return this.brushes != null && this.brushes.count > 0;
        }
    }
    CustomPaletteBrushScale.$t = /*@__PURE__*/ markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, /*@__PURE__*/ enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
})();
/**
 * @hidden
 */
export let BubbleSeriesView = /*@__PURE__*/ (() => {
    class BubbleSeriesView extends ScatterBaseView {
        constructor(a) {
            super(a);
            this.dk = null;
            this.dk = a;
            this.c2 = new ScatterTrendLineManager();
        }
        au() {
            super.au();
            if (!this.q) {
                this.b4.w5 = Defaults.e;
            }
        }
        cz() {
            return new BubbleMarkerManager((a) => this.c3.item(a), (a) => this.c1.yr.c.item(a), runOn(this, this.de), runOn(this, this.cw), runOn(this, this.c4));
        }
        dm() {
            let a = this.c0;
            this.dk.adv(a.n, a.o, this.bx, this == this.e.ct);
            this.as();
        }
        dn() {
            let a = this.c0;
            this.dk.adu(a.n);
        }
        dl() {
            let a = this.c0;
            for (let b of fromEnum(a.n)) {
                let c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.ba.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dk.title + "</span><br/><span>" + "(${item." + this.dk.aao + "}, ${item." + this.dk.aaw + "})</span>";
            if (!stringIsNullOrEmpty(this.dk.ado)) {
                a += "<span>, Radius: ${item." + this.dk.ado + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    BubbleSeriesView.$t = /*@__PURE__*/ markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
})();
