/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { Base, Number_$type, typeCast, Array_$type, markType, markDep, TypeRegistrar } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { MathUtil } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let CategoryXAxis = /*@__PURE__*/ (() => {
    class CategoryXAxis extends CategoryAxisBase {
        a4() {
            return new CategoryXAxisView(this);
        }
        ht(a) {
            super.ht(a);
            this.mk = a;
        }
        constructor() {
            super();
            this.mx = 1;
            this.mw = 1;
            this.m0 = null;
            this.mn = 0;
            this.mo = 0;
            this.k0 = new List$1(Number_$type, 0);
            this.ab = CategoryXAxis.$;
        }
        get mz() {
            return this.mx;
        }
        set mz(a) {
            this.mx = a;
        }
        get my() {
            return this.mw;
        }
        set my(a) {
            this.mw = a;
        }
        av() {
            if (this.c6) {
                return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        }
        getCategorySize(a, b, c) {
            let d = this.kd(b, c);
            return d.width / (this.lh * a.width);
        }
        k6(a, b, c) {
            let d = this.ld(a, b, c);
            let e = 0;
            if (!isNaN_(this.lc)) {
                e = Math.min(this.lc, 1);
            }
            else {
                e = 0;
            }
            ;
            let f = 1 - 0.5 * d;
            let g = this.lj == 0 ? 1 : this.lj;
            let h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
            return h;
        }
        getGroupCenter(a, b, c, d) {
            let e = 0.5;
            if (this.lj > 1) {
                let f = this.ld(b, c, d);
                let g = 0;
                if (!isNaN_(this.lc)) {
                    g = Math.min(this.lc, 1);
                }
                let h = 1 - 0.5 * f;
                let i = h / (this.lj - (this.lj - 1) * g);
                let j = (h - i) / (this.lj - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        }
        d5() {
            return this.mu;
        }
        na(a) {
            let b = this.bi != null ? this.bi.vx : Rect.empty;
            b = b.copy();
            let c = this.kf;
            let d = this.kc();
            let e = new Rect(0, 0, 0, 1, 1);
            let f = new ScalerParams(0, e, e, this.ch, d);
            let g = !b.isEmpty && !c.isEmpty && this.kt != null ? this.kt.indexOf(a) : -1;
            let h = g > -1 ? this.ek(g, f) : NaN;
            if (!isNaN_(h) && this.bi.ff) {
                if (!isNaN_(h)) {
                    if (h < b.left + 0.1 * b.width) {
                        h = h + 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                    if (h > b.right - 0.1 * b.width) {
                        h = h - 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                }
                this.bi.rt(b, false, true);
            }
        }
        ek(a, b) {
            if (!b.c.isEmpty) {
                let c = this.mt(a, NumericScaler.ac, b.c, this.categoryMode);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.mt(a, b.e, b.d, this.categoryMode);
        }
        mj(a) {
            if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        }
        hn(a, b, c, d, e) {
            let f;
            let g = e.e;
            let h = e.d;
            let i = e.c;
            let j = e.a;
            let k = !i.isEmpty;
            let l = this.categoryMode == 0 ? this.lh - 1 : this.lh;
            if (l < 0) {
                l = 0;
            }
            let m = i.left;
            let n = i.width;
            let o = g.left;
            let p = g.width;
            let q = h.left;
            let r = h.width;
            let s = 0;
            let t = 1;
            let u = this.mj(a);
            let v = false;
            if (u != null) {
                v = true;
            }
            let w;
            for (let x = 0; x < b.count; x++) {
                w = b.item(x);
                for (let y = c; y < d; y++) {
                    if (v) {
                        f = u[y];
                    }
                    else {
                        f = a.item(y);
                    }
                    if (k) {
                        let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            z = 1 - z;
                        }
                        z = m + n * (z - s) / t;
                        z = (z - q) / r;
                        let aa = q + r * (z - o) / p;
                        f[w] = aa;
                    }
                    else {
                        let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = q + r * (ab - o) / p;
                        f[w] = ab;
                    }
                }
            }
        }
        el(a, b, c) {
            if (!b.c.isEmpty) {
                let d = this.mt(a, NumericScaler.ac, b.c, c);
                d = (d - b.d.left) / b.d.width;
                d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
                return d;
            }
            return this.mt(a, b.e, b.d, c);
        }
        mt(a, b, c, d) {
            let e = d == 0 ? this.lh - 1 : this.lh;
            if (e < 0) {
                e = 0;
            }
            let f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
            if (this.ci) {
                f = 1 - f;
            }
            return c.left + c.width * (f - b.left) / b.width;
        }
        en(a, b) {
            if (!b.c.isEmpty) {
                let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
                return c;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        }
        eo(a, b, c) {
            if (!b.c.isEmpty) {
                let d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                d = (d * b.d.width) + b.d.left;
                d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
                return d;
            }
            return this.getUnscaledValue3(a, b.e, b.d, c);
        }
        getUnscaledValue3(a, b, c, d) {
            let e = b.left + (a - c.left) * b.width / c.width;
            if (this.ci) {
                e = 1 - e;
            }
            let f = d == 0 ? this.lh - 1 : this.lh;
            if (f < 0) {
                f = 0;
            }
            return e * f;
        }
        nb(a, b) {
            if (isNaN_(a) || isNaN_(b) || this.kt == null || this.kt.count == 0) {
                return;
            }
            let c = a / this.kt.count;
            let d = (b + 1) / this.kt.count;
            this.bi.wd = new Rect(0, c, this.bi.wd.y, d - c, this.bi.wd.height);
        }
        ia(a) {
            super.ia(a);
            let b = this.bi != null ? this.bi.vx : Rect.empty;
            let c = this.kf;
            let d = this.ka();
            let e = this.j9();
            let f = new ScalerParams(0, b, c, this.ch, d);
            let g = this.a5.a4();
            let h = this.a5.a7();
            let i = this.a5.a5();
            let j = this.a5.a6();
            let k = this.a5.e();
            let l = this.a5.f();
            let m = this.a5.g();
            let n = this.kt;
            let o = this.ml();
            this.im();
            this.hj(g);
            this.hj(h);
            this.hj(i);
            this.hj(j);
            this.dc.clear();
            this.dd.clear();
            this.k0.clear();
            this.a5.az(this, b, c);
            if (b.isEmpty || c.isEmpty) {
                this.br.count = 0;
                this.bq.count = 0;
                this.bp.count = 0;
            }
            if (this.br.count == 0 && this.bq.count == 0 && this.a5.l()) {
                this.a5.ad();
            }
            if (this.az != null) {
                this.az.registerAxis(this);
            }
            if (this.itemsSource == null || o == null || n.count == 0) {
                this.br.count = 0;
                this.bq.count = 0;
                this.bp.count = 0;
                this.a5.ad();
                return;
            }
            if (!b.isEmpty && !c.isEmpty) {
                let p = this.en(e.left, f);
                let q = this.en(e.right, f);
                let r = 0;
                let s = false;
                if (this.c4) {
                    let t = Math.abs(q - p);
                    r = Math.ceil(t) + 1;
                    if (this.ch) {
                        if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                            s = true;
                        }
                    }
                    else {
                        if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                            s = true;
                        }
                    }
                }
                if (this.ch) {
                    p = Math.ceil(p);
                    q = Math.floor(q);
                }
                else {
                    p = Math.floor(p);
                    q = Math.ceil(q);
                }
                if (this.c4) {
                    if (Math.abs(q - p) < r) {
                        if (this.ch) {
                            if (s) {
                                q--;
                            }
                            else {
                                p++;
                            }
                        }
                        else {
                            if (s) {
                                q++;
                            }
                            else {
                                p--;
                            }
                        }
                    }
                }
                let u = c.bottom;
                let v = u - c.top;
                if (this.aj != null) {
                    let w = typeCast(NumericYAxis.$, this.aj);
                    if (w != null) {
                        let x = this.ig(u, v, b, c, d, c.top, c.bottom);
                        u = x.p0;
                        v = x.p1;
                    }
                }
                this.hr(g, u, c, k, true);
                this.a5.au(v);
                let y = Math.min(p, q);
                let z = Math.max(p, q);
                let aa = e.width;
                if (this.c4) {
                    let ab = this.ek(y, f);
                    let ac = this.ek(z, f);
                    if (ab != ac) {
                        aa = Math.abs(ac - ab);
                    }
                }
                let ad = new LinearCategorySnapper(1, y, z, aa, this.mu, this.categoryMode, this.ez());
                let ae = ad.g;
                ae = this.d2(ae, this.mm(), b, c, d);
                if (ad.g != ae) {
                    ad = new LinearCategorySnapper(1, y, z, aa, ae, this.categoryMode, this.ez());
                }
                let af = Math.floor((y - 0) / ad.g);
                let ag = Math.ceil((z - 0) / ad.g);
                this.mp = ad.g;
                if (!isNaN_(af) && !isNaN_(ag)) {
                    let ah = truncate(af);
                    let ai = truncate(ag);
                    let aj = this.ms(0 + ah * ad.g, f);
                    let ak = this.ek(ad.g, f);
                    let al = Math.abs(ak - this.ek(0, f));
                    this.a5.av(ak);
                    let am = truncate(Math.ceil(e.right));
                    let an = truncate(Math.floor(e.left));
                    let ao = this.mv;
                    let ap = ao > 0 && ao < ad.g;
                    let aq = c.right;
                    let ar = this.k0;
                    let as = ad.g;
                    let at = truncate(as);
                    let au = this.lj;
                    let av = this.ch;
                    let aw = this.categoryMode;
                    this.m0 = null;
                    for (let ax = ah; ax <= ai; ++ax) {
                        let ay = this.ms(0 + (ax + 1) * ad.g, f);
                        if (aj <= aq) {
                            if (ax % 2 == 0) {
                                this.ip(h, aj, ay, c);
                            }
                            this.io(i, aj, c, l, false);
                            ar.add(aj);
                        }
                        if (this.categoryMode != 0 && this.lj != 0 && this.cy) {
                            if (ap) {
                                let az = al * this.mv;
                                if (this.ch) {
                                    let a0 = aj;
                                    while (a0 - az > ay) {
                                        a0 -= az;
                                        if (Math.abs(a0 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.io(j, a0, c, m, false);
                                    }
                                }
                                else {
                                    let a1 = aj;
                                    while (a1 + az < ay) {
                                        a1 += az;
                                        if (Math.abs(a1 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.io(j, a1, c, m, false);
                                    }
                                }
                                this.mq = this.mv;
                            }
                            else {
                                for (let a2 = 0; a2 < truncate(ad.g); a2++) {
                                    for (let a3 = 0; a3 < this.lj; a3++) {
                                        let a4 = this.getGroupCenter(a3, b, c, d);
                                        if (this.ch) {
                                            a4 = -a4;
                                        }
                                        let a5 = this.ek(a2 + ax * ad.g, f) + a4;
                                        this.io(j, a5, c, m, false);
                                    }
                                }
                                this.mq = 0.5;
                            }
                        }
                        let a6 = this.mr(ax * as, aj, aw == 0, f);
                        let a7 = truncate(Math.round(a6));
                        if (a7 >= an && a7 <= am) {
                            let a8 = 0;
                            if (as >= 1) {
                                a8 = ax * truncate(Math.floor(as));
                            }
                            else {
                                if ((ax * as) * 2 % 2 == 0) {
                                    a8 = truncate(Math.floor(ax * as));
                                }
                                else {
                                    a8 = -1;
                                }
                            }
                            if (o != null && a8 < n.count && a8 >= 0) {
                                let a9 = o.getItem(a8);
                                let ba = this.f0(a9);
                                this.m0 = a9;
                                if (!isNaN_(a6) && !isInfinity(a6) && ba != null) {
                                    if ((typeof ba === 'string') && Base.equalsStatic(ba, "")) {
                                    }
                                    else {
                                        this.dc.add1(ba);
                                        this.dd.add(new LabelPosition(a6));
                                    }
                                }
                            }
                        }
                        aj = ay;
                    }
                }
                this.m0 = null;
                if ((this.az == null || this.az.visibility == 0) && this.aj != null) {
                    if (this.az != null && (this.az.location == 4 || this.az.location == 5)) {
                        this.bi.ny();
                    }
                }
                this.a5.a0(this.dc, this.dd);
                this.l7();
            }
        }
        c3() {
            if (this.cq && this.c4) {
                this.bc = this.bb();
            }
            if (this.kt == null) {
                return false;
            }
            let a = false;
            let b = this.kt.count;
            if (b != this.my) {
                let c = new AxisRangeChangedEventArgs(0, 1, 1, this.my, b);
                this.my = b;
                this.h4(c);
                a = true;
            }
            this.nd();
            this.nc();
            return a;
        }
        getWindowZoomFromCategories(a) {
            let b = MathUtil.a(a) && a > 0;
            let c = this.kt.count;
            if (c > 0 && b) {
                let d = this.bi.wc.width;
                let e = isNaN_(d) || isInfinity(d);
                if (e) {
                    return NaN;
                }
                let f = new Rect(0, 0, 0, 1, 1);
                let g = this.bi.wc;
                let h = this.getCategorySize(f, g, g);
                let i = isNaN_(h) || isInfinity(h);
                if (i) {
                    return NaN;
                }
                let j = h * a / d;
                if (j >= 0 && j <= 1) {
                    return j;
                }
            }
            return NaN;
        }
        getWindowZoomFromItemSpan(a) {
            let b = MathUtil.a(a) && a > 0;
            let c = this.kt.count;
            if (c > 0 && b) {
                let d = this.bi.wc.width;
                let e = isNaN_(d) || isInfinity(d);
                if (e) {
                    return NaN;
                }
                let f = new Rect(0, 0, 0, 1, 1);
                let g = this.bi.wc;
                let h = this.k6(f, g, g);
                let i = a / h;
                let j = Math.min(1, 1 / i);
                if (j > 0 && j <= 1) {
                    return j;
                }
            }
            return NaN;
        }
        nd() {
            if (this.kt == null || this.bi == null) {
                return;
            }
            let a = !isNaN_(this.bi.iq) && !isNaN_(this.bi.is);
            if (a) {
                return;
            }
            if (!isNaN_(this.zoomMaximumItemSpan) && !isInfinity(this.zoomMaximumItemSpan)) {
                let b = this.getWindowZoomFromItemSpan(this.zoomMaximumItemSpan);
                if (!isNaN_(b) && !isInfinity(b)) {
                    this.bi.hj = b;
                }
            }
            else if (!isNaN_(this.zoomMaximumCategoryRange) && !isInfinity(this.zoomMaximumCategoryRange)) {
                let c = this.getWindowZoomFromCategories(this.zoomMaximumCategoryRange);
                if (!isNaN_(c) && !isInfinity(c)) {
                    this.bi.hj = c;
                }
            }
        }
        nc() {
            if (this.kt == null || this.bi == null) {
                return;
            }
            let a = NaN;
            let b = NaN;
            let c = this.bi.hp();
            let d = this.bi.hq();
            let e = false;
            if (MathUtil.a(this.zoomToItemSpan) && this.zoomToItemSpan > 0) {
                e = true;
                c = this.getWindowZoomFromItemSpan(this.zoomToItemSpan);
                c = Math.max(c, this.bi.hj);
            }
            else if (MathUtil.a(this.zoomToCategoryRange) && this.zoomToCategoryRange > 0 && this.zoomToCategoryRange <= this.li) {
                e = true;
                c = this.getWindowZoomFromCategories(this.zoomToCategoryRange);
                c = Math.max(c, this.bi.hj);
            }
            if (MathUtil.a(this.zoomToCategoryStart) && this.zoomToCategoryStart >= 0 && this.zoomToCategoryStart < this.li) {
                e = true;
                a = this.getWindowZoomFromCategories(this.zoomToCategoryStart);
                let f = c + a - 1;
                let g = c - f;
                if (f > 0 && g > this.bi.hj) {
                    c = g;
                    c = Math.max(c, this.bi.hj);
                }
            }
            if (e) {
                this.bi.rr(a, b, c, d);
            }
        }
        hx(a, b, c, d) {
            super.hx(a, b, c, d);
            switch (b) {
                case CategoryXAxis.$$p[0]:
                case CategoryXAxis.$$p[1]:
                    this.nd();
                    break;
                case CategoryXAxis.$$p[2]:
                case CategoryXAxis.$$p[3]:
                case CategoryXAxis.$$p[4]:
                    this.nc();
                    break;
            }
        }
        get mu() {
            return this.c(CategoryXAxis.ne);
        }
        set mu(a) {
            this.h(CategoryXAxis.ne, a);
        }
        mm() {
            return !isNaN_(this.mu);
        }
        get mp() {
            return this.mn;
        }
        set mp(a) {
            if (this.mp != a) {
                let b = this.mn;
                this.mn = a;
                this.h3("ActualInterval", b, this.mp);
            }
        }
        ew() {
            return this.mp;
        }
        get mv() {
            return this.c(CategoryXAxis.nf);
        }
        set mv(a) {
            this.h(CategoryXAxis.nf, a);
        }
        get mq() {
            return this.mo;
        }
        set mq(a) {
            if (this.mq != a) {
                let b = this.mo;
                this.mo = a;
                this.h3("ActualMinorInterval", b, this.mq);
            }
        }
        kw(a) {
            if (a == null) {
                return false;
            }
            let b = this.be();
            if (b == null) {
                return false;
            }
            return b.synchronizeHorizontally;
        }
        get_a2() {
            return 0;
        }
        get a2() {
            return this.get_a2();
        }
        ml() {
            return this.kt;
        }
        ms(a, b) {
            return this.ek(a, b);
        }
        mr(a, b, c, d) {
            if (!c) {
                let e = this.ms(a + 1, d);
                return (b + e) / 2;
            }
            return b;
        }
        get isVertical() {
            return this.cp;
        }
        j$d(a, b) {
            return this.en.apply(this, arguments);
        }
        j$c(a, b) {
            return this.ek.apply(this, arguments);
        }
        j$e(a, b, c, d, e) {
            this.hn.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.ho.apply(this, arguments);
        }
        j$g(a, b, c, d) {
            this.hp.apply(this, arguments);
        }
        get j$b() {
            return this.ch;
        }
        j$a() {
            return this.ag.apply(this, arguments);
        }
    }
    CategoryXAxis.$t = /*@__PURE__*/ markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$, [IZoomableCategoryAxis_$type]);
    CategoryXAxis.ne = /*@__PURE__*/ DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, /*@__PURE__*/ new PropertyMetadata(2, NaN, (a, b) => {
        a.h3("Interval", b.oldValue, b.newValue);
        a.h9(false);
    }));
    CategoryXAxis.nf = /*@__PURE__*/ DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, /*@__PURE__*/ new PropertyMetadata(2, NaN, (a, b) => {
        (typeCast(CategoryXAxis.$, a)).h3("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).h9(false);
    }));
    CategoryXAxis.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CategoryXAxis, 'h3', ['ZoomMaximumCategoryRange::ng', [1, NaN], 'ZoomMaximumItemSpan::nh', [1, NaN], 'ZoomToCategoryRange::ni', [1, NaN], 'ZoomToCategoryStart::nj', [1, NaN], 'ZoomToItemSpan::nk', [1, NaN]]);
    return CategoryXAxis;
})();
/**
 * @hidden
 */
export let CategoryXAxisView = /*@__PURE__*/ (() => {
    class CategoryXAxisView extends CategoryAxisBaseView {
        constructor(a) {
            super(a);
            this.bm = null;
            this.bm = a;
        }
        al() {
            super.al();
            this.a.fi = AxisDefaults.f;
        }
    }
    CategoryXAxisView.$t = /*@__PURE__*/ markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
})();
