/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-react-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-react-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, truncate } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Defaults } from "./Defaults";
import { TranslateTransform } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export let CrosshairLayer = /*@__PURE__*/ (() => {
    class CrosshairLayer extends AnnotationLayer {
        bj() {
            return new CrosshairLayer();
        }
        get_eq() {
            return true;
        }
        get_eo() {
            return true;
        }
        constructor() {
            super();
            this.xAxisAnnotationFormatLabel = null;
            this.yAxisAnnotationFormatLabel = null;
            this.acf = null;
            this.z2 = null;
            this.z1 = null;
            let a = new CrosshairLayerFrame();
            let b = new CrosshairLayerFrame();
            let c = new CrosshairLayerFrame();
            let d = this.kc / 1000;
            this.w7 = a;
            this.w6 = b;
            this.w8 = c;
            this.ab = CrosshairLayer.$;
        }
        cr() {
            return new CrosshairLayerView(this);
        }
        qz(a) {
            super.qz(a);
            this.zu = a;
        }
        gt(a) {
            if (this.zv == null) {
                return true;
            }
            if (this.zv == a) {
                return true;
            }
            return false;
        }
        zw() {
            return this.xAxisAnnotationFormatLabel != null;
        }
        zx() {
            return this.yAxisAnnotationFormatLabel != null;
        }
        get ach() {
            return new Thickness(1, this.z5, this.z7, this.z6, this.z4);
        }
        get aci() {
            return new Thickness(1, this.aab, this.aad, this.aac, this.aaa);
        }
        yk(a, b) {
            if (this.zv == null || this.zv == a) {
                if (!this.a1.c) {
                    this.rp(b);
                }
            }
        }
        ym(a, b) {
            super.ym(a, b);
            let c = a;
            let d = this.z0;
            let e = this.zz;
            c.af.clear();
            c.ag.clear();
            c.ae.clear();
            c.ah.clear();
            AxisAnnotationFrameManager.b(c);
            if (this.xd(this.zv)) {
                this.abc(this.zv, c, d, e);
            }
            else {
                for (let f of fromEnum(this.da.series)) {
                    if (this.xd(f)) {
                        this.abc(f, c, d, e);
                    }
                    if (f.isStacked) {
                        f.p0((g) => {
                            if (this.xd(g)) {
                                this.abc(g, c, d, e);
                            }
                            if (g.ef) {
                                g.py((h) => {
                                    if (this.xd(h)) {
                                        this.abc(h, c, d, e);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (f.ef) {
                        f.py((g) => {
                            if (this.xd(g)) {
                                this.abc(g, c, d, e);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        xd(a) {
            if (!super.xd(a)) {
                return false;
            }
            if (this.aal != null) {
                if (a.fa) {
                    let b = a.nb();
                    if (!Base.equalsStatic(this.aal, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.aal, a.name)) {
                        return false;
                    }
                }
            }
            let c = this.yf(a);
            if (!c.c) {
                return false;
            }
            return true;
        }
        qn() {
            super.qn();
            if (!this.a1.c && !this.d2()) {
                return;
            }
            if (this.d2()) {
                this.abd(this.w8, false);
            }
            else {
                this.abd(this.w6, false);
            }
        }
        wx() {
            return 1;
        }
        xk() {
            return 0.1;
        }
        xn() {
            return -0.4;
        }
        xm() {
            return 0.5;
        }
        zj() {
            return this.wu == 3 ? this.acg() : null;
        }
        zk() {
            return this.wv == 3 ? this.acg() : null;
        }
        acg() {
            if (this.acf == null) {
                this.acf = new DoubleCollection();
                this.acf.add(DeviceUtils.g(5));
                this.acf.add(DeviceUtils.g(5));
            }
            return this.acf;
        }
        abc(a, b, c, d) {
            let e = this.yf(a);
            if (!e.c) {
                return;
            }
            let f = e.d;
            f = a.v8(f, c, d);
            let g = false;
            let h = this.u5;
            if (h == null) {
                h = this.vb;
            }
            if (h == null) {
                h = a.u5;
                g = true;
            }
            let i = false;
            let j = this.ab9;
            if (j == null) {
                if (this.vb != null) {
                    j = this.vb;
                }
                else {
                    j = a.u5;
                    i = true;
                }
            }
            let k = false;
            let l = this.acc;
            if (l == null) {
                if (this.vb != null) {
                    l = this.vb;
                }
                else {
                    l = a.u5;
                    k = true;
                }
            }
            let m = h;
            let n = h;
            let o = j;
            let p = l;
            if (this.ab7 != null) {
                m = this.ab7;
            }
            else if (g) {
                switch (this.wu) {
                    case 0:
                    case 1:
                        m = this.zu.ce(m, this.xh);
                        break;
                    case 2:
                        m = this.zu.cg(m, this.xh);
                        break;
                    case 4:
                        m = this.zu.cf(m, this.xh);
                        break;
                }
            }
            if (this.ab8 != null) {
                n = this.ab8;
            }
            else if (g) {
                switch (this.wv) {
                    case 0:
                    case 1:
                        n = this.zu.ce(n, this.xj);
                        break;
                    case 2:
                        n = this.zu.cg(n, this.xj);
                        break;
                    case 4:
                        n = this.zu.cf(n, this.xj);
                        break;
                }
            }
            if (i) {
                switch (this.wv) {
                    case 1:
                        o = this.zu.ce(o, this.xj);
                        break;
                    case 2:
                        o = this.zu.cg(o, this.xj);
                        break;
                }
            }
            if (k) {
                switch (this.wu) {
                    case 1:
                        p = this.zu.ce(p, this.xh);
                        break;
                    case 2:
                        p = this.zu.cg(p, this.xh);
                        break;
                }
            }
            b.ae.add(m);
            b.ah.add(n);
            b.af.add(f.y);
            b.ag.add(f.x);
            if (this.zy && !isNaN_(f.y)) {
                AxisAnnotationFrameManager.c(b, f, a, this.da, this.getEffectiveViewport(), h, o, this.z3, this.acb, this.aca, this.ach, this.z8, p, this.z9, this.ace, this.acd, this.aci, this.aae, this.ack == 0, this.acj == 0);
            }
        }
        abd(a, b) {
            let c = false;
            if (this.z1 == null) {
                c = true;
                this.z2 = new List$1(Axis.$, 0);
                this.z1 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.z1, this.z2, b, this.aaf, this.aag, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
        }
        abb(a, b, c, d, e) {
            let f = a.item(b);
            b++;
            if (e) {
                f._stroke = d.ah._inner[c];
                f._fill = d.ah._inner[c];
            }
            else {
                f._stroke = d.ae._inner[c];
                f._fill = d.ae._inner[c];
            }
            f.ad = this.id;
            f.ai = e ? this.zi : this.zh;
            f.am = this.v1;
            f.al = this.v0;
            f.ak = this.v0;
            f.aj = this.vz;
            f.ac = this.jg;
            return new Tuple$2(Path.$, Number_$type, f, b);
        }
        yp(a, b) {
            super.yp(a, b);
            let c = this.zu.b8;
            let d = a;
            let e = d.af.count;
            let f = 0;
            let g = b.bx.left;
            let h = b.bx.right;
            let i = b.bx.top;
            let j = b.bx.bottom;
            let k = this.ack == 0;
            let l = this.acj == 0;
            for (let m = 0; m < e; m++) {
                let n = Math.floor(d.af._inner[m]);
                let o = Math.floor(d.ag._inner[m]);
                let p = null;
                if (k) {
                    if (isNaN_(n)) {
                        continue;
                    }
                    let q = this.abb(c, f, m, d, true);
                    p = q.c;
                    f = q.d;
                    let r = new PathGeometry();
                    let s = new PathFigure();
                    s._startPoint = { $type: Point_$type, x: o, y: i };
                    let t = new LineSegment(1);
                    t.c = { $type: Point_$type, x: o, y: j };
                    s._segments.add(t);
                    r.c.add(s);
                    p.an = r;
                }
                if (l) {
                    if (isNaN_(n)) {
                        continue;
                    }
                    let u = this.abb(c, f, m, d, false);
                    p = u.c;
                    f = u.d;
                    let v = new PathGeometry();
                    let w = new PathFigure();
                    w._startPoint = { $type: Point_$type, x: g, y: n };
                    let x = new LineSegment(1);
                    x.c = { $type: Point_$type, x: h, y: n };
                    w._segments.add(x);
                    v.c.add(w);
                    p.an = v;
                }
            }
            c.count = f;
            if (this.d2()) {
                this.abd(this.w8, true);
            }
            else {
                this.abd(this.w6, false);
            }
        }
        f9() {
            return true;
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (d == null) {
                        if (this.z1 != null && this.z1.count > 0) {
                            let e;
                            if (this.d2()) {
                                e = this.w8;
                            }
                            else {
                                e = this.w6;
                            }
                            AxisAnnotationFrameManager.b(e);
                            AxisAnnotationFrameManager.d(this, e, true, this.z1, this.z2, true, this.aaf, this.aag, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
                        }
                    }
                    break;
                case CrosshairLayer.$$p[1]:
                    this.rp(true);
                    break;
                case CrosshairLayer.$$p[8]:
                    this.rp(true);
                    break;
                case CrosshairLayer.$$p[4]:
                case CrosshairLayer.$$p[5]:
                    this.rp(true);
                    break;
                case CrosshairLayer.$$p[2]:
                case CrosshairLayer.$$p[10]:
                case CrosshairLayer.$$p[9]:
                case CrosshairLayer.$$p[12]:
                case CrosshairLayer.$$p[14]:
                case CrosshairLayer.$$p[16]:
                case CrosshairLayer.$$p[15]:
                case CrosshairLayer.$$p[13]:
                case CrosshairLayer.$$p[17]:
                case CrosshairLayer.$$p[18]:
                case CrosshairLayer.$$p[20]:
                case CrosshairLayer.$$p[22]:
                case CrosshairLayer.$$p[24]:
                case CrosshairLayer.$$p[26]:
                case CrosshairLayer.$$p[25]:
                case CrosshairLayer.$$p[23]:
                case CrosshairLayer.$$p[27]:
                case CrosshairLayer.$$p[28]:
                case CrosshairLayer.$$p[0]:
                case CrosshairLayer.$$p[7]:
                case CrosshairLayer.$$p[6]:
                    this.rp(true);
                    break;
            }
        }
    }
    CrosshairLayer.$t = /*@__PURE__*/ markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:ab7:abe', [Brush.$, null], 'HorizontalLineVisibility:acj:abf', [Visibility_$type, /*@__PURE__*/ enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:zy:abg', [0, false], 'SkipUnknownValues:zz:abh', [0, true], 'TargetSeriesName:aal:abi', [2, null], 'TargetSeries:zv:abj', [Series.$, null], 'UseInterpolation:z0:abk', [0, true], 'VerticalLineStroke:ab8:abl', [Brush.$, null], 'VerticalLineVisibility:ack:abm', [Visibility_$type, /*@__PURE__*/ enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackgroundCornerRadius:z3:abn', [1, /*@__PURE__*/ DeviceUtils.g(3)], 'XAxisAnnotationBackground:ab9:abo', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:aaf:abp', [1, -1], 'XAxisAnnotationOutline:aca:abq', [Brush.$, null], 'XAxisAnnotationPaddingBottom:z4:abr', [1, NaN], 'XAxisAnnotationPaddingLeft:z5:abs', [1, NaN], 'XAxisAnnotationPaddingRight:z6:abt', [1, NaN], 'XAxisAnnotationPaddingTop:z7:abu', [1, NaN], 'XAxisAnnotationStrokeThickness:z8:abv', [1, NaN], 'XAxisAnnotationTextColor:acb:abw', [Brush.$, null], 'YAxisAnnotationBackgroundCornerRadius:z9:abx', [1, /*@__PURE__*/ DeviceUtils.g(3)], 'YAxisAnnotationBackground:acc:aby', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:aag:abz', [1, -1], 'YAxisAnnotationOutline:acd:ab0', [Brush.$, null], 'YAxisAnnotationPaddingBottom:aaa:ab1', [1, NaN], 'YAxisAnnotationPaddingLeft:aab:ab2', [1, NaN], 'YAxisAnnotationPaddingRight:aac:ab3', [1, NaN], 'YAxisAnnotationPaddingTop:aad:ab4', [1, NaN], 'YAxisAnnotationStrokeThickness:aae:ab5', [1, NaN], 'YAxisAnnotationTextColor:ace:ab6', [Brush.$, null]]);
    return CrosshairLayer;
})();
/**
 * @hidden
 */
export let CrosshairLayerView = /*@__PURE__*/ (() => {
    class CrosshairLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b7 = null;
            this.b8 = null;
            this.b9 = null;
            this.b7 = a;
            this.b9 = new List$1(Path.$, 0);
        }
        au() {
            super.au();
            this.b8 = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.ch);
                $ret.activate = runOn(this, this.ca);
                $ret.disactivate = runOn(this, this.cc);
                $ret.destroy = runOn(this, this.cb);
                return $ret;
            })());
            this.b7.jo = Defaults.j;
        }
        ch() {
            let a = new Path();
            a.j = new TranslateTransform();
            this.b9.add(a);
            return a;
        }
        ca(a) {
            a._visibility = 0;
        }
        cc(a) {
            a._visibility = 1;
        }
        cb(a) {
            this.b9.remove(a);
        }
        cd(a, b, c, d) {
            if (a.an == null || a.an.c.x != d || a.an.d.x != c) {
                let e = ((() => {
                    let $ret = new LineGeometry();
                    $ret.d = { $type: Point_$type, x: c, y: b };
                    $ret.c = { $type: Point_$type, x: d, y: b };
                    return $ret;
                })());
                a.an = e;
            }
        }
        ce(a, b) {
            if (a == null) {
                return a;
            }
            return BrushUtil.m(a, b);
        }
        cg(a, b) {
            if (a == null) {
                return a;
            }
            return BrushUtil.o(a, b);
        }
        cf(a, b) {
            if (a == null) {
                return a;
            }
            let c = new Brush();
            c.color = Color.u(truncate((a.color.l * b)), a.color.o, a.color.n, a.color.m);
            return c;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d && !b) {
                for (let c = 0; c < this.b9.count; c++) {
                    let d = this.b9._inner[c];
                    if (d._visibility == 0) {
                        a.t(d);
                    }
                }
            }
        }
        an(a) {
            super.an(a);
            for (let b = 0; b < this.b9.count; b++) {
                this.e.bc.exportPathData(a, this.b9._inner[b], "crosshairLine", ["Main", "Crosshair"]);
            }
        }
    }
    CrosshairLayerView.$t = /*@__PURE__*/ markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
})();
