/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, Base, markType, typeCast, runOn, delegateCombine, enumGetBox, Point_$type, String_$type, Number_$type, fromEnum, toEnum, Date_$type, markDep, Delegate_$type } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { IFastItemColumn$1_$type } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-react-core";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FastReflectionHelper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-react-core";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { dateToStringFormat } from "igniteui-react-core";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { SRProvider } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export let FinancialEventArgs = /*@__PURE__*/ (() => {
    class FinancialEventArgs extends EventArgs {
        constructor(a, b, c, d, e) {
            super();
            this._position = 0;
            this._count = 0;
            this._dataSource = null;
            this._supportingCalculations = null;
            this._basedOn = null;
            this.position = a;
            this.count = b;
            this.dataSource = c;
            this.supportingCalculations = d;
            if (c != null) {
                c.series = e;
            }
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get dataSource() {
            return this._dataSource;
        }
        set dataSource(a) {
            this._dataSource = a;
        }
        get supportingCalculations() {
            return this._supportingCalculations;
        }
        set supportingCalculations(a) {
            this._supportingCalculations = a;
        }
        get basedOn() {
            return this._basedOn;
        }
        set basedOn(a) {
            this._basedOn = a;
        }
    }
    FinancialEventArgs.$t = /*@__PURE__*/ markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
})();
/**
 * @hidden
 */
export let FinancialBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialBucketCalculator extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.c = 0;
            this.d = 0;
            this.b = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "view");
            }
            this.a = a;
            this.c = -1;
            this.d = this.d;
            this.b = 0;
        }
        getBucket(a) {
            return null;
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        getBucketInfo(a, b, c, d) {
            a = this.c;
            b = this.d;
            c = this.b;
            d = this.a.b2.ic;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        e(a) {
            let b = this.a.by;
            let c = this.a.bx;
            let d = this.a.bx;
            if (this.a.b2 != null) {
                d = this.a.b2.getEffectiveViewport1(this.a);
            }
            if (b.isEmpty || c.isEmpty || this.a.b2.w1 == null) {
                this.b = 0;
                return;
            }
            let e = (this.a.b2.w1 != null) ? this.a.b2.w1.ch : false;
            let f = new ScalerParams(0, b, c, e, d);
            let g = this.a.b2.wf(this.a);
            let h = typeCast(ISortingAxis_$type, this.a.b2.w1);
            if (h == null || h.i$b == null) {
                let i = Math.floor(this.a.b2.w1.en(g.left, f));
                let j = Math.ceil(this.a.b2.w1.en(g.right, f));
                if (this.a.b2.w1.ch) {
                    j = Math.ceil(this.a.b2.w1.en(g.left, f));
                    i = Math.floor(this.a.b2.w1.en(g.right, f));
                }
                let k = Math.floor((j - i + 1) * a / g.width);
                this.b = truncate(Math.max(1, k));
                this.c = truncate(Math.floor(i / this.b));
                this.d = truncate(Math.ceil(j / this.b));
            }
            else {
                this.c = h.i$e(b, c, d, g);
                this.d = h.i$g(b, c, d, g);
                this.b = 1;
            }
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    FinancialBucketCalculator.$t = /*@__PURE__*/ markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialSeries = /*@__PURE__*/ (() => {
    class FinancialSeries extends Series {
        hs() {
            let a = super.hs();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "OpenMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedOpenMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.z4));
                a.add(b);
            }
            {
                let c = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "HighMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedHighMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.z2));
                a.add(c);
            }
            {
                let d = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "LowMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedLowMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.z3));
                a.add(d);
            }
            {
                let e = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "CloseMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedCloseMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                e.valueResolving = delegateCombine(e.valueResolving, runOn(this, this.z1));
                a.add(e);
            }
            {
                let f = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "VolumeMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedVolumeMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                f.valueResolving = delegateCombine(f.valueResolving, runOn(this, this.z5));
                a.add(f);
            }
            {
                let g = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Brush";
                    $ret.p = true;
                    $ret.y = "ActualBrush";
                    $ret.q = true;
                    return $ret;
                })());
                g.valueResolving = delegateCombine(g.valueResolving, runOn(this, this.rx));
                a.add(g);
            }
            {
                let h = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Outline";
                    $ret.p = true;
                    $ret.y = "ActualOutline";
                    $ret.q = true;
                    return $ret;
                })());
                h.valueResolving = delegateCombine(h.valueResolving, runOn(this, this.rx));
                a.add(h);
            }
            {
                let i = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "NegativeBrush";
                    $ret.p = true;
                    $ret.q = true;
                    return $ret;
                })());
                i.valueResolving = delegateCombine(i.valueResolving, runOn(this, this.rx));
                a.add(i);
            }
            {
                let j = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "NegativeOutline";
                    $ret.p = true;
                    $ret.q = true;
                    return $ret;
                })());
                j.valueResolving = delegateCombine(j.valueResolving, runOn(this, this.rx));
                a.add(j);
            }
            let k = ((() => {
                let $ret = new SeriesLayerPropertyOverlay();
                $ret.p = true;
                $ret.ad = "IsTransitionInEnabled";
                $ret.x = true;
                $ret.q = true;
                return $ret;
            })());
            a.add(k);
            let l = ((() => {
                let $ret = new SeriesLayerPropertyOverlay();
                $ret.p = true;
                $ret.ad = "TransitionInMode";
                $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
                $ret.q = true;
                return $ret;
            })());
            a.add(l);
            return a;
        }
        z4(a, b) {
            if (this.ze != null) {
                b.value = this.ze;
                return;
            }
            b.value = this.zr;
        }
        z2(a, b) {
            if (this.za != null) {
                b.value = this.za;
                return;
            }
            b.value = this.zi;
        }
        z3(a, b) {
            if (this.zc != null) {
                b.value = this.zc;
                return;
            }
            b.value = this.zn;
        }
        z1(a, b) {
            if (this.y8 != null) {
                b.value = this.y8;
                return;
            }
            b.value = this.y5;
        }
        z5(a, b) {
            if (this.zg != null) {
                b.value = this.zg;
                return;
            }
            b.value = this.zv;
        }
        ku() {
            if (this.d2()) {
                return this.bm.w7;
            }
            else {
                return this.bm.w3;
            }
        }
        qz(a) {
            super.qz(a);
            this.xi = a;
        }
        get_e5() {
            return true;
        }
        ai() {
            return [this.w1, this.xk];
        }
        kp(a, b) {
            let c = this.nc(b);
            if (c == FinancialSeries.$$p[11]) {
                return this.kq(a, b, this.zr);
            }
            if (c == FinancialSeries.$$p[1]) {
                return this.kq(a, b, this.zi);
            }
            if (c == FinancialSeries.$$p[9]) {
                return this.kq(a, b, this.zn);
            }
            if (c == FinancialSeries.$$p[0]) {
                return this.kq(a, b, this.y5);
            }
            if (c == FinancialSeries.$$p[13]) {
                return this.kq(a, b, this.zv);
            }
            if (c == FinancialSeries.$$p[5]) {
                return this.kq(a, b, this.ze);
            }
            if (c == FinancialSeries.$$p[3]) {
                return this.kq(a, b, this.za);
            }
            if (c == FinancialSeries.$$p[4]) {
                return this.kq(a, b, this.zc);
            }
            if (c == FinancialSeries.$$p[2]) {
                return this.kq(a, b, this.y8);
            }
            if (c == FinancialSeries.$$p[6]) {
                return this.kq(a, b, this.zg);
            }
            return super.kp(a, b);
        }
        mc(a) {
            let b = this.nc(a);
            if (b == FinancialSeries.$$p[11]) {
                return this.zr;
            }
            if (b == FinancialSeries.$$p[1]) {
                return this.zi;
            }
            if (b == FinancialSeries.$$p[9]) {
                return this.zn;
            }
            if (b == FinancialSeries.$$p[0]) {
                return this.y5;
            }
            if (b == FinancialSeries.$$p[13]) {
                return this.zv;
            }
            if (b == FinancialSeries.$$p[5]) {
                return this.ze;
            }
            if (b == FinancialSeries.$$p[3]) {
                return this.za;
            }
            if (b == FinancialSeries.$$p[4]) {
                return this.zc;
            }
            if (b == FinancialSeries.$$p[2]) {
                return this.y8;
            }
            if (b == FinancialSeries.$$p[6]) {
                return this.zg;
            }
            return super.mc(a);
        }
        y1() {
            return 2;
        }
        yz() {
            return 4;
        }
        aj(a) {
            let b = this.an(this.w1, this.w3.f, this.yy(this.cu), this.y0(this.cu), this.wd(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            let g = this.y1();
            f[0] = { $type: Point_$type, x: c[0], y: c[g] };
            f[1] = { $type: Point_$type, x: d[0], y: d[g] };
            e[0] = f;
            return e;
        }
        al(a) {
            let b = this.an(this.w1, this.w3.f, this.yy(this.cu), this.y0(this.cu), this.wd(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            f[0] = { $type: Point_$type, x: c[0], y: c[1] };
            f[1] = { $type: Point_$type, x: d[0], y: d[1] };
            e[0] = f;
            return e;
        }
        constructor() {
            super();
            this.xs = null;
            this.xq = null;
            this.xr = null;
            this.xp = null;
            this.xt = null;
            this.x2 = false;
            this.assigningCategoryStyle = null;
            this.xa = null;
            this.yc = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
            this.yd = new Dictionary$2(String_$type, String_$type, 0);
            this.x1 = false;
            this.xo = null;
            this.w5 = null;
            this.w7 = null;
            this.w3 = null;
            this.xd = null;
            this.typical = null;
            this.typicalBasedOn = null;
            this.x0 = false;
            this.yp = null;
            this.yn = null;
            this.yo = null;
            this.ym = null;
            this.yq = null;
            this.w6 = null;
            this.w2 = null;
            this.w8 = 0;
            this.xj = null;
            this.xl = null;
            this.xa = new CategorySeriesRenderManager();
            this.x2 = false;
            this.xd = new CategoryTransitionSourceFramePreparer();
            this.w6 = new CategoryFrame(3);
            this.ab = FinancialSeries.$;
            this.w9 = 0;
        }
        vs() {
            return this.aar;
        }
        vt() {
            return this.aar;
        }
        o1() {
            super.o1();
            this.w1 = null;
            this.xk = null;
        }
        get_ej() {
            return true;
        }
        get_f4() {
            return this.xk != null && this.xk.ch;
        }
        get xx() {
            return this.xs;
        }
        set xx(a) {
            if (this.xs != a) {
                let b = this.xs;
                this.xs = a;
                this.raisePropertyChanged("OpenColumn", b, this.xs);
            }
        }
        get xv() {
            return this.xq;
        }
        set xv(a) {
            if (this.xq != a) {
                let b = this.xq;
                this.xq = a;
                this.raisePropertyChanged("HighColumn", b, this.xq);
            }
        }
        get xw() {
            return this.xr;
        }
        set xw(a) {
            if (this.xr != a) {
                let b = this.xr;
                this.xr = a;
                this.raisePropertyChanged("LowColumn", b, this.xr);
            }
        }
        get xu() {
            return this.xp;
        }
        set xu(a) {
            if (this.xp != a) {
                let b = this.xp;
                this.xp = a;
                this.raisePropertyChanged("CloseColumn", b, this.xp);
            }
        }
        get xz() {
            return this.xt;
        }
        set xz(a) {
            if (this.xt != a) {
                let b = this.xt;
                this.xt = a;
                this.raisePropertyChanged("VolumeColumn", b, this.xt);
            }
        }
        ga() {
            return this.highlightedItemsSource != null || (this.ze != null && this.za != null && this.zc != null && this.y8 != null);
        }
        x9() {
            return (this.assigningCategoryStyle != null && this.x2) || this.bw != 1 || this.co != 1 || this.cn != 1;
        }
        z8(a) {
            if (this.assigningCategoryStyle != null && this.x2) {
                this.assigningCategoryStyle(this, a);
            }
        }
        z6(a, b, c, d, e, f, g) {
            let h = this.bw != 1;
            let i = this.co != 1;
            let j = this.cn != 1;
            this.xa.a3(this.xa.b, d.cn, a, b, c, d, e, f, false, g);
            this.xa.ab(this.ia);
            let k = this.xa.ay;
            let l = null;
            let m = null;
            let n = null;
            let o = this.dm;
            if (h && this.da != null) {
                l = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, false);
                k.c = l;
            }
            if (i && this.da != null) {
                m = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, false);
                if (m == null && this.bm != null) {
                    m = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, k.z, k.y, false);
                }
                k.d = m;
            }
            if (j && this.da != null) {
                n = this.da.dj.getHighlightingInfo(this, o, k.z, k.y, false);
                k.b = n;
            }
            k.h = f;
            this.z8(k);
            this.xa.z(this, l, m, n, f, h, i, j, b < 0);
        }
        yr(a) {
            return this.is(a, this.w1);
        }
        j9(a, b) {
            return this.ka(a, b, this.w1, runOn(this, this.yr), new FinancialValueList(this.xx, this.xv, this.xw, this.xu, this.xz));
        }
        j7(a, b) {
            return this.j8(a, b, this.w1, runOn(this, this.yr), new FinancialValueList(this.xx, this.xv, this.xw, this.xu, this.xz));
        }
        io(a, b, c, d, e) {
            if (c == null) {
                return Number.POSITIVE_INFINITY;
            }
            let f = this.w1.lh;
            return this.ip(a, b, this.w1, d, e, f, runOn(this, this.yr));
        }
        getOffsetValue() {
            return this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
        }
        getCategoryWidth() {
            return this.w1.getCategorySize(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
        }
        v8(a, b, c) {
            return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, null, null, null);
        }
        i4(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ys(this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
            return this.i6(new FinancialValueList(this.xx, this.xv, this.xw, this.xu, this.xz), a, this.w1, f, e, runOn(this, this.yr), b, c);
        }
        i0(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ys(this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
            return this.i6(this.xv, a, this.w1, f, e, runOn(this, this.yr), b, c);
        }
        i2(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ys(this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
            return this.i6(this.xw, a, this.w1, f, e, runOn(this, this.yr), b, c);
        }
        yt(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ys(this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
            return this.i6(this.xu, a, this.w1, f, e, runOn(this, this.yr), b, c);
        }
        yu(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ys(this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
            return this.i6(this.xx, a, this.w1, f, e, runOn(this, this.yr), b, c);
        }
        yv(a, b, c) {
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.ys(this.cu.by, this.cu.bx, d);
            let f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
            return this.i6(this.xz, a, this.w1, f, e, runOn(this, this.yr), b, c);
        }
        v4(a, b, c) {
            return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.i0), (d, e) => this.ka(d, e, this.w1, runOn(this, this.yr), this.xv), (d, e) => this.j8(d, e, this.w1, runOn(this, this.yr), this.xv));
        }
        v6(a, b, c) {
            return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.i2), (d, e) => this.ka(d, e, this.w1, runOn(this, this.yr), this.xw), (d, e) => this.j8(d, e, this.w1, runOn(this, this.yr), this.xw));
        }
        aat(a, b, c) {
            return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.yu), (d, e) => this.ka(d, e, this.w1, runOn(this, this.yr), this.xx), (d, e) => this.j8(d, e, this.w1, runOn(this, this.yr), this.xx));
        }
        aas(a, b, c) {
            return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.yt), (d, e) => this.ka(d, e, this.w1, runOn(this, this.yr), this.xu), (d, e) => this.j8(d, e, this.w1, runOn(this, this.yr), this.xu));
        }
        aau(a, b, c) {
            return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.yv), (d, e) => this.ka(d, e, this.w1, runOn(this, this.yr), this.xz), (d, e) => this.j8(d, e, this.w1, runOn(this, this.yr), this.xz));
        }
        p8() {
            super.p8();
            if (this.w1 != null) {
                this.w1.h9(false);
            }
            if (this.xk != null) {
                this.xk.h9(false);
            }
        }
        sn(a, b) {
            this.xi.b0.e(this.ic);
            this.rp(false);
        }
        sm(a, b) {
            if (this.g0 && this.jp < 0.05) {
                this.g1 = true;
                this.g4 = false;
                this.gj = false;
            }
            this.xi.b0.e(this.ic);
            this.rp(false);
        }
        xy(a, b, c) {
            let d = this.dj(b);
            this.yc.addItem(d, b);
            this.yd.addItem(b, c);
            return d;
        }
        z0(a, b) {
            if (b == null) {
                return;
            }
            a.deregisterColumn(b);
            let c = this.yc.item(b);
            this.yd.removeItem(c);
            this.yc.removeItem(b);
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            switch (b) {
                case "SyncLink":
                    if (this.c2 != null && this.da != null) {
                        this.xi.b0.e(this.ic);
                        this.rp(false);
                    }
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        if (this.w1 != null) {
                            this.w1.b0(this);
                        }
                        if (this.xk != null) {
                            this.xk.b0(this);
                        }
                    }
                    if (c == null && d != null) {
                        if (this.w1 != null) {
                            this.w1.ct(this);
                        }
                        if (this.xk != null) {
                            this.xk.ct(this);
                        }
                    }
                    this.xi.b0.e(this.ic);
                    this.rp(false);
                    break;
                case "FastItemsSource":
                    this.x1 = true;
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        this.z0(typeCast(IFastItemsSource_$type, c), this.xx);
                        this.z0(typeCast(IFastItemsSource_$type, c), this.xv);
                        this.z0(typeCast(IFastItemsSource_$type, c), this.xw);
                        this.z0(typeCast(IFastItemsSource_$type, c), this.xu);
                        this.z0(typeCast(IFastItemsSource_$type, c), this.xz);
                        this.xx = null;
                        this.xv = null;
                        this.xw = null;
                        this.xu = null;
                        this.xz = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        if (stringIsNullOrEmpty(this.zr) == false) {
                            this.xx = this.xy(typeCast(IFastItemsSource_$type, d), this.zr, "OpenColumn");
                        }
                        if (stringIsNullOrEmpty(this.zi) == false) {
                            this.xv = this.xy(typeCast(IFastItemsSource_$type, d), this.zi, "HighColumn");
                        }
                        if (stringIsNullOrEmpty(this.zn) == false) {
                            this.xw = this.xy(typeCast(IFastItemsSource_$type, d), this.zn, "LowColumn");
                        }
                        if (stringIsNullOrEmpty(this.y5) == false) {
                            this.xu = this.xy(typeCast(IFastItemsSource_$type, d), this.y5, "CloseColumn");
                        }
                        if (stringIsNullOrEmpty(this.zv) == false) {
                            this.xz = this.xy(typeCast(IFastItemsSource_$type, d), this.zv, "VolumeColumn");
                        }
                    }
                    this.x1 = false;
                    if (this.xk != null && !this.xk.c1()) {
                        this.xi.b0.e(this.ic);
                        this.rp(this.gf && c != null);
                    }
                    break;
                case FinancialSeries.$$p[11]:
                    if (this.dm != null) {
                        this.z0(this.dm, this.xx);
                        this.xx = this.xy(this.dm, this.zr, "OpenColumn");
                    }
                    break;
                case "OpenColumn":
                    if (this.xk != null && !this.xk.c1() && !this.x1) {
                        this.xi.b0.e(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    break;
                case FinancialSeries.$$p[1]:
                    if (this.dm != null) {
                        this.z0(this.dm, this.xv);
                        this.xv = this.xy(this.dm, this.zi, "HighColumn");
                    }
                    break;
                case "HighColumn":
                    if (this.xk != null && !this.xk.c1() && !this.x1) {
                        this.xi.b0.e(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    break;
                case FinancialSeries.$$p[9]:
                    if (this.dm != null) {
                        this.z0(this.dm, this.xw);
                        this.xw = this.xy(this.dm, this.zn, "LowColumn");
                    }
                    break;
                case "LowColumn":
                    if (this.xk != null && !this.xk.c1() && !this.x1) {
                        this.xi.b0.e(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    break;
                case FinancialSeries.$$p[0]:
                    if (this.dm != null) {
                        this.z0(this.dm, this.xu);
                        this.xu = this.xy(this.dm, this.y5, "CloseColumn");
                    }
                    break;
                case "CloseColumn":
                    if (this.xk != null && !this.xk.c1() && !this.x1) {
                        this.xi.b0.e(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    this.aaa();
                    break;
                case FinancialSeries.$$p[13]:
                    if (this.dm != null) {
                        this.z0(this.dm, this.xz);
                        this.xz = this.xy(this.dm, this.zv, "VolumeColumn");
                    }
                    break;
                case "VolumeColumn":
                    if (this.xk != null && !this.xk.c1() && !this.x1) {
                        this.xi.b0.e(this.ic);
                        this.rp(this.gf && this.d6);
                    }
                    break;
                case FinancialSeries.$$p[14]:
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    this.xi.b0.e(this.ic);
                    this.rp(false);
                    this.qj();
                    this.xj = typeCast(ITimeRangeSelectorAxis_$type, this.w1);
                    break;
                case FinancialSeries.$$p[15]:
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    this.xi.b0.e(this.ic);
                    if (this.xk != null) {
                        this.xk.c1();
                    }
                    {
                        this.rp(false);
                    }
                    this.qj();
                    break;
                case "TransitionProgress":
                    this.w7.c(this.jp, this.w5, this.w3);
                    if (this.d4(this.cu)) {
                        return;
                    }
                    if (this.jp == 1) {
                        this.w3.w();
                        this.z9(this.w3, this.xi);
                        if (this.g0) {
                            this.g0 = false;
                            this.o5();
                            this.db.r = truncate(this.i8());
                            this.db.b = this.dc;
                        }
                        if (this.g3) {
                            this.g3 = false;
                            this.o5();
                            this.db.r = truncate(this.i8());
                            this.db.b = this.dc;
                            this.qy();
                        }
                        this.qm();
                    }
                    else {
                        this.z9(this.w7, this.xi);
                    }
                    if (this.da != null) {
                        this.da.qj(this);
                    }
                    break;
                case FinancialSeries.$$p[10]:
                    this.rp(false);
                    break;
                case "IsCustomCategoryStyleAllowed":
                    this.x2 = this.x5();
                    this.rp(false);
                    break;
                case "CategoryMode":
                    if (this.w1 != null) {
                        this.w1.l8(true);
                    }
                    break;
            }
        }
        x4(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        x3(a) {
            if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
                return true;
            }
            return false;
        }
        wu(a, b, c) {
            if (b < a || a < 0 || a > this.dm.count || b < 0 || b > this.dm.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cn;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.dm.item(g);
            }
            return d;
        }
        yy(a) {
            return a.b0.b;
        }
        y0(a) {
            return a.b0.c;
        }
        wt(a, b) {
            return this.wu(a, b, this.xk);
        }
        get_fd() {
            return true;
        }
        o2() {
            super.o2();
            this.xo = null;
        }
        df(a, b, c) {
            if (this.ec && this.fy(this.bw) && !c) {
                let d = this.xn(a, b, this.xo);
                this.xo = d;
                return d;
            }
            else {
                let e = this.xm(a, b, this.xo);
                this.xo = e;
                return e;
            }
        }
        y2(a) {
            let b = this.w4();
            let c = this.cu.bx;
            let d = this.cu.by;
            let e = this.w1;
            let f = 0;
            if (e.cp) {
                let g = (a.y - d.top) / d.height;
                f = g * c.height + c.top;
            }
            else {
                let h = (a.x - d.left) / d.width;
                f = h * c.width + c.left;
            }
            let i = b.f.count;
            let j = 0;
            for (j = 0; j < i; j++) {
                let k = b.f._inner[j];
                let l = null;
                if (j < i - 1) {
                    l = b.f._inner[j + 1];
                }
                if (k[0] <= f && l == null || l[0] >= f) {
                    if (l != null) {
                        if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                            return j;
                        }
                        else {
                            return j + 1;
                        }
                    }
                    else {
                        return j;
                    }
                }
            }
            return j;
        }
        xn(a, b, c) {
            if (this.dm == null) {
                return null;
            }
            let d = this.dm.count;
            let e = this.xi.b0.c;
            let f = this.xi.b0.d;
            let g = this.xi.b0.b;
            let h = this.w1;
            let i = -1;
            let j = -1;
            if (h.cn) {
                let k = this.w4();
                let l = this.y2(b);
                if (k.m != null && l >= 0 && l < k.m.count) {
                    l = truncate(Math.round(k.m._inner[l]));
                }
                i = l;
                j = l;
            }
            else {
                let m = this.j2(b);
                i = truncate(Math.floor((intDivide(m, g)))) * g;
                j = i + (g - 1);
            }
            if (c != null && c.g == i && c.f == j) {
                return c;
            }
            let n = new HighlightingInfo();
            n.i = this;
            n.g = i;
            n.f = j;
            return n;
        }
        xm(a, b, c) {
            let d = new HighlightingInfo();
            d.i = this;
            d.g = 0;
            d.f = this.dm.count - 1;
            d.c = true;
            if (c != null && c.g == d.g && c.f == d.f) {
                return c;
            }
            return d;
        }
        x5() {
            return this.x7;
        }
        iq(a) {
            let b = this.cu.by;
            let c = this.cu.bx;
            let d = -1;
            if (!b.isEmpty && !c.isEmpty && this.w1 != null) {
                let e = this.getEffectiveViewport1(this.cu);
                let f = new ScalerParams(0, b, c, this.w1.ch, e);
                let g = this.wf(this.cu);
                let h = this.w1.en(g.left, f);
                let i = this.w1.en(g.right, f);
                let j = (a.x - b.left) / b.width;
                let k = h + (j * (i - h));
                if (this.w1.categoryMode != 0) {
                    k -= 0.5;
                }
                d = k;
            }
            return d;
        }
        j2(a) {
            return truncate(Math.round(this.iq(a)));
        }
        get_fr() {
            return typeCast(ISortingAxis_$type, this.w1) !== null;
        }
        a0() {
            return this.w1;
        }
        j4(a) {
            let b = this.cu.by;
            let c = this.cu.bx;
            let d = this.getEffectiveViewport1(this.cu);
            if (b.isEmpty || c.isEmpty) {
                return -1;
            }
            let e = new Rect(0, 0, 0, 1, 1);
            let f = new ScalerParams(0, b, c, this.w1.ch, d);
            let g = typeCast(ISortingAxis_$type, this.w1);
            let h = this.wf(this.cu);
            let i = h.left;
            let j = h.right;
            let k = this.v3(a).x;
            let l = this.w1.en(k, f);
            let m = this.w1.en(i, f);
            let n = this.w1.en(j, f);
            l = Math.max(m, Math.min(n, l));
            let o = g.i$f(l);
            return o;
        }
        km(a) {
            let b = 0;
            if (typeCast(ISortingAxis_$type, this.w1) !== null) {
                b = this.j4(a);
                if (b == -1) {
                    return null;
                }
            }
            else {
                b = this.j2(a);
            }
            return b >= 0 && this.dm != null && b < this.dm.count ? this.dm.item(b) : null;
        }
        w4() {
            let a = this.w3;
            if (this.d2()) {
                if (this.db.g) {
                    this.db.t();
                }
                a = this.w7;
            }
            return a;
        }
        ys(a, b, c) {
            if (this.w1 == null) {
                return 0;
            }
            return this.w1.k7(a, b, c, this.index);
        }
        gm() {
            return this.x8;
        }
        xb() {
            return 11;
        }
        c3() {
            return 3;
        }
        c6() {
            return 3;
        }
        z9(a, b) {
            this.qv();
            this.we = a.ab;
            b.aw();
        }
        z7(a, b) {
            a.v();
        }
        hd(a, b, c) {
            let d = super.hd(a, b, c);
            let e = c;
            if (this.dm == null || this.dm.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.w1 == null || this.xk == null || e.b0.b < 1 || this.w1.bi == null || this.xk.bi == null || this.xk.l2 == this.xk.l1 || this.w1.itemsSource == null || this.w1.lh < 1) {
                e.b0.b = 0;
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            b = this.cu.by;
            a = this.cu.bx;
            return {
                p0: a,
                p1: b
            };
        }
        yw(a) {
            let b = 0;
            let c = a.by;
            let d = a.bx;
            let e = this.getEffectiveViewport1(this.cu);
            if (!c.isEmpty && !d.isEmpty && this.xk != null) {
                let f = new ScalerParams(0, c, d, this.xk.ch, e);
                f.b = this.ix();
                b = this.xk.ek(this.xk.mc, f);
            }
            return b;
        }
        o5() {
            super.o5();
            this.w5.w();
            this.w3.w();
            this.w7.w();
        }
        rq(a) {
            super.rq(a);
            this.xi.b0.e(this.ic);
            if (this.d4(this.cu)) {
                return;
            }
            if (this.gq) {
                if (this.d2()) {
                    this.z9(this.w7, this.xi);
                }
                else {
                    this.z9(this.w3, this.xi);
                }
                return;
            }
            if (this.ge(a)) {
                let b = this.w5;
                if (this.d2()) {
                    if (this.db.g) {
                        this.db.t();
                    }
                    this.w5 = this.w7;
                    this.w7 = b;
                }
                else {
                    this.w5 = this.w3;
                    this.w3 = b;
                }
                this.z7(this.w3, this.xi);
                let c = false;
                if (this.g2) {
                    this.db.w();
                    this.db.r = truncate(this.i9());
                    this.db.b = this.dd != null ? this.dd : this.dc;
                    if (this.g3) {
                        let d = this.w7;
                        this.w7 = this.w5;
                        this.w5 = d;
                        c = true;
                    }
                    this.xd.s(this, this.w5, this.w3, this.isVertical, this.w1, this.xk, this.xc, this.xb(), this.c4, this.c3(), () => this.yw(this.xi), this.xi.bx);
                    if (this.g3) {
                        let e = this.w7;
                        this.w7 = this.w5;
                        this.w5 = e;
                    }
                    this.g3 = false;
                }
                if (this.g5) {
                    this.db.w();
                    this.db.r = truncate(this.ja());
                    this.db.b = this.de != null ? this.de : this.dc;
                    if (this.g0) {
                        let f = this.w7;
                        this.w7 = this.w5;
                        this.w5 = f;
                        c = true;
                    }
                    this.xd.s(this, this.w5, this.w3, this.isVertical, this.w1, this.xk, this.xc, this.xb(), this.c4, this.c3(), () => this.yw(this.xi), this.xi.bx);
                    let g = this.w3;
                    this.w3 = this.w5;
                    this.w5 = g;
                    if (this.g0) {
                        let h = this.w7;
                        this.w7 = this.w5;
                        this.w5 = h;
                    }
                    this.g0 = false;
                }
                this.d8 = false;
                if (!c) {
                    this.o0();
                }
                this.r3();
                if (this.g2) {
                    this.g1 = false;
                    this.g4 = false;
                    this.gj = false;
                    this.g0 = true;
                }
                if (this.g5) {
                    this.g4 = false;
                    this.g3 = true;
                }
            }
            else {
                this.z7(this.w3, this.xi);
                this.z9(this.w3, this.xi);
            }
        }
        gn() {
            return true;
        }
        ya(a) {
            for (let b of fromEnum(a)) {
                switch (b) {
                    case "HighColumn":
                        if (this.xv == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.xw == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.xx == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.xu == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.xz == null) {
                            return false;
                        }
                        break;
                }
            }
            return true;
        }
        get yb() {
            return this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null;
        }
        x6() {
            return this.typical != null;
        }
        zz(a) {
            this.typical(this, a);
        }
        get yj() {
            return this.yg();
        }
        *_yg() {
            let a = false;
            if (this.x6()) {
                let b = this.xe(0, this.dm.count);
                this.zz(new FinancialEventArgs(0, this.dm.count, b, this.xf(b), this));
                if (b.typicalColumn != null) {
                    a = true;
                    for (let c of fromEnum(b.typicalColumn)) {
                        yield c;
                    }
                }
            }
            if (!a) {
                if (this.yb && this.w1.i$b != null) {
                    let d = this.dm.count;
                    let e = this.w1.i$b;
                    for (let f = 0; f < d; ++f) {
                        yield (this.xv.item(e.item(f)) + this.xw.item(e.item(f)) + this.xu.item(e.item(f))) / 3;
                    }
                }
                else {
                    let g = this.dm.count;
                    for (let h = 0; h < g; ++h) {
                        yield (this.xv.item(h) + this.xw.item(h) + this.xu.item(h)) / 3;
                    }
                }
            }
        }
        yg() {
            return toEnum(() => this._yg());
        }
        get yi() {
            return this.yf();
        }
        *_yf() {
            if (this.yb && this.w1.i$b != null) {
                let a = this.xv.count;
                let b = this.w1.i$b;
                if (a > 0) {
                    yield this.yx(this.xv.item(b.item(0)) - this.xw.item(b.item(0)));
                }
                for (let c = 1; c < a; ++c) {
                    yield Math.max(this.yx(this.xv.item(b.item(c)) - this.xw.item(b.item(c))), Math.max(this.yx(Math.abs(this.xv.item(b.item(c)) - this.xu.item(b.item(c - 1)))), this.yx(Math.abs(this.xw.item(b.item(c)) - this.xu.item(b.item(c - 1))))));
                }
            }
            else {
                let d = this.xv.count;
                if (d > 0) {
                    yield this.yx(this.xv.item(0) - this.xw.item(0));
                }
                for (let e = 1; e < d; ++e) {
                    yield Math.max(this.yx(this.xv.item(e) - this.xw.item(e)), Math.max(this.yx(Math.abs(this.xv.item(e) - this.xu.item(e - 1))), this.yx(Math.abs(this.xw.item(e) - this.xu.item(e - 1)))));
                }
            }
        }
        yf() {
            return toEnum(() => this._yf());
        }
        get yh() {
            return this.ye();
        }
        *_ye() {
            if (this.yb && this.w1.i$b != null) {
                let a = this.xw.count;
                let b = this.w1.i$b;
                if (a > 0) {
                    yield this.yx(this.xw.item(b.item(0)));
                }
                for (let c = 1; c < a; c++) {
                    yield Math.min(this.yx(this.xw.item(b.item(c))), this.yx(this.xu.item(b.item(c - 1))));
                }
            }
            else {
                let d = this.xw.count;
                if (d > 0) {
                    yield this.yx(this.xw.item(0));
                }
                for (let e = 1; e < d; e++) {
                    yield Math.min(this.yx(this.xw.item(e)), this.yx(this.xu.item(e - 1)));
                }
            }
        }
        ye() {
            return toEnum(() => this._ye());
        }
        yl(a) {
            if (a == null) {
                return null;
            }
            if (this.yb && this.w1.i$b != null) {
                return new SafeSortedReadOnlyDoubleCollection(0, a, this.w1.i$b);
            }
            return new SafeReadOnlyDoubleCollection(0, a);
        }
        yk() {
            let a = new List$1(String_$type, 0);
            a.add("HighColumn");
            a.add("LowColumn");
            a.add("CloseColumn");
            if (this.typicalBasedOn != null && this.dm != null && !this.x0) {
                this.x0 = true;
                let b = this.xe(0, this.dm.count);
                this.x0 = false;
                let c = new FinancialEventArgs(0, this.dm.count, b, this.xf(b), this);
                this.typicalBasedOn(this, c);
                if (c.basedOn != null && c.basedOn.count > 0) {
                    return c.basedOn;
                }
            }
            return a;
        }
        getOpenColumnAsArray() {
            if (this.xx == null) {
                return null;
            }
            if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
                if (this.yp != null) {
                    return this.yp.asArray();
                }
                let a = new List$1(Number_$type, 2, this.xx.count);
                let b = this.w1.i$b;
                let c = this.xx.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.yp = a;
                return this.yp.asArray();
            }
            else {
                return this.xx.asArray();
            }
        }
        getHighColumnAsArray() {
            if (this.xv == null) {
                return null;
            }
            if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
                if (this.yn != null) {
                    return this.yn.asArray();
                }
                let a = new List$1(Number_$type, 2, this.xv.count);
                let b = this.w1.i$b;
                let c = this.xv.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.yn = a;
                return this.yn.asArray();
            }
            else {
                return this.xv.asArray();
            }
        }
        getLowColumnAsArray() {
            if (this.xw == null) {
                return null;
            }
            if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
                if (this.yo != null) {
                    return this.yo.asArray();
                }
                let a = new List$1(Number_$type, 2, this.xw.count);
                let b = this.w1.i$b;
                let c = this.xw.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.yo = a;
                return this.yo.asArray();
            }
            else {
                return this.xw.asArray();
            }
        }
        getCloseColumnAsArray() {
            if (this.xu == null) {
                return null;
            }
            if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
                if (this.ym != null) {
                    return this.ym.asArray();
                }
                let a = new List$1(Number_$type, 2, this.xu.count);
                let b = this.w1.i$b;
                let c = this.xu.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.ym = a;
                return this.ym.asArray();
            }
            else {
                return this.xu.asArray();
            }
        }
        getVolumeColumnAsArray() {
            if (this.xz == null) {
                return null;
            }
            if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
                if (this.yq != null) {
                    return this.yq.asArray();
                }
                let a = new List$1(Number_$type, 2, this.xz.count);
                let b = this.w1.i$b;
                let c = this.xz.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.yq = a;
                return this.yq.asArray();
            }
            else {
                return this.xz.asArray();
            }
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            if (this.w1 == null || !(typeCast(ISortingAxis_$type, this.w1) !== null)) {
                return;
            }
            let e = this.w1.i$b;
            switch (a) {
                case 1:
                    for (let f = b; f < c; f++) {
                        let g = e._inner[f];
                        if (this.yp != null) {
                            this.yp.insert(f, this.xx.item(g));
                        }
                        if (this.yn != null) {
                            this.yn.insert(f, this.xv.item(g));
                        }
                        if (this.yo != null) {
                            this.yo.insert(f, this.xw.item(g));
                        }
                        if (this.ym != null) {
                            this.ym.insert(f, this.xu.item(g));
                        }
                        if (this.yq != null) {
                            this.yq.insert(f, this.xz.item(g));
                        }
                    }
                    break;
                case 0:
                    if (this.yp != null) {
                        this.yp.v(b, c);
                    }
                    if (this.yn != null) {
                        this.yn.v(b, c);
                    }
                    if (this.yo != null) {
                        this.yo.v(b, c);
                    }
                    if (this.ym != null) {
                        this.ym.v(b, c);
                    }
                    if (this.yq != null) {
                        this.yq.v(b, c);
                    }
                    break;
                case 4:
                    if (this.yp != null) {
                        this.yp = new List$1(Number_$type, 0);
                    }
                    if (this.yn != null) {
                        this.yn = new List$1(Number_$type, 0);
                    }
                    if (this.yo != null) {
                        this.yo = new List$1(Number_$type, 0);
                    }
                    if (this.ym != null) {
                        this.ym = new List$1(Number_$type, 0);
                    }
                    if (this.yq != null) {
                        this.yq = new List$1(Number_$type, 0);
                    }
                    break;
                case 3:
                case 2:
                    for (let h = b; h < c; h++) {
                        let i = e._inner[h];
                        if (this.yp != null) {
                            this.yp._inner[h] = this.xx.item(i);
                        }
                        if (this.yn != null) {
                            this.yn._inner[h] = this.xv.item(i);
                        }
                        if (this.yo != null) {
                            this.yo._inner[h] = this.xw.item(i);
                        }
                        if (this.ym != null) {
                            this.ym._inner[h] = this.xu.item(i);
                        }
                        if (this.yq != null) {
                            this.yq._inner[h] = this.xz.item(i);
                        }
                    }
                    break;
            }
            this.aaa();
            this.sj();
        }
        xe(a, b) {
            let c = this.yl(this.xx);
            let d = this.yl(this.xu);
            let e = this.yl(this.xv);
            let f = this.yl(this.xw);
            let g = this.yl(this.xz);
            let h = ((() => {
                let $ret = new FinancialCalculationDataSource();
                $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(this.yj), this.yk());
                $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(this.yi), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("HighColumn");
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(this.yh), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.openColumn = c;
                $ret.closeColumn = d;
                $ret.highColumn = e;
                $ret.lowColumn = f;
                $ret.volumeColumn = g;
                $ret.calculateFrom = a;
                $ret.calculateCount = b;
                $ret.minimumValue = NaN;
                $ret.maximumValue = NaN;
                $ret.count = this.dm != null ? this.dm.count : 0;
                return $ret;
            })());
            return h;
        }
        yx(a) {
            if (isInfinity(a) || isNaN_(a)) {
                return 0;
            }
            return a;
        }
        xf(a) {
            return ((() => {
                let $ret = new FinancialCalculationSupportingCalculations();
                $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
                $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
                $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
                $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
                $ret.h = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.shortPeriod), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.f = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.longPeriod), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.g = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.shortPeriod), a.typicalColumn.basedOn);
                $ret.e = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.longPeriod), a.typicalColumn.basedOn);
                $ret.k = Series.hp;
                $ret.j = Series.ho;
                $ret.i = runOn(this, this.yx);
                return $ret;
            })());
        }
        get categoryAxis() {
            return this.w1;
        }
        rr(a, b) {
            super.rr(a, b);
            if (!this.gz) {
                this.cu.a4(b);
                return;
            }
            let c = typeCast(FinancialSeriesView.$, this.ct);
            this.cu.a4(b);
            c.b0.e(this.ic);
            if (this.d4(this.ct)) {
                return;
            }
            if (!this.gr) {
                this.z7(this.w6, c);
            }
            this.gr = false;
            this.z9(this.w6, c);
            this.gz = false;
        }
        ro(a, b, c, d, e) {
            super.ro(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            let g = f;
            g.b0.e(this.ic);
            f.a3(c);
            if (this.d4(g)) {
                return;
            }
            if (this.w2 == null) {
                this.w2 = new CategoryFrame(3);
            }
            this.w2.v();
            this.z7(this.w2, g);
            this.z9(this.w2, g);
        }
        aw(a) {
            if (this.w1 == a) {
                return this.xk;
            }
            if (this.xk == a) {
                return this.w1;
            }
            return null;
        }
        preferredCategoryMode(a) {
            let b = typeCast(IDateTimeAxis_$type, this.w1);
            return b != null ? b.preferredCategoryMode(this) : this.w9;
        }
        get w9() {
            return this.w8;
        }
        set w9(a) {
            let b = this.w9;
            if (a != b) {
                this.w8 = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.w9));
            }
        }
        get_fl() {
            return true;
        }
        rz(a, b) {
            super.rz(a, b);
            this.aar = a;
        }
        aaa() {
            this.il = this.xu == null || this.xu.count == 0 ? NaN : this.xu.item(this.xu.count - 1);
        }
        ko(a) {
            if (this.xj != null && a != null) {
                if (this.xl == null || this.xl.propertyName != this.xj.dateTimeMemberPath) {
                    this.xl = new FastReflectionHelper(false, this.xj.dateTimeMemberPath);
                }
                let b = this.xl.getPropertyValue(a);
                if (typeCast(Date_$type, b) !== null) {
                    return dateToStringFormat(b, this.xj.itemLabelFormat());
                }
            }
            return super.ko(a);
        }
    }
    FinancialSeries.$t = /*@__PURE__*/ markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:y5:aab', [2, null], 'HighMemberPath:zi:aah', [2, null], 'HighlightedCloseMemberPath:y8:aac', [2, null], 'HighlightedHighMemberPath:za:aad', [2, null], 'HighlightedLowMemberPath:zc:aae', [2, null], 'HighlightedOpenMemberPath:ze:aaf', [2, null], 'HighlightedVolumeMemberPath:zg:aag', [2, null], 'IsCustomCategoryStyleAllowed:x7:aai', [0, false], 'IsTransitionInEnabled:x8:aaj', [0, false], 'LowMemberPath:zn:aak', [2, null], 'NegativeBrush:aar:aal', [Brush.$, null], 'OpenMemberPath:zr:aam', [2, null], 'TransitionInMode:xc:aan', [CategoryTransitionInMode_$type, /*@__PURE__*/ enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:zv:aao', [2, null], 'XAxis:w1:aap', [CategoryAxisBase.$, null], 'YAxis:xk:aaq', [NumericYAxis.$, null]]);
    return FinancialSeries;
})();
/**
 * @hidden
 */
export let FinancialCalculationSupportingCalculations = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculations extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = null;
            this.d = null;
            this.b = null;
            this.h = null;
            this.f = null;
            this.g = null;
            this.e = null;
            this.k = null;
            this.j = null;
            this.i = null;
        }
    }
    FinancialCalculationSupportingCalculations.$t = /*@__PURE__*/ markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
})();
/**
 * @hidden
 */
export let DataSourceSupportingCalculation = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculation extends SupportingCalculation$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(Delegate_$type, 0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(Delegate_$type, 1, c, d);
                    }
                    break;
            }
        }
    }
    DataSourceSupportingCalculation.$t = /*@__PURE__*/ markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', /*@__PURE__*/ SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
})();
/**
 * @hidden
 */
export let FinancialCalculationDataSource = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSource extends Base {
        constructor() {
            super(...arguments);
            this._openColumn = null;
            this._closeColumn = null;
            this._highColumn = null;
            this._lowColumn = null;
            this._volumeColumn = null;
            this._indicatorColumn = null;
            this._typicalColumn = null;
            this._trueRange = null;
            this._trueLow = null;
            this._period = 0;
            this._shortPeriod = 0;
            this._longPeriod = 0;
            this._count = 0;
            this._calculateFrom = 0;
            this._calculateCount = 0;
            this._multiplier = 0;
            this._minimumValue = 0;
            this._maximumValue = 0;
            this._specifiesRange = false;
            this._series = null;
        }
        get openColumn() {
            return this._openColumn;
        }
        set openColumn(a) {
            this._openColumn = a;
        }
        get closeColumn() {
            return this._closeColumn;
        }
        set closeColumn(a) {
            this._closeColumn = a;
        }
        get highColumn() {
            return this._highColumn;
        }
        set highColumn(a) {
            this._highColumn = a;
        }
        get lowColumn() {
            return this._lowColumn;
        }
        set lowColumn(a) {
            this._lowColumn = a;
        }
        get volumeColumn() {
            return this._volumeColumn;
        }
        set volumeColumn(a) {
            this._volumeColumn = a;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        get typicalColumn() {
            return this._typicalColumn;
        }
        set typicalColumn(a) {
            this._typicalColumn = a;
        }
        get trueRange() {
            return this._trueRange;
        }
        set trueRange(a) {
            this._trueRange = a;
        }
        get trueLow() {
            return this._trueLow;
        }
        set trueLow(a) {
            this._trueLow = a;
        }
        get period() {
            return this._period;
        }
        set period(a) {
            this._period = a;
        }
        get shortPeriod() {
            return this._shortPeriod;
        }
        set shortPeriod(a) {
            this._shortPeriod = a;
        }
        get longPeriod() {
            return this._longPeriod;
        }
        set longPeriod(a) {
            this._longPeriod = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get calculateFrom() {
            return this._calculateFrom;
        }
        set calculateFrom(a) {
            this._calculateFrom = a;
        }
        get calculateCount() {
            return this._calculateCount;
        }
        set calculateCount(a) {
            this._calculateCount = a;
        }
        get multiplier() {
            return this._multiplier;
        }
        set multiplier(a) {
            this._multiplier = a;
        }
        get minimumValue() {
            return this._minimumValue;
        }
        set minimumValue(a) {
            this._minimumValue = a;
        }
        get maximumValue() {
            return this._maximumValue;
        }
        set maximumValue(a) {
            this._maximumValue = a;
        }
        get specifiesRange() {
            return this._specifiesRange;
        }
        set specifiesRange(a) {
            this._specifiesRange = a;
        }
        get series() {
            return this._series;
        }
        set series(a) {
            this._series = a;
        }
    }
    FinancialCalculationDataSource.$t = /*@__PURE__*/ markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
})();
/**
 * @hidden
 */
export let FinancialSeriesView = /*@__PURE__*/ (() => {
    class FinancialSeriesView extends SeriesView {
        b3(a) {
            if (this.b4 != a.u) {
                return true;
            }
            return false;
        }
        b5(a) {
            this.b4 = a.u;
        }
        constructor(a) {
            super(a);
            this.b2 = null;
            this.b0 = null;
            this.b4 = 0;
            this.b4 = -1;
            this.b2 = a;
            this.b0 = this.b1();
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.b2.w1.ce) {
                a += "<span>${itemLabel}</span><br/>";
            }
            else if (this.b2.w1.f1 != null) {
                a += "<span>${item." + this.b2.w1.f1 + "}</span><br/>";
            }
            a += "<span class='ui-priority-primary'";
            let b = this.e.ba.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            let c = new SRProvider(this.w);
            let d = c.b1("financialSeries_Open");
            let e = c.b1("financialSeries_High");
            let f = c.b1("financialSeries_Low");
            let g = c.b1("financialSeries_Close");
            d = stringIsNullOrEmpty(d) ? "Open" : d;
            e = stringIsNullOrEmpty(e) ? "High" : e;
            f = stringIsNullOrEmpty(f) ? "Low" : f;
            g = stringIsNullOrEmpty(g) ? "Close" : g;
            a += ">" + this.b2.title + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.b2.zr + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.b2.zi + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.b2.zn + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.b2.y5 + "}</td></tr>";
            if (!stringIsNullOrEmpty(this.b2.zv)) {
                let h = c.b1("financialSeries_Volume");
                h = stringIsNullOrEmpty(h) ? "Volume" : h;
                a += "<tr><td>" + h + ":</td><td>" + "${item." + this.b2.zv + "}</td></tr>";
            }
            a += "</table></div>";
            return a;
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.vx = a;
            this.e.jl = 5;
            this.e.jm = 2;
            this.e.jn = 2;
        }
    }
    FinancialSeriesView.$t = /*@__PURE__*/ markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
})();
