/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { Defaults } from "./Defaults";
import { KDTree2D } from "./KDTree2D";
import { Point_$type, typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, markDep, toNullable } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-react-core";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core";
import { dateNow } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
/**
 * @hidden
 */
export let HighDensityScatterSeries = /*@__PURE__*/ (() => {
    class HighDensityScatterSeries extends Series {
        bj() {
            return new HighDensityScatterSeries();
        }
        get_fn() {
            return true;
        }
        jj() {
            if (!isNaN_(this.ji)) {
                return super.jj();
            }
            return Defaults.q;
        }
        constructor() {
            super();
            this.w6 = null;
            this.w8 = null;
            this.yh = 0;
            this.xa = false;
            this.xw = Defaults.aq.o;
            this.xv = Defaults.aq.n;
            this.xu = Defaults.aq.m;
            this.xt = Defaults.aq.l;
            this.xs = Defaults.ap.o;
            this.xr = Defaults.ap.n;
            this.xq = Defaults.ap.m;
            this.xp = Defaults.ap.l;
            this.wy = null;
            this.w3 = null;
            this.w4 = null;
            this.wz = null;
            this.w1 = null;
            this.xc = false;
            this.yi = 0;
            this.yk = 0;
            this.ye = 0;
            this.yd = 0;
            this.progressiveLoadStatusChanged = null;
            this.xh = null;
            this.xn = 0;
            this.xm = 0;
            this.xo = 0;
            this.x3 = 0;
            this.x1 = 0;
            this.x2 = 0;
            this.x4 = 0;
            this.x6 = 0;
            this.x8 = 0;
            this.x7 = 0;
            this.x5 = 0;
            this.xj = 0;
            this.xk = 0;
            this.xl = 0;
            this.xi = 0;
            this.yg = 0;
            this.yf = 0;
            this.wv = null;
            this.yj = 0;
            this.xb = false;
            this._itemIndexes = null;
            this.ww = null;
            this.wt = null;
            this.w5 = null;
            this.ab = HighDensityScatterSeries.$;
            this.f7 = false;
        }
        get_fv() {
            return true;
        }
        get w7() {
            return this.w6;
        }
        set w7(a) {
            if (this.w6 != a) {
                let b = this.w7;
                this.w6 = a;
                this.raisePropertyChanged("XColumn", b, this.w7);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.km(c);
            let e = d == null ? NaN : this.iw(d, "XMemberPath");
            let f = d == null ? NaN : this.iw(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.l = e;
            g.a = 13;
            g.q = "X";
            g.r = this.y3 != null ? this.y3 : "X";
            g.s = this.yz != null ? this.yz : "X:";
            g.t = this.y1 != null ? this.y1 : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.q = "Y";
            h.r = this.zb != null ? this.zb : "Y";
            h.s = this.y7 != null ? this.y7 : "Y:";
            h.t = this.y9 != null ? this.y9 : "";
            let i = new DataLegendSeriesContext();
            i.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.h = this.mb();
            return i;
        }
        kp(a, b) {
            let c = this.nc(b);
            if (c == HighDensityScatterSeries.$$p[10]) {
                return this.kq(a, b, this.y3);
            }
            if (c == HighDensityScatterSeries.$$p[14]) {
                return this.kq(a, b, this.zb);
            }
            return super.kp(a, b);
        }
        mc(a) {
            let b = this.nc(a);
            if (b == HighDensityScatterSeries.$$p[10]) {
                return this.y3;
            }
            if (b == HighDensityScatterSeries.$$p[14]) {
                return this.zb;
            }
            return super.mc(a);
        }
        get w9() {
            return this.w8;
        }
        set w9(a) {
            if (this.w8 != a) {
                let b = this.w9;
                this.w8 = a;
                this.raisePropertyChanged("YColumn", b, this.w9);
            }
        }
        zq() {
            if (this.wy == null) {
                return;
            }
            this.wy.s();
            let a = this.wy;
            a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.zd));
            this.wy = null;
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            switch (b) {
                case HighDensityScatterSeries.$$p[8]:
                case HighDensityScatterSeries.$$p[12]:
                case HighDensityScatterSeries.$$p[9]:
                case HighDensityScatterSeries.$$p[13]:
                    this.qd();
                    break;
                case "SeriesViewer":
                    if (this.da != null) {
                        let e = this.getEffectiveViewport1(this.cu);
                        this.xb = !e.isEmpty;
                    }
                    break;
                case "FastItemsSource":
                    this.zq();
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.w7);
                        c.deregisterColumn(this.w9);
                        this.w7 = null;
                        this.w9 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.w7 = this.dj(this.y3);
                        this.w9 = this.dj(this.zb);
                    }
                    if ((this.w2 != null && !this.w2.c1()) || (this.w0 != null && !this.w0.c1())) {
                        this.rp(this.gf && c != null);
                    }
                    this.qk();
                    break;
                case HighDensityScatterSeries.$$p[7]:
                    let f = this.wz;
                    this.wz = this.w0;
                    this.zq();
                    if (f != null) {
                        f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.zg));
                    }
                    if (this.wz != null) {
                        let g = this.wz;
                        g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.zg));
                    }
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    if ((this.w0 != null && !this.w0.c1()) || (d == null && c != null)) {
                        this.rp(false);
                    }
                    break;
                case HighDensityScatterSeries.$$p[11]:
                    let h = this.w1;
                    this.w1 = this.w2;
                    this.zq();
                    if (h != null) {
                        h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.zg));
                    }
                    if (this.w1 != null) {
                        let i = this.w1;
                        i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.zg));
                    }
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    if ((this.w2 != null && !this.w2.c1()) || (d == null && c != null)) {
                        this.rp(false);
                    }
                    break;
                case "MouseOverEnabled":
                    this.xc = this.f7;
                    this.rp(false);
                    break;
                case HighDensityScatterSeries.$$p[10]:
                    if (this.dm != null) {
                        this.dm.deregisterColumn(this.w7);
                        this.w7 = this.dj(this.y3);
                    }
                    break;
                case "XColumn":
                    this.zq();
                    if (this.w0 != null && !this.w0.c1()) {
                        this.rp(false);
                    }
                    this.qk();
                    break;
                case HighDensityScatterSeries.$$p[14]:
                    if (this.dm != null) {
                        this.dm.deregisterColumn(this.w9);
                        this.w9 = this.dj(this.zb);
                    }
                    break;
                case "YColumn":
                    this.zq();
                    if (this.w2 != null && !this.w2.c1()) {
                        this.rp(false);
                    }
                    this.qk();
                    break;
                case HighDensityScatterSeries.$$p[6]:
                    this.zq();
                    this.rp(false);
                    this.qj();
                    break;
                case HighDensityScatterSeries.$$p[3]:
                    this.rp(false);
                    this.qj();
                    break;
                case HighDensityScatterSeries.$$p[1]:
                    this.rp(false);
                    this.qj();
                    break;
                case HighDensityScatterSeries.$$p[0]:
                case HighDensityScatterSeries.$$p[2]:
                    if (!this.wx.b4(this.z9, this.z8)) {
                        return;
                    }
                    this.zk();
                    this.rp(false);
                    this.qj();
                    break;
                case HighDensityScatterSeries.$$p[4]:
                    this.yh = Math.max(typeGetValue(d) - 1, 0);
                    this.xa = this.yh > 0;
                    this.rp(false);
                    this.qj();
                    break;
                case HighDensityScatterSeries.$$p[5]:
                    this.rp(false);
                    this.qj();
                    break;
            }
        }
        zk() {
            this.xt = this.z9.l;
            this.xw = this.z9.o;
            this.xv = this.z9.n;
            this.xu = this.z9.m;
            this.xp = this.z8.l;
            this.xs = this.z8.o;
            this.xr = this.z8.n;
            this.xq = this.z8.m;
            this.vr = BrushUtil.h(truncate(this.xt), truncate(this.xw), truncate(this.xv), truncate(this.xu));
            this.vb = BrushUtil.h(truncate(this.xp), truncate(this.xs), truncate(this.xr), truncate(this.xq));
        }
        xe(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        xd(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        zg(a, b) {
            this.zq();
            this.rp(false);
        }
        get x0() {
            return this.xs - this.xw;
        }
        get xz() {
            return this.xr - this.xv;
        }
        get xy() {
            return this.xq - this.xu;
        }
        get xx() {
            return this.xp - this.xt;
        }
        hd(a, b, c) {
            let d = super.hd(a, b, c);
            if (this.w2 == null || this.w0 == null || this.w0.bi == null || this.w2.bi == null || this.w9 == null || this.w7 == null || this.w9.count < 1 || this.w7.count < 1 || this.w9.count != this.w7.count || this.w0.l2 == this.w0.l1 || this.w2.l2 == this.w2.l1 || this.wo.isEmpty) {
                d = false;
            }
            return d;
        }
        get yo() {
            return this.yi;
        }
        set yo(a) {
            let b = this.yi;
            this.yi = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.yi);
        }
        rq(a) {
            super.rq(a);
            this.zi(a, this.cu);
        }
        zi(a, b) {
            if (this.d4(b)) {
                return;
            }
            if (this.wy == null && !this.xg) {
                let c = new List$1(KDPointData.$, 2, this.w7.count);
                let d = this.w0;
                let e = this.w2;
                let f = new Rect(0, 0, 0, 1, 1);
                let g = new Rect(0, 0, 0, 1, 1);
                let h = new ScalerParams(1, f, g, d.ch);
                let i = new ScalerParams(1, f, g, e.ch);
                let j;
                let k;
                for (let l = 0; l < this.w7.count; l++) {
                    j = d.ek(this.w7.item(l), h);
                    k = e.ek(this.w9.item(l), i);
                    if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k)) {
                        c.add(((() => {
                            let $ret = new KDPointData();
                            $ret.a = j;
                            $ret.b = k;
                            $ret.c = l;
                            return $ret;
                        })()));
                    }
                }
                if (this.xf) {
                    this.yd = 1;
                    this.ye = truncate(logBase(c.count, 2)) + 3;
                    this.yo = truncate(((this.yd / this.ye) * 100));
                    if (this.progressiveLoadStatusChanged != null) {
                        this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.yo));
                    }
                    this.wy = KDTree2D.b(c.toArray(), 1);
                    let m = this.wy;
                    m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.zd));
                    if (!this.wy.f(this.jy)) {
                        let n = this.wy;
                        n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.zd));
                    }
                    this.qj();
                }
                else {
                    let o = dateNow();
                    this.wy = new KDTree2D(0, c.toArray(), 1);
                    let p = dateNow();
                }
            }
            if (this.xf && !this.xg) {
                this.zj(b);
            }
            else {
                this.zl(b);
            }
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            this.zq();
            let e = false;
            if (this.w0 != null && !this.w0.c1()) {
                e = true;
            }
            if (this.w2 != null && !this.w2.c1()) {
                e = true;
            }
            if (e) {
                this.rp(false);
            }
            this.qk();
        }
        zf(a) {
            let b = a;
            let c = this.yg * this.yf;
            if (this.xc) {
                if (this._itemIndexes == null || this._itemIndexes.length != c) {
                    this._itemIndexes = new Array(c);
                    for (let d = 0; d < c; d++) {
                        this._itemIndexes[d] = 0;
                    }
                }
                else {
                    for (let e = 0; e < c; e++) {
                        this._itemIndexes[e] = 0;
                    }
                }
            }
        }
        zl(a) {
            let b;
            let c;
            let d = null;
            if (a.q) {
                d = this._itemIndexes;
            }
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            let f = a;
            let g = this.getEffectiveViewport1(a);
            this.w3 = new ScalerParams(0, b, c, this.wz.ch, g);
            this.w4 = new ScalerParams(0, b, c, this.w1.ch, g);
            this.ze(a);
            this.zf(a);
            let h = this.yg * this.yf;
            if (this.ww == null || this.ww.length != h) {
                this.ww = new Array(h);
                this.wt = new Array(h);
            }
            let i = this.ww.length;
            let j = this.ww;
            let k = this.wt;
            for (let l = 0; l < i; l++) {
                j[l] = 0;
                k[l] = 0;
            }
            this.yk = truncate(Math.round(this.ic));
            this.wv = f.b1();
            let m = this.wv.length;
            let n = this.wv;
            for (let o = 0; o < m; o++) {
                n[o] = 0;
            }
            let p = this.yb;
            let q = this.ya;
            if (isNaN_(p) || isInfinity(p)) {
                p = 0;
            }
            if (isNaN_(q) || isInfinity(q)) {
                q = 50;
            }
            this.xn = Math.min(p, q);
            this.xm = Math.max(p, q);
            if (this.xn < 0) {
                this.xn = 0;
            }
            if (this.xm < 0) {
                this.xm = 0;
            }
            this.xo = this.xm - this.xn;
            if (this.xg) {
                this.zh(a);
            }
            else {
                this.zs(a);
            }
            f.cc();
            if (a.q) {
                this._itemIndexes = d;
                this.wx.cd();
            }
        }
        zj(a) {
            if (this.wy == null) {
                return;
            }
            this.zl(a);
        }
        zd(a, b) {
            this.wx.cb(() => {
                if (this.yd < this.ye - 1) {
                    this.yd++;
                }
                this.yo = truncate(((this.yd / this.ye) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.yo));
                }
                this.zj(this.cu);
                this.qj();
                if (this.wy != null) {
                    if (!this.wy.f(this.jy)) {
                        let c = this.wy;
                        c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(this, this.zd));
                        this.yo = 100;
                        if (this.progressiveLoadStatusChanged != null) {
                            this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.yo));
                        }
                    }
                }
            });
        }
        zh(a) {
            let b = arrayShallowClone(this.w7.asArray());
            this.w0.ho(boxArray$1(b), 0, b.length, this.w3);
            let c = arrayShallowClone(this.w9.asArray());
            this.yj = 0;
            let d = this.yh;
            let e = this.xa;
            let f = this.ww.length;
            this.w2.ho(boxArray$1(c), 0, c.length, this.w4);
            let g = 255 << 24 | truncate(this.xw) << 16 | truncate(this.xv) << 8 | truncate(this.xu);
            for (let h = 0; h < b.length; h++) {
                let i = truncate(b[h]);
                let j = truncate(c[h]);
                i = truncate(Math.floor(i));
                j = truncate(Math.floor(j));
                if (i < 0 || i >= this.yg || j < 0 || j >= this.yf) {
                    continue;
                }
                if (e) {
                    let k = i - d;
                    let l = i + d;
                    l = l > (this.yg - 1) ? (this.yg - 1) : l;
                    k = k < 0 ? 0 : k;
                    let m = j + d;
                    let n = j - d;
                    for (let o = k; o <= l; o++) {
                        for (let p = n; p <= m; p++) {
                            let q = (p * this.yg) + o;
                            if (q < 0 || q > f - 1) {
                                continue;
                            }
                            this.ww[q] = this.ww[q] + 1;
                            this.wt[q] = 1;
                            this.yj++;
                            if (this.xc) {
                                this._itemIndexes[q] = h + 1;
                            }
                        }
                    }
                }
                else {
                    let r = (j * this.yg) + i;
                    this.ww[r] = this.ww[r] + 1;
                    this.wt[r] = 1;
                    this.yj++;
                    if (this.xc) {
                        this._itemIndexes[r] = h + 1;
                    }
                }
            }
            this.zm();
        }
        zs(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.wy == null) {
                return;
            }
            if (this.xh == null) {
                this.xh = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
            }
            else {
                this.xh.clear();
            }
            let e = c.left;
            let f = c.right;
            let g = c.top;
            let h = c.bottom;
            this.x7 = c.top;
            this.x5 = c.height;
            this.x6 = c.left;
            this.x8 = c.width;
            this.x3 = b.top;
            this.x1 = b.height;
            this.x2 = b.left;
            this.x4 = b.width;
            let i = this.getEffectiveViewport1(a);
            this.xj = (i.left - this.x2) / this.x4;
            this.xk = (i.top - this.x3) / this.x1;
            let j = (i.right - this.x2) / this.x4;
            this.xl = j - this.xj;
            let k = (i.bottom - this.x3) / this.x1;
            this.xi = k - this.xk;
            if (this.xb) {
                e = (e - this.xj) / this.xl;
                f = (f - this.xj) / this.xl;
                g = (g - this.xk) / this.xi;
                h = (h - this.xk) / this.xi;
            }
            let l = this.ic / b.width * c.width;
            let m = this.ic / b.height * c.height;
            let n = Math.min(l, m);
            let o = ((() => {
                let $ret = new SearchArgs();
                $ret.c = e;
                $ret.a = f;
                $ret.d = g;
                $ret.b = h;
                $ret.e = l;
                $ret.f = m;
                $ret.g = 0x7FFFFFFF;
                return $ret;
            })());
            this.wy.t(this.xh, o, 0, 1, 0, 1);
            let p;
            this.yj = 0;
            for (let q = 0; q < this.xh.count; q++) {
                p = this.xh._inner[q];
                this.zn(p);
            }
            this.zm();
        }
        zn(a) {
            if (a.g) {
                return;
            }
            let b = a.e != null && a.e.a;
            let c = a.a == null ? 0 : a.a.length;
            let d = (a.h - c) + 1;
            if (b && d > 0) {
            }
            else {
                d = 1;
            }
            this.zp(a.b, d, b, a.e);
            if (c > 0 && !b) {
                let e;
                for (let f = 0; f < c; f++) {
                    e = a.a[f];
                    this.zp(e, d, false, a.e);
                }
            }
            if (a.e != null) {
                a.e.a = false;
            }
        }
        gc(a) {
            let b = this.da != null ? this.da.vx : Rect.empty;
            let c = this.da != null ? this.da.wc : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.wh(this.cu);
            let f = new ScalerParams(0, d, d, this.w0.ch, e);
            let g = new ScalerParams(0, d, d, this.w2.ch, e);
            let h = !b.isEmpty && !c.isEmpty && this.dm != null ? this.dm.indexOf(a) : -1;
            let i = this.w0 != null && this.w7 != null && h < this.w7.count ? this.w0.ek(this.w7.item(h), f) : NaN;
            let j = this.w2 != null && this.w9 != null && h < this.w9.count ? this.w2.ek(this.w9.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.c2 != null) {
                this.c2.au(this.da, b, true);
            }
            return h >= 0;
        }
        zp(a, b, c, d) {
            let e = this.ym(b);
            let f = a.c;
            let g = this.yh;
            if (c) {
                let h = d.d;
                let i = d.b;
                let j = d.e;
                let k = d.c;
                if (this.xb) {
                    h = this.xj + this.xl * h;
                    i = this.xj + this.xl * i;
                    j = this.xk + this.xi * j;
                    k = this.xk + this.xi * k;
                }
                let l = truncate((this.x2 + this.x4 * (h - this.x6) / this.x8));
                let m = truncate((this.x2 + this.x4 * (i - this.x6) / this.x8));
                let n = truncate((this.x3 + this.x1 * (j - this.x7) / this.x5));
                let o = truncate((this.x3 + this.x1 * (k - this.x7) / this.x5));
                l = truncate(Math.floor(l));
                m = truncate(Math.floor(m));
                n = truncate(Math.floor(n));
                o = truncate(Math.floor(o));
                if (this.xa) {
                    l -= g;
                    m += g;
                    n -= g;
                    o += g;
                }
                let p = ((m - l) + 1) * ((o - n) + 1);
                let q = b / p;
                let r = q;
                for (let s = l; s <= m; s++) {
                    for (let t = n; t <= o; t++) {
                        this.zo(f, s, t, q, r);
                    }
                }
            }
            else {
                let u = a.a;
                let v = a.b;
                if (this.xb) {
                    u = this.xj + this.xl * u;
                    v = this.xk + this.xi * v;
                }
                let w = truncate((this.x2 + this.x4 * (u - this.x6) / this.x8));
                let x = truncate((this.x3 + this.x1 * (v - this.x7) / this.x5));
                w = truncate(Math.floor(w));
                x = truncate(Math.floor(x));
                if (this.xa) {
                    let y = w - g;
                    let z = w + g;
                    let aa = x + g;
                    let ab = x - g;
                    let ac = ((z - y) + 1) * ((aa - ab) + 1);
                    let ad = b / ac;
                    let ae = ad;
                    for (let af = y; af <= z; af++) {
                        for (let ag = ab; ag <= aa; ag++) {
                            this.zo(f, af, ag, ad, ae);
                        }
                    }
                }
                else {
                    this.zo(f, w, x, b, 1);
                }
            }
        }
        yl(a, b) {
            return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.xw + a * this.x0))) << 16 | truncate(Math.floor(b * (this.xv + a * this.xz))) << 8 | truncate(Math.floor(b * (this.xu + a * this.xy)));
        }
        ym(a) {
            return 255 << 24 | truncate(Math.floor((this.xw + a * this.x0))) << 16 | truncate(Math.floor((this.xv + a * this.xz))) << 8 | truncate(Math.floor((this.xu + a * this.xy)));
        }
        x9(a) {
            return (a >> 24 & 255) / 255;
        }
        zo(a, b, c, d, e) {
            if (b < 0 || b >= this.yg || c < 0 || c >= this.yf) {
                return;
            }
            let f = (c * this.yg) + b;
            this.ww[f] = this.ww[f] + d;
            this.wt[f] = this.wt[f] + e;
            if (this.xc) {
                this._itemIndexes[f] = a + 1;
            }
            this.yj += truncate(d);
        }
        zm() {
            let a = 0;
            let b = 0;
            let c = this.xo;
            let d = this.xn;
            let e = this.xm;
            let f = this.ww.length;
            let g = this.ww;
            let h = this.wt;
            let i = this.wv;
            let j = NaN;
            let k = NaN;
            let l = 0;
            let m = 0;
            for (let n = 0; n < f; n++) {
                a = g[n];
                if (a != 0) {
                    b = h[n];
                    if (a >= e) {
                        a = 1;
                    }
                    else if (a <= d) {
                        a = 0;
                    }
                    else {
                        a = (a - d) / (c);
                    }
                    if (b > 1) {
                        b = 1;
                    }
                    if (b < 0.2) {
                        b = 0.2;
                    }
                    if (j != a || k != b) {
                        l = this.yl(a, b);
                        j = a;
                        k = b;
                    }
                    i[m] = l >> 16 & 255;
                    i[m + 1] = l >> 8 & 255;
                    i[m + 2] = l & 255;
                    i[m + 3] = l >> 24 & 255;
                }
                m += 4;
            }
        }
        ze(a) {
            let b = a;
            b.b9();
        }
        cr() {
            return new HighDensityScatterSeriesView(this);
        }
        qz(a) {
            super.qz(a);
            this.wx = a;
        }
        ay(a) {
            if (a != null && a == this.w0 && this.w7 != null) {
                return new AxisRange(this.w7.minimum, this.w7.maximum);
            }
            if (a != null && a == this.w2 && this.w9 != null) {
                return new AxisRange(this.w9.minimum, this.w9.maximum);
            }
            return null;
        }
        sm(a, b) {
            if (this.da != null) {
                let c = this.getEffectiveViewport1(this.cu);
                this.xb = !c.isEmpty;
            }
            this.rp(false);
        }
        sn(a, b) {
            this.rp(false);
        }
        km(a) {
            if (!this.xc || this._itemIndexes == null || this.da == null || this.dm == null || this._itemIndexes.length != (this.yg * this.yf)) {
                return null;
            }
            let b = this.da.vx;
            let c = (a.x - b.left) / b.width;
            let d = (a.y - b.top) / b.height;
            let e = truncate(Math.round(this.wo.left + (this.wo.width * c)));
            let f = truncate(Math.round(this.wo.top + (this.wo.height * d)));
            let g = this.yp(e, f);
            if (g < 0 || g > this._itemIndexes.length - 1) {
                return null;
            }
            let h = this._itemIndexes[g] - 1;
            if (h < 0 || h > this.dm.count) {
                return null;
            }
            return this.dm.item(h);
        }
        yp(a, b) {
            let c = (this.yg * b) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            let d = 1;
            c = (this.yg * (b - d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b + d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b - d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b + d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b - d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.yg * (b + d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            return 0;
        }
        zr(a, b, c) {
            this.wv = a;
            this.yg = b;
            this.yf = c;
        }
        get_g6() {
            return true;
        }
        set_g6(a) {
            super.set_g6(a);
        }
        o4(a, b) {
            super.o4(a, b);
            this.wx.ca();
            if (this.ct != null) {
                this.ct.ca();
            }
            this.qj();
        }
        rr(a, b) {
            super.rr(a, b);
            if (!this.gz) {
                this.cu.a4(b);
                return;
            }
            this.cu.a4(b);
            if (this.d4(this.ct)) {
                return;
            }
            let c = typeCast(HighDensityScatterSeriesView.$, this.ct);
            let d = new ScatterFrame();
            this.zi(false, c);
            this.gz = false;
        }
        ro(a, b, c, d, e) {
            super.ro(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            let g = f;
            f.a3(c);
            if (this.d4(g)) {
                return;
            }
            if (this.w5 == null) {
                this.w5 = new ScatterFrame();
            }
            this.zi(false, f);
        }
        o1() {
            super.o1();
            this.w0 = null;
            this.w2 = null;
        }
    }
    HighDensityScatterSeries.$t = /*@__PURE__*/ markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    HighDensityScatterSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:z8:zt', [Color.$, Defaults.ap], 'HeatMaximum:ya:zu', [1, 50], 'HeatMinimumColor:z9:zv', [Color.$, Defaults.aq], 'HeatMinimum:yb:zw', [1, 0], 'PointExtent:yn:zx', [1, 1], 'ProgressiveLoad:xf:zy', [0, true], 'UseBruteForce:xg:zz', [0, false], 'XAxis:w0:z0', [NumericXAxis.$, null], 'XMemberAsLegendLabel:yz:z1', [2, null], 'XMemberAsLegendUnit:y1:z2', [2, null], 'XMemberPath:y3:z3', [2, null], 'YAxis:w2:z4', [NumericYAxis.$, null], 'YMemberAsLegendLabel:y7:z5', [2, null], 'YMemberAsLegendUnit:y9:z6', [2, null], 'YMemberPath:zb:z7', [2, null]]);
    return HighDensityScatterSeries;
})();
/**
 * @hidden
 */
export let HighDensityScatterSeriesView = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b2 = null;
            this.b0 = null;
            this.b8 = 0;
            this.b7 = 0;
            this.b5 = null;
            this.b6 = null;
            this.b3 = null;
            this.b2 = a;
        }
        au() {
            super.au();
            if (!this.q) {
                this.b2.z9 = Defaults.aq;
                this.b2.z8 = Defaults.ap;
                this.b2.vb = Defaults.al;
                this.b2.vr = Defaults.ak;
            }
        }
        cd() {
            this.b2.zr(this.b0, this.b8, this.b7);
        }
        b9() {
            if (this.b5 == null) {
                this.b5 = this.e.jy.createElement("canvas");
                let a = this.e.jy.get2DCanvasContext(this.b5);
                this.b3 = new RenderingContext(new CanvasViewRenderer(), a);
            }
            let b;
            if (this.p) {
                b = this.bx;
            }
            else {
                b = this.e.da.v2();
            }
            let c = truncate(Math.round(b.left));
            let d = truncate(Math.round(b.top));
            let e = truncate(Math.round(b.width));
            let f = truncate(Math.round(b.height));
            let g = this.b8;
            let h = this.b7;
            this.b8 = e;
            this.b7 = f;
            if (g != this.b8 || h != this.b7 || this.b0 == null) {
                this.b5.setAttribute("width", e.toString());
                this.b5.setAttribute("height", f.toString());
                this.b6 = this.b3.h().getImageData(0, 0, e, f);
                let imageDataArray_ = this.b6.data;
                this.b0 = imageDataArray_;
            }
            this.b2.zr(this.b0, this.b8, this.b7);
        }
        b1() {
            return this.b0;
        }
        cc() {
            let a = truncate(Math.round(this.bx.left));
            let b = truncate(Math.round(this.bx.left));
            let c = truncate(Math.round(this.bx.width));
            let d = truncate(Math.round(this.bx.height));
            this.b3.h().putImageData(this.b6, 0, 0);
            this.as();
        }
        cb(a) {
            if (this.e.jy != null) {
                this.e.jy.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        a8(a, b) {
            super.a8(a, b);
            if (b) {
                if (!this.b2.f7) {
                    return;
                }
                let c = new Rectangle();
                c.n = this.bx.left;
                c.o = this.bx.top;
                c.width = this.bx.width;
                c.height = this.bx.height;
                c._fill = this.br();
                a.w(c);
                return;
            }
            if (this.b5 == null) {
                return;
            }
            let d = truncate(Math.round(this.bx.left));
            let e = truncate(Math.round(this.bx.top));
            let f = truncate(Math.round(this.bx.width));
            let g = truncate(Math.round(this.bx.height));
            this.k.o(this.b5.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
        }
        b4(a, b) {
            return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
        }
        ca() {
            if (this.b0 != null) {
                for (let a = 0; a < this.b0.length; a++) {
                    this.b0[a] = 0;
                }
                this.cc();
            }
        }
        an(a) {
            super.an(a);
            if (this.b0 == null) {
                this.e.bc.exportSeriesPixelsData(a, null, this.b8, this.b7);
                return;
            }
            let b = new Array(intDivide(this.b0.length, 4));
            let c;
            for (let d = 0; d < intDivide(this.b0.length, 4); d++) {
                c = d * 4;
                b[d] = this.b0[c + 3] << 24 | this.b0[c] << 16 | this.b0[c + 1] << 8 | this.b0[c + 2];
            }
            this.e.bc.exportSeriesPixelsData(a, b, this.b8, this.b7);
        }
    }
    HighDensityScatterSeriesView.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
})();
