/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType, markDep } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Axis } from "./Axis";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { TrendLineType_$type } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let HorizontalAnchoredCategorySeries = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.acc = null;
            this.ab8 = null;
            this.ace = null;
            this.aca = 0;
        }
        get acd() {
            if (this.acc == null) {
                this.acc = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, () => this.dq.n);
            }
            return this.acc;
        }
        o1() {
            super.o1();
            this.xAxis = null;
            this.yAxis = null;
        }
        cj() {
            return 1;
        }
        ck() {
            if (this.yAxis != null && this.yAxis.ch) {
                return 4;
            }
            return 3;
        }
        b1() {
            if (this.b2 == 0) {
                return 1;
            }
            else {
                return super.b1();
            }
        }
        yn() {
            return this.ab8;
        }
        y4() {
            return this.ace;
        }
        wl(a) {
            if (this.yp == null || this.yp.n.count == 0 || !this.hasMarkers || !this.xb()) {
                return Rect.empty;
            }
            return this.acd.d$d(this, this.yp.n, a, runOn(this, this.acq));
        }
        acq(a) {
            return this.aaq.de(a);
        }
        aci(a, b, c) {
            return this.acd.d$c(this, this.y4(), a, b, c);
        }
        aj(a) {
            return this.acd.d$a(this, this.yp.f, this.zq(this.cu), this.zr(this.cu), a);
        }
        al(a) {
            return this.acd.d$b(this, this.yp.f, this.zq(this.cu), this.zr(this.cu), a);
        }
        gv(a, b) {
            if (this.gu(a, b)) {
                return true;
            }
            if (this.xc(a, b)) {
                return true;
            }
            return false;
        }
        getOffsetValue() {
            return this.yu.r(this.yn(), this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
        }
        getCategoryWidth() {
            let a = this.getEffectiveViewport1(this.cu);
            return this.yn().getCategorySize(this.cu.by, this.cu.bx, a);
        }
        i4(a, b, c) {
            if (this.da == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.cu);
            let e = this.yn();
            if (e == null) {
                return NaN;
            }
            let f = new ScalerParams(0, this.da.vx, this.cu.bx, e.ch, d);
            let g = this.yu.r(e, this.da.vx, this.cu.bx, d);
            return this.i6(this.valueColumn, a, e, f, g, runOn(this, this.zo), b, c);
        }
        j9(a, b) {
            return this.ka(a, b, this.yn(), runOn(this, this.zo), this.valueColumn);
        }
        j7(a, b) {
            return this.j8(a, b, this.yn(), runOn(this, this.zo), this.valueColumn);
        }
        io(a, b, c, d, e) {
            if (this.valueColumn == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.ip(a, b, this.yn(), d, e, this.valueColumn.count, runOn(this, this.zo));
        }
        v8(a, b, c) {
            if (this.yn() == null || this.y4() == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            return this.wa(a, b, c, this.yu.r(this.yn(), this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.y4(), this.yn(), null, null, null);
        }
        fetchXAxis() {
            return this.ab8;
        }
        fetchYAxis() {
            return this.ace;
        }
        abm(a) {
            this.xAxis = typeCast(CategoryAxisBase.$, a);
        }
        abn(a) {
            this.yAxis = typeCast(NumericYAxis.$, a);
        }
        zk() {
            return this.ace != null && this.ace.c1();
        }
        acm(a) {
            this.ab8 = a;
        }
        acn(a) {
            this.ace = a;
        }
        yh(a, b) {
            return this.aan(a, b, this.ab8);
        }
        q7(a, b, c, d) {
            switch (b) {
                case HorizontalAnchoredCategorySeries.$$p[0]:
                    this.acm(this.xAxis);
                    if (this.aaq.c8) {
                        this.aaq.c7 = CategoryTrendLineManagerFactory.a(this.aaq.c7, this.ab8, this.sr, this, this.dq);
                    }
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.aaq.c7 = CategoryTrendLineManagerFactory.a(this.aaq.c7, this.ab8, this.sr, this, this.dq);
                    }
                    break;
            }
            super.q7(a, b, c, d);
            switch (b) {
                case HorizontalAnchoredCategorySeries.$$p[0]:
                    if (c != d) {
                        this.pb(typeCast(Axis.$, c));
                        this.rf(typeCast(Axis.$, d));
                        this.acm(this.xAxis);
                        this.yy.cw.g(this.ic);
                        this.rp(false);
                        this.qj();
                    }
                    break;
                case HorizontalAnchoredCategorySeries.$$p[1]:
                    if (c != d) {
                        this.pb(typeCast(Axis.$, c));
                        this.rf(typeCast(Axis.$, d));
                        this.acn(this.yAxis);
                        if (this.da != null) {
                            this.da.nx();
                        }
                        this.yy.cw.g(this.ic);
                        this.zk();
                        this.rp(false);
                        this.qj();
                    }
                    break;
                case "CategoryMode":
                    if (this.xAxis != null) {
                        this.xAxis.l8(true);
                    }
                    break;
            }
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            if (this.ab8 != null && typeCast(ISortingAxis_$type, this.ab8) !== null) {
                this.ab8.i$i();
            }
            switch (a) {
                case 4:
                    if (this.ab8 != null) {
                        this.ab8.c1();
                    }
                    if (this.ace != null && !this.ace.c1()) {
                        this.rp(true);
                    }
                    break;
                case 1:
                    if (this.ab8 != null) {
                        this.ab8.c1();
                    }
                    if (this.ace != null && !this.ace.c1()) {
                        this.rp(true);
                    }
                    break;
                case 0:
                    if (this.ab8 != null) {
                        this.ab8.c1();
                    }
                    if (this.ace != null && !this.ace.c1()) {
                        this.rp(true);
                    }
                    break;
                case 2:
                    if (this.aa8 != null && this.aaq.cw.d > 0 && this.ace != null && !this.ace.c1()) {
                        this.rp(true);
                    }
                    break;
                case 3:
                    if (d == this.aa8) {
                        if (this.ab8 != null) {
                            this.ab8.c1();
                        }
                        if (this.ace != null && !this.ace.c1()) {
                            this.rp(true);
                        }
                    }
                    break;
            }
        }
        acg(a) {
            if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
                return true;
            }
            return false;
        }
        ach(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        get acb() {
            return this.aca;
        }
        set acb(a) {
            let b = this.acb;
            if (a != b) {
                this.aca = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.acb));
            }
        }
        get useHighMarkerFidelity() {
            return this.zl;
        }
    }
    HorizontalAnchoredCategorySeries.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    HorizontalAnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::aco', [CategoryAxisBase.$, null], 'YAxis::acp', [NumericYAxis.$, null]]);
    return HorizontalAnchoredCategorySeries;
})();
