/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { ICoalescingModerator_$type } from "./ICoalescingModerator";
import { DependencyProperty } from "igniteui-react-core";
import { OthersCategoryType_$type } from "igniteui-react-core";
import { typeCast, Number_$type, enumGetBox, Boolean_$type, markType, markDep } from "igniteui-react-core";
import { OthersCategoryContext } from "./OthersCategoryContext";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { SeriesViewer } from "./SeriesViewer";
import { List$1 } from "igniteui-react-core";
import { CoreGeometryUtil } from "igniteui-react-core";
import { ArrayExtension } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
/**
 * @hidden
 */
export let ProportionalCategoryAngleAxis = /*@__PURE__*/ (() => {
    class ProportionalCategoryAngleAxis extends CategoryAngleAxis {
        constructor() {
            super(...arguments);
            this.ob = null;
            this.nx = null;
            this.n1 = true;
            this.n6 = NaN;
            this.n4 = new List$1(Number_$type, 0);
            this.n3 = new List$1(Number_$type, 0);
            this.n2 = new List$1(Boolean_$type, 0);
            this.n0 = false;
            this.n5 = NaN;
            this.oa = -1;
        }
        get oi() {
            return this.ob;
        }
        set oi(a) {
            let b = this.oi;
            if (a != b) {
                this.ob = a;
                this.h3("ValueMemberPath", b, this.oi);
            }
        }
        fy(a, b) {
            let c = this.gt(b);
            if (this.hasOthersCategory && c == "Label") {
                if (typeCast(OthersCategoryContext.$, a) !== null) {
                    return this.og();
                }
            }
            return super.fy(a, b);
        }
        get normalizationMayContainUnknowns() {
            return this.nz == null || this.nz.mayContainUnknowns;
        }
        get nz() {
            return this.nx;
        }
        set nz(a) {
            if (this.nx != a) {
                let b = this.nx;
                this.nx = a;
                this.h3("ValueColumn", b, this.nx);
            }
        }
        ny(a) {
            if (a == null) {
                return this.kt.registerColumn(null, null, false);
            }
            let b = null;
            let c = SeriesViewer.cu(a, this.coercionMethods);
            b = c.a;
            return this.kt.registerColumn(a, b, this.expectFunctions);
        }
        hx(a, b, c, d) {
            super.hx(a, b, c, d);
            switch (b) {
                case "ValueMemberPath":
                    if (this.kt != null) {
                        this.kt.deregisterColumn(this.nz);
                        this.nz = this.ny(this.oi);
                    }
                    break;
                case "ValueColumn":
                    this.n1 = true;
                    this.n0 = false;
                    this.h8();
                    break;
                case ProportionalCategoryAngleAxis.$$p[0]:
                case ProportionalCategoryAngleAxis.$$p[1]:
                case ProportionalCategoryAngleAxis.$$p[2]:
                    this.n1 = true;
                    this.n0 = false;
                    this.h8();
                    break;
                case "FastItemsSource":
                    this.n1 = true;
                    this.n0 = false;
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.nz);
                        this.nz = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.nz = this.ny(this.oi);
                    }
                    this.h8();
                    break;
            }
        }
        l5(a) {
            super.l5(a);
            this.n1 = true;
            this.n0 = false;
        }
        getScaledAngle(a) {
            this.ok();
            if (isNaN_(a) || isInfinity(a)) {
                return NaN;
            }
            let b = this.lh;
            let c = a % b;
            if (c < 0) {
                c = b + c;
            }
            let d = truncate(Math.floor(c));
            let e = this.n3._inner[d];
            let f = c - d;
            let g = 0;
            if (isNaN_(this.n4._inner[d])) {
                g = 0 * f;
            }
            else {
                g = this.n4._inner[d] * f;
            }
            let h = e + g;
            if (this.ci) {
                h = 1 - h;
            }
            let i = (h * 2 * Math.PI);
            if (a >= b) {
                i += (2 * Math.PI) * Math.floor(a / b);
            }
            if (a < 0) {
                i -= (2 * Math.PI) * Math.abs(Math.floor(a / b));
            }
            return i + this.m0;
        }
        get_cl() {
            return true;
        }
        m4(a, b, c, d, e) {
            let f = 0.5;
            if (this.lj > 1) {
                let g = this.ld(c, d, e);
                let h = 0;
                if (!isNaN_(this.lc)) {
                    h = Math.min(this.lc, 1);
                }
                let i = 1 - 0.5 * g;
                let j = i / (this.lj - (this.lj - 1) * h);
                let k = (i - j) / (this.lj - 1);
                f = 0.25 * g + 0.5 * j + a * k;
            }
            return this.n7(a, c, d, e) * f;
        }
        n7(a, b, c, d) {
            if (a < 0 || a > this.li - 1) {
                return this.getCategorySize(b, c, d);
            }
            this.ok();
            let e = this.n4._inner[a];
            if (isNaN_(e)) {
                return NaN;
            }
            let f = Math.PI * 2 * this.n4._inner[a];
            return f;
        }
        m5(a, b, c, d) {
            this.ok();
            let e = this.ld(b, c, d);
            let f = 0;
            if (!isNaN_(this.lc)) {
                f = Math.min(this.lc, 1);
            }
            let g = 1 - 0.5 * e;
            if (a < 0 || a > this.li - 1) {
                return this.k6(b, c, d);
            }
            let h = this.n4._inner[a];
            if (isNaN_(h)) {
                return NaN;
            }
            let i = Math.PI * 2 * h;
            return i * g / (this.lj - (this.lj - 1) * f);
        }
        lk() {
            if (this.kt == null) {
                return 0;
            }
            this.ok();
            if (this.n0) {
                return super.lk() + 1;
            }
            return super.lk();
        }
        mv(a) {
            return this.hasOthersCategory && a == this.li - 1;
        }
        ni() {
            return this.og();
        }
        mw(a) {
            if (a >= 0 && a < this.li) {
                if (isNaN_(this.n4._inner[a])) {
                    return true;
                }
            }
            return super.mw(a);
        }
        ia(a) {
            this.ok();
            super.ia(a);
        }
        ensureSum() {
            this.ok();
        }
        ok() {
            if (this.n1) {
                this.n1 = false;
                this.n0 = false;
                this.li = this.lk();
                this.n5 = NaN;
                this.oa = -1;
                if (this.nz != null && this.nz.count > 0) {
                    this.n6 = NaN;
                    let a = true;
                    for (let b = 0; b < this.nz.count; b++) {
                        let c = this.nz.item(b);
                        if (isNaN_(c) || isInfinity(c) || c < 0) {
                            continue;
                        }
                        if (a) {
                            a = false;
                            this.n6 = 0;
                        }
                        this.n6 += c;
                    }
                    let d = 0;
                    this.n4.clear();
                    this.n3.clear();
                    this.n2.clear();
                    let e = 0;
                    for (let f = 0; f < this.nz.count; f++) {
                        let g = 0;
                        if (isNaN_(this.n6)) {
                            g = 1 / this.li;
                        }
                        else {
                            let h = this.nz.item(f);
                            if (isNaN_(h) || isInfinity(h) || h < 0) {
                                g = 0;
                            }
                            else {
                                g = h;
                            }
                        }
                        let i = false;
                        if (this.nw == 0) {
                            if (g < this.n9) {
                                i = true;
                            }
                        }
                        else {
                            if ((g / this.n6) * 100 < this.n9) {
                                i = true;
                            }
                        }
                        if (i) {
                            this.n3.add(d);
                            this.n4.add(NaN);
                            this.n2.add(true);
                            e += g;
                        }
                        else {
                            this.n3.add(d);
                            this.n4.add(g / this.n6);
                            this.n2.add(false);
                            d += (g / this.n6);
                        }
                    }
                    if (e > 0) {
                        this.n0 = true;
                        this.n3.add(d);
                        this.n4.add(e / this.n6);
                        this.n2.add(false);
                        this.n5 = e;
                        this.oa = this.n3.count - 1;
                    }
                }
                else {
                    if (this.li > 0) {
                        this.n4.clear();
                        this.n3.clear();
                        let j = 0;
                        for (let k = 0; k < this.li; k++) {
                            this.n3.add(j);
                            this.n4.add(1 / this.li);
                            j += (1 / this.li);
                        }
                    }
                }
                this.li = this.lk();
            }
        }
        get othersValue() {
            return this.n5;
        }
        get othersIndex() {
            return this.oa;
        }
        get hasOthersCategory() {
            return this.n0;
        }
        ho(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.ek(a.item(e), d));
            }
        }
        getUnscaledAngle(a) {
            this.ok();
            if (isNaN_(a) || isInfinity(a)) {
                return NaN;
            }
            a = CoreGeometryUtil.b(a);
            while (a < this.m0) {
                a += 2 * Math.PI;
            }
            while (a > (this.m0 + (2 * Math.PI))) {
                a -= 2 * Math.PI;
            }
            let b = (a - this.m0) / (2 * Math.PI);
            if (this.ch) {
                b = 1 - b;
            }
            let c = -1;
            c = ArrayExtension.binarySearch$11(Number_$type, this.n3, (d) => b < d ? -1 : (b > d ? 1 : 0));
            if (c < 0) {
                c = ~c;
                c--;
            }
            if (c < 0) {
                c = 0;
            }
            if (c > this.n3.count - 1) {
                c = this.n3.count - 1;
            }
            let d = this.n3._inner[c];
            let e = this.n4._inner[c];
            if (isNaN_(e)) {
                b = c;
            }
            else {
                b = c + (b - d) / e;
            }
            return b;
        }
        isOthersValue(a) {
            if (a < 0 || a > this.n2.count - 1) {
                return false;
            }
            return this.n2._inner[a];
        }
        ge(a) {
            let b = a;
            if (this.categoryMode == 0) {
                b = truncate(Math.round(a));
            }
            else {
                b = truncate(Math.floor(a));
            }
            if (this.hasOthersCategory && b >= this.li - 1) {
                b = this.li - 1;
                return this.og();
            }
            return super.ge(a);
        }
        og() {
            if (this.oc != null) {
                return this.oc;
            }
            return "Others";
        }
        getNormalizingValueAtIndex(a, b) {
            if (a < 0 || this.nz == null || a > this.nz.count - 1) {
                return b;
            }
            return this.nz.item(a);
        }
        n8(a) {
            this.ok();
            let b = this.n4._inner[a] * 100;
            return b;
        }
        get isVertical() {
            return this.cp;
        }
        j$d(a, b) {
            return this.en.apply(this, arguments);
        }
        j$c(a, b) {
            return this.ek.apply(this, arguments);
        }
        j$e(a, b, c, d, e) {
            this.hn.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.ho.apply(this, arguments);
        }
        j$g(a, b, c, d) {
            this.hp.apply(this, arguments);
        }
        get j$b() {
            return this.ch;
        }
        j$a() {
            return this.ag.apply(this, arguments);
        }
        get itemsCount() {
            return this.li;
        }
    }
    ProportionalCategoryAngleAxis.$t = /*@__PURE__*/ markType(ProportionalCategoryAngleAxis, 'ProportionalCategoryAngleAxis', CategoryAngleAxis.$, [ICoalescingModerator_$type]);
    ProportionalCategoryAngleAxis.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ProportionalCategoryAngleAxis, 'h3', ['OthersCategoryText:oc:ol', [2, null], 'OthersCategoryThreshold:n9:om', [1, 3], 'OthersCategoryType:nw:on', [OthersCategoryType_$type, /*@__PURE__*/ enumGetBox(OthersCategoryType_$type, 1)]]);
    return ProportionalCategoryAngleAxis;
})();
