/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, typeCast, Point_$type, runOn, delegateCombine, enumGetBox, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { FastItemCoalescingColumn } from "./FastItemCoalescingColumn";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { RadialBaseView } from "./RadialBaseView";
import { ChartSelection } from "./ChartSelection";
import { CollisionRect } from "igniteui-react-core";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.c1.ab3;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f, 0];
        }
        return [0.5 * (c + d), NaN, NaN, 0];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.aby = null;
        _this.ab8 = false;
        _this.ab2 = null;
        _this.adj = { $type: Point_$type, x: 0, y: 0 };
        _this.ab0 = null;
        _this.abz = null;
        _this.ab4 = false;
        _this.ab0 = new RadialFrame(3);
        _this.aby = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.cr = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.o1 = function () {
        _super.prototype.o1.call(this);
        this.yu = null;
        this.y0 = null;
    };
    AnchoredRadialSeries.prototype.md = function () {
        return AnchoredRadialSeries.$$p[4];
    };
    AnchoredRadialSeries.prototype.kp = function (a, b) {
        var c = this.nc(b);
        if (c == AnchoredRadialSeries.$$p[4]) {
            return this.kq(a, b, this.acs);
        }
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.kq(a, b, this.ack);
        }
        return _super.prototype.kp.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.mc = function (a) {
        var b = this.nc(a);
        if (b == AnchoredRadialSeries.$$p[4]) {
            return this.acs;
        }
        if (b == AnchoredRadialSeries.$$p[0]) {
            return this.ack;
        }
        return _super.prototype.mc.call(this, a);
    };
    AnchoredRadialSeries.prototype.jb = function (a) {
        if (a == this.y2) {
            return this.z4(this.ab3.count - 1, this.ab3.item(this.ab3.count - 1));
        }
        return _super.prototype.jb.call(this, a);
    };
    AnchoredRadialSeries.prototype.ks = function (a) {
        if (this.yu != null && this.yu.cl) {
            if (a == this.yu.othersIndex) {
                return this.y2;
            }
        }
        return _super.prototype.ks.call(this, a);
    };
    AnchoredRadialSeries.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.abx = a;
    };
    AnchoredRadialSeries.prototype.j9 = function (a, b) {
        return this.ka(a, b, this.yu, null, this.ab3);
    };
    AnchoredRadialSeries.prototype.j7 = function (a, b) {
        return this.j8(a, b, this.yu, null, this.ab3);
    };
    AnchoredRadialSeries.prototype.io = function (a, b, c, d, e) {
        if (this.ab3 == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ip(a, b, this.yu, d, e, this.ab3.count, null);
    };
    AnchoredRadialSeries.prototype.i4 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ace(this.yu, this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.yu.ch, d);
        f.c = this.da.wc;
        var g = this.ab3;
        if (this.ab8 && typeCast(FastItemCoalescingColumn.$, g) !== null) {
            g = new FastItemCoalescingColumn(this.yu, g.c, false);
        }
        return this.i6(g, a, this.yu, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.v8 = function (a, b, c) {
        if (this.y0 == null || this.yu == null || this.cu == null || this.cu.by.isEmpty || this.cu.bx.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.cu);
        var e = new ScalerParams(0, this.cu.by, this.cu.bx, this.y0.ch, d);
        e.c = this.getEffectiveViewport1(this.cu);
        var f = this.i4(a, b, c);
        f = this.y0.ek(f, e);
        var g = this.y3.c(a, this.cu.by, this.cu.bx, d);
        if (!b && this.yu != null) {
            var h = this.j9(a, c);
            var i = this.j7(a, c);
            var j = this.ace(this.yu, this.cu.by, this.cu.bx, d);
            var k = new ScalerParams(0, this.cu.by, this.cu.bx, this.yu.ch, d);
            k.c = this.da.wc;
            var l = this.io(a, h, this.yu, k, j);
            var m = this.io(a, i, this.yu, k, j);
            if (this.yu.cl) {
                if (m <= l) {
                    j = this.acd(i, this.yu, this.cu.by, this.cu.bx, d);
                    if (isNaN_(j)) {
                        j = 0;
                    }
                    g = this.yu.ek(i, k) + j;
                }
                else {
                    j = this.acd(h, this.yu, this.cu.by, this.cu.bx, d);
                    if (isNaN_(j)) {
                        j = 0;
                    }
                    g = this.yu.ek(h, k) + j;
                }
            }
            else {
                if (m <= l) {
                    g = this.yu.ek(i, k) + j;
                }
                else {
                    g = this.yu.ek(h, k) + j;
                }
            }
        }
        var n = this.y3.d(g, f, this.cu.by, this.cu.bx, this.cu.getEffectiveViewport());
        var o = this.y3.e(g, f, this.cu.by, this.cu.bx, this.cu.getEffectiveViewport());
        return { $type: Point_$type, x: n, y: o };
    };
    AnchoredRadialSeries.prototype.ga = function () {
        return this.highlightedItemsSource != null || this.ack != null;
    };
    AnchoredRadialSeries.prototype.hs = function () {
        var a = _super.prototype.hs.call(this);
        {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "ValueMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedValueMemberPath";
                $ret.q = true;
                return $ret;
            })());
            b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.acy));
            a.add(b);
        }
        return a;
    };
    AnchoredRadialSeries.prototype.acy = function (a, b) {
        if (this.ack != null) {
            b.value = this.ack;
            return;
        }
        b.value = this.acs;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "ab3", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            if (this.ab2 != a) {
                var b = this.ab2;
                this.ab2 = a;
                this.raisePropertyChanged("ValueColumn", b, this.ab2);
            }
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = new DataLegendSeriesValueInfo();
        c.a = 0;
        this.ab8 = true;
        c.l = this.i4({ $type: Point_$type, x: a, y: b }, false, false);
        this.ab8 = false;
        c.q = "Value";
        c.r = this.acs != null ? this.acs : "Value";
        c.s = this.aco != null ? this.aco : "V:";
        c.t = this.acq != null ? this.acq : "";
        var d = new DataLegendSeriesContext();
        d.e = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(c);
            return $ret;
        })());
        d.h = this.mb();
        return d;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "adf", {
        get: function () {
            return this.c(AnchoredRadialSeries.ac2);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.ac2, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.ay = function (a) {
        if (a != null && a == this.yu && this.ab3 != null && this.ab3.count > 0) {
            return new AxisRange(0, this.ab3.count - 1);
        }
        if (a != null && a == this.y0 && this.ab3 != null && this.ab3.count > 0) {
            return new AxisRange(this.ab3.minimum, this.ab3.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.z4 = function (a, b) {
        if (this.acc) {
            var c = this.ab3.c;
            if (a < 0) {
                return _super.prototype.z4.call(this, a, b);
            }
            if (a > c.count - 1) {
                if (typeCast(ProportionalCategoryAngleAxis.$, this.yu) !== null) {
                    var d = this.ab3;
                    return d.f;
                }
                return _super.prototype.z4.call(this, a, b);
            }
            return c.item(a);
        }
        else {
            return _super.prototype.z4.call(this, a, b);
        }
    };
    AnchoredRadialSeries.prototype.dj = function (a) {
        var b = _super.prototype.dj.call(this, a);
        this.ab4 = false;
        if (this.yu != null && this.yu.cl) {
            this.ab4 = true;
            b = new FastItemCoalescingColumn(this.yu, b, this.acc);
        }
        return b;
    };
    AnchoredRadialSeries.prototype.acw = function (a, b) {
        if (this.ab4) {
            var c = b;
            var d = c.c;
            a.deregisterColumn(d);
        }
        else {
            a.deregisterColumn(b);
        }
    };
    AnchoredRadialSeries.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        if (this.abx.c2.g$b(a, b, c, d)) {
            this.rp(false);
            this.qj();
        }
        var e = typeCast(NumericAxisBase.$, this.y0);
        switch (b) {
            case AnchoredRadialSeries.$$p[2]:
            case AnchoredRadialSeries.$$p[3]:
                this.qd();
                break;
            case AnchoredRadialSeries.$$p[1]:
            case RadialBase.$$p[0]:
                if (this.ab3 != null) {
                    this.acw(this.dm, this.ab3);
                    this.ab3 = this.dj(this.acs);
                }
                break;
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    this.acw(c, this.ab3);
                    this.ab3 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.ab3 = this.dj(this.acs);
                    this.abx.cx.e(this.ic);
                }
                if (e != null && !e.c1()) {
                    this.abx.cx.e(this.ic);
                    this.rp(this.gf && c != null);
                }
                break;
            case AnchoredRadialSeries.$$p[4]:
                if (this.dm != null) {
                    this.acw(this.dm, this.ab3);
                    this.ab3 = this.dj(this.acs);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.c1()) {
                    this.abx.cx.e(this.ic);
                    this.rp(this.gf && this.d6);
                }
                break;
            case "TrendLineBrush":
                this.rd(b);
                break;
            case "TrendLineType":
                this.qj();
                break;
        }
    };
    AnchoredRadialSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.abx.cx.e(this.ic);
                break;
        }
        this.abx.c2.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.y0 != null && !this.y0.c1()) {
                    this.rp(true);
                }
                break;
            case 1:
                if (this.y0 != null && !this.y0.c1()) {
                    this.rp(true);
                }
                break;
            case 0:
                if (this.y0 != null && !this.y0.c1()) {
                    this.rp(true);
                }
                break;
            case 2:
                if (this.acs != null && this.abx.cx.b > 0 && this.y0 != null && !this.y0.c1()) {
                    this.rp(true);
                }
                break;
            case 3:
                if (d == this.acs) {
                    if (this.y0 != null && !this.y0.c1()) {
                        this.rp(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.hd = function (a, b, c) {
        var d = _super.prototype.hd.call(this, a, b, c);
        var e = c;
        if (this.dm == null || this.dm.count == 0 || this.yu == null || this.ab3 == null || this.yu.lh == 0 || this.y0 == null || isInfinity(this.y0.l2) || isInfinity(this.y0.l1) || e.cx.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.ace(this.yu, this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.yu.getCategorySize(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
    };
    AnchoredRadialSeries.prototype.get_ab9 = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "ab9", {
        get: function () {
            return this.get_ab9();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.get_ej = function () {
        return true;
    };
    AnchoredRadialSeries.prototype.get_f4 = function () {
        return this.y0 != null && this.y0.ch;
    };
    AnchoredRadialSeries.prototype.ace = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.z3(), b, c, d);
                break;
        }
        if (a.ch) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.acd = function (a, b, c, d, e) {
        var f = 0;
        var g = this.preferredCategoryMode(b);
        if (g == 0 && b.categoryMode != 0) {
            g = 1;
        }
        switch (g) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * b.m5(a, c, d, e);
                break;
            case 2:
                f = b.m4(a, this.z3(), c, d, e);
                break;
        }
        if (b.ch) {
            f = -f;
        }
        return f;
    };
    AnchoredRadialSeries.prototype.acx = function (a, b, c, d) {
        var _this = this;
        if (d == 0) {
            this.p1(a, b, c);
            return;
        }
        var e = this.cu.by;
        var f = this.cu.bx;
        var g = this.getEffectiveViewport1(this.cu);
        var h = this.wf(this.cu);
        var i = this.y0.k3(f, e, g, h);
        var j = this.yu != null && this.yu.cl;
        var k = new CollisionRect(0, a);
        var _loop_1 = function (l) {
            var m = typeCast(RadialBaseView.$, this_1.cu);
            var n = m.cx.getBucket(l);
            var o = this_1.ace(this_1.yu, e, f, g);
            if (j) {
                o = this_1.acd(l, this_1.yu, e, f, g);
                if (isNaN_(o)) {
                    o = 0;
                }
            }
            n[0] = this_1.yu.getScaledAngle(n[0]) + o;
            var p = Math.min(this_1.y3.b.oc(n[2]), i.maxLength);
            var q = this_1.y3.d(n[0], p, e, f, g);
            var r = this_1.y3.e(n[0], p, e, f, g);
            if (k.containsLocation(q, r)) {
                if (c == 7 || c == 6) {
                    b.add(((function () {
                        var $ret = new ChartSelection();
                        $ret.series = _this;
                        return $ret;
                    })()));
                    return { value: void 0 };
                }
                else if (c == 2 || c == 1) {
                    b.add(((function () {
                        var $ret = new ChartSelection();
                        $ret.item = _this.dm.item(l);
                        return $ret;
                    })()));
                }
                else {
                    b.add(((function () {
                        var $ret = new ChartSelection();
                        $ret.item = _this.dm.item(l);
                        $ret.series = _this;
                        return $ret;
                    })()));
                }
            }
        };
        var this_1 = this;
        for (var l = 0; l < this.dm.count; l++) {
            var state_1 = _loop_1(l);
            if (typeof state_1 === "object")
                return state_1.value;
        }
    };
    AnchoredRadialSeries.prototype.get_acb = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "acb", {
        get: function () {
            return this.get_acb();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.get_ab5 = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "ab5", {
        get: function () {
            return this.get_ab5();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.aa4 = function (a, b) {
        var _this = this;
        var c = b.by;
        var d = b.bx;
        var e = this.getEffectiveViewport1(b);
        var f = this.yu;
        var g = this.y0;
        var h = g.l2;
        var i = g.l1;
        a.f.clear();
        a.n.clear();
        a.q.clear();
        var j = this.xb();
        var k = 0;
        var l = b;
        var m = f.cl;
        var n = new CollisionAvoider();
        var o = 0;
        var p = 0;
        var q = b.cx.d;
        o = this.ace(f, c, d, e);
        l.c2.i = this.y0.n6;
        l.c2.h = this.y0.n5;
        l.c2.j = function (r, s) { return _this.acf(r, s, c, d, e); };
        l.c2.k = function (r, s) { return _this.acg(r, s, c, d, e); };
        var r = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.q;
            return $ret;
        })());
        var s = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.e = b.cx.b;
            $ret.f = b.cx.c;
            $ret.g = q;
            $ret.a = o;
            $ret.d = _this.ic;
            $ret.i = d;
            $ret.h = e;
            $ret.j = c;
            return $ret;
        })());
        l.c2.l(a.q, this.ab1, this.ab3, this.aci, function (t) { return _this.yu.getScaledAngle(t); }, function (t) { return _this.y0.oc(t); }, s, r);
        var t = true;
        if (this.aca(b)) {
            q--;
        }
        for (var u = b.cx.c; u <= q; ++u) {
            var v = u;
            if (v * b.cx.b >= this.yu.lh) {
                v -= intDivide((this.yu.lh), b.cx.b);
            }
            var w = b.cx.getBucket(v);
            p = 0;
            if (m) {
                p = this.zv(v, c, d, e);
            }
            w[3] = p;
            if (!isNaN_(w[0])) {
                var x = false;
                if (m) {
                    o = this.acd(v, f, c, d, e);
                    if (isNaN_(o)) {
                        o = 0;
                        x = true;
                    }
                }
                w[0] = f.getScaledAngle(w[0]) + o;
                if (w[1] < h || w[1] > i) {
                    if (this.acb) {
                        if (w[1] > i && this.ab5) {
                        }
                        else {
                            x = true;
                        }
                    }
                    else {
                        if (w[1] > i && this.ab5) {
                        }
                        else {
                            continue;
                        }
                    }
                }
                if (x) {
                    w[1] = NaN;
                    w[2] = NaN;
                }
                w[1] = g.oc(w[1]);
                if (b.cx.b > 1) {
                    if (w[2] < h || w[2] > i) {
                        continue;
                    }
                    w[2] = g.oc(w[2]);
                }
                else {
                    w[2] = w[1];
                }
                if ((isNaN_(w[1]) || isNaN_(w[2])) && t && this.ab9 && this.ab7()) {
                    q++;
                }
                else {
                    t = false;
                }
                a.f.add(w);
                if (j) {
                    var y = Math.min(v * b.cx.b, this.dm.count - 1);
                    var z = false;
                    if (this.yu.cl) {
                        var aa = this.yu;
                        var ab = aa.hasOthersCategory && (v * b.cx.b) == this.yu.lh - 1;
                        z = ab;
                    }
                    var ac = this.y3.d(w[0], w[1], c, d, e);
                    var ad = this.y3.e(w[0], w[1], c, d, e);
                    var ae = new Rect(0, ac - 5, ad - 5, 11, 11);
                    if (!isNaN_(ac) && !isNaN_(ad) && !isInfinity(ac) && !isInfinity(ad) && n.tryAdd(ae)) {
                        a.n.add({ $type: Point_$type, x: w[0], y: w[1] });
                        var af = b.cy.item(k);
                        af.al = v;
                        af.ak = y;
                        af.content.item = this.dm.item(y);
                        if (z) {
                            af.ak = this.dm.count;
                            var ag = this.yu;
                            af.content.item = this.y2;
                        }
                        ++k;
                    }
                }
            }
            else {
                if (t && this.ab9 && this.ab7()) {
                    q++;
                }
            }
        }
        b.cy.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.acf = function (a, b, c, d, e) {
        return this.y3.d(a, b, c, d, e);
    };
    AnchoredRadialSeries.prototype.acg = function (a, b, c, d, e) {
        return this.y3.e(a, b, c, d, e);
    };
    AnchoredRadialSeries.prototype.aca = function (a) {
        var b = a;
        return !this.ab9 && b.cx.c == 0 && b.cx.d == this.yu.lh;
    };
    AnchoredRadialSeries.prototype.abw = function (a, b, c) {
        var d = null;
        var e = c.by;
        var f = c.bx;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.ac1 = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.ab6()) {
                a.add(this.adj);
                a.add(a._inner[0]);
                d.add(this.adj);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.ab7 = function () {
        return !this.ab6();
    };
    AnchoredRadialSeries.prototype.ab6 = function () {
        var a = this.cu.by;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.o4 = function (a, b) {
        _super.prototype.o4.call(this, a, b);
        var c = b;
        if (a) {
            c.cy.clear();
        }
        c.c2.g$d();
    };
    AnchoredRadialSeries.prototype.aa7 = function (a, b) {
        this.qv();
        var c = b.by;
        var d = b.bx;
        var e = this.getEffectiveViewport1(b);
        var f = this.wf(b);
        var g = b;
        g.c2.g$g(a.q);
        var h = new List$1(Point_$type, 0);
        for (var i = 0; i < a.n.count; i++) {
            var j = a.n._inner[i];
            var k = this.y3.d(j.x, j.y, c, d, e);
            var l = this.y3.e(j.x, j.y, c, d, e);
            var m = { $type: Point_$type, x: k, y: l };
            h.add(m);
        }
        CategoryMarkerManager.e(this, h, g.cy, this.xd);
        this.acv(b, a);
        g.cr();
        this.acu(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.abv = function (a, b, c) {
        if (b < a || a < 0 || a > this.ab3.count || b < 0 || b > this.ab3.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cn;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.dm.item(g);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.acz = function (a, b, c, d, e, f) {
        var g = this.bw != 1;
        var h = this.co != 1;
        var i = this.cn != 1;
        var j = this.d1;
        this.zb.a3(this.zb.d, d.cn, a, b, c, d, e, f, true);
        this.zb.aa(this.ia);
        var k = this.zb.ax;
        var l = null;
        var m = null;
        var n = null;
        var o = this.dm;
        var p = null;
        var q = null;
        var r = null;
        if (j && this.da != null && !k.e) {
            var s = this.vk(k.z);
            var t = this.vl(k.z);
            this.zb.ag = s;
            this.zb.ah = t;
            k.aa = s;
            k.ab = t;
        }
        if (g && this.da != null) {
            l = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, true);
            if (this.da.dk.isCrossContextHighlight(this)) {
                p = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, true);
            }
            k.c = l;
        }
        if (h && this.da != null) {
            m = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, true);
            if (m == null && this.bm != null) {
                m = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, k.z, k.y, true);
            }
            if (this.da.dl.isCrossContextHighlight(this)) {
                q = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, true);
            }
            k.d = m;
        }
        if (i && this.da != null) {
            n = this.da.dj.getHighlightingInfo(this, o, k.z, k.y, true);
            if (this.da.dj.isCrossContextHighlight(this)) {
                r = this.da.dj.getHighlightingInfo(this, o, k.z, k.y, true);
            }
            k.b = n;
        }
        k.h = f;
        this.aa5(k);
        this.zb.y(this, l, m, n, f, g, h, i, k.v, this.da.dk.totalHighWaterMark, k.x, this.da.dl.totalHighWaterMark, k.t, this.da.dj.totalHighWaterMark);
    };
    AnchoredRadialSeries.prototype.ac0 = function (a, b, c, d, e, f) {
        var g = this.bw != 1;
        var h = this.co != 1;
        var i = this.co != 1;
        var j = this.d1;
        this.zb.a3(this.zb.b, d.cn, a, b, c, d, e, f, false);
        this.zb.ab(this.ia);
        var k = this.zb.ay;
        var l = null;
        var m = null;
        var n = null;
        var o = this.dm;
        if (j && this.da != null && !k.e) {
            var p = this.vj(k.z);
            var q = this.vm(k.z);
            this.zb.ag = p;
            this.zb.ah = q;
            k.aa = p;
            k.ab = q;
        }
        if (g && this.da != null) {
            l = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, false);
            k.c = l;
        }
        if (h && this.da != null) {
            m = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, false);
            if (m == null && this.bm != null) {
                m = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, k.z, k.y, false);
            }
            k.d = m;
        }
        k.h = f;
        this.aa6(k);
        this.zb.z(this, l, m, n, f, g, h, i, b < 0);
    };
    AnchoredRadialSeries.prototype.acv = function (a, b) {
        a.b7 = true;
        this.zb.a1(this, this.zr(), runOn(this, this.yi), this.z1(a), this.z2(a));
        var c = this.zb.d;
        var d = c != null;
        var e = this.yu;
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.by, a.bx, e.ch, f);
        var h = this.dm == null ? 0 : this.dm.count;
        var i = a;
        var j = b.f;
        var k = i.cx.c;
        var l = i.cx.d;
        var m = i.cx.b;
        var n = k * m;
        for (var o = 0; o < a.cy.count; o++) {
            var p = a.cy.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.acz(j, r, h, e, g, a.q);
            }
            this.zb.ac(p, q);
        }
    };
    AnchoredRadialSeries.prototype.acu = function (a, b, c, d, e) {
        e.c3(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.sd = function () {
        _super.prototype.sd.call(this);
        if (this.index < 0) {
            return;
        }
        this.abx.c4();
    };
    AnchoredRadialSeries.prototype.kw = function (a, b) {
        if (a == this.abx.c2.g$j) {
            return null;
        }
        return _super.prototype.kw.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.gc = function (a) {
        var b = this.cu.by;
        b = b.copy();
        var c = this.cu.bx;
        var d = !b.isEmpty && !c.isEmpty && this.dm != null ? this.dm.indexOf(a) : -1;
        if (this.yu == null || this.ab3 == null || this.y0 == null) {
            return false;
        }
        if (d < 0 || d > this.ab3.count - 1) {
            return false;
        }
        var e = this.yu.getScaledAngle(d);
        var f = this.y0.oc(this.ab3.item(d));
        if (isNaN_(f)) {
            f = (this.y0.n5 + this.y0.n6) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.c2 != null) {
            this.c2.au(this.da, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.rr = function (a, b) {
        _super.prototype.rr.call(this, a, b);
        if (!this.gz) {
            this.cu.a4(b);
            return;
        }
        this.cu.a4(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.ct);
        c.cx.e(this.ic);
        if (this.d4(this.ct)) {
            return;
        }
        if (!this.gr) {
            this.ab0 = new RadialFrame(3);
            this.aa4(this.ab0, c);
        }
        this.gr = false;
        this.aa7(this.ab0, c);
        this.gz = false;
    };
    AnchoredRadialSeries.prototype.ro = function (a, b, c, d, e) {
        _super.prototype.ro.call(this, a, b, c, d, e);
        var f = this.ba.a$j.item(d);
        var g = f;
        g.cx.e(this.ic);
        f.a3(c);
        if (this.d4(g)) {
            return;
        }
        if (this.abz == null) {
            this.abz = new RadialFrame(3);
        }
        this.abz.v();
        this.aa4(this.abz, g);
        this.aa7(this.abz, g);
    };
    AnchoredRadialSeries.prototype.pw = function (a) {
        _super.prototype.pw.call(this, a);
        this.bc.exportTrendlineData(this, a, this.abx.c2.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.ac2 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['HighlightedValueMemberPath:ack:ac3', [2, null], 'UseCategoryNormalizedValues:acc:adb', [0, false], 'ValueMemberAsLegendLabel:aco:adc', [2, null], 'ValueMemberAsLegendUnit:acq:add', [2, null], 'ValueMemberPath:acs:ade', [2, null], 'TrendLineType:ab1:ac9', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:ach:ac8', [1, 1.5], 'TrendLinePeriod:aci:ac7', [1, 7], 'TrendLineZIndex:acj:ada', [1, 1], 'TrendLineBrush:adg:ac4', [Brush.$, null], 'TrendLineDashArray:adh:ac5', [DoubleCollection.$], 'TrendLineDashCap:adi:ac6', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c1 = null;
        _this.c2 = null;
        _this.cx = new AnchoredRadialBucketCalculator(_this);
        _this.c1 = a;
        _this.c2 = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.c3 = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.c4 = function () {
        this.c1.adf = null;
        if (this.c1.adg != null) {
            this.c1.adf = this.c1.adg;
        }
        else {
            this.c1.adf = this.c1.u5;
        }
    };
    AnchoredRadialSeriesView.prototype.a7 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.c1.ab1 != 0 && !b) {
                var c = this.c2.g$j;
                c.ad = this.c1.ach;
                c._stroke = this.c1.adf;
                c.ai = this.c1.adh;
                c.aj = this.c1.adi;
                a.v(c);
            }
        }
        _super.prototype.a7.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.c1.yu.f1 != null) {
            a += "<span>${item." + this.c1.yu.f1 + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.ba.a$u(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.c1.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.c1.acs + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
