/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-react-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-react-core";
import { IChartScaleLegend_$type } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { FastItemsSource } from "igniteui-react-core";
import { FastItemColumn } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, logBase } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.aec = null;
        _this.aeb = null;
        _this.acz = null;
        _this.acq = null;
        _this.acp = null;
        _this.aco = null;
        _this.acm = null;
        _this.ab = BubbleSeries.$;
        _this.yx = new ScatterFrame();
        _this.yz = new ScatterFrame();
        _this.yv = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.bj = function () {
        return new BubbleSeries();
    };
    BubbleSeries.prototype.get_eh = function () {
        return true;
    };
    BubbleSeries.prototype.cr = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.acl = a;
    };
    BubbleSeries.prototype.jk = function () {
        return 0.7;
    };
    BubbleSeries.prototype.ww = function () {
        if (this.wv == 0) {
            return 2;
        }
        return _super.prototype.ww.call(this);
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.a5 == a;
    };
    BubbleSeries.prototype.eg = function () {
        return true;
    };
    BubbleSeries.prototype.pz = function (a) {
        _super.prototype.pz.call(this, a);
        if (this.acu != null && this.acz != null && this.acz.count > 0) {
            for (var b = 0; b < this.acz.count; b++) {
                a(this.acz._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "act", {
        get: function () {
            return this.acv;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.get_isColoredItemwise = function () {
        return this.acr != null && this.acr.count > 0;
    };
    BubbleSeries.prototype.aea = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.ack);
        var c = typeCast(ValueBrushScale.$, this.ack);
        var d = this.ack;
        if (b != null && this.dm != null) {
            return b.getBrush1(a, this.dm.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.acr);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.acv != null && this.acv.count != 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            var a = this.acj(this.acn).b;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            var a = this.acj(this.acn).a;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.acv.count; b++) {
            if (this.ack == null || !this.ack.isReady) {
                return false;
            }
            var c = NaN;
            if (this.acr != null) {
                c = (this.acr.item(b) - this.acr.minimum) / (this.acr.maximum - this.acr.minimum);
            }
            var d = (this.acv.item(b) - this.acv.minimum) / (this.acv.maximum - this.acv.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.yc;
            var f = this.aea(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.kp = function (a, b) {
        var c = this.nc(b);
        if (c == BubbleSeries.$$p[5]) {
            return this.kq(a, b, this.ade);
        }
        if (c == BubbleSeries.$$p[11]) {
            return this.kq(a, b, this.ado);
        }
        if (c == ScatterBase.$$p[12]) {
            return this.kq(a, b, this.aao);
        }
        if (c == ScatterBase.$$p[16]) {
            return this.kq(a, b, this.aaw);
        }
        if (c == BubbleSeries.$$p[2]) {
            return this.kq(a, b, this.ac9);
        }
        return _super.prototype.kp.call(this, a, b);
    };
    BubbleSeries.prototype.mc = function (a) {
        var b = this.nc(a);
        if (b == BubbleSeries.$$p[5]) {
            return this.ade;
        }
        if (b == BubbleSeries.$$p[11]) {
            return this.ado;
        }
        if (b == ScatterBase.$$p[12]) {
            return this.aao;
        }
        if (b == ScatterBase.$$p[16]) {
            return this.aaw;
        }
        if (b == BubbleSeries.$$p[2]) {
            return this.ac9;
        }
        return _super.prototype.mc.call(this, a);
    };
    Object.defineProperty(BubbleSeries.prototype, "acv", {
        get: function () {
            return this.acq;
        },
        set: function (a) {
            if (this.acq != a) {
                var b = this.acv;
                this.acq = a;
                this.raisePropertyChanged("RadiusColumn", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "acu", {
        get: function () {
            return this.acp;
        },
        set: function (a) {
            if (this.acp != a) {
                var b = this.acu;
                this.acp = a;
                this.raisePropertyChanged("LabelColumn", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "acr", {
        get: function () {
            return this.aco;
        },
        set: function (a) {
            if (this.aco != a) {
                var b = this.acr;
                this.aco = a;
                this.raisePropertyChanged("FillColumn", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.aaz = function (a, b, c, d, e) {
        if (c <= this.z4) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.z4;
        var g = this.dm;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.yr.d, j);
        var l = new ScalerParams(0, d, e, this.yr.e, j);
        var m = false;
        var n = 0;
        if (this.da != null) {
            if (this.da.f2()) {
                var o = this.da.mz(d, k);
                m = o.c;
                n = o.d;
            }
        }
        var _loop_1 = function (p) {
            h = this_1.zc.item(p);
            i = this_1.zd.item(p);
            var q = { $type: Point_$type, x: this_1.yr.a.ek(h, k), y: this_1.yr.b.ek(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                var r_1 = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r_1)) {
                        var s_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = r_1;
                            $ret.b = s_1;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var p = 0; p < c; p++) {
            _loop_1(p);
        }
    };
    BubbleSeries.prototype.aba = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.c0;
        d.m = this.acv;
        _super.prototype.aba.call(this, a, b);
        var e = Math.min(this.zc != null ? this.zc.count : 0, this.zd != null ? this.zd.count : 0);
        if (e < 1) {
            return;
        }
        c.dm();
        c.dn();
    };
    BubbleSeries.prototype.adt = function () {
        if (this.da == null) {
            return;
        }
        if (this.a5 == null) {
            return;
        }
        if (this.a5.isItemwise) {
            var a = this.a5;
            this.a5.clearLegendItemsForSeries(this);
            this.ads();
            a.renderItemwiseContent(this);
        }
        if (this.a5.isScale) {
            var b = this.a5;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.ac0 = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.ac1 = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.ac0(g, h, c, d, f);
    };
    BubbleSeries.prototype.hd = function (a, b, c) {
        var d = _super.prototype.hd.call(this, a, b, c);
        if (this.acv == null || this.dm == null || this.acv.count == 0 || this.dm.count != this.acv.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.zm = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.aao == a || this.aaw == a || this.ado == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.ads = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.a5);
        if (a == null || this.dm == null) {
            return;
        }
        this.acz = new List$1(UIElement.$, 0);
        var b = typeCast(CustomPaletteBrushScale.$, this.ack);
        var c = typeCast(ValueBrushScale.$, this.ack);
        var d = this.ack;
        var e = this.aci();
        var f = e.b;
        var g = e.a;
        var h = this.dm;
        var _loop_2 = function (i) {
            var j = null;
            if (c != null && this_2.acr != null) {
                var k = this_2.acr.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            var l = new ContentControl();
            var m = this_2.acu != null && this_2.acu.item(i) != null ? this_2.acu.item(i).toString() : "";
            l.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                $ret.legendLabel = m;
                return $ret;
            })());
            var n = this_2.st;
            if (n == null) {
                n = this_2.cu.bn(this_2.cz);
            }
            l.ah = n;
            this_2.acz.add(l);
        };
        var this_2 = this;
        for (var i = 0; i < h.count; i++) {
            _loop_2(i);
        }
    };
    BubbleSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        if (this.acn != null) {
            this.acn.aa();
        }
        if (this.ack != null) {
            this.ack.x();
        }
        this.adt();
    };
    BubbleSeries.prototype.qb = function () {
        _super.prototype.qb.call(this);
        this.adt();
    };
    BubbleSeries.prototype.qi = function () {
        _super.prototype.qi.call(this);
        this.adt();
    };
    BubbleSeries.prototype.q7 = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case ScatterBase.$$p[10]:
            case ScatterBase.$$p[14]:
            case ScatterBase.$$p[11]:
            case ScatterBase.$$p[15]:
            case BubbleSeries.$$p[9]:
            case BubbleSeries.$$p[10]:
                this.qd();
                break;
            case "FastItemsSource":
                if (this.acn != null) {
                    this.acn.aa();
                }
                if (this.ack != null) {
                    this.ack.x();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.acv);
                    c.deregisterColumn(this.acr);
                    c.deregisterColumn(this.acu);
                    this.acv = null;
                    this.acr = null;
                    this.acu = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.acv = this.dj(this.ado);
                    if (!stringIsNullOrEmpty(this.ac9)) {
                        this.acr = this.dj(this.ac9);
                    }
                    this.acu = this.dl(this.ade);
                }
                this.rp(false);
                this.adt();
                break;
            case BubbleSeries.$$p[11]:
                if (this.acn != null) {
                    this.acn.aa();
                }
                if (this.dm != null) {
                    this.dm.deregisterColumn(this.acv);
                    this.acv = this.dj(this.ado);
                    this.adt();
                }
                break;
            case "RadiusColumn":
                if (this.acn != null) {
                    this.acn.aa();
                }
                this.ys.c2.g$i();
                this.rp(this.gf && this.d6);
                this.qk();
                break;
            case BubbleSeries.$$p[12]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.rp(false);
                this.qj();
                break;
            case BubbleSeries.$$p[13]:
                this.rp(false);
                this.qj();
                break;
            case "DiscreteLegendItemTemplate":
                this.adt();
                break;
            case BubbleSeries.$$p[3]:
                if (c != null) {
                    c.o.remove(this);
                    c.x();
                }
                if (d != null) {
                    d.o.add(this);
                    d.x();
                }
                this.rp(false);
                this.adt();
                this.qj();
                break;
            case BubbleSeries.$$p[4]:
            case BubbleSeries.$$p[8]:
            case BubbleSeries.$$p[7]:
            case BubbleSeries.$$p[6]:
                this.rp(false);
                this.adt();
                this.qj();
                break;
            case "FillColumn":
                this.rp(this.gf && this.d6);
                this.qj();
                break;
            case BubbleSeries.$$p[2]:
                if (this.ack != null) {
                    this.ack.x();
                }
                if (this.dm != null) {
                    this.dm.deregisterColumn(this.acr);
                    this.acr = this.dj(this.ac9);
                    this.adt();
                }
                break;
            case BubbleSeries.$$p[5]:
                if (this.dm != null) {
                    this.dm.deregisterColumn(this.acu);
                    this.acu = this.dl(this.ade);
                    this.adt();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    var f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var g = typeCast(IChartScaleLegend_$type, e);
                    var h = true;
                    var i = null;
                    if (this.da != null) {
                        try {
                            for (var _b = __values(fromEnum(this.da.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var j = _c.value;
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.adt();
                break;
            case "SeriesViewer":
                this.adt();
                break;
        }
    };
    BubbleSeries.prototype.updateSizeScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.acv != null) {
            a.b = this.acv.minimum;
            a.a = this.acv.maximum;
        }
        if (this.acn != null) {
            this.acn.ab(a.b, a.a);
        }
    };
    BubbleSeries.prototype.updateFillScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.acr != null) {
            a.b = this.acr.minimum;
            a.a = this.acr.maximum;
        }
        if (this.ack != null) {
            this.ack.z(a.b, a.a);
        }
    };
    BubbleSeries.prototype.acj = function (a) {
        var b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.acv != null) {
            b.b = this.acv.minimum;
            b.a = this.acv.maximum;
        }
        if (a != null) {
            a.x();
            if (this.acy) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    };
    BubbleSeries.prototype.aci = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.acr != null) {
            a.b = this.acr.minimum;
            a.a = this.acr.maximum;
        }
        var b = typeCast(ValueBrushScale.$, this.ack);
        if (b != null) {
            b.s();
            if (this.acw && this.ack.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    };
    BubbleSeries.prototype.adv = function (a, b, c, d) {
        var e = c.width;
        if (!this.cu.bx.isEmpty) {
            e = this.cu.bx.width;
        }
        else if (this.da != null && !this.da.wc.isEmpty) {
            e = this.da.wc.width;
        }
        var f = DeviceUtils.c(e);
        this.acm = this.acn || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (this.acm != null) {
            var g = this.acm.minimumValue;
            var h = this.acm.maximumValue;
            var i = this.acm.logarithmBase;
            var j = this.acj(this.acm);
            var k = j.b;
            var l = j.a;
            if (this.acm.isLogarithmic) {
                for (var m = 0; m < b.count; m++) {
                    b._inner[m] = BubbleSeries.ac1(k, l, g, h, i, b._inner[m]);
                }
            }
            else {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.ac0(k, l, g, h, b._inner[n]);
                }
            }
        }
        var o = 1;
        o = DeviceUtils.d();
        var p = this.acn == null;
        if (d) {
            var q = c.width / e;
            for (var r = 0; r < b.count; r++) {
                if (p) {
                    b._inner[r] = b._inner[r] / o;
                }
                b._inner[r] = b._inner[r] * q;
            }
        }
        for (var s = 0; s < a.count; s++) {
            var t = a._inner[s];
            if (p && !d) {
                t.width = Math.max(0, b._inner[s] / o);
                t.height = Math.max(0, b._inner[s] / o);
            }
            else {
                t.width = Math.max(0, b._inner[s]);
                t.height = Math.max(0, b._inner[s]);
            }
        }
    };
    BubbleSeries.prototype.adu = function (a) {
        var b = typeCast(BubbleSeriesView.$, this.ct);
        this.acl.b7 = false;
        if (b != null) {
            b.b7 = false;
        }
        var c = typeCast(CustomPaletteBrushScale.$, this.ack);
        var d = typeCast(ValueBrushScale.$, this.ack);
        var e = this.ack;
        var f = this.aci();
        var g = f.b;
        var h = f.a;
        var i = this.ack == null || !this.ack.isReady || (d != null && this.ac9 == null);
        if (i) {
            this.acl.dl();
            if (b != null) {
                b.dl();
            }
            return;
        }
        this.acl.b7 = true;
        if (b != null) {
            b.b7 = true;
        }
        var j = a.count;
        var k = this.dm;
        for (var l = 0; l < j; l++) {
            var m = a._inner[l];
            var n = typeCast(DataContext.$, m.content);
            if (n != null) {
                var o = null;
                var p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.acr != null) {
                    var q = this.acr.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.ye == null) {
                        o = this.yc;
                    }
                    else {
                        o = this.ye;
                    }
                }
                var r = null;
                if (this.yf == null) {
                    r = this.yd;
                }
                else {
                    r = this.yf;
                }
                if (this.acx && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.ac3)) {
                    r = BrushUtil.m(r, this.ac3);
                }
                if (o != null && !isNaN_(this.ac2)) {
                    o = BrushUtil.m(o, this.ac2);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    };
    BubbleSeries.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.p1(a, c, b);
        return c.toArray();
    };
    BubbleSeries.prototype.p1 = function (a, b, c) {
        var d = 1;
        if (d == 1) {
            var e = this.acs();
            this.aa2(a, b, c, d, e);
        }
        else {
            _super.prototype.p1.call(this, a, b, c);
        }
    };
    BubbleSeries.prototype.acs = function () {
        var a = new FastItemColumn(typeCast(FastItemsSource.$, this.dm), "RadiusColumn", null, false);
        var b = this.cu.bx;
        var c = b.width;
        if (!this.cu.bx.isEmpty) {
            c = this.cu.bx.width;
        }
        else if (this.da != null && !this.da.wc.isEmpty) {
            c = this.da.wc.width;
        }
        var d = DeviceUtils.c(c);
        this.acm = this.acn || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = d / 10;
            $ret.maximumValue = d / 5;
            return $ret;
        })());
        if (this.acm != null) {
            var e = this.acm.minimumValue;
            var f = this.acm.maximumValue;
            var g = this.acm.logarithmBase;
            var h = this.acj(this.acm);
            var i = h.b;
            var j = h.a;
            if (this.acm.isLogarithmic) {
                for (var k = 0; k < a.count; k++) {
                    a.item(k, BubbleSeries.ac1(i, j, e, f, g, a.item(k)));
                }
            }
            else {
                for (var l = 0; l < a.count; l++) {
                    a.item(l, BubbleSeries.ac0(i, j, e, f, a.item(l)));
                }
            }
        }
        var m = DeviceUtils.d();
        var n = this.acn == null;
        var o = this.cu == this.ct;
        if (o) {
            var p = b.width / c;
            for (var q = 0; q < a.count; q++) {
                if (n) {
                    a.item(q, a.item(q) / m);
                }
                a.item(q, a.item(q) * p);
            }
        }
        for (var r = 0; r < a.count; r++) {
            var s = void 0;
            if (n && !o) {
                a.item(r, Math.max(0, a.item(r) / m));
            }
            else {
                a.item(r, Math.max(0, a.item(r)));
            }
        }
        return a;
    };
    BubbleSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.km(c);
        var e = d == null ? NaN : this.iw(d, "XMemberPath");
        var f = d == null ? NaN : this.iw(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.a = 13;
        g.l = e;
        g.q = "X";
        g.r = this.aao != null ? this.aao : "X";
        g.s = this.aak != null ? this.aak : "X:";
        g.t = this.aam != null ? this.aam : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.q = "Y";
        h.r = this.aaw != null ? this.aaw : "Y";
        h.s = this.aas != null ? this.aas : "Y:";
        h.t = this.aau != null ? this.aau : "";
        var i = new DataLegendSeriesContext();
        i.e = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.h = this.mb();
        if (!stringIsNullOrEmpty(this.ado)) {
            var j = d == null ? NaN : this.iw(d, "RadiusMemberPath");
            var k = new DataLegendSeriesValueInfo();
            k.l = j;
            k.a = 11;
            k.q = "Radius";
            k.r = this.ado != null ? this.ado : "Radius";
            k.s = this.adk != null ? this.adk : "R:";
            k.t = this.adm != null ? this.adm : "";
            i.e.add(k);
        }
        else if (this.acm != null) {
            var l = new DataLegendSeriesValueInfo();
            l.l = this.acm.maximumValue;
            l.a = 11;
            l.q = "Radius";
            l.r = this.ado != null ? this.ado : "Radius";
            l.s = this.adk != null ? this.adk : "R:";
            l.t = this.adm != null ? this.adm : "";
            i.e.add(l);
        }
        if (!stringIsNullOrEmpty(this.ac9)) {
            var m = d == null ? NaN : this.iw(d, "FillMemberPath");
            var n = new DataLegendSeriesValueInfo();
            n.l = m;
            n.a = 12;
            n.q = "Fill";
            n.r = this.ac9 != null ? this.ac9 : "Fill";
            n.s = this.ac5 != null ? this.ac5 : "F:";
            n.t = this.ac7 != null ? this.ac7 : "";
            i.e.add(n);
        }
        return i;
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.yc;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:ac5:adw', [2, null], 'FillMemberAsLegendUnit:ac7:adx', [2, null], 'FillMemberPath:ac9:ady', [2], 'FillScale:ack:adz', [BrushScale.$], 'FillScaleUseGlobalValues:acw:ad0', [0, false], 'LabelMemberPath:ade:ad1', [2], 'MarkerBrushBrightness:ac2:ad2', [1, NaN], 'MarkerOutlineBrightness:ac3:ad3', [1, NaN], 'MarkerOutlineUsesFillScale:acx:ad4', [0, false], 'RadiusMemberAsLegendLabel:adk:ad5', [2, null], 'RadiusMemberAsLegendUnit:adm:ad6', [2, null], 'RadiusMemberPath:ado:ad7', [2, null], 'RadiusScale:acn:ad8', [SizeScale.$], 'RadiusScaleUseGlobalValues:acy:ad9', [0, false]]);
    return BubbleSeries;
}(ScatterBase));
export { BubbleSeries };
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.ac0(0, b - 1, 0, this.brushes.count - 1, a);
        return this.ab(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
export { CustomPaletteBrushScale };
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dk = null;
        _this.dk = a;
        _this.c2 = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.b4.w5 = Defaults.e;
        }
    };
    BubbleSeriesView.prototype.cz = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.c3.item(a); }, function (a) { return _this.c1.yr.c.item(a); }, runOn(this, this.de), runOn(this, this.cw), runOn(this, this.c4));
    };
    BubbleSeriesView.prototype.dm = function () {
        var a = this.c0;
        this.dk.adv(a.n, a.o, this.bx, this == this.e.ct);
        this.as();
    };
    BubbleSeriesView.prototype.dn = function () {
        var a = this.c0;
        this.dk.adu(a.n);
    };
    BubbleSeriesView.prototype.dl = function () {
        var e_2, _a;
        var a = this.c0;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.ba.a$u(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.dk.title + "</span><br/><span>" + "(${item." + this.dk.aao + "}, ${item." + this.dk.aaw + "})</span>";
        if (!stringIsNullOrEmpty(this.dk.ado)) {
            a += "<span>, Radius: ${item." + this.dk.ado + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));
export { BubbleSeriesView };
