/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, typeCast, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, delegateCombine, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryCollisionMode_$type } from "./CategoryCollisionMode";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Pool$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
/**
 * @hidden
 */
var CategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryBucketCalculator, _super);
    function CategoryBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.e = 0;
        _this.f = 0;
        _this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.c = a;
        _this.e = -1;
        _this.d = 0;
        return _this;
    }
    CategoryBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    CategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    CategoryBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    CategoryBucketCalculator.prototype.g = function (a) {
        var b = this.c.by;
        var c = this.c.bx;
        var d = this.c.cy;
        var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        var f = d.dm;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        var g = d.getEffectiveViewport1(this.c);
        var h = d.wf(this.c);
        var i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            var j = new ScalerParams(0, b, c, e.ch, g);
            var k = Math.floor(e.en(h.left, j));
            var l = Math.ceil(e.en(h.right, j));
            if (e.ch) {
                l = Math.ceil(e.en(h.left, j));
                k = Math.floor(e.en(h.right, j));
            }
            l = Math.min(l, e.li - 1);
            var m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    };
    CategoryBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cy.ic;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    CategoryBucketCalculator.prototype.cacheValues = function () {
    };
    CategoryBucketCalculator.prototype.unCacheValues = function () {
    };
    CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
}(Base));
export { CategoryBucketCalculator };
/**
 * @hidden
 */
var CategoryFramePreparerBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFramePreparerBase, _super);
    function CategoryFramePreparerBase(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, g, h, i) || this;
                        _this.g = null;
                        _this.h = null;
                        _this.m = false;
                        _this.o = new List$1(Array_$type, 0);
                        _this.p = new List$1(Number_$type, 0);
                        _this.n = new List$1(Number_$type, 0);
                        _this.h = f;
                        _this.g = j;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, d, e, f) || this;
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                    _this.h = c;
                    _this.g = g;
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparerBase.prototype.i = function (a) {
        var b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        var c;
        var d;
        var e;
        var f;
        var g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.k = c;
        b.l = d;
        b.j = e;
        b.i = f;
        if (b.l < b.k) {
            return null;
        }
        var h;
        var i;
        var j;
        var k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        var l = this.a.getMainContentViewport();
        b.p = h;
        b.o = i;
        b.n = j;
        b.m = l;
        if (Rect.l_op_Equality(b.p, Rect.empty) || Rect.l_op_Equality(b.o, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.fa) && this.g != null) {
            b.e = true;
        }
        return b;
    };
    CategoryFramePreparerBase.prototype.r = function (a, b, c, d) {
        return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    };
    CategoryFramePreparerBase.prototype.s = function (a) {
        return this.r(a.b, a.p, a.o, a.n);
    };
    CategoryFramePreparerBase.prototype.d = function (a, b) {
        var c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.n.clear();
        c.a.q.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        if (c.a.m != null) {
            c.a.m.clear();
        }
        var d = this.c.shouldDisplayMarkers;
        var e = false;
        var f = this.s(c);
        var g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            var h = c.d.i$b._inner[c.k];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.k > 0) {
                c.k = c.k - 1;
                h = c.d.i$b._inner[c.k];
                this.z(g, h, true, c.e);
            }
            var i = c.d.i$b._inner[c.l];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.l < g.e - 1) {
                c.l = c.l + 1;
                i = c.d.i$b._inner[c.l];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            var j = c.k;
            var k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.k > 0) {
                c.k = c.k - 1;
                j = c.k;
                k = this.g.getBucket(j);
            }
            var l = c.l;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.l < (intDivide(g.e, c.j))) {
                c.l = c.l + 1;
                l = c.l;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        var m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    };
    CategoryFramePreparerBase.prototype.v = function (a, b) {
    };
    Object.defineProperty(CategoryFramePreparerBase.prototype, "q", {
        get: function () {
            return this.o;
        },
        enumerable: false,
        configurable: true
    });
    CategoryFramePreparerBase.prototype.t = function (a, b, c, d, e) {
        var _this = this;
        var f = 0;
        var g = false;
        var h = null;
        var i = false;
        var j = a.d != null;
        var k = a.p;
        var l = a.o;
        var m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.ln;
        var n = a.f;
        var o = this.h.mayContainUnknowns;
        var p = this.o;
        var q = this.n;
        var r = this.p;
        p.clear();
        q.clear();
        r.clear();
        var s = this.g;
        var t = this.h.provideCollisionDetector();
        var u = 0;
        var v = a.n;
        var w = new ScalerParams(0, k, l, a.b.j$b, v);
        var x = ((function () {
            var $ret = new ScalerParams(0, k, l, a.c.j$b, v);
            $ret.b = typeCast(Series.$, _this.h) !== null ? _this.h.ix() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$d(2, w) - a.b.j$d(1, w);
            i = this.k();
        }
        var y = a.k;
        var z = a.l;
        var aa = a.a.f;
        var ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        var _loop_1 = function (ac) {
            var ad = void 0;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((function () { var ae = _this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            var ae = !m || (m && ad[1] > 0);
            var af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (j) {
                    if (a.a.m == null) {
                        a.a.m = new List$1(Number_$type, 0);
                    }
                    a.a.m.add(ac * a.j);
                }
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                        if (j) {
                            if (a.a.m == null) {
                                a.a.m = new List$1(Number_$type, 0);
                            }
                            a.a.m.add(ac * a.j);
                        }
                    }
                }
                if (d && ae) {
                    var ag = ac * a.j;
                    var ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    var ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this_1.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
            out_ac_1 = ac;
        };
        var this_1 = this, out_ac_1;
        for (var ac = y; ac <= z; ++ac) {
            _loop_1(ac);
            ac = out_ac_1;
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            var aj = p.count;
            var ak = void 0;
            for (var al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    };
    CategoryFramePreparerBase.prototype.k = function () {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.eu;
        }
        return false;
    };
    CategoryFramePreparerBase.prototype.f = function (a, b, c, d, e, f, g) {
        var h;
        f = null;
        e = false;
        var i = typeCast(CategorySeries.$, this.h);
        var j = a.o;
        var k = a.p;
        var l = a.n;
        var m = new ScalerParams(0, k, j, a.b.j$b, l);
        var n = new ScalerParams(0, k, j, a.c.j$b, l);
        var o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.dm != null && i.dm.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        var p = a.d.i$b._inner[b];
        var q = a.d.i$d(p);
        var r = q;
        this.z(c, p, false, o);
        while (b < a.l) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    var s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$c(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                var t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                var u = [a.b.j$c(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        if (a.d != null) {
                            if (a.a.m == null) {
                                a.a.m = new List$1(Number_$type, 0);
                            }
                            a.a.m.add(b);
                        }
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        var v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$c(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    };
    CategoryFramePreparerBase.prototype.y = function (a, b, c, d, e, f, g) {
        var h = a.j;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.o;
        var l = k.count;
        if (f) {
            var m = a.c.j$c(a.c.mc, e);
            a.c.j$f(a.a.k, 0, a.a.k.count, e);
            var n = a.a.k;
            var o = n.count;
            for (var p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    };
    CategoryFramePreparerBase.prototype.w = function (a, b, c) {
    };
    CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
}(FramePreparer));
export { CategoryFramePreparerBase };
/**
 * @hidden
 */
var CategoryFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFramePreparer, _super);
    function CategoryFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        _this.ab = new DefaultSingleValueProvider();
                        _this.ac = null;
                        _this.ad = null;
                        _this.ac = _this.aa;
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.ac = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ad = _this.ab;
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            _this.ad = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    _this.ab = new DefaultSingleValueProvider();
                    _this.ac = null;
                    _this.ad = null;
                    _this.ac = _this.aa;
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.ac = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ad = _this.ab;
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        _this.ad = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.n.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    CategoryFramePreparer.prototype.j = function (a) {
        var b = new SingleValuesHolder();
        var c = this.ad.valueColumn;
        b.f = c;
        return b;
    };
    CategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$c(b[0], e) + c;
        }
        b[1] = a.c.j$c(b[1], f);
        if (a.j > 1 || d) {
            b[2] = a.c.j$c(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    };
    CategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
        _super.prototype.y.call(this, a, b, c, d, e, f, g);
        var h = a.j;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.q;
        var l = k.count;
        var m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        var n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$e(j, m, 0, i, d);
        a.c.j$e(j, n, 0, i, e);
        for (var o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (var p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$e(k, m, 0, l, d);
            a.c.j$e(k, n, 0, l, e);
            for (var q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (var r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    };
    CategoryFramePreparer.prototype.w = function (a, b, c) {
        if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
            return;
        }
        this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
    };
    CategoryFramePreparer.prototype.z = function (a, b, c, d) {
        var e = a;
        var f = e.f;
        var g = f.item(b);
        var h = g;
        if (d) {
            var i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    };
    CategoryFramePreparer.prototype.u = function (a, b, c) {
        var d = a;
        var e = d.f;
        if (b < e.count) {
            var f = void 0;
            if (c) {
                var g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    };
    CategoryFramePreparer.prototype.e = function (a, b) {
        var c = b;
        return [a, c.a, c.b];
    };
    CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
}(CategoryFramePreparerBase));
export { CategoryFramePreparer };
/**
 * @hidden
 */
var CategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeries, _super);
    function CategorySeries() {
        var _this = _super.call(this) || this;
        _this.yu = null;
        _this.y2 = null;
        _this.zb = false;
        _this.za = false;
        _this.assigningCategoryStyle = null;
        _this.assigningCategoryMarkerStyle = null;
        _this.y8 = null;
        _this.y9 = null;
        _this.yr = new CategoryFrame(3);
        _this.yt = new CategoryFrame(3);
        _this.yp = new CategoryFrame(3);
        _this.ys = new CategoryFrame(3);
        _this.yx = null;
        _this.y1 = null;
        _this.yx = new CategorySeriesRenderManager();
        _this.y1 = new CategoryTransitionSourceFramePreparer();
        _this.zb = false;
        _this.d1 = false;
        _this.za = false;
        _this.ab = CategorySeries.$;
        return _this;
    }
    CategorySeries.prototype.cr = function () {
        var a = new CategorySeriesView(this);
        return a;
    };
    Object.defineProperty(CategorySeries.prototype, "y3", {
        get: function () {
            var _this = this;
            if (this.y2 == null) {
                this.y2 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, function () { return _this.dq.n; });
            }
            return this.y2;
        },
        enumerable: false,
        configurable: true
    });
    CategorySeries.prototype.ea = function (a, b, c, d, e) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var f = this.getEffectiveViewport1(this.cu);
        var g = this.yn();
        var h = new ScalerParams(1, this.da.vx, this.wo, g.ch);
        h.c = f;
        var i = this.y4();
        var j = new ScalerParams(1, this.da.vx, this.wo, i.ch);
        j.c = f;
        var k = this.da.vx;
        var l = this.wo;
        var m = this.currentMode2Index;
        var n = 0;
        if (g.ce && g.cc) {
            n = g.getSeriesOffset(k, l, f, m, g.categoryMode);
        }
        a.clear();
        this.w1.cj(function (o) {
            if (o._visibility == 0) {
                var p = new SeriesPointOfInterest();
                var q = o.n;
                var r = o.o;
                if (q < _this.wo.left || q > _this.wo.right || r < _this.wo.top || r > _this.wo.bottom) {
                    return;
                }
                if (_this.isVertical) {
                    if (g.cb && !g.ce && g.categoryMode != 0) {
                        p.e = o.ak;
                    }
                    else {
                        p.e = g.en(r, h);
                    }
                    p.d = i.en(q, j);
                }
                else {
                    if (g.cb && !g.ce && g.categoryMode != 0) {
                        p.d = o.ak;
                    }
                    else {
                        p.d = g.en(q, h);
                    }
                    p.e = i.en(r, j);
                }
                p.b = o.content;
                if (b) {
                    if (_this.isVertical) {
                        if (c) {
                            p.f = _this.zu(p.d, d);
                        }
                        else {
                            var s = _this.jc(o);
                            if (!isNaN_(s)) {
                                p.f = _this.zu(s, d);
                            }
                            else {
                                p.f = _this.zu(p.d, d);
                            }
                        }
                    }
                    else {
                        if (c) {
                            p.f = _this.zu(p.e, d);
                        }
                        else {
                            var t = _this.jc(o);
                            if (!isNaN_(t)) {
                                p.f = _this.zu(t, d);
                            }
                            else {
                                p.f = _this.zu(p.e, d);
                            }
                        }
                    }
                }
                else {
                    var u = _this.au(true);
                    if (u != null) {
                        var v = _this.kr(o.ak, false);
                        if (v != null) {
                            p.f = u.i(v);
                        }
                        else {
                            p.f = null;
                        }
                    }
                    else {
                        p.f = g.ge(o.ak);
                    }
                }
                p.c = o.ak;
                p.g = _this.vc;
                if (_this.g8) {
                    p.g = _this.vj(o.ak);
                }
                a.add(p);
            }
        });
        return true;
    };
    CategorySeries.prototype.zu = function (a, b) {
        var c;
        if (b >= 0) {
            c = round10N(a, b);
        }
        else {
            c = a;
        }
        var d = this.au(false);
        if (d != null) {
            var e = d;
            return e.i(c);
        }
        else {
            return c.toString();
        }
    };
    CategorySeries.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.yy = a;
    };
    CategorySeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(CategorySeries.prototype, "categoryAxis", {
        get: function () {
            return this.yn();
        },
        enumerable: false,
        configurable: true
    });
    CategorySeries.prototype.yn = function () {
        return this.fetchXAxis();
    };
    CategorySeries.prototype.y4 = function () {
        return this.fetchYAxis();
    };
    CategorySeries.prototype.get_ej = function () {
        return true;
    };
    CategorySeries.prototype.get_f4 = function () {
        return this.y4() != null && this.y4().ch;
    };
    CategorySeries.prototype.get_ex = function () {
        return true;
    };
    CategorySeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.yy.cw.g(this.ic);
    };
    CategorySeries.prototype.zh = function () {
        return (this.assigningCategoryStyle != null && this.zb) || (this.bw != 1) || this.d1 || (this.co != 1) || (this.cn != 1);
    };
    CategorySeries.prototype.zi = function () {
        return (this.assigningCategoryMarkerStyle != null && this.za) || (this.bw != 1) || this.d1 || (this.co != 1) || (this.cn != 1);
    };
    CategorySeries.prototype.aae = function (a) {
        if (this.assigningCategoryStyle != null && this.zb) {
            this.assigningCategoryStyle(this, a);
        }
    };
    CategorySeries.prototype.aad = function (a) {
        if (this.assigningCategoryMarkerStyle != null && this.za) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    };
    CategorySeries.prototype.yh = function (a, b) {
        return null;
    };
    CategorySeries.prototype.o4 = function (a, b) {
        _super.prototype.o4.call(this, a, b);
        if (a) {
            this.z3(b);
        }
    };
    CategorySeries.prototype.bq = function () {
        var a = _super.prototype.bq.call(this);
        return a;
    };
    CategorySeries.prototype.p8 = function () {
        _super.prototype.p8.call(this);
        var a = this.fetchXAxis();
        if (a != null) {
            a.h9(false);
        }
        var b = this.fetchYAxis();
        if (b != null) {
            b.h9(false);
        }
    };
    CategorySeries.prototype.sn = function (a, b) {
        _super.prototype.sn.call(this, a, b);
        this.yy.cw.g(this.ic);
        this.rp(false);
    };
    CategorySeries.prototype.sm = function (a, b) {
        if (this.g0 && this.jp < 0.05 && (this.da == null || !this.da.fm())) {
            this.g1 = true;
            this.g4 = false;
            this.gj = false;
        }
        _super.prototype.sm.call(this, a, b);
        this.yy.cw.g(this.ic);
        this.rp(false);
    };
    CategorySeries.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = this.fetchYAxis();
                var f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.pb(f);
                    this.pb(e);
                }
                if (c == null && d != null) {
                    this.rf(f);
                    this.rf(e);
                }
                this.yy.cw.g(this.ic);
                this.rp(false);
                break;
            case "SyncLink":
                if (this.c2 != null && this.da != null) {
                    this.yy.cw.g(this.ic);
                }
                this.rp(false);
                break;
            case "TransitionProgress":
                this.yt.c(this.jp, this.yr, this.yp);
                if (this.d4(this.cu)) {
                    return;
                }
                if (this.jp == 1) {
                    this.yp.w();
                    this.aaf(this.yp, this.yy);
                    if (this.g0) {
                        this.g0 = false;
                        this.o5();
                        this.db.r = truncate(this.i8());
                        this.db.b = this.dc;
                    }
                    if (this.g3) {
                        this.g3 = false;
                        this.o5();
                        this.db.r = truncate(this.i8());
                        this.db.b = this.dc;
                        this.qy();
                    }
                    this.qm();
                }
                else {
                    this.aaf(this.yt, this.yy);
                }
                if (this.da != null) {
                    this.da.qj(this);
                }
                break;
            case "ErrorBarSettings":
                this.qj();
                break;
            case CategorySeries.$$p[5]:
                this.rp(false);
                break;
            case CategorySeries.$$p[2]:
                this.zb = this.zd();
                this.rp(false);
                break;
            case CategorySeries.$$p[1]:
                this.za = this.zc();
                this.rp(false);
                break;
        }
    };
    CategorySeries.prototype.zd = function () {
        return this.zf;
    };
    CategorySeries.prototype.zc = function () {
        return this.ze;
    };
    CategorySeries.prototype.zo = function (a) {
        return this.is(a, this.fetchXAxis());
    };
    CategorySeries.prototype.get_fr = function () {
        return typeCast(ISortingAxis_$type, this.yn()) !== null;
    };
    CategorySeries.prototype.a0 = function () {
        return this.yn();
    };
    CategorySeries.prototype.j4 = function (a) {
        return this.y3.b$d(this, a);
    };
    CategorySeries.prototype.km = function (a) {
        return this.y3.b$f(this, a);
    };
    CategorySeries.prototype.j2 = function (a) {
        var b = truncate(Math.round(this.iq(a)));
        return b;
    };
    CategorySeries.prototype.iq = function (a) {
        return this.y3.b$c(this, a);
    };
    CategorySeries.prototype.dg = function (a, b, c) {
        if (this.fy(this.bw) && !c) {
            var d = this.y7(a, b, this.y9);
            this.y9 = d;
            return d;
        }
        else {
            var e = this.y5(a, b, this.y9);
            e.d = true;
            this.y9 = e;
            return e;
        }
    };
    CategorySeries.prototype.get_fd = function () {
        return true;
    };
    CategorySeries.prototype.o2 = function () {
        _super.prototype.o2.call(this);
        this.y8 = null;
        this.y9 = null;
    };
    CategorySeries.prototype.df = function (a, b, c) {
        if (this.ec && this.fy(this.bw) && !c) {
            var d = this.y6(a, b, this.y8);
            this.y8 = d;
            return d;
        }
        else {
            var e = this.y5(a, b, this.y8);
            this.y8 = e;
            return e;
        }
    };
    CategorySeries.prototype.zn = function () {
        return this.yy.cz.a;
    };
    CategorySeries.prototype.y7 = function (a, b, c) {
        if (!this.xb()) {
            return null;
        }
        var d = this.yq();
        var e = this.zn();
        return this.y3.b$b(this, e, this.zr(this.cu), this.zq(this.cu), d.f, a, b, c);
    };
    CategorySeries.prototype.y6 = function (a, b, c) {
        var d = this.zr(this.cu);
        var e = this.zs(this.cu);
        var f = this.zq(this.cu);
        var g = this.yq();
        return this.y3.b$a(this, g.f, g.m, d, e, f, a, b, c);
    };
    CategorySeries.prototype.y5 = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.dm != null ? this.dm.count - 1 : 0;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    CategorySeries.prototype.yq = function () {
        var a = this.yp;
        if (this.d2()) {
            if (this.db.g) {
                this.db.t();
            }
            a = this.yt;
        }
        return a;
    };
    CategorySeries.prototype.aaa = function (a, b, c, d, e, f, g) {
        var h = this.bw != 1;
        var i = this.d1;
        var j = this.co != 1;
        var k = this.cn != 1;
        this.yx.a3(this.yx.d, d.cn, a, b, c, d, e, f, true, g);
        this.yx.aa(this.ia);
        var l = this.yx.ax;
        var m = null;
        var n = this.dm;
        var o = null;
        var p = null;
        var q = null;
        var r = null;
        var s = null;
        if (i && this.da != null && !l.e) {
            var t = this.vk(l.z);
            var u = this.vl(l.z);
            this.yx.ae = t;
            this.yx.af = u;
            l.aa = t;
            l.ab = u;
        }
        if (h && this.da != null) {
            m = this.da.dk.getHighlightingInfo(this, n, l.z, l.y, true);
            if (this.da.dk.isCrossContextHighlight(this)) {
                o = this.da.dk.getHighlightingInfo(this, n, l.z, l.y, true);
            }
            l.c = m;
        }
        if (j && this.da != null) {
            p = this.da.dl.getHighlightingInfo(this, n, l.z, l.y, true);
            if (p == null && this.bm != null) {
                p = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, l.z, l.y, true);
            }
            if (this.da.dl.isCrossContextHighlight(this)) {
                r = this.da.dl.getHighlightingInfo(this, n, l.z, l.y, true);
            }
            l.d = p;
        }
        if (k && this.da != null) {
            q = this.da.dj.getHighlightingInfo(this, n, l.z, l.y, true);
            if (this.da.dj.isCrossContextHighlight(this)) {
                s = this.da.dj.getHighlightingInfo(this, n, l.z, l.y, true);
            }
            l.b = q;
        }
        l.h = f;
        this.aad(l);
        this.yx.y(this, m, p, q, f, h, j, k, l.v, this.da.dk.totalHighWaterMark, l.x, this.da.dl.totalHighWaterMark, l.t, this.da.dj.totalHighWaterMark);
    };
    CategorySeries.prototype.aab = function (a, b, c, d, e, f, g) {
        var h = this.bw != 1;
        var i = this.co != 1;
        var j = this.cn != 1;
        var k = this.d1;
        this.yx.a3(this.yx.b, d.cn, a, b, c, d, e, f, false, g);
        this.yx.ab(this.ia);
        var l = this.yx.ay;
        var m = null;
        var n = null;
        var o = null;
        var p = this.dm;
        if (k && this.da != null && !l.e) {
            var q = this.vj(l.z);
            var r = this.vm(l.z);
            this.yx.ag = q;
            this.yx.ah = r;
            l.aa = q;
            l.ab = r;
        }
        if (h && this.da != null) {
            m = this.da.dk.getHighlightingInfo(this, p, l.z, l.y, false);
            l.c = m;
        }
        if (i && this.da != null) {
            n = this.da.dl.getHighlightingInfo(this, p, l.z, l.y, false);
            if (n == null && this.bm != null) {
                n = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, l.z, l.y, false);
            }
            l.d = n;
        }
        if (j && this.da != null) {
            o = this.da.dj.getHighlightingInfo(this, p, l.z, l.y, false);
            if (o == null && this.bm != null) {
                o = this.da.dj.getHighlightingInfo(this.bm, this.bm.dm, l.z, l.y, false);
            }
            l.b = o;
        }
        l.h = f;
        this.aae(l);
        this.yx.z(this, m, n, o, f, h, i, j, b < 0);
    };
    CategorySeries.prototype.hd = function (a, b, c) {
        var d = _super.prototype.hd.call(this, a, b, c);
        d = d && this.zm(this.fetchXAxis());
        d = d && this.zm(this.fetchYAxis());
        var e = c;
        if (!c.o() || b.isEmpty || a.isEmpty || this.dm == null) {
            d = false;
        }
        if (!d) {
            e.cw.d = 0;
        }
        return d;
    };
    CategorySeries.prototype.zm = function (a) {
        if (a == null || a.bi == null) {
            return false;
        }
        var b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.lh < 1) {
                return false;
            }
        }
        else {
            var c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.l2 != c.l1;
            }
        }
        return true;
    };
    CategorySeries.prototype.gm = function () {
        return this.zg;
    };
    CategorySeries.prototype.gn = function () {
        return true;
    };
    CategorySeries.prototype.yz = function () {
        return 12;
    };
    CategorySeries.prototype.o5 = function () {
        _super.prototype.o5.call(this);
        this.yr.w();
        this.yp.w();
        this.yt.w();
    };
    CategorySeries.prototype.rq = function (a) {
        _super.prototype.rq.call(this, a);
        this.yy.cw.g(this.ic);
        if (this.d4(this.cu)) {
            this.yp.z();
            this.yt.z();
            this.yr.z();
            return;
        }
        if (this.gq) {
            if (this.d2()) {
                if (this.db.g) {
                    this.db.t();
                }
                this.aaf(this.yt, this.yy);
            }
            else {
                this.aaf(this.yp, this.yy);
            }
            return;
        }
        if (this.ge(a)) {
            var b = this.yr;
            if (this.d2()) {
                if (this.db.g) {
                    this.db.t();
                }
                this.yr = this.yt;
                this.yt = b;
            }
            else {
                this.yr = this.yp;
                this.yp = b;
            }
            var c = false;
            this.aac(this.yp, this.yy);
            if (this.g2) {
                this.db.w();
                this.db.r = truncate(this.i9());
                this.db.b = this.dd != null ? this.dd : this.dc;
                if (this.g3) {
                    var d = this.yt;
                    this.yt = this.yr;
                    this.yr = d;
                    c = true;
                }
                this.y1.s(this, this.yr, this.yp, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.y0, this.yz(), this.c4, this.c3(), runOn(this, this.zp), this.yy.bx);
                if (this.g3) {
                    var e = this.yt;
                    this.yt = this.yr;
                    this.yr = e;
                }
                this.g3 = false;
            }
            if (this.g5) {
                this.db.w();
                this.db.r = truncate(this.ja());
                this.db.b = this.de != null ? this.de : this.dc;
                if (this.g0) {
                    var f = this.yt;
                    this.yt = this.yr;
                    this.yr = f;
                    c = true;
                }
                this.y1.s(this, this.yr, this.yp, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.y0, this.yz(), this.c4, this.c3(), runOn(this, this.zp), this.yy.bx);
                var g = this.yp;
                this.yp = this.yr;
                this.yr = g;
                if (this.g0) {
                    var h = this.yt;
                    this.yt = this.yr;
                    this.yr = h;
                }
                this.g0 = false;
            }
            this.d8 = false;
            if (!c) {
                this.o0();
            }
            this.r3();
            if (this.g2) {
                this.g1 = false;
                this.g0 = true;
            }
            if (this.g5) {
                this.g4 = false;
                this.g3 = true;
            }
        }
        else {
            this.aac(this.yp, this.yy);
            this.aaf(this.yp, this.yy);
        }
    };
    CategorySeries.prototype.c3 = function () {
        return 3;
    };
    CategorySeries.prototype.c6 = function () {
        var a = this.c3();
        switch (a) {
            case 0: return 0;
            case 1: return 1;
            case 4: return 4;
            case 2: return 2;
            case 3: return 3;
        }
        return 3;
    };
    CategorySeries.prototype.zp = function () {
        if (this.isVertical) {
            return this.wo.left;
        }
        return this.wo.bottom;
    };
    CategorySeries.prototype.zj = function () {
        return false;
    };
    CategorySeries.prototype.hs = function () {
        var a = _super.prototype.hs.call(this);
        if (this.zj()) {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "DashArray";
                $ret.p = true;
                $ret.x = ((function () {
                    var $ret = new DoubleCollection();
                    $ret.add(5);
                    $ret.add(5);
                    return $ret;
                })());
                $ret.q = true;
                return $ret;
            })());
            a.add(b);
        }
        if (!this.zj()) {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.rx));
            a.add(c);
        }
        if (!this.zj()) {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.rx));
            a.add(d);
        }
        var e = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(e);
        var f = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(f);
        return a;
    };
    CategorySeries.prototype.ku = function () {
        if (this.d2()) {
            return this.bm.yt;
        }
        else {
            return this.bm.yp;
        }
    };
    CategorySeries.prototype.zt = function () {
        var e_1, _a;
        if (this.bm != null) {
            var a = this.bm;
            return a.zt();
        }
        var b = 0;
        var c = this.fetchXAxis();
        try {
            for (var _b = __values(fromEnum(this.da.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                if (d == this) {
                    return b;
                }
                var e = typeCast(CategorySeries.$, d);
                if (e != null) {
                    var f = typeCast(CategoryAxisBase.$, e.fetchXAxis());
                    if (f == c && e.preferredCategoryMode(f) == 2) {
                        b++;
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.fetchXAxis();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.fetchYAxis();
        },
        enumerable: false,
        configurable: true
    });
    CategorySeries.prototype.z4 = function (a, b) {
        this.yx.a1(this, this.zi(), runOn(this, this.yh), this.zq(a), this.zr(a));
        var c = this.yx.d;
        var d = c != null;
        var e = this.yn();
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.by, a.bx, e.ch, f);
        var h = this.dm == null ? 0 : this.dm.count;
        var i = a;
        var j = b.f;
        var k = i.cw.e;
        var l = i.cw.f;
        var m = i.cw.d;
        var n = k * m;
        for (var o = 0; o < a.cz.count; o++) {
            var p = a.cz.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.aaa(j, r, h, e, g, a.q, p.ak);
            }
            this.yx.ac(p, q);
        }
    };
    CategorySeries.prototype.aaf = function (a, b) {
        this.qv();
        this.we = a.ab;
        b.aw();
    };
    CategorySeries.prototype.aac = function (a, b) {
        a.v();
    };
    CategorySeries.prototype.zq = function (a) {
        return a.cw.d;
    };
    CategorySeries.prototype.zr = function (a) {
        return a.cw.e;
    };
    CategorySeries.prototype.zs = function (a) {
        return a.cw.f;
    };
    CategorySeries.prototype.z3 = function (a) {
        var b = a;
        b.cz.count = 0;
    };
    CategorySeries.prototype.rr = function (a, b) {
        _super.prototype.rr.call(this, a, b);
        if (!this.gz) {
            this.cu.a4(b);
            return;
        }
        var c = typeCast(CategorySeriesView.$, this.ct);
        c.cw.g(this.ic);
        this.cu.a4(b);
        if (this.d4(this.ct)) {
            return;
        }
        this.aag();
        this.gz = false;
    };
    CategorySeries.prototype.aag = function () {
        var a = typeCast(CategorySeriesView.$, this.ct);
        if (!this.gr) {
            this.aac(this.ys, a);
        }
        this.gr = false;
        this.aaf(this.ys, a);
    };
    CategorySeries.prototype.yv = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.q) {
            if (b.p) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cw);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.da.c9.o, this, b.cw);
            }
        }
        else {
            return this.yu;
        }
    };
    CategorySeries.prototype.aw = function (a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    };
    CategorySeries.prototype.ai = function () {
        return [this.fetchXAxis(), this.fetchYAxis()];
    };
    CategorySeries.yi = function (a, b, c, d, e) {
        var f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            var g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            var h = c.bottom + 10;
            var i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            var j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    };
    CategorySeries.prototype.z7 = function (a, b, c, d, e) {
        var f = this.wn(a);
        var g = this.yn();
        var h = this.y4();
        var i = this.fetchXAxis();
        var j = g == i;
        var k = this.wf(this.cu);
        var l, m;
        var n = this.z6(f, g, j, k, l, m);
        l = n.p4;
        m = n.p5;
        if (d == 0) {
            this.z9(b, l, m, c);
        }
        else {
            var o = void 0, p = void 0;
            var q = this.z5(f, h, j, k, o, p);
            o = q.p4;
            p = q.p5;
            this.z8(e, b, l, m, o, p, c);
        }
    };
    CategorySeries.prototype.z9 = function (a, b, c, d) {
        var _this = this;
        if (b == -1 || c == -1) {
            return;
        }
        if (d == 7 || d == 6) {
            a.add(((function () {
                var $ret = new ChartSelection();
                $ret.series = _this;
                return $ret;
            })()));
            return;
        }
        for (var e = b; e <= c; e++) {
            this.z2(a, e, d);
        }
    };
    CategorySeries.prototype.z5 = function (a, b, c, d, e, f) {
        var g = new ScalerParams(0, a, this.da.wc, b.ch, this.getEffectiveViewport());
        var h = c ? (b.ch ? d.top : d.bottom) : (b.ch ? d.right : d.left);
        var i = c ? (b.ch ? d.bottom : d.top) : (b.ch ? d.left : d.right);
        e = b.en(h, g);
        f = b.en(i, g);
        return {
            p4: e,
            p5: f
        };
    };
    CategorySeries.prototype.z6 = function (a, b, c, d, e, f) {
        var g = new ScalerParams(0, a, this.da.wc, b.ch, this.getEffectiveViewport());
        var h = c ? (b.ch ? d.right : d.left) : (b.ch ? d.top : d.bottom);
        var i = c ? (b.ch ? d.left : d.right) : (b.ch ? d.bottom : d.top);
        var j = b.en(h, g);
        var k = b.en(i, g);
        e = Math.max(0, truncate((b.categoryMode == 0 ? Math.ceil(j) : Math.floor(j))));
        f = Math.min(truncate(Math.floor(k)), this.dm.count - 1);
        return {
            p4: e,
            p5: f
        };
    };
    CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    CategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['CategoryCollisionMode:yo:aah', [CategoryCollisionMode_$type, enumGetBox(CategoryCollisionMode_$type, 0)], 'IsCustomCategoryMarkerStyleAllowed:ze:aai', [0, false], 'IsCustomCategoryStyleAllowed:zf:aaj', [0, false], 'IsTransitionInEnabled:zg:aak', [0, false], 'TransitionInMode:y0:aal', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:zl:aam', [0, false]]);
    return CategorySeries;
}(MarkerSeries));
export { CategorySeries };
/**
 * @hidden
 */
var CategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeriesView, _super);
    function CategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cy = null;
        _this.c1 = 0;
        _this.cw = null;
        _this.cz = null;
        _this.c1 = -1;
        _this.cy = a;
        _this.cw = _this.cx();
        _this.cz = ((function () {
            var $ret = new Pool$1(Marker.$);
            $ret.create = runOn(_this, _this.b3);
            $ret.activate = runOn(_this, _this.co);
            $ret.disactivate = runOn(_this, _this.cq);
            $ret.destroy = runOn(_this, _this.cp);
            return $ret;
        })());
        return _this;
    }
    CategorySeriesView.prototype.c0 = function (a) {
        if (this.c1 != a.u) {
            return true;
        }
        return false;
    };
    CategorySeriesView.prototype.c3 = function (a) {
        this.c1 = a.u;
    };
    CategorySeriesView.prototype.updateMarkerTemplate = function (a, b, c) {
        if (!this.b4.xd) {
            var d = this.cz.item(a);
            var e = d.content;
            e.item = this.e.dm.item(b);
            d.ak = b;
            d.al = c;
        }
    };
    CategorySeriesView.prototype.cx = function () {
        return new CategoryBucketCalculator(this);
    };
    Object.defineProperty(CategorySeriesView.prototype, "shouldDisplayMarkers", {
        get: function () {
            return this.cy.xb();
        },
        enumerable: false,
        configurable: true
    });
    CategorySeriesView.prototype.updateMarkerCount = function (a) {
        this.cz.count = a;
    };
    CategorySeriesView.prototype.cj = function (a) {
        this.cz.c(a);
    };
    CategorySeriesView.prototype.c2 = function () {
    };
    CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
}(MarkerSeriesView));
export { CategorySeriesView };
