/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __generator, __values } from "tslib";
import { EventArgs, Base, markType, typeCast, runOn, delegateCombine, enumGetBox, Point_$type, String_$type, Number_$type, fromEnum, toEnum, Date_$type, markDep, Delegate_$type } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { IFastItemColumn$1_$type } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-react-core";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FastReflectionHelper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-react-core";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { dateToStringFormat } from "igniteui-react-core";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { SRProvider } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
var FinancialEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialEventArgs, _super);
    function FinancialEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._position = 0;
        _this._count = 0;
        _this._dataSource = null;
        _this._supportingCalculations = null;
        _this._basedOn = null;
        _this.position = a;
        _this.count = b;
        _this.dataSource = c;
        _this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
        return _this;
    }
    Object.defineProperty(FinancialEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (a) {
            this._dataSource = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
        get: function () {
            return this._supportingCalculations;
        },
        set: function (a) {
            this._supportingCalculations = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
        get: function () {
            return this._basedOn;
        },
        set: function (a) {
            this._basedOn = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
}(EventArgs));
export { FinancialEventArgs };
/**
 * @hidden
 */
var FinancialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialBucketCalculator, _super);
    function FinancialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        _this.c = -1;
        _this.d = _this.d;
        _this.b = 0;
        return _this;
    }
    FinancialBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.b2.ic;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    FinancialBucketCalculator.prototype.e = function (a) {
        var b = this.a.by;
        var c = this.a.bx;
        var d = this.a.bx;
        if (this.a.b2 != null) {
            d = this.a.b2.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.b2.w1 == null) {
            this.b = 0;
            return;
        }
        var e = (this.a.b2.w1 != null) ? this.a.b2.w1.ch : false;
        var f = new ScalerParams(0, b, c, e, d);
        var g = this.a.b2.wf(this.a);
        var h = typeCast(ISortingAxis_$type, this.a.b2.w1);
        if (h == null || h.i$b == null) {
            var i = Math.floor(this.a.b2.w1.en(g.left, f));
            var j = Math.ceil(this.a.b2.w1.en(g.right, f));
            if (this.a.b2.w1.ch) {
                j = Math.ceil(this.a.b2.w1.en(g.left, f));
                i = Math.floor(this.a.b2.w1.en(g.right, f));
            }
            var k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    };
    FinancialBucketCalculator.prototype.cacheValues = function () {
    };
    FinancialBucketCalculator.prototype.unCacheValues = function () {
    };
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
}(Base));
export { FinancialBucketCalculator };
/**
 * @hidden
 */
var FinancialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeries, _super);
    function FinancialSeries() {
        var _this = _super.call(this) || this;
        _this.xs = null;
        _this.xq = null;
        _this.xr = null;
        _this.xp = null;
        _this.xt = null;
        _this.x2 = false;
        _this.assigningCategoryStyle = null;
        _this.xa = null;
        _this.yc = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        _this.yd = new Dictionary$2(String_$type, String_$type, 0);
        _this.x1 = false;
        _this.xo = null;
        _this.w5 = null;
        _this.w7 = null;
        _this.w3 = null;
        _this.xd = null;
        _this.typical = null;
        _this.typicalBasedOn = null;
        _this.x0 = false;
        _this.yp = null;
        _this.yn = null;
        _this.yo = null;
        _this.ym = null;
        _this.yq = null;
        _this.w6 = null;
        _this.w2 = null;
        _this.w8 = 0;
        _this.xj = null;
        _this.xl = null;
        _this.xa = new CategorySeriesRenderManager();
        _this.x2 = false;
        _this.xd = new CategoryTransitionSourceFramePreparer();
        _this.w6 = new CategoryFrame(3);
        _this.ab = FinancialSeries.$;
        _this.w9 = 0;
        return _this;
    }
    FinancialSeries.prototype.hs = function () {
        var a = _super.prototype.hs.call(this);
        {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "OpenMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedOpenMemberPath";
                $ret.q = true;
                return $ret;
            })());
            b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.z4));
            a.add(b);
        }
        {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "HighMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedHighMemberPath";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.z2));
            a.add(c);
        }
        {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "LowMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedLowMemberPath";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.z3));
            a.add(d);
        }
        {
            var e = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "CloseMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedCloseMemberPath";
                $ret.q = true;
                return $ret;
            })());
            e.valueResolving = delegateCombine(e.valueResolving, runOn(this, this.z1));
            a.add(e);
        }
        {
            var f = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "VolumeMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedVolumeMemberPath";
                $ret.q = true;
                return $ret;
            })());
            f.valueResolving = delegateCombine(f.valueResolving, runOn(this, this.z5));
            a.add(f);
        }
        {
            var g = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            g.valueResolving = delegateCombine(g.valueResolving, runOn(this, this.rx));
            a.add(g);
        }
        {
            var h = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            h.valueResolving = delegateCombine(h.valueResolving, runOn(this, this.rx));
            a.add(h);
        }
        {
            var i = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "NegativeBrush";
                $ret.p = true;
                $ret.q = true;
                return $ret;
            })());
            i.valueResolving = delegateCombine(i.valueResolving, runOn(this, this.rx));
            a.add(i);
        }
        {
            var j = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "NegativeOutline";
                $ret.p = true;
                $ret.q = true;
                return $ret;
            })());
            j.valueResolving = delegateCombine(j.valueResolving, runOn(this, this.rx));
            a.add(j);
        }
        var k = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(k);
        var l = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(l);
        return a;
    };
    FinancialSeries.prototype.z4 = function (a, b) {
        if (this.ze != null) {
            b.value = this.ze;
            return;
        }
        b.value = this.zr;
    };
    FinancialSeries.prototype.z2 = function (a, b) {
        if (this.za != null) {
            b.value = this.za;
            return;
        }
        b.value = this.zi;
    };
    FinancialSeries.prototype.z3 = function (a, b) {
        if (this.zc != null) {
            b.value = this.zc;
            return;
        }
        b.value = this.zn;
    };
    FinancialSeries.prototype.z1 = function (a, b) {
        if (this.y8 != null) {
            b.value = this.y8;
            return;
        }
        b.value = this.y5;
    };
    FinancialSeries.prototype.z5 = function (a, b) {
        if (this.zg != null) {
            b.value = this.zg;
            return;
        }
        b.value = this.zv;
    };
    FinancialSeries.prototype.ku = function () {
        if (this.d2()) {
            return this.bm.w7;
        }
        else {
            return this.bm.w3;
        }
    };
    FinancialSeries.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.xi = a;
    };
    FinancialSeries.prototype.get_e5 = function () {
        return true;
    };
    FinancialSeries.prototype.ai = function () {
        return [this.w1, this.xk];
    };
    FinancialSeries.prototype.kp = function (a, b) {
        var c = this.nc(b);
        if (c == FinancialSeries.$$p[11]) {
            return this.kq(a, b, this.zr);
        }
        if (c == FinancialSeries.$$p[1]) {
            return this.kq(a, b, this.zi);
        }
        if (c == FinancialSeries.$$p[9]) {
            return this.kq(a, b, this.zn);
        }
        if (c == FinancialSeries.$$p[0]) {
            return this.kq(a, b, this.y5);
        }
        if (c == FinancialSeries.$$p[13]) {
            return this.kq(a, b, this.zv);
        }
        if (c == FinancialSeries.$$p[5]) {
            return this.kq(a, b, this.ze);
        }
        if (c == FinancialSeries.$$p[3]) {
            return this.kq(a, b, this.za);
        }
        if (c == FinancialSeries.$$p[4]) {
            return this.kq(a, b, this.zc);
        }
        if (c == FinancialSeries.$$p[2]) {
            return this.kq(a, b, this.y8);
        }
        if (c == FinancialSeries.$$p[6]) {
            return this.kq(a, b, this.zg);
        }
        return _super.prototype.kp.call(this, a, b);
    };
    FinancialSeries.prototype.mc = function (a) {
        var b = this.nc(a);
        if (b == FinancialSeries.$$p[11]) {
            return this.zr;
        }
        if (b == FinancialSeries.$$p[1]) {
            return this.zi;
        }
        if (b == FinancialSeries.$$p[9]) {
            return this.zn;
        }
        if (b == FinancialSeries.$$p[0]) {
            return this.y5;
        }
        if (b == FinancialSeries.$$p[13]) {
            return this.zv;
        }
        if (b == FinancialSeries.$$p[5]) {
            return this.ze;
        }
        if (b == FinancialSeries.$$p[3]) {
            return this.za;
        }
        if (b == FinancialSeries.$$p[4]) {
            return this.zc;
        }
        if (b == FinancialSeries.$$p[2]) {
            return this.y8;
        }
        if (b == FinancialSeries.$$p[6]) {
            return this.zg;
        }
        return _super.prototype.mc.call(this, a);
    };
    FinancialSeries.prototype.y1 = function () {
        return 2;
    };
    FinancialSeries.prototype.yz = function () {
        return 4;
    };
    FinancialSeries.prototype.aj = function (a) {
        var b = this.an(this.w1, this.w3.f, this.yy(this.cu), this.y0(this.cu), this.wd(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        var g = this.y1();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.al = function (a) {
        var b = this.an(this.w1, this.w3.f, this.yy(this.cu), this.y0(this.cu), this.wd(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.vs = function () {
        return this.aar;
    };
    FinancialSeries.prototype.vt = function () {
        return this.aar;
    };
    FinancialSeries.prototype.o1 = function () {
        _super.prototype.o1.call(this);
        this.w1 = null;
        this.xk = null;
    };
    FinancialSeries.prototype.get_ej = function () {
        return true;
    };
    FinancialSeries.prototype.get_f4 = function () {
        return this.xk != null && this.xk.ch;
    };
    Object.defineProperty(FinancialSeries.prototype, "xx", {
        get: function () {
            return this.xs;
        },
        set: function (a) {
            if (this.xs != a) {
                var b = this.xs;
                this.xs = a;
                this.raisePropertyChanged("OpenColumn", b, this.xs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "xv", {
        get: function () {
            return this.xq;
        },
        set: function (a) {
            if (this.xq != a) {
                var b = this.xq;
                this.xq = a;
                this.raisePropertyChanged("HighColumn", b, this.xq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "xw", {
        get: function () {
            return this.xr;
        },
        set: function (a) {
            if (this.xr != a) {
                var b = this.xr;
                this.xr = a;
                this.raisePropertyChanged("LowColumn", b, this.xr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "xu", {
        get: function () {
            return this.xp;
        },
        set: function (a) {
            if (this.xp != a) {
                var b = this.xp;
                this.xp = a;
                this.raisePropertyChanged("CloseColumn", b, this.xp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "xz", {
        get: function () {
            return this.xt;
        },
        set: function (a) {
            if (this.xt != a) {
                var b = this.xt;
                this.xt = a;
                this.raisePropertyChanged("VolumeColumn", b, this.xt);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.ga = function () {
        return this.highlightedItemsSource != null || (this.ze != null && this.za != null && this.zc != null && this.y8 != null);
    };
    FinancialSeries.prototype.x9 = function () {
        return (this.assigningCategoryStyle != null && this.x2) || this.bw != 1 || this.co != 1 || this.cn != 1;
    };
    FinancialSeries.prototype.z8 = function (a) {
        if (this.assigningCategoryStyle != null && this.x2) {
            this.assigningCategoryStyle(this, a);
        }
    };
    FinancialSeries.prototype.z6 = function (a, b, c, d, e, f, g) {
        var h = this.bw != 1;
        var i = this.co != 1;
        var j = this.cn != 1;
        this.xa.a3(this.xa.b, d.cn, a, b, c, d, e, f, false, g);
        this.xa.ab(this.ia);
        var k = this.xa.ay;
        var l = null;
        var m = null;
        var n = null;
        var o = this.dm;
        if (h && this.da != null) {
            l = this.da.dk.getHighlightingInfo(this, o, k.z, k.y, false);
            k.c = l;
        }
        if (i && this.da != null) {
            m = this.da.dl.getHighlightingInfo(this, o, k.z, k.y, false);
            if (m == null && this.bm != null) {
                m = this.da.dl.getHighlightingInfo(this.bm, this.bm.dm, k.z, k.y, false);
            }
            k.d = m;
        }
        if (j && this.da != null) {
            n = this.da.dj.getHighlightingInfo(this, o, k.z, k.y, false);
            k.b = n;
        }
        k.h = f;
        this.z8(k);
        this.xa.z(this, l, m, n, f, h, i, j, b < 0);
    };
    FinancialSeries.prototype.yr = function (a) {
        return this.is(a, this.w1);
    };
    FinancialSeries.prototype.j9 = function (a, b) {
        return this.ka(a, b, this.w1, runOn(this, this.yr), new FinancialValueList(this.xx, this.xv, this.xw, this.xu, this.xz));
    };
    FinancialSeries.prototype.j7 = function (a, b) {
        return this.j8(a, b, this.w1, runOn(this, this.yr), new FinancialValueList(this.xx, this.xv, this.xw, this.xu, this.xz));
    };
    FinancialSeries.prototype.io = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.w1.lh;
        return this.ip(a, b, this.w1, d, e, f, runOn(this, this.yr));
    };
    FinancialSeries.prototype.getOffsetValue = function () {
        return this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
    };
    FinancialSeries.prototype.getCategoryWidth = function () {
        return this.w1.getCategorySize(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu));
    };
    FinancialSeries.prototype.v8 = function (a, b, c) {
        return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, null, null, null);
    };
    FinancialSeries.prototype.i4 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ys(this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
        return this.i6(new FinancialValueList(this.xx, this.xv, this.xw, this.xu, this.xz), a, this.w1, f, e, runOn(this, this.yr), b, c);
    };
    FinancialSeries.prototype.i0 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ys(this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
        return this.i6(this.xv, a, this.w1, f, e, runOn(this, this.yr), b, c);
    };
    FinancialSeries.prototype.i2 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ys(this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
        return this.i6(this.xw, a, this.w1, f, e, runOn(this, this.yr), b, c);
    };
    FinancialSeries.prototype.yt = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ys(this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
        return this.i6(this.xu, a, this.w1, f, e, runOn(this, this.yr), b, c);
    };
    FinancialSeries.prototype.yu = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ys(this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
        return this.i6(this.xx, a, this.w1, f, e, runOn(this, this.yr), b, c);
    };
    FinancialSeries.prototype.yv = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cu);
        var e = this.ys(this.cu.by, this.cu.bx, d);
        var f = new ScalerParams(0, this.cu.by, this.cu.bx, this.w1.ch, d);
        return this.i6(this.xz, a, this.w1, f, e, runOn(this, this.yr), b, c);
    };
    FinancialSeries.prototype.v4 = function (a, b, c) {
        var _this = this;
        return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.i0), function (d, e) { return _this.ka(d, e, _this.w1, runOn(_this, _this.yr), _this.xv); }, function (d, e) { return _this.j8(d, e, _this.w1, runOn(_this, _this.yr), _this.xv); });
    };
    FinancialSeries.prototype.v6 = function (a, b, c) {
        var _this = this;
        return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.i2), function (d, e) { return _this.ka(d, e, _this.w1, runOn(_this, _this.yr), _this.xw); }, function (d, e) { return _this.j8(d, e, _this.w1, runOn(_this, _this.yr), _this.xw); });
    };
    FinancialSeries.prototype.aat = function (a, b, c) {
        var _this = this;
        return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.yu), function (d, e) { return _this.ka(d, e, _this.w1, runOn(_this, _this.yr), _this.xx); }, function (d, e) { return _this.j8(d, e, _this.w1, runOn(_this, _this.yr), _this.xx); });
    };
    FinancialSeries.prototype.aas = function (a, b, c) {
        var _this = this;
        return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.yt), function (d, e) { return _this.ka(d, e, _this.w1, runOn(_this, _this.yr), _this.xu); }, function (d, e) { return _this.j8(d, e, _this.w1, runOn(_this, _this.yr), _this.xu); });
    };
    FinancialSeries.prototype.aau = function (a, b, c) {
        var _this = this;
        return this.wa(a, b, c, this.ys(this.cu.by, this.cu.bx, this.getEffectiveViewport1(this.cu)), this.xk, this.w1, runOn(this, this.yv), function (d, e) { return _this.ka(d, e, _this.w1, runOn(_this, _this.yr), _this.xz); }, function (d, e) { return _this.j8(d, e, _this.w1, runOn(_this, _this.yr), _this.xz); });
    };
    FinancialSeries.prototype.p8 = function () {
        _super.prototype.p8.call(this);
        if (this.w1 != null) {
            this.w1.h9(false);
        }
        if (this.xk != null) {
            this.xk.h9(false);
        }
    };
    FinancialSeries.prototype.sn = function (a, b) {
        this.xi.b0.e(this.ic);
        this.rp(false);
    };
    FinancialSeries.prototype.sm = function (a, b) {
        if (this.g0 && this.jp < 0.05) {
            this.g1 = true;
            this.g4 = false;
            this.gj = false;
        }
        this.xi.b0.e(this.ic);
        this.rp(false);
    };
    FinancialSeries.prototype.xy = function (a, b, c) {
        var d = this.dj(b);
        this.yc.addItem(d, b);
        this.yd.addItem(b, c);
        return d;
    };
    FinancialSeries.prototype.z0 = function (a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        var c = this.yc.item(b);
        this.yd.removeItem(c);
        this.yc.removeItem(b);
    };
    FinancialSeries.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.c2 != null && this.da != null) {
                    this.xi.b0.e(this.ic);
                    this.rp(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.w1 != null) {
                        this.w1.b0(this);
                    }
                    if (this.xk != null) {
                        this.xk.b0(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.w1 != null) {
                        this.w1.ct(this);
                    }
                    if (this.xk != null) {
                        this.xk.ct(this);
                    }
                }
                this.xi.b0.e(this.ic);
                this.rp(false);
                break;
            case "FastItemsSource":
                this.x1 = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.z0(typeCast(IFastItemsSource_$type, c), this.xx);
                    this.z0(typeCast(IFastItemsSource_$type, c), this.xv);
                    this.z0(typeCast(IFastItemsSource_$type, c), this.xw);
                    this.z0(typeCast(IFastItemsSource_$type, c), this.xu);
                    this.z0(typeCast(IFastItemsSource_$type, c), this.xz);
                    this.xx = null;
                    this.xv = null;
                    this.xw = null;
                    this.xu = null;
                    this.xz = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (stringIsNullOrEmpty(this.zr) == false) {
                        this.xx = this.xy(typeCast(IFastItemsSource_$type, d), this.zr, "OpenColumn");
                    }
                    if (stringIsNullOrEmpty(this.zi) == false) {
                        this.xv = this.xy(typeCast(IFastItemsSource_$type, d), this.zi, "HighColumn");
                    }
                    if (stringIsNullOrEmpty(this.zn) == false) {
                        this.xw = this.xy(typeCast(IFastItemsSource_$type, d), this.zn, "LowColumn");
                    }
                    if (stringIsNullOrEmpty(this.y5) == false) {
                        this.xu = this.xy(typeCast(IFastItemsSource_$type, d), this.y5, "CloseColumn");
                    }
                    if (stringIsNullOrEmpty(this.zv) == false) {
                        this.xz = this.xy(typeCast(IFastItemsSource_$type, d), this.zv, "VolumeColumn");
                    }
                }
                this.x1 = false;
                if (this.xk != null && !this.xk.c1()) {
                    this.xi.b0.e(this.ic);
                    this.rp(this.gf && c != null);
                }
                break;
            case FinancialSeries.$$p[11]:
                if (this.dm != null) {
                    this.z0(this.dm, this.xx);
                    this.xx = this.xy(this.dm, this.zr, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.xk != null && !this.xk.c1() && !this.x1) {
                    this.xi.b0.e(this.ic);
                    this.rp(this.gf && this.d6);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.dm != null) {
                    this.z0(this.dm, this.xv);
                    this.xv = this.xy(this.dm, this.zi, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.xk != null && !this.xk.c1() && !this.x1) {
                    this.xi.b0.e(this.ic);
                    this.rp(this.gf && this.d6);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (this.dm != null) {
                    this.z0(this.dm, this.xw);
                    this.xw = this.xy(this.dm, this.zn, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.xk != null && !this.xk.c1() && !this.x1) {
                    this.xi.b0.e(this.ic);
                    this.rp(this.gf && this.d6);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.dm != null) {
                    this.z0(this.dm, this.xu);
                    this.xu = this.xy(this.dm, this.y5, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.xk != null && !this.xk.c1() && !this.x1) {
                    this.xi.b0.e(this.ic);
                    this.rp(this.gf && this.d6);
                }
                this.aaa();
                break;
            case FinancialSeries.$$p[13]:
                if (this.dm != null) {
                    this.z0(this.dm, this.xz);
                    this.xz = this.xy(this.dm, this.zv, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.xk != null && !this.xk.c1() && !this.x1) {
                    this.xi.b0.e(this.ic);
                    this.rp(this.gf && this.d6);
                }
                break;
            case FinancialSeries.$$p[14]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.xi.b0.e(this.ic);
                this.rp(false);
                this.qj();
                this.xj = typeCast(ITimeRangeSelectorAxis_$type, this.w1);
                break;
            case FinancialSeries.$$p[15]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.xi.b0.e(this.ic);
                if (this.xk != null) {
                    this.xk.c1();
                }
                {
                    this.rp(false);
                }
                this.qj();
                break;
            case "TransitionProgress":
                this.w7.c(this.jp, this.w5, this.w3);
                if (this.d4(this.cu)) {
                    return;
                }
                if (this.jp == 1) {
                    this.w3.w();
                    this.z9(this.w3, this.xi);
                    if (this.g0) {
                        this.g0 = false;
                        this.o5();
                        this.db.r = truncate(this.i8());
                        this.db.b = this.dc;
                    }
                    if (this.g3) {
                        this.g3 = false;
                        this.o5();
                        this.db.r = truncate(this.i8());
                        this.db.b = this.dc;
                        this.qy();
                    }
                    this.qm();
                }
                else {
                    this.z9(this.w7, this.xi);
                }
                if (this.da != null) {
                    this.da.qj(this);
                }
                break;
            case FinancialSeries.$$p[10]:
                this.rp(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.x2 = this.x5();
                this.rp(false);
                break;
            case "CategoryMode":
                if (this.w1 != null) {
                    this.w1.l8(true);
                }
                break;
        }
    };
    FinancialSeries.prototype.x4 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.x3 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.wu = function (a, b, c) {
        if (b < a || a < 0 || a > this.dm.count || b < 0 || b > this.dm.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cn;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.dm.item(g);
        }
        return d;
    };
    FinancialSeries.prototype.yy = function (a) {
        return a.b0.b;
    };
    FinancialSeries.prototype.y0 = function (a) {
        return a.b0.c;
    };
    FinancialSeries.prototype.wt = function (a, b) {
        return this.wu(a, b, this.xk);
    };
    FinancialSeries.prototype.get_fd = function () {
        return true;
    };
    FinancialSeries.prototype.o2 = function () {
        _super.prototype.o2.call(this);
        this.xo = null;
    };
    FinancialSeries.prototype.df = function (a, b, c) {
        if (this.ec && this.fy(this.bw) && !c) {
            var d = this.xn(a, b, this.xo);
            this.xo = d;
            return d;
        }
        else {
            var e = this.xm(a, b, this.xo);
            this.xo = e;
            return e;
        }
    };
    FinancialSeries.prototype.y2 = function (a) {
        var b = this.w4();
        var c = this.cu.bx;
        var d = this.cu.by;
        var e = this.w1;
        var f = 0;
        if (e.cp) {
            var g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            var h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        var i = b.f.count;
        var j = 0;
        for (j = 0; j < i; j++) {
            var k = b.f._inner[j];
            var l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    };
    FinancialSeries.prototype.xn = function (a, b, c) {
        if (this.dm == null) {
            return null;
        }
        var d = this.dm.count;
        var e = this.xi.b0.c;
        var f = this.xi.b0.d;
        var g = this.xi.b0.b;
        var h = this.w1;
        var i = -1;
        var j = -1;
        if (h.cn) {
            var k = this.w4();
            var l = this.y2(b);
            if (k.m != null && l >= 0 && l < k.m.count) {
                l = truncate(Math.round(k.m._inner[l]));
            }
            i = l;
            j = l;
        }
        else {
            var m = this.j2(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.g == i && c.f == j) {
            return c;
        }
        var n = new HighlightingInfo();
        n.i = this;
        n.g = i;
        n.f = j;
        return n;
    };
    FinancialSeries.prototype.xm = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.dm.count - 1;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    FinancialSeries.prototype.x5 = function () {
        return this.x7;
    };
    FinancialSeries.prototype.iq = function (a) {
        var b = this.cu.by;
        var c = this.cu.bx;
        var d = -1;
        if (!b.isEmpty && !c.isEmpty && this.w1 != null) {
            var e = this.getEffectiveViewport1(this.cu);
            var f = new ScalerParams(0, b, c, this.w1.ch, e);
            var g = this.wf(this.cu);
            var h = this.w1.en(g.left, f);
            var i = this.w1.en(g.right, f);
            var j = (a.x - b.left) / b.width;
            var k = h + (j * (i - h));
            if (this.w1.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    };
    FinancialSeries.prototype.j2 = function (a) {
        return truncate(Math.round(this.iq(a)));
    };
    FinancialSeries.prototype.get_fr = function () {
        return typeCast(ISortingAxis_$type, this.w1) !== null;
    };
    FinancialSeries.prototype.a0 = function () {
        return this.w1;
    };
    FinancialSeries.prototype.j4 = function (a) {
        var b = this.cu.by;
        var c = this.cu.bx;
        var d = this.getEffectiveViewport1(this.cu);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, b, c, this.w1.ch, d);
        var g = typeCast(ISortingAxis_$type, this.w1);
        var h = this.wf(this.cu);
        var i = h.left;
        var j = h.right;
        var k = this.v3(a).x;
        var l = this.w1.en(k, f);
        var m = this.w1.en(i, f);
        var n = this.w1.en(j, f);
        l = Math.max(m, Math.min(n, l));
        var o = g.i$f(l);
        return o;
    };
    FinancialSeries.prototype.km = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.w1) !== null) {
            b = this.j4(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.j2(a);
        }
        return b >= 0 && this.dm != null && b < this.dm.count ? this.dm.item(b) : null;
    };
    FinancialSeries.prototype.w4 = function () {
        var a = this.w3;
        if (this.d2()) {
            if (this.db.g) {
                this.db.t();
            }
            a = this.w7;
        }
        return a;
    };
    FinancialSeries.prototype.ys = function (a, b, c) {
        if (this.w1 == null) {
            return 0;
        }
        return this.w1.k7(a, b, c, this.index);
    };
    FinancialSeries.prototype.gm = function () {
        return this.x8;
    };
    FinancialSeries.prototype.xb = function () {
        return 11;
    };
    FinancialSeries.prototype.c3 = function () {
        return 3;
    };
    FinancialSeries.prototype.c6 = function () {
        return 3;
    };
    FinancialSeries.prototype.z9 = function (a, b) {
        this.qv();
        this.we = a.ab;
        b.aw();
    };
    FinancialSeries.prototype.z7 = function (a, b) {
        a.v();
    };
    FinancialSeries.prototype.hd = function (a, b, c) {
        var d = _super.prototype.hd.call(this, a, b, c);
        var e = c;
        if (this.dm == null || this.dm.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.w1 == null || this.xk == null || e.b0.b < 1 || this.w1.bi == null || this.xk.bi == null || this.xk.l2 == this.xk.l1 || this.w1.itemsSource == null || this.w1.lh < 1) {
            e.b0.b = 0;
            d = false;
        }
        return d;
    };
    FinancialSeries.prototype.getViewInfo = function (a, b) {
        b = this.cu.by;
        a = this.cu.bx;
        return {
            p0: a,
            p1: b
        };
    };
    FinancialSeries.prototype.yw = function (a) {
        var b = 0;
        var c = a.by;
        var d = a.bx;
        var e = this.getEffectiveViewport1(this.cu);
        if (!c.isEmpty && !d.isEmpty && this.xk != null) {
            var f = new ScalerParams(0, c, d, this.xk.ch, e);
            f.b = this.ix();
            b = this.xk.ek(this.xk.mc, f);
        }
        return b;
    };
    FinancialSeries.prototype.o5 = function () {
        _super.prototype.o5.call(this);
        this.w5.w();
        this.w3.w();
        this.w7.w();
    };
    FinancialSeries.prototype.rq = function (a) {
        var _this = this;
        _super.prototype.rq.call(this, a);
        this.xi.b0.e(this.ic);
        if (this.d4(this.cu)) {
            return;
        }
        if (this.gq) {
            if (this.d2()) {
                this.z9(this.w7, this.xi);
            }
            else {
                this.z9(this.w3, this.xi);
            }
            return;
        }
        if (this.ge(a)) {
            var b = this.w5;
            if (this.d2()) {
                if (this.db.g) {
                    this.db.t();
                }
                this.w5 = this.w7;
                this.w7 = b;
            }
            else {
                this.w5 = this.w3;
                this.w3 = b;
            }
            this.z7(this.w3, this.xi);
            var c = false;
            if (this.g2) {
                this.db.w();
                this.db.r = truncate(this.i9());
                this.db.b = this.dd != null ? this.dd : this.dc;
                if (this.g3) {
                    var d = this.w7;
                    this.w7 = this.w5;
                    this.w5 = d;
                    c = true;
                }
                this.xd.s(this, this.w5, this.w3, this.isVertical, this.w1, this.xk, this.xc, this.xb(), this.c4, this.c3(), function () { return _this.yw(_this.xi); }, this.xi.bx);
                if (this.g3) {
                    var e = this.w7;
                    this.w7 = this.w5;
                    this.w5 = e;
                }
                this.g3 = false;
            }
            if (this.g5) {
                this.db.w();
                this.db.r = truncate(this.ja());
                this.db.b = this.de != null ? this.de : this.dc;
                if (this.g0) {
                    var f = this.w7;
                    this.w7 = this.w5;
                    this.w5 = f;
                    c = true;
                }
                this.xd.s(this, this.w5, this.w3, this.isVertical, this.w1, this.xk, this.xc, this.xb(), this.c4, this.c3(), function () { return _this.yw(_this.xi); }, this.xi.bx);
                var g = this.w3;
                this.w3 = this.w5;
                this.w5 = g;
                if (this.g0) {
                    var h = this.w7;
                    this.w7 = this.w5;
                    this.w5 = h;
                }
                this.g0 = false;
            }
            this.d8 = false;
            if (!c) {
                this.o0();
            }
            this.r3();
            if (this.g2) {
                this.g1 = false;
                this.g4 = false;
                this.gj = false;
                this.g0 = true;
            }
            if (this.g5) {
                this.g4 = false;
                this.g3 = true;
            }
        }
        else {
            this.z7(this.w3, this.xi);
            this.z9(this.w3, this.xi);
        }
    };
    FinancialSeries.prototype.gn = function () {
        return true;
    };
    FinancialSeries.prototype.ya = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b) {
                    case "HighColumn":
                        if (this.xv == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.xw == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.xx == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.xu == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.xz == null) {
                            return false;
                        }
                        break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "yb", {
        get: function () {
            return this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null;
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.x6 = function () {
        return this.typical != null;
    };
    FinancialSeries.prototype.zz = function (a) {
        this.typical(this, a);
    };
    Object.defineProperty(FinancialSeries.prototype, "yj", {
        get: function () {
            return this.yg();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._yg = function () {
        var a, b, _a, _b, c, e_2_1, d, e, f, g, h;
        var e_2, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    a = false;
                    if (!this.x6())
                        return [3 /*break*/, 8];
                    b = this.xe(0, this.dm.count);
                    this.zz(new FinancialEventArgs(0, this.dm.count, b, this.xf(b), this));
                    if (!(b.typicalColumn != null))
                        return [3 /*break*/, 8];
                    a = true;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(b.typicalColumn)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 5];
                    c = _b.value;
                    return [4 /*yield*/, c];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                    return [7 /*endfinally*/];
                case 8:
                    if (!!a)
                        return [3 /*break*/, 17];
                    if (!(this.yb && this.w1.i$b != null))
                        return [3 /*break*/, 13];
                    d = this.dm.count;
                    e = this.w1.i$b;
                    f = 0;
                    _d.label = 9;
                case 9:
                    if (!(f < d))
                        return [3 /*break*/, 12];
                    return [4 /*yield*/, (this.xv.item(e.item(f)) + this.xw.item(e.item(f)) + this.xu.item(e.item(f))) / 3];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    ++f;
                    return [3 /*break*/, 9];
                case 12: return [3 /*break*/, 17];
                case 13:
                    g = this.dm.count;
                    h = 0;
                    _d.label = 14;
                case 14:
                    if (!(h < g))
                        return [3 /*break*/, 17];
                    return [4 /*yield*/, (this.xv.item(h) + this.xw.item(h) + this.xu.item(h)) / 3];
                case 15:
                    _d.sent();
                    _d.label = 16;
                case 16:
                    ++h;
                    return [3 /*break*/, 14];
                case 17: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.yg = function () {
        var _this = this;
        return toEnum(function () { return _this._yg(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "yi", {
        get: function () {
            return this.yf();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._yf = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.yb && this.w1.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.xv.count;
                    b = this.w1.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.yx(this.xv.item(b.item(0)) - this.xw.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.max(this.yx(this.xv.item(b.item(c)) - this.xw.item(b.item(c))), Math.max(this.yx(Math.abs(this.xv.item(b.item(c)) - this.xu.item(b.item(c - 1)))), this.yx(Math.abs(this.xw.item(b.item(c)) - this.xu.item(b.item(c - 1))))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++c;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.xv.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.yx(this.xv.item(0) - this.xw.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.max(this.yx(this.xv.item(e) - this.xw.item(e)), Math.max(this.yx(Math.abs(this.xv.item(e) - this.xu.item(e - 1))), this.yx(Math.abs(this.xw.item(e) - this.xu.item(e - 1)))))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    ++e;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.yf = function () {
        var _this = this;
        return toEnum(function () { return _this._yf(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "yh", {
        get: function () {
            return this.ye();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._ye = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.yb && this.w1.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.xw.count;
                    b = this.w1.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.yx(this.xw.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.min(this.yx(this.xw.item(b.item(c))), this.yx(this.xu.item(b.item(c - 1))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    c++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.xw.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.yx(this.xw.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.min(this.yx(this.xw.item(e)), this.yx(this.xu.item(e - 1)))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    e++;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.ye = function () {
        var _this = this;
        return toEnum(function () { return _this._ye(); });
    };
    FinancialSeries.prototype.yl = function (a) {
        if (a == null) {
            return null;
        }
        if (this.yb && this.w1.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.w1.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    };
    FinancialSeries.prototype.yk = function () {
        var a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.dm != null && !this.x0) {
            this.x0 = true;
            var b = this.xe(0, this.dm.count);
            this.x0 = false;
            var c = new FinancialEventArgs(0, this.dm.count, b, this.xf(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    };
    FinancialSeries.prototype.getOpenColumnAsArray = function () {
        if (this.xx == null) {
            return null;
        }
        if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
            if (this.yp != null) {
                return this.yp.asArray();
            }
            var a = new List$1(Number_$type, 2, this.xx.count);
            var b = this.w1.i$b;
            var c = this.xx.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.yp = a;
            return this.yp.asArray();
        }
        else {
            return this.xx.asArray();
        }
    };
    FinancialSeries.prototype.getHighColumnAsArray = function () {
        if (this.xv == null) {
            return null;
        }
        if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
            if (this.yn != null) {
                return this.yn.asArray();
            }
            var a = new List$1(Number_$type, 2, this.xv.count);
            var b = this.w1.i$b;
            var c = this.xv.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.yn = a;
            return this.yn.asArray();
        }
        else {
            return this.xv.asArray();
        }
    };
    FinancialSeries.prototype.getLowColumnAsArray = function () {
        if (this.xw == null) {
            return null;
        }
        if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
            if (this.yo != null) {
                return this.yo.asArray();
            }
            var a = new List$1(Number_$type, 2, this.xw.count);
            var b = this.w1.i$b;
            var c = this.xw.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.yo = a;
            return this.yo.asArray();
        }
        else {
            return this.xw.asArray();
        }
    };
    FinancialSeries.prototype.getCloseColumnAsArray = function () {
        if (this.xu == null) {
            return null;
        }
        if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
            if (this.ym != null) {
                return this.ym.asArray();
            }
            var a = new List$1(Number_$type, 2, this.xu.count);
            var b = this.w1.i$b;
            var c = this.xu.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.ym = a;
            return this.ym.asArray();
        }
        else {
            return this.xu.asArray();
        }
    };
    FinancialSeries.prototype.getVolumeColumnAsArray = function () {
        if (this.xz == null) {
            return null;
        }
        if (this.w1 != null && typeCast(ISortingAxis_$type, this.w1) !== null) {
            if (this.yq != null) {
                return this.yq.asArray();
            }
            var a = new List$1(Number_$type, 2, this.xz.count);
            var b = this.w1.i$b;
            var c = this.xz.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.yq = a;
            return this.yq.asArray();
        }
        else {
            return this.xz.asArray();
        }
    };
    FinancialSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        if (this.w1 == null || !(typeCast(ISortingAxis_$type, this.w1) !== null)) {
            return;
        }
        var e = this.w1.i$b;
        switch (a) {
            case 1:
                for (var f = b; f < c; f++) {
                    var g = e._inner[f];
                    if (this.yp != null) {
                        this.yp.insert(f, this.xx.item(g));
                    }
                    if (this.yn != null) {
                        this.yn.insert(f, this.xv.item(g));
                    }
                    if (this.yo != null) {
                        this.yo.insert(f, this.xw.item(g));
                    }
                    if (this.ym != null) {
                        this.ym.insert(f, this.xu.item(g));
                    }
                    if (this.yq != null) {
                        this.yq.insert(f, this.xz.item(g));
                    }
                }
                break;
            case 0:
                if (this.yp != null) {
                    this.yp.v(b, c);
                }
                if (this.yn != null) {
                    this.yn.v(b, c);
                }
                if (this.yo != null) {
                    this.yo.v(b, c);
                }
                if (this.ym != null) {
                    this.ym.v(b, c);
                }
                if (this.yq != null) {
                    this.yq.v(b, c);
                }
                break;
            case 4:
                if (this.yp != null) {
                    this.yp = new List$1(Number_$type, 0);
                }
                if (this.yn != null) {
                    this.yn = new List$1(Number_$type, 0);
                }
                if (this.yo != null) {
                    this.yo = new List$1(Number_$type, 0);
                }
                if (this.ym != null) {
                    this.ym = new List$1(Number_$type, 0);
                }
                if (this.yq != null) {
                    this.yq = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (var h = b; h < c; h++) {
                    var i = e._inner[h];
                    if (this.yp != null) {
                        this.yp._inner[h] = this.xx.item(i);
                    }
                    if (this.yn != null) {
                        this.yn._inner[h] = this.xv.item(i);
                    }
                    if (this.yo != null) {
                        this.yo._inner[h] = this.xw.item(i);
                    }
                    if (this.ym != null) {
                        this.ym._inner[h] = this.xu.item(i);
                    }
                    if (this.yq != null) {
                        this.yq._inner[h] = this.xz.item(i);
                    }
                }
                break;
        }
        this.aaa();
        this.sj();
    };
    FinancialSeries.prototype.xe = function (a, b) {
        var _this = this;
        var c = this.yl(this.xx);
        var d = this.yl(this.xu);
        var e = this.yl(this.xv);
        var f = this.yl(this.xw);
        var g = this.yl(this.xz);
        var h = ((function () {
            var $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.yj), _this.yk());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.yi), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.yh), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = _this.dm != null ? _this.dm.count : 0;
            return $ret;
        })());
        return h;
    };
    FinancialSeries.prototype.yx = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    FinancialSeries.prototype.xf = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
            $ret.k = Series.hp;
            $ret.j = Series.ho;
            $ret.i = runOn(_this, _this.yx);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
        get: function () {
            return this.w1;
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.rr = function (a, b) {
        _super.prototype.rr.call(this, a, b);
        if (!this.gz) {
            this.cu.a4(b);
            return;
        }
        var c = typeCast(FinancialSeriesView.$, this.ct);
        this.cu.a4(b);
        c.b0.e(this.ic);
        if (this.d4(this.ct)) {
            return;
        }
        if (!this.gr) {
            this.z7(this.w6, c);
        }
        this.gr = false;
        this.z9(this.w6, c);
        this.gz = false;
    };
    FinancialSeries.prototype.ro = function (a, b, c, d, e) {
        _super.prototype.ro.call(this, a, b, c, d, e);
        var f = this.ba.a$j.item(d);
        var g = f;
        g.b0.e(this.ic);
        f.a3(c);
        if (this.d4(g)) {
            return;
        }
        if (this.w2 == null) {
            this.w2 = new CategoryFrame(3);
        }
        this.w2.v();
        this.z7(this.w2, g);
        this.z9(this.w2, g);
    };
    FinancialSeries.prototype.aw = function (a) {
        if (this.w1 == a) {
            return this.xk;
        }
        if (this.xk == a) {
            return this.w1;
        }
        return null;
    };
    FinancialSeries.prototype.preferredCategoryMode = function (a) {
        var b = typeCast(IDateTimeAxis_$type, this.w1);
        return b != null ? b.preferredCategoryMode(this) : this.w9;
    };
    Object.defineProperty(FinancialSeries.prototype, "w9", {
        get: function () {
            return this.w8;
        },
        set: function (a) {
            var b = this.w9;
            if (a != b) {
                this.w8 = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.w9));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.get_fl = function () {
        return true;
    };
    FinancialSeries.prototype.rz = function (a, b) {
        _super.prototype.rz.call(this, a, b);
        this.aar = a;
    };
    FinancialSeries.prototype.aaa = function () {
        this.il = this.xu == null || this.xu.count == 0 ? NaN : this.xu.item(this.xu.count - 1);
    };
    FinancialSeries.prototype.ko = function (a) {
        if (this.xj != null && a != null) {
            if (this.xl == null || this.xl.propertyName != this.xj.dateTimeMemberPath) {
                this.xl = new FastReflectionHelper(false, this.xj.dateTimeMemberPath);
            }
            var b = this.xl.getPropertyValue(a);
            if (typeCast(Date_$type, b) !== null) {
                return dateToStringFormat(b, this.xj.itemLabelFormat());
            }
        }
        return _super.prototype.ko.call(this, a);
    };
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:y5:aab', [2, null], 'HighMemberPath:zi:aah', [2, null], 'HighlightedCloseMemberPath:y8:aac', [2, null], 'HighlightedHighMemberPath:za:aad', [2, null], 'HighlightedLowMemberPath:zc:aae', [2, null], 'HighlightedOpenMemberPath:ze:aaf', [2, null], 'HighlightedVolumeMemberPath:zg:aag', [2, null], 'IsCustomCategoryStyleAllowed:x7:aai', [0, false], 'IsTransitionInEnabled:x8:aaj', [0, false], 'LowMemberPath:zn:aak', [2, null], 'NegativeBrush:aar:aal', [Brush.$, null], 'OpenMemberPath:zr:aam', [2, null], 'TransitionInMode:xc:aan', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:zv:aao', [2, null], 'XAxis:w1:aap', [CategoryAxisBase.$, null], 'YAxis:xk:aaq', [NumericYAxis.$, null]]);
    return FinancialSeries;
}(Series));
export { FinancialSeries };
/**
 * @hidden
 */
var FinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationSupportingCalculations, _super);
    function FinancialCalculationSupportingCalculations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.h = null;
        _this.f = null;
        _this.g = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.i = null;
        return _this;
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
}(Base));
export { FinancialCalculationSupportingCalculations };
/**
 * @hidden
 */
var DataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataSourceSupportingCalculation, _super);
    function DataSourceSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
}(SupportingCalculation$1));
export { DataSourceSupportingCalculation };
/**
 * @hidden
 */
var FinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationDataSource, _super);
    function FinancialCalculationDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._openColumn = null;
        _this._closeColumn = null;
        _this._highColumn = null;
        _this._lowColumn = null;
        _this._volumeColumn = null;
        _this._indicatorColumn = null;
        _this._typicalColumn = null;
        _this._trueRange = null;
        _this._trueLow = null;
        _this._period = 0;
        _this._shortPeriod = 0;
        _this._longPeriod = 0;
        _this._count = 0;
        _this._calculateFrom = 0;
        _this._calculateCount = 0;
        _this._multiplier = 0;
        _this._minimumValue = 0;
        _this._maximumValue = 0;
        _this._specifiesRange = false;
        _this._series = null;
        return _this;
    }
    Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this._openColumn;
        },
        set: function (a) {
            this._openColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this._closeColumn;
        },
        set: function (a) {
            this._closeColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this._highColumn;
        },
        set: function (a) {
            this._highColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this._lowColumn;
        },
        set: function (a) {
            this._lowColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this._volumeColumn;
        },
        set: function (a) {
            this._volumeColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
        get: function () {
            return this._typicalColumn;
        },
        set: function (a) {
            this._typicalColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
        get: function () {
            return this._trueRange;
        },
        set: function (a) {
            this._trueRange = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
        get: function () {
            return this._trueLow;
        },
        set: function (a) {
            this._trueLow = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
        get: function () {
            return this._period;
        },
        set: function (a) {
            this._period = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
        get: function () {
            return this._shortPeriod;
        },
        set: function (a) {
            this._shortPeriod = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
        get: function () {
            return this._longPeriod;
        },
        set: function (a) {
            this._longPeriod = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
        get: function () {
            return this._calculateFrom;
        },
        set: function (a) {
            this._calculateFrom = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
        get: function () {
            return this._calculateCount;
        },
        set: function (a) {
            this._calculateCount = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
        get: function () {
            return this._multiplier;
        },
        set: function (a) {
            this._multiplier = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
        get: function () {
            return this._specifiesRange;
        },
        set: function (a) {
            this._specifiesRange = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
}(Base));
export { FinancialCalculationDataSource };
/**
 * @hidden
 */
var FinancialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeriesView, _super);
    function FinancialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b2 = null;
        _this.b0 = null;
        _this.b4 = 0;
        _this.b4 = -1;
        _this.b2 = a;
        _this.b0 = _this.b1();
        return _this;
    }
    FinancialSeriesView.prototype.b3 = function (a) {
        if (this.b4 != a.u) {
            return true;
        }
        return false;
    };
    FinancialSeriesView.prototype.b5 = function (a) {
        this.b4 = a.u;
    };
    FinancialSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
        }
    };
    FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.b2.w1.ce) {
            a += "<span>${itemLabel}</span><br/>";
        }
        else if (this.b2.w1.f1 != null) {
            a += "<span>${item." + this.b2.w1.f1 + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        var b = this.e.ba.a$u(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        var c = new SRProvider(this.w);
        var d = c.b1("financialSeries_Open");
        var e = c.b1("financialSeries_High");
        var f = c.b1("financialSeries_Low");
        var g = c.b1("financialSeries_Close");
        d = stringIsNullOrEmpty(d) ? "Open" : d;
        e = stringIsNullOrEmpty(e) ? "High" : e;
        f = stringIsNullOrEmpty(f) ? "Low" : f;
        g = stringIsNullOrEmpty(g) ? "Close" : g;
        a += ">" + this.b2.title + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.b2.zr + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.b2.zi + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.b2.zn + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.b2.y5 + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.b2.zv)) {
            var h = c.b1("financialSeries_Volume");
            h = stringIsNullOrEmpty(h) ? "Volume" : h;
            a += "<tr><td>" + h + ":</td><td>" + "${item." + this.b2.zv + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    };
    FinancialSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.vx = a;
        this.e.jl = 5;
        this.e.jm = 2;
        this.e.jn = 2;
    };
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
}(SeriesView));
export { FinancialSeriesView };
