/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { Defaults } from "./Defaults";
import { KDTree2D } from "./KDTree2D";
import { Point_$type, typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, markDep, toNullable } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-react-core";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core";
import { dateNow } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
/**
 * @hidden
 */
var HighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighDensityScatterSeries, _super);
    function HighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.w6 = null;
        _this.w8 = null;
        _this.yh = 0;
        _this.xa = false;
        _this.xw = Defaults.aq.o;
        _this.xv = Defaults.aq.n;
        _this.xu = Defaults.aq.m;
        _this.xt = Defaults.aq.l;
        _this.xs = Defaults.ap.o;
        _this.xr = Defaults.ap.n;
        _this.xq = Defaults.ap.m;
        _this.xp = Defaults.ap.l;
        _this.wy = null;
        _this.w3 = null;
        _this.w4 = null;
        _this.wz = null;
        _this.w1 = null;
        _this.xc = false;
        _this.yi = 0;
        _this.yk = 0;
        _this.ye = 0;
        _this.yd = 0;
        _this.progressiveLoadStatusChanged = null;
        _this.xh = null;
        _this.xn = 0;
        _this.xm = 0;
        _this.xo = 0;
        _this.x3 = 0;
        _this.x1 = 0;
        _this.x2 = 0;
        _this.x4 = 0;
        _this.x6 = 0;
        _this.x8 = 0;
        _this.x7 = 0;
        _this.x5 = 0;
        _this.xj = 0;
        _this.xk = 0;
        _this.xl = 0;
        _this.xi = 0;
        _this.yg = 0;
        _this.yf = 0;
        _this.wv = null;
        _this.yj = 0;
        _this.xb = false;
        _this._itemIndexes = null;
        _this.ww = null;
        _this.wt = null;
        _this.w5 = null;
        _this.ab = HighDensityScatterSeries.$;
        _this.f7 = false;
        return _this;
    }
    HighDensityScatterSeries.prototype.bj = function () {
        return new HighDensityScatterSeries();
    };
    HighDensityScatterSeries.prototype.get_fn = function () {
        return true;
    };
    HighDensityScatterSeries.prototype.jj = function () {
        if (!isNaN_(this.ji)) {
            return _super.prototype.jj.call(this);
        }
        return Defaults.q;
    };
    HighDensityScatterSeries.prototype.get_fv = function () {
        return true;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "w7", {
        get: function () {
            return this.w6;
        },
        set: function (a) {
            if (this.w6 != a) {
                var b = this.w7;
                this.w6 = a;
                this.raisePropertyChanged("XColumn", b, this.w7);
            }
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.km(c);
        var e = d == null ? NaN : this.iw(d, "XMemberPath");
        var f = d == null ? NaN : this.iw(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.l = e;
        g.a = 13;
        g.q = "X";
        g.r = this.y3 != null ? this.y3 : "X";
        g.s = this.yz != null ? this.yz : "X:";
        g.t = this.y1 != null ? this.y1 : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.q = "Y";
        h.r = this.zb != null ? this.zb : "Y";
        h.s = this.y7 != null ? this.y7 : "Y:";
        h.t = this.y9 != null ? this.y9 : "";
        var i = new DataLegendSeriesContext();
        i.e = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.h = this.mb();
        return i;
    };
    HighDensityScatterSeries.prototype.kp = function (a, b) {
        var c = this.nc(b);
        if (c == HighDensityScatterSeries.$$p[10]) {
            return this.kq(a, b, this.y3);
        }
        if (c == HighDensityScatterSeries.$$p[14]) {
            return this.kq(a, b, this.zb);
        }
        return _super.prototype.kp.call(this, a, b);
    };
    HighDensityScatterSeries.prototype.mc = function (a) {
        var b = this.nc(a);
        if (b == HighDensityScatterSeries.$$p[10]) {
            return this.y3;
        }
        if (b == HighDensityScatterSeries.$$p[14]) {
            return this.zb;
        }
        return _super.prototype.mc.call(this, a);
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "w9", {
        get: function () {
            return this.w8;
        },
        set: function (a) {
            if (this.w8 != a) {
                var b = this.w9;
                this.w8 = a;
                this.raisePropertyChanged("YColumn", b, this.w9);
            }
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.zq = function () {
        if (this.wy == null) {
            return;
        }
        this.wy.s();
        var a = this.wy;
        a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.zd));
        this.wy = null;
    };
    HighDensityScatterSeries.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case HighDensityScatterSeries.$$p[8]:
            case HighDensityScatterSeries.$$p[12]:
            case HighDensityScatterSeries.$$p[9]:
            case HighDensityScatterSeries.$$p[13]:
                this.qd();
                break;
            case "SeriesViewer":
                if (this.da != null) {
                    var e = this.getEffectiveViewport1(this.cu);
                    this.xb = !e.isEmpty;
                }
                break;
            case "FastItemsSource":
                this.zq();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.w7);
                    c.deregisterColumn(this.w9);
                    this.w7 = null;
                    this.w9 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.w7 = this.dj(this.y3);
                    this.w9 = this.dj(this.zb);
                }
                if ((this.w2 != null && !this.w2.c1()) || (this.w0 != null && !this.w0.c1())) {
                    this.rp(this.gf && c != null);
                }
                this.qk();
                break;
            case HighDensityScatterSeries.$$p[7]:
                var f = this.wz;
                this.wz = this.w0;
                this.zq();
                if (f != null) {
                    f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.zg));
                }
                if (this.wz != null) {
                    var g = this.wz;
                    g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.zg));
                }
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                if ((this.w0 != null && !this.w0.c1()) || (d == null && c != null)) {
                    this.rp(false);
                }
                break;
            case HighDensityScatterSeries.$$p[11]:
                var h = this.w1;
                this.w1 = this.w2;
                this.zq();
                if (h != null) {
                    h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.zg));
                }
                if (this.w1 != null) {
                    var i = this.w1;
                    i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.zg));
                }
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                if ((this.w2 != null && !this.w2.c1()) || (d == null && c != null)) {
                    this.rp(false);
                }
                break;
            case "MouseOverEnabled":
                this.xc = this.f7;
                this.rp(false);
                break;
            case HighDensityScatterSeries.$$p[10]:
                if (this.dm != null) {
                    this.dm.deregisterColumn(this.w7);
                    this.w7 = this.dj(this.y3);
                }
                break;
            case "XColumn":
                this.zq();
                if (this.w0 != null && !this.w0.c1()) {
                    this.rp(false);
                }
                this.qk();
                break;
            case HighDensityScatterSeries.$$p[14]:
                if (this.dm != null) {
                    this.dm.deregisterColumn(this.w9);
                    this.w9 = this.dj(this.zb);
                }
                break;
            case "YColumn":
                this.zq();
                if (this.w2 != null && !this.w2.c1()) {
                    this.rp(false);
                }
                this.qk();
                break;
            case HighDensityScatterSeries.$$p[6]:
                this.zq();
                this.rp(false);
                this.qj();
                break;
            case HighDensityScatterSeries.$$p[3]:
                this.rp(false);
                this.qj();
                break;
            case HighDensityScatterSeries.$$p[1]:
                this.rp(false);
                this.qj();
                break;
            case HighDensityScatterSeries.$$p[0]:
            case HighDensityScatterSeries.$$p[2]:
                if (!this.wx.b4(this.z9, this.z8)) {
                    return;
                }
                this.zk();
                this.rp(false);
                this.qj();
                break;
            case HighDensityScatterSeries.$$p[4]:
                this.yh = Math.max(typeGetValue(d) - 1, 0);
                this.xa = this.yh > 0;
                this.rp(false);
                this.qj();
                break;
            case HighDensityScatterSeries.$$p[5]:
                this.rp(false);
                this.qj();
                break;
        }
    };
    HighDensityScatterSeries.prototype.zk = function () {
        this.xt = this.z9.l;
        this.xw = this.z9.o;
        this.xv = this.z9.n;
        this.xu = this.z9.m;
        this.xp = this.z8.l;
        this.xs = this.z8.o;
        this.xr = this.z8.n;
        this.xq = this.z8.m;
        this.vr = BrushUtil.h(truncate(this.xt), truncate(this.xw), truncate(this.xv), truncate(this.xu));
        this.vb = BrushUtil.h(truncate(this.xp), truncate(this.xs), truncate(this.xr), truncate(this.xq));
    };
    HighDensityScatterSeries.prototype.xe = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.xd = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.zg = function (a, b) {
        this.zq();
        this.rp(false);
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "x0", {
        get: function () {
            return this.xs - this.xw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "xz", {
        get: function () {
            return this.xr - this.xv;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "xy", {
        get: function () {
            return this.xq - this.xu;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "xx", {
        get: function () {
            return this.xp - this.xt;
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.hd = function (a, b, c) {
        var d = _super.prototype.hd.call(this, a, b, c);
        if (this.w2 == null || this.w0 == null || this.w0.bi == null || this.w2.bi == null || this.w9 == null || this.w7 == null || this.w9.count < 1 || this.w7.count < 1 || this.w9.count != this.w7.count || this.w0.l2 == this.w0.l1 || this.w2.l2 == this.w2.l1 || this.wo.isEmpty) {
            d = false;
        }
        return d;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "yo", {
        get: function () {
            return this.yi;
        },
        set: function (a) {
            var b = this.yi;
            this.yi = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.yi);
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.rq = function (a) {
        _super.prototype.rq.call(this, a);
        this.zi(a, this.cu);
    };
    HighDensityScatterSeries.prototype.zi = function (a, b) {
        if (this.d4(b)) {
            return;
        }
        if (this.wy == null && !this.xg) {
            var c = new List$1(KDPointData.$, 2, this.w7.count);
            var d = this.w0;
            var e = this.w2;
            var f = new Rect(0, 0, 0, 1, 1);
            var g = new Rect(0, 0, 0, 1, 1);
            var h = new ScalerParams(1, f, g, d.ch);
            var i = new ScalerParams(1, f, g, e.ch);
            var j_1;
            var k_1;
            var _loop_1 = function (l) {
                j_1 = d.ek(this_1.w7.item(l), h);
                k_1 = e.ek(this_1.w9.item(l), i);
                if (!isNaN_(j_1) && !isNaN_(k_1) && !isInfinity(j_1) && !isInfinity(k_1)) {
                    c.add(((function () {
                        var $ret = new KDPointData();
                        $ret.a = j_1;
                        $ret.b = k_1;
                        $ret.c = l;
                        return $ret;
                    })()));
                }
            };
            var this_1 = this;
            for (var l = 0; l < this.w7.count; l++) {
                _loop_1(l);
            }
            if (this.xf) {
                this.yd = 1;
                this.ye = truncate(logBase(c.count, 2)) + 3;
                this.yo = truncate(((this.yd / this.ye) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.yo));
                }
                this.wy = KDTree2D.b(c.toArray(), 1);
                var m = this.wy;
                m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.zd));
                if (!this.wy.f(this.jy)) {
                    var n = this.wy;
                    n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.zd));
                }
                this.qj();
            }
            else {
                var o = dateNow();
                this.wy = new KDTree2D(0, c.toArray(), 1);
                var p = dateNow();
            }
        }
        if (this.xf && !this.xg) {
            this.zj(b);
        }
        else {
            this.zl(b);
        }
    };
    HighDensityScatterSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        this.zq();
        var e = false;
        if (this.w0 != null && !this.w0.c1()) {
            e = true;
        }
        if (this.w2 != null && !this.w2.c1()) {
            e = true;
        }
        if (e) {
            this.rp(false);
        }
        this.qk();
    };
    HighDensityScatterSeries.prototype.zf = function (a) {
        var b = a;
        var c = this.yg * this.yf;
        if (this.xc) {
            if (this._itemIndexes == null || this._itemIndexes.length != c) {
                this._itemIndexes = new Array(c);
                for (var d = 0; d < c; d++) {
                    this._itemIndexes[d] = 0;
                }
            }
            else {
                for (var e = 0; e < c; e++) {
                    this._itemIndexes[e] = 0;
                }
            }
        }
    };
    HighDensityScatterSeries.prototype.zl = function (a) {
        var b;
        var c;
        var d = null;
        if (a.q) {
            d = this._itemIndexes;
        }
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        var f = a;
        var g = this.getEffectiveViewport1(a);
        this.w3 = new ScalerParams(0, b, c, this.wz.ch, g);
        this.w4 = new ScalerParams(0, b, c, this.w1.ch, g);
        this.ze(a);
        this.zf(a);
        var h = this.yg * this.yf;
        if (this.ww == null || this.ww.length != h) {
            this.ww = new Array(h);
            this.wt = new Array(h);
        }
        var i = this.ww.length;
        var j = this.ww;
        var k = this.wt;
        for (var l = 0; l < i; l++) {
            j[l] = 0;
            k[l] = 0;
        }
        this.yk = truncate(Math.round(this.ic));
        this.wv = f.b1();
        var m = this.wv.length;
        var n = this.wv;
        for (var o = 0; o < m; o++) {
            n[o] = 0;
        }
        var p = this.yb;
        var q = this.ya;
        if (isNaN_(p) || isInfinity(p)) {
            p = 0;
        }
        if (isNaN_(q) || isInfinity(q)) {
            q = 50;
        }
        this.xn = Math.min(p, q);
        this.xm = Math.max(p, q);
        if (this.xn < 0) {
            this.xn = 0;
        }
        if (this.xm < 0) {
            this.xm = 0;
        }
        this.xo = this.xm - this.xn;
        if (this.xg) {
            this.zh(a);
        }
        else {
            this.zs(a);
        }
        f.cc();
        if (a.q) {
            this._itemIndexes = d;
            this.wx.cd();
        }
    };
    HighDensityScatterSeries.prototype.zj = function (a) {
        if (this.wy == null) {
            return;
        }
        this.zl(a);
    };
    HighDensityScatterSeries.prototype.zd = function (a, b) {
        var _this = this;
        this.wx.cb(function () {
            if (_this.yd < _this.ye - 1) {
                _this.yd++;
            }
            _this.yo = truncate(((_this.yd / _this.ye) * 100));
            if (_this.progressiveLoadStatusChanged != null) {
                _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.yo));
            }
            _this.zj(_this.cu);
            _this.qj();
            if (_this.wy != null) {
                if (!_this.wy.f(_this.jy)) {
                    var c = _this.wy;
                    c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(_this, _this.zd));
                    _this.yo = 100;
                    if (_this.progressiveLoadStatusChanged != null) {
                        _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.yo));
                    }
                }
            }
        });
    };
    HighDensityScatterSeries.prototype.zh = function (a) {
        var b = arrayShallowClone(this.w7.asArray());
        this.w0.ho(boxArray$1(b), 0, b.length, this.w3);
        var c = arrayShallowClone(this.w9.asArray());
        this.yj = 0;
        var d = this.yh;
        var e = this.xa;
        var f = this.ww.length;
        this.w2.ho(boxArray$1(c), 0, c.length, this.w4);
        var g = 255 << 24 | truncate(this.xw) << 16 | truncate(this.xv) << 8 | truncate(this.xu);
        for (var h = 0; h < b.length; h++) {
            var i = truncate(b[h]);
            var j = truncate(c[h]);
            i = truncate(Math.floor(i));
            j = truncate(Math.floor(j));
            if (i < 0 || i >= this.yg || j < 0 || j >= this.yf) {
                continue;
            }
            if (e) {
                var k = i - d;
                var l = i + d;
                l = l > (this.yg - 1) ? (this.yg - 1) : l;
                k = k < 0 ? 0 : k;
                var m = j + d;
                var n = j - d;
                for (var o = k; o <= l; o++) {
                    for (var p = n; p <= m; p++) {
                        var q = (p * this.yg) + o;
                        if (q < 0 || q > f - 1) {
                            continue;
                        }
                        this.ww[q] = this.ww[q] + 1;
                        this.wt[q] = 1;
                        this.yj++;
                        if (this.xc) {
                            this._itemIndexes[q] = h + 1;
                        }
                    }
                }
            }
            else {
                var r = (j * this.yg) + i;
                this.ww[r] = this.ww[r] + 1;
                this.wt[r] = 1;
                this.yj++;
                if (this.xc) {
                    this._itemIndexes[r] = h + 1;
                }
            }
        }
        this.zm();
    };
    HighDensityScatterSeries.prototype.zs = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.wy == null) {
            return;
        }
        if (this.xh == null) {
            this.xh = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
        }
        else {
            this.xh.clear();
        }
        var e = c.left;
        var f = c.right;
        var g = c.top;
        var h = c.bottom;
        this.x7 = c.top;
        this.x5 = c.height;
        this.x6 = c.left;
        this.x8 = c.width;
        this.x3 = b.top;
        this.x1 = b.height;
        this.x2 = b.left;
        this.x4 = b.width;
        var i = this.getEffectiveViewport1(a);
        this.xj = (i.left - this.x2) / this.x4;
        this.xk = (i.top - this.x3) / this.x1;
        var j = (i.right - this.x2) / this.x4;
        this.xl = j - this.xj;
        var k = (i.bottom - this.x3) / this.x1;
        this.xi = k - this.xk;
        if (this.xb) {
            e = (e - this.xj) / this.xl;
            f = (f - this.xj) / this.xl;
            g = (g - this.xk) / this.xi;
            h = (h - this.xk) / this.xi;
        }
        var l = this.ic / b.width * c.width;
        var m = this.ic / b.height * c.height;
        var n = Math.min(l, m);
        var o = ((function () {
            var $ret = new SearchArgs();
            $ret.c = e;
            $ret.a = f;
            $ret.d = g;
            $ret.b = h;
            $ret.e = l;
            $ret.f = m;
            $ret.g = 0x7FFFFFFF;
            return $ret;
        })());
        this.wy.t(this.xh, o, 0, 1, 0, 1);
        var p;
        this.yj = 0;
        for (var q = 0; q < this.xh.count; q++) {
            p = this.xh._inner[q];
            this.zn(p);
        }
        this.zm();
    };
    HighDensityScatterSeries.prototype.zn = function (a) {
        if (a.g) {
            return;
        }
        var b = a.e != null && a.e.a;
        var c = a.a == null ? 0 : a.a.length;
        var d = (a.h - c) + 1;
        if (b && d > 0) {
        }
        else {
            d = 1;
        }
        this.zp(a.b, d, b, a.e);
        if (c > 0 && !b) {
            var e = void 0;
            for (var f = 0; f < c; f++) {
                e = a.a[f];
                this.zp(e, d, false, a.e);
            }
        }
        if (a.e != null) {
            a.e.a = false;
        }
    };
    HighDensityScatterSeries.prototype.gc = function (a) {
        var b = this.da != null ? this.da.vx : Rect.empty;
        var c = this.da != null ? this.da.wc : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.wh(this.cu);
        var f = new ScalerParams(0, d, d, this.w0.ch, e);
        var g = new ScalerParams(0, d, d, this.w2.ch, e);
        var h = !b.isEmpty && !c.isEmpty && this.dm != null ? this.dm.indexOf(a) : -1;
        var i = this.w0 != null && this.w7 != null && h < this.w7.count ? this.w0.ek(this.w7.item(h), f) : NaN;
        var j = this.w2 != null && this.w9 != null && h < this.w9.count ? this.w2.ek(this.w9.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.c2 != null) {
            this.c2.au(this.da, b, true);
        }
        return h >= 0;
    };
    HighDensityScatterSeries.prototype.zp = function (a, b, c, d) {
        var e = this.ym(b);
        var f = a.c;
        var g = this.yh;
        if (c) {
            var h = d.d;
            var i = d.b;
            var j = d.e;
            var k = d.c;
            if (this.xb) {
                h = this.xj + this.xl * h;
                i = this.xj + this.xl * i;
                j = this.xk + this.xi * j;
                k = this.xk + this.xi * k;
            }
            var l = truncate((this.x2 + this.x4 * (h - this.x6) / this.x8));
            var m = truncate((this.x2 + this.x4 * (i - this.x6) / this.x8));
            var n = truncate((this.x3 + this.x1 * (j - this.x7) / this.x5));
            var o = truncate((this.x3 + this.x1 * (k - this.x7) / this.x5));
            l = truncate(Math.floor(l));
            m = truncate(Math.floor(m));
            n = truncate(Math.floor(n));
            o = truncate(Math.floor(o));
            if (this.xa) {
                l -= g;
                m += g;
                n -= g;
                o += g;
            }
            var p = ((m - l) + 1) * ((o - n) + 1);
            var q = b / p;
            var r = q;
            for (var s = l; s <= m; s++) {
                for (var t = n; t <= o; t++) {
                    this.zo(f, s, t, q, r);
                }
            }
        }
        else {
            var u = a.a;
            var v = a.b;
            if (this.xb) {
                u = this.xj + this.xl * u;
                v = this.xk + this.xi * v;
            }
            var w = truncate((this.x2 + this.x4 * (u - this.x6) / this.x8));
            var x = truncate((this.x3 + this.x1 * (v - this.x7) / this.x5));
            w = truncate(Math.floor(w));
            x = truncate(Math.floor(x));
            if (this.xa) {
                var y = w - g;
                var z = w + g;
                var aa = x + g;
                var ab = x - g;
                var ac = ((z - y) + 1) * ((aa - ab) + 1);
                var ad = b / ac;
                var ae = ad;
                for (var af = y; af <= z; af++) {
                    for (var ag = ab; ag <= aa; ag++) {
                        this.zo(f, af, ag, ad, ae);
                    }
                }
            }
            else {
                this.zo(f, w, x, b, 1);
            }
        }
    };
    HighDensityScatterSeries.prototype.yl = function (a, b) {
        return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.xw + a * this.x0))) << 16 | truncate(Math.floor(b * (this.xv + a * this.xz))) << 8 | truncate(Math.floor(b * (this.xu + a * this.xy)));
    };
    HighDensityScatterSeries.prototype.ym = function (a) {
        return 255 << 24 | truncate(Math.floor((this.xw + a * this.x0))) << 16 | truncate(Math.floor((this.xv + a * this.xz))) << 8 | truncate(Math.floor((this.xu + a * this.xy)));
    };
    HighDensityScatterSeries.prototype.x9 = function (a) {
        return (a >> 24 & 255) / 255;
    };
    HighDensityScatterSeries.prototype.zo = function (a, b, c, d, e) {
        if (b < 0 || b >= this.yg || c < 0 || c >= this.yf) {
            return;
        }
        var f = (c * this.yg) + b;
        this.ww[f] = this.ww[f] + d;
        this.wt[f] = this.wt[f] + e;
        if (this.xc) {
            this._itemIndexes[f] = a + 1;
        }
        this.yj += truncate(d);
    };
    HighDensityScatterSeries.prototype.zm = function () {
        var a = 0;
        var b = 0;
        var c = this.xo;
        var d = this.xn;
        var e = this.xm;
        var f = this.ww.length;
        var g = this.ww;
        var h = this.wt;
        var i = this.wv;
        var j = NaN;
        var k = NaN;
        var l = 0;
        var m = 0;
        for (var n = 0; n < f; n++) {
            a = g[n];
            if (a != 0) {
                b = h[n];
                if (a >= e) {
                    a = 1;
                }
                else if (a <= d) {
                    a = 0;
                }
                else {
                    a = (a - d) / (c);
                }
                if (b > 1) {
                    b = 1;
                }
                if (b < 0.2) {
                    b = 0.2;
                }
                if (j != a || k != b) {
                    l = this.yl(a, b);
                    j = a;
                    k = b;
                }
                i[m] = l >> 16 & 255;
                i[m + 1] = l >> 8 & 255;
                i[m + 2] = l & 255;
                i[m + 3] = l >> 24 & 255;
            }
            m += 4;
        }
    };
    HighDensityScatterSeries.prototype.ze = function (a) {
        var b = a;
        b.b9();
    };
    HighDensityScatterSeries.prototype.cr = function () {
        return new HighDensityScatterSeriesView(this);
    };
    HighDensityScatterSeries.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.wx = a;
    };
    HighDensityScatterSeries.prototype.ay = function (a) {
        if (a != null && a == this.w0 && this.w7 != null) {
            return new AxisRange(this.w7.minimum, this.w7.maximum);
        }
        if (a != null && a == this.w2 && this.w9 != null) {
            return new AxisRange(this.w9.minimum, this.w9.maximum);
        }
        return null;
    };
    HighDensityScatterSeries.prototype.sm = function (a, b) {
        if (this.da != null) {
            var c = this.getEffectiveViewport1(this.cu);
            this.xb = !c.isEmpty;
        }
        this.rp(false);
    };
    HighDensityScatterSeries.prototype.sn = function (a, b) {
        this.rp(false);
    };
    HighDensityScatterSeries.prototype.km = function (a) {
        if (!this.xc || this._itemIndexes == null || this.da == null || this.dm == null || this._itemIndexes.length != (this.yg * this.yf)) {
            return null;
        }
        var b = this.da.vx;
        var c = (a.x - b.left) / b.width;
        var d = (a.y - b.top) / b.height;
        var e = truncate(Math.round(this.wo.left + (this.wo.width * c)));
        var f = truncate(Math.round(this.wo.top + (this.wo.height * d)));
        var g = this.yp(e, f);
        if (g < 0 || g > this._itemIndexes.length - 1) {
            return null;
        }
        var h = this._itemIndexes[g] - 1;
        if (h < 0 || h > this.dm.count) {
            return null;
        }
        return this.dm.item(h);
    };
    HighDensityScatterSeries.prototype.yp = function (a, b) {
        var c = (this.yg * b) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        var d = 1;
        c = (this.yg * (b - d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b + d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b - d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b + d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b - d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.yg * (b + d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        return 0;
    };
    HighDensityScatterSeries.prototype.zr = function (a, b, c) {
        this.wv = a;
        this.yg = b;
        this.yf = c;
    };
    HighDensityScatterSeries.prototype.get_g6 = function () {
        return true;
    };
    HighDensityScatterSeries.prototype.set_g6 = function (a) {
        _super.prototype.set_g6.call(this, a);
    };
    HighDensityScatterSeries.prototype.o4 = function (a, b) {
        _super.prototype.o4.call(this, a, b);
        this.wx.ca();
        if (this.ct != null) {
            this.ct.ca();
        }
        this.qj();
    };
    HighDensityScatterSeries.prototype.rr = function (a, b) {
        _super.prototype.rr.call(this, a, b);
        if (!this.gz) {
            this.cu.a4(b);
            return;
        }
        this.cu.a4(b);
        if (this.d4(this.ct)) {
            return;
        }
        var c = typeCast(HighDensityScatterSeriesView.$, this.ct);
        var d = new ScatterFrame();
        this.zi(false, c);
        this.gz = false;
    };
    HighDensityScatterSeries.prototype.ro = function (a, b, c, d, e) {
        _super.prototype.ro.call(this, a, b, c, d, e);
        var f = this.ba.a$j.item(d);
        var g = f;
        f.a3(c);
        if (this.d4(g)) {
            return;
        }
        if (this.w5 == null) {
            this.w5 = new ScatterFrame();
        }
        this.zi(false, f);
    };
    HighDensityScatterSeries.prototype.o1 = function () {
        _super.prototype.o1.call(this);
        this.w0 = null;
        this.w2 = null;
    };
    HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    HighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:z8:zt', [Color.$, Defaults.ap], 'HeatMaximum:ya:zu', [1, 50], 'HeatMinimumColor:z9:zv', [Color.$, Defaults.aq], 'HeatMinimum:yb:zw', [1, 0], 'PointExtent:yn:zx', [1, 1], 'ProgressiveLoad:xf:zy', [0, true], 'UseBruteForce:xg:zz', [0, false], 'XAxis:w0:z0', [NumericXAxis.$, null], 'XMemberAsLegendLabel:yz:z1', [2, null], 'XMemberAsLegendUnit:y1:z2', [2, null], 'XMemberPath:y3:z3', [2, null], 'YAxis:w2:z4', [NumericYAxis.$, null], 'YMemberAsLegendLabel:y7:z5', [2, null], 'YMemberAsLegendUnit:y9:z6', [2, null], 'YMemberPath:zb:z7', [2, null]]);
    return HighDensityScatterSeries;
}(Series));
export { HighDensityScatterSeries };
/**
 * @hidden
 */
var HighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighDensityScatterSeriesView, _super);
    function HighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b2 = null;
        _this.b0 = null;
        _this.b8 = 0;
        _this.b7 = 0;
        _this.b5 = null;
        _this.b6 = null;
        _this.b3 = null;
        _this.b2 = a;
        return _this;
    }
    HighDensityScatterSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.b2.z9 = Defaults.aq;
            this.b2.z8 = Defaults.ap;
            this.b2.vb = Defaults.al;
            this.b2.vr = Defaults.ak;
        }
    };
    HighDensityScatterSeriesView.prototype.cd = function () {
        this.b2.zr(this.b0, this.b8, this.b7);
    };
    HighDensityScatterSeriesView.prototype.b9 = function () {
        if (this.b5 == null) {
            this.b5 = this.e.jy.createElement("canvas");
            var a = this.e.jy.get2DCanvasContext(this.b5);
            this.b3 = new RenderingContext(new CanvasViewRenderer(), a);
        }
        var b;
        if (this.p) {
            b = this.bx;
        }
        else {
            b = this.e.da.v2();
        }
        var c = truncate(Math.round(b.left));
        var d = truncate(Math.round(b.top));
        var e = truncate(Math.round(b.width));
        var f = truncate(Math.round(b.height));
        var g = this.b8;
        var h = this.b7;
        this.b8 = e;
        this.b7 = f;
        if (g != this.b8 || h != this.b7 || this.b0 == null) {
            this.b5.setAttribute("width", e.toString());
            this.b5.setAttribute("height", f.toString());
            this.b6 = this.b3.h().getImageData(0, 0, e, f);
            var imageDataArray_ = this.b6.data;
            this.b0 = imageDataArray_;
        }
        this.b2.zr(this.b0, this.b8, this.b7);
    };
    HighDensityScatterSeriesView.prototype.b1 = function () {
        return this.b0;
    };
    HighDensityScatterSeriesView.prototype.cc = function () {
        var a = truncate(Math.round(this.bx.left));
        var b = truncate(Math.round(this.bx.left));
        var c = truncate(Math.round(this.bx.width));
        var d = truncate(Math.round(this.bx.height));
        this.b3.h().putImageData(this.b6, 0, 0);
        this.as();
    };
    HighDensityScatterSeriesView.prototype.cb = function (a) {
        if (this.e.jy != null) {
            this.e.jy.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    HighDensityScatterSeriesView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (b) {
            if (!this.b2.f7) {
                return;
            }
            var c = new Rectangle();
            c.n = this.bx.left;
            c.o = this.bx.top;
            c.width = this.bx.width;
            c.height = this.bx.height;
            c._fill = this.br();
            a.w(c);
            return;
        }
        if (this.b5 == null) {
            return;
        }
        var d = truncate(Math.round(this.bx.left));
        var e = truncate(Math.round(this.bx.top));
        var f = truncate(Math.round(this.bx.width));
        var g = truncate(Math.round(this.bx.height));
        this.k.o(this.b5.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
    };
    HighDensityScatterSeriesView.prototype.b4 = function (a, b) {
        return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
    };
    HighDensityScatterSeriesView.prototype.ca = function () {
        if (this.b0 != null) {
            for (var a = 0; a < this.b0.length; a++) {
                this.b0[a] = 0;
            }
            this.cc();
        }
    };
    HighDensityScatterSeriesView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        if (this.b0 == null) {
            this.e.bc.exportSeriesPixelsData(a, null, this.b8, this.b7);
            return;
        }
        var b = new Array(intDivide(this.b0.length, 4));
        var c;
        for (var d = 0; d < intDivide(this.b0.length, 4); d++) {
            c = d * 4;
            b[d] = this.b0[c + 3] << 24 | this.b0[c] << 16 | this.b0[c + 1] << 8 | this.b0[c + 2];
        }
        this.e.bc.exportSeriesPixelsData(a, b, this.b8, this.b7);
    };
    HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
}(SeriesView));
export { HighDensityScatterSeriesView };
