/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, enumGetBox, EnumUtil, Array_$type, runOn, delegateCombine, typeCast, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { DependencyProperty } from "igniteui-react-core";
import { RadialLabelMode_$type } from "igniteui-react-core";
import { CategoryCollisionMode_$type } from "./CategoryCollisionMode";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { BindingFormatter } from "igniteui-react-core";
import { OthersCategoryContext } from "./OthersCategoryContext";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { RadialFrame } from "./RadialFrame";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { ProportionalRadialLabelContext } from "./ProportionalRadialLabelContext";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-react-core";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cw.ic;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.by;
        var c = this.a.bx;
        var d = this.a.getEffectiveViewport();
        var e = this.a.cw.yu;
        if (b.isEmpty || c.isEmpty || e == null || this.a.cw.dm == null || this.a.cw.dm.count == 0) {
            this.b = 0;
            return;
        }
        var f = Math.floor(e.m7(c, d, b));
        var g = Math.ceil(e.m6(c, d, b));
        if (e.ch) {
            g = Math.ceil(e.m7(c, d, b));
            f = Math.floor(e.m6(c, d, b));
        }
        if (g < f) {
            g = e.lh + g;
        }
        var h = this.a.cw.y0;
        var i = h != null ? h.n6 : 0.75;
        var j = Math.min(c.width, c.height) * 0.5 * (i) * 2 * Math.PI;
        var k = Math.floor((g - f + 1) * a / j);
        this.b = truncate(Math.max(1, k));
        this.c = truncate(Math.max(0, Math.floor(f / this.b) - 1));
        this.d = truncate(Math.ceil(g / this.b));
        if (e.cl) {
            this.b = 1;
            this.c = truncate(Math.max(0, Math.floor(f / this.b) - 1));
            this.d = truncate(Math.ceil(g / this.b));
        }
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.zb = null;
        _this.zi = false;
        _this.zh = false;
        _this.zf = null;
        _this.zg = null;
        _this.assigningRadialStyle = null;
        _this.assigningRadialMarkerStyle = null;
        _this.yn = null;
        _this.yr = null;
        _this.yo = null;
        _this.yq = null;
        _this.yp = null;
        _this.y1 = new OthersCategoryContext();
        _this.y7 = new RadialFrame(4);
        _this.y8 = new RadialFrame(4);
        _this.y5 = new RadialFrame(4);
        _this.y3 = null;
        _this.yz = null;
        _this.yz = new CategoryTransitionSourceFramePreparer();
        _this.zb = new RadialSeriesRenderManager();
        return _this;
    }
    RadialBase.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.y4 = a;
    };
    RadialBase.prototype.aa3 = function () {
        if (this.db.g) {
            this.db.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.yu;
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.a0 = function () {
        return this.yu;
    };
    RadialBase.prototype.yi = function (a, b) {
        return null;
    };
    RadialBase.prototype.pq = function (a) {
        if (a == this.y2) {
            if (this.fh) {
                this.ba.a$x(this, a, this.yu.li - 1);
            }
            return;
        }
        _super.prototype.pq.call(this, a);
    };
    RadialBase.prototype.ed = function (a) {
        if (a == this.y2 && this.yu != null && this.yu.cl && this.yu.hasOthersCategory) {
            return true;
        }
        return _super.prototype.ed.call(this, a);
    };
    RadialBase.prototype.po = function (a) {
        if (a == this.y2) {
            if (this.fh) {
                this.ba.a$an(this, a, this.dm.count - 1);
            }
            return;
        }
        _super.prototype.po.call(this, a);
    };
    RadialBase.prototype.ea = function (a, b, c, d, e) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var f = this.yu;
        var g = new ScalerParams(1, this.da.vx, this.wo, f.ch);
        g.c = this.getEffectiveViewport1(this.cu);
        var h = this.y0;
        var i = new ScalerParams(1, this.da.vx, this.wo, h.ch);
        i.c = this.getEffectiveViewport1(this.cu);
        var j = this.z0;
        a.clear();
        this.w1.cj(function (k) {
            if (k._visibility == 0) {
                var l = new SeriesPointOfInterest();
                var m = k.n;
                var n = k.o;
                if (m < _this.wo.left || m > _this.wo.right || n < _this.wo.top || n > _this.wo.bottom) {
                    return;
                }
                var o = null;
                if (k.content != null) {
                    o = k.content.item;
                }
                var p = void 0;
                var q = void 0;
                var r = _this.y3.h(m, n, _this.cu.by, _this.cu.bx, _this.cu.getEffectiveViewport(), p, q);
                p = r.p5;
                q = r.p6;
                l.d = p;
                l.e = q;
                var s = l.e;
                var t = k.ak;
                l.f = _this.aa0(s, o, t, d, j, c, b, false);
                l.b = k.content;
                l.g = _this.vc;
                l.c = k.ak;
                if (_this.g8) {
                    l.g = _this.vj(k.ak);
                }
                l.a = _this.ar(k.ak, k.al);
                a.add(l);
            }
        });
        return true;
    };
    RadialBase.prototype.kr = function (a, b) {
        var c = null;
        if (this.dm != null) {
            if (a >= 0 && a < this.dm.count) {
                c = this.dm.item(a);
            }
            if (this.yu != null && this.yu.cl && a == this.yu.othersIndex) {
                c = this.y2;
            }
        }
        var d = NaN;
        if (c != null) {
            d = this.jb(c);
        }
        var e = this.aa0(d, c, a, this.zz >= 0 ? this.zz : 5, this.z0, false, false, b);
        if (e != null) {
            return e;
        }
        return _super.prototype.kr.call(this, a, b);
    };
    RadialBase.prototype.aa0 = function (a, b, c, d, e, f, g, h) {
        var i = null;
        var j = (b == this.y2);
        var k = this.y9;
        if (h) {
            k = this.za;
        }
        if (k == 0) {
            if (h) {
                k = 5;
            }
            else {
                k = 6;
            }
        }
        if ((h && ((this.yo != null) || (j && this.yp != null))) || (!h && ((this.yr != null) || (j && this.yq != null)))) {
            var l_1 = this.zw(a, b, c, d, f);
            var m_1 = this.zx(a, b, c, e, f);
            var n_1 = this.aah(c);
            var o = ((function () {
                var $ret = new ProportionalRadialLabelContext();
                $ret.value = l_1;
                $ret.percent = m_1;
                $ret.label = n_1;
                $ret.item = b;
                return $ret;
            })());
            var p = null;
            if (j) {
                if (h) {
                    p = this.yp;
                }
                else {
                    p = this.yq;
                }
                if (p == null) {
                    if (h) {
                        p = this.yo;
                    }
                    else {
                        p = this.yr;
                    }
                }
            }
            else {
                if (h) {
                    p = this.yo;
                }
                else {
                    p = this.yr;
                }
            }
            i = p.i(o);
        }
        else if (k != 1) {
            switch (k) {
                case 2:
                    i = this.aai(a, b, c, d, f);
                    break;
                case 3:
                    i = this.aaj(a, b, c, e, f);
                    break;
                case 4:
                    {
                        var q = this.aai(a, b, c, d, f);
                        var r = this.aaj(a, b, c, e, f);
                        i = q + this.z8 + r;
                    }
                    break;
                case 5:
                    i = this.aah(c);
                    break;
                case 6:
                    {
                        var s = this.aai(a, b, c, d, f);
                        var t = this.aah(c);
                        i = t + this.z8 + s;
                    }
                    break;
                case 7:
                    {
                        var u = this.aaj(a, b, c, e, f);
                        var v = this.aah(c);
                        i = v + this.z8 + u;
                    }
                    break;
                case 8:
                    {
                        var w = this.aai(a, b, c, d, f);
                        var x = this.aaj(a, b, c, e, f);
                        var y = this.aah(c);
                        i = y + this.z8 + w + this.z8 + x;
                    }
                    break;
            }
        }
        else {
            if (g) {
                i = this.aai(a, b, c, d, f);
            }
            else {
                i = this.aah(c);
            }
        }
        return i;
    };
    RadialBase.prototype.aah = function (a) {
        var b = this.yu;
        var c = this.au(true);
        if (this.yu != null && this.yu.cl && this.yu.hasOthersCategory && a == this.yu.othersIndex) {
            if (this.yn != null) {
                c = this.yn;
            }
        }
        if (c != null) {
            var d = _super.prototype.kr.call(this, a, false);
            if (d != null) {
                return c.i(d);
            }
            else {
                return null;
            }
        }
        else {
            return b.ge(a);
        }
    };
    RadialBase.prototype.aai = function (a, b, c, d, e) {
        var f = a;
        f = this.z4(c, f);
        if (e) {
            return this.z6(f, d);
        }
        else {
            a = this.jb(b);
            if (!isNaN_(a)) {
                return this.z6(a, d);
            }
            else {
                return this.z6(f, d);
            }
        }
    };
    RadialBase.prototype.zw = function (a, b, c, d, e) {
        var f = a;
        f = this.z4(c, f);
        if (e) {
            return f;
        }
        else {
            a = this.jb(b);
            if (!isNaN_(a)) {
                return a;
            }
            else {
                return f;
            }
        }
    };
    RadialBase.prototype.aaj = function (a, b, c, d, e) {
        if (this.yu == null || !this.yu.cl) {
            return this.aai(a, b, c, d, e);
        }
        var f = this.yu.n8(c);
        if (e) {
            return this.z6(f, d) + "%";
        }
        else {
            a = this.yu.n8(c);
            if (!isNaN_(a)) {
                return this.z6(a, d) + "%";
            }
            else {
                return this.z6(f, d) + "%";
            }
        }
    };
    RadialBase.prototype.zx = function (a, b, c, d, e) {
        if (this.yu == null || !this.yu.cl) {
            return this.zw(a, b, c, d, e);
        }
        var f = this.yu.n8(c);
        if (e) {
            return f;
        }
        else {
            a = this.yu.n8(c);
            if (!isNaN_(a)) {
                return a;
            }
            else {
                return f;
            }
        }
    };
    RadialBase.prototype.z4 = function (a, b) {
        return b;
    };
    RadialBase.prototype.z6 = function (a, b) {
        var c;
        if (b >= 0) {
            c = round10N(a, b);
        }
        else {
            c = a;
        }
        var d = this.au(false);
        if (d != null) {
            var e = d;
            return e.i(c);
        }
        else {
            return c.toString();
        }
    };
    RadialBase.prototype.get_fs = function () {
        return true;
    };
    RadialBase.prototype.get_fd = function () {
        return true;
    };
    RadialBase.prototype.zc = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.dm.count - 1;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    RadialBase.prototype.zt = function () {
        return false;
    };
    RadialBase.prototype.hs = function () {
        var a = _super.prototype.hs.call(this);
        if (this.zt()) {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "DashArray";
                $ret.p = true;
                $ret.x = ((function () {
                    var $ret = new DoubleCollection();
                    $ret.add(5);
                    $ret.add(5);
                    return $ret;
                })());
                $ret.q = true;
                return $ret;
            })());
            a.add(b);
        }
        if (!this.zt()) {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.rx));
            a.add(c);
        }
        if (!this.zt()) {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.rx));
            a.add(d);
        }
        var e = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(e);
        var f = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(f);
        return a;
    };
    RadialBase.prototype.ku = function () {
        if (this.d2()) {
            return this.bm.y8;
        }
        else {
            return this.bm.y5;
        }
    };
    RadialBase.prototype.zd = function (a, b, c) {
        if (this.dm == null) {
            return null;
        }
        var d = this.y4.cx.c;
        var e = this.y4.cx.d;
        var f = this.y4.cx.b;
        var g = this.y6();
        var h = this.dm.count;
        var i = this.yu;
        var j = -1;
        var k = -1;
        var l = this.j2(b);
        if (isNaN_(b.x) || isNaN_(b.y)) {
            if (a != null && this.dm != null) {
                if (a == this.y2) {
                    l = this.yu.othersIndex;
                }
                else {
                    l = this.dm.indexOf(a);
                }
            }
        }
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.g == j && c.f == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.i = this;
        m.g = j;
        m.f = k;
        return m;
    };
    RadialBase.prototype.ze = function (a, b, c) {
        if (this.dm == null) {
            return null;
        }
        var d = this.y4.cx.c;
        var e = this.y4.cx.d;
        var f = this.y4.cx.b;
        var g = this.y6();
        var h = this.dm.count;
        var i = this.yu;
        var j = -1;
        var k = -1;
        var l = this.j2(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.g == j && c.f == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.d = true;
        m.i = this;
        m.g = j;
        m.f = k;
        return m;
    };
    RadialBase.prototype.df = function (a, b, c) {
        if (this.ec && this.fy(this.bw) && !c) {
            var d = this.zd(a, b, this.zf);
            this.zf = d;
            return d;
        }
        else {
            var e = this.zc(a, b, this.zf);
            this.zf = e;
            return e;
        }
    };
    RadialBase.prototype.dg = function (a, b, c) {
        if (this.fy(this.bw) && !c) {
            var d = this.ze(a, b, this.zg);
            this.zg = d;
            return d;
        }
        else {
            var e = this.zc(a, b, this.zg);
            e.d = true;
            this.zg = e;
            return e;
        }
    };
    RadialBase.prototype.zs = function () {
        return (this.assigningRadialStyle != null && this.zi) || this.d1 || (this.bw != 1) || (this.co != 1) || (this.cn != 1);
    };
    RadialBase.prototype.zr = function () {
        return (this.assigningRadialMarkerStyle != null && this.zh) || this.d1 || (this.bw != 1) || (this.co != 1) || (this.cn != 1);
    };
    RadialBase.prototype.aa6 = function (a) {
        if (this.assigningRadialStyle != null && this.zi) {
            this.assigningRadialStyle(this, a);
        }
    };
    RadialBase.prototype.aa5 = function (a) {
        if (this.assigningRadialMarkerStyle != null && this.zh) {
            this.assigningRadialMarkerStyle(this, a);
        }
    };
    RadialBase.prototype.z1 = function (a) {
        return a.cx.b;
    };
    RadialBase.prototype.z2 = function (a) {
        return a.cx.c;
    };
    RadialBase.prototype.ai = function () {
        return [this.yu, this.y0];
    };
    RadialBase.prototype.sn = function (a, b) {
        this.y4.cx.e(this.ic);
        this.rp(false);
    };
    RadialBase.prototype.sm = function (a, b) {
        if (this.g0 && this.jp < 0.05 && (this.da == null || !this.da.fm())) {
            this.g1 = true;
            this.g4 = false;
            this.gj = false;
        }
        this.y4.cx.e(this.ic);
        this.rp(false);
    };
    RadialBase.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.yu != null) {
                        this.yu.b0(this);
                    }
                    if (this.y0 != null) {
                        this.y0.b0(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.yu != null) {
                        this.yu.ct(this);
                    }
                    if (this.y0 != null) {
                        this.y0.ct(this);
                    }
                }
                this.y4.cx.e(this.ic);
                this.rp(false);
                break;
            case RadialBase.$$p[0]:
                if (this.yu != null && this.y0 != null) {
                    this.y3 = new RadialAxes(this.y0, this.yu);
                }
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.y4.cx.e(this.ic);
                this.rp(false);
                break;
            case RadialBase.$$p[22]:
                if (this.yu != null && this.y0 != null) {
                    this.y3 = new RadialAxes(this.y0, this.yu);
                }
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.y4.cx.e(this.ic);
                if (this.y0 == null || !this.y0.c1()) {
                    this.rp(false);
                }
                break;
            case RadialBase.$$p[3]:
            case RadialBase.$$p[4]:
                if (this.aaa != null) {
                    this.yn = new BindingFormatter();
                    this.yn.j = this.aaa;
                    this.yn.d = this.yh;
                }
                else {
                    this.yn = null;
                }
                break;
            case RadialBase.$$p[19]:
            case RadialBase.$$p[20]:
                if (this.aax != null) {
                    this.yr = new BindingFormatter();
                    this.yr.j = this.aax;
                    this.yr.d = this.ym;
                }
                else {
                    this.yr = null;
                }
                break;
            case RadialBase.$$p[12]:
            case RadialBase.$$p[13]:
                if (this.aan != null) {
                    this.yo = new BindingFormatter();
                    this.yo.j = this.aan;
                    this.yo.d = this.yj;
                }
                else {
                    this.yo = null;
                }
                break;
            case RadialBase.$$p[17]:
            case RadialBase.$$p[18]:
                if (this.aax != null) {
                    this.yq = new BindingFormatter();
                    this.yq.j = this.aau;
                    this.yq.d = this.yl;
                }
                else {
                    this.yq = null;
                }
                break;
            case RadialBase.$$p[15]:
            case RadialBase.$$p[16]:
                if (this.aan != null) {
                    this.yp = new BindingFormatter();
                    this.yp.j = this.aar;
                    this.yp.d = this.yk;
                }
                else {
                    this.yp = null;
                }
                break;
            case "SyncLink":
                if (this.c2 != null && this.da != null) {
                    this.y4.cx.e(this.ic);
                    this.rp(false);
                }
                break;
            case "TransitionProgress":
                this.y8.c(this.jp, this.y7, this.y5);
                if (this.d4(this.cu)) {
                    return;
                }
                if (this.jp == 1) {
                    this.y5.w();
                    this.aa7(this.y5, this.y4);
                    if (this.g0) {
                        this.g0 = false;
                        this.o5();
                        this.db.r = truncate(this.i8());
                        this.db.b = this.dc;
                    }
                    if (this.g3) {
                        this.g3 = false;
                        this.o5();
                        this.db.r = truncate(this.i8());
                        this.db.b = this.dc;
                        this.qy();
                    }
                    this.qm();
                }
                else {
                    this.aa7(this.y8, this.y4);
                }
                if (this.da != null) {
                    this.da.qj(this);
                }
                break;
            case RadialBase.$$p[8]:
                this.rp(false);
                this.qj();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.y4.cx.e(this.ic);
                }
                break;
            case RadialBase.$$p[10]:
                this.zi = this.zq();
                this.rp(false);
                break;
            case RadialBase.$$p[9]:
                this.zh = this.zp();
                this.rp(false);
                break;
        }
    };
    RadialBase.prototype.zq = function () {
        return this.zn;
    };
    RadialBase.prototype.zp = function () {
        return this.zm;
    };
    RadialBase.prototype.zk = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.zj = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.get_y2 = function () {
        return this.y1;
    };
    Object.defineProperty(RadialBase.prototype, "y2", {
        get: function () {
            return this.get_y2();
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.km = function (a) {
        var b = this.j2(a);
        var c = false;
        if (this.yu != null && this.yu.cl) {
            var d = this.yu;
            var e = d.hasOthersCategory && b == this.yu.lh - 1;
            c = e;
        }
        if (c) {
            var f = this.yu;
            return this.y2;
        }
        return b >= 0 && this.dm != null && b < this.dm.count ? this.dm.item(b) : null;
    };
    RadialBase.prototype.zu = function (a) {
        var b = this.cu.by;
        var c = this.cu.bx;
        var d = this.cu.getEffectiveViewport();
        if (this.yu != null && !b.isEmpty && !c.isEmpty && this.y3 != null) {
            var e = this.y3.c(a, b, c, d);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            return e;
        }
        return NaN;
    };
    RadialBase.prototype.iq = function (a) {
        var b = this.cu.by;
        var c = this.cu.bx;
        var d = this.getEffectiveViewport1(this.cu);
        var e = -1;
        if (this.yu != null && !b.isEmpty && !c.isEmpty && this.y3 != null) {
            var f = this.y3.c(a, b, c, d);
            if (f < 0) {
                f += Math.PI * 2;
            }
            if (f > Math.PI * 2) {
                f -= Math.PI * 2;
            }
            var g = this.yu.getUnscaledAngle(f);
            if (this.yu.categoryMode != 0) {
                g -= 0.5;
            }
            e = g;
        }
        return e;
    };
    RadialBase.prototype.zv = function (a, b, c, d) {
        return this.yu.m5(a, b, c, d);
    };
    RadialBase.prototype.j2 = function (a) {
        var b = truncate(Math.round(this.iq(a)));
        var c = false;
        if (this.yu != null && this.yu.cl) {
            var d = this.yu;
            var e = d.hasOthersCategory && b == this.yu.lh - 1;
            c = e;
        }
        if (c) {
            var f = this.yu;
            return this.yu.lh - 1;
        }
        if (this.dm != null && b == this.dm.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.gc = function (a) {
        return false;
    };
    RadialBase.prototype.y6 = function () {
        var a = this.y5;
        if (this.d2()) {
            if (this.db.g) {
                this.db.t();
            }
            a = this.y8;
        }
        return a;
    };
    RadialBase.prototype.p8 = function () {
        _super.prototype.p8.call(this);
        if (this.yu != null) {
            this.yu.h9(false);
        }
        if (this.y0 != null) {
            this.y0.h9(false);
        }
    };
    RadialBase.prototype.hd = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.hd.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.yu == null || this.yu.itemsSource == null || this.y0 == null || this.y3 == null || this.dm == null || this.yu.bi == null || this.y0.bi == null || this.y0.l2 == this.y0.l1) {
            e.cx.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.yx = function () {
        return 1;
    };
    RadialBase.prototype.zy = function () {
        return Math.max(0, 0.5 * this.y0.n5);
    };
    RadialBase.prototype.gm = function () {
        return this.zo;
    };
    RadialBase.prototype.gn = function () {
        return true;
    };
    RadialBase.prototype.rq = function (a) {
        _super.prototype.rq.call(this, a);
        this.y4.cx.e(this.ic);
        if (this.d4(this.cu)) {
            this.y5.z();
            this.y8.z();
            this.y7.z();
            return;
        }
        if (this.gq) {
            if (this.d2()) {
                if (this.db.g) {
                    this.db.t();
                }
                this.aa7(this.y8, this.y4);
            }
            else {
                this.aa7(this.y5, this.y4);
            }
            return;
        }
        if (this.ge(a)) {
            var b = this.y7;
            if (this.d2()) {
                if (this.db.g) {
                    this.db.t();
                }
                this.y7 = this.y8;
                this.y8 = b;
            }
            else {
                this.y7 = this.y5;
                this.y5 = b;
            }
            var c = false;
            this.aa4(this.y5, this.y4);
            if (this.g2) {
                this.db.w();
                this.db.r = truncate(this.i9());
                this.db.b = this.dd != null ? this.dd : this.dc;
                if (this.g3) {
                    var d = this.y8;
                    this.y8 = this.y7;
                    this.y7 = d;
                    c = true;
                }
                this.yz.s(this, this.y7, this.y5, this.isVertical, this.yu, this.y0, this.yy, this.yx(), this.c4, this.c3(), runOn(this, this.zy), this.y4.bx);
                if (this.g3) {
                    var e = this.y8;
                    this.y8 = this.y7;
                    this.y7 = e;
                }
                this.g3 = false;
            }
            if (this.g5) {
                this.db.w();
                this.db.r = truncate(this.ja());
                this.db.b = this.de != null ? this.de : this.dc;
                if (this.g0) {
                    var f = this.y8;
                    this.y8 = this.y7;
                    this.y7 = f;
                    c = true;
                }
                this.yz.s(this, this.y7, this.y5, this.isVertical, this.yu, this.y0, this.yy, this.yx(), this.c4, this.c3(), runOn(this, this.zy), this.y4.bx);
                var g = this.y5;
                this.y5 = this.y7;
                this.y7 = g;
                if (this.g0) {
                    var h = this.y8;
                    this.y8 = this.y7;
                    this.y7 = h;
                }
                this.g0 = false;
            }
            this.d8 = false;
            if (!c) {
                this.o0();
            }
            this.r3();
            if (this.g2) {
                this.g1 = false;
                this.g0 = true;
            }
            if (this.g5) {
                this.g4 = false;
                this.g3 = true;
            }
        }
        else {
            this.aa4(this.y5, this.y4);
            this.aa7(this.y5, this.y4);
        }
    };
    RadialBase.prototype.z3 = function () {
        var e_1, _a;
        if (this.bm != null) {
            var a = this.bm;
            return a.z3();
        }
        var b = 0;
        try {
            for (var _b = __values(fromEnum(this.da.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c == this || this.bm == c) {
                    return b;
                }
                var d = typeCast(RadialBase.$, c);
                if (d != null && d.yu == this.yu && d.preferredCategoryMode(d.yu) == 2) {
                    b++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.p1(a, c, b);
        return c.toArray();
    };
    RadialBase.prototype.p1 = function (a, b, c) {
        var _this = this;
        var d = this.cu.by;
        var e = this.cu.bx;
        var f = this.cu.getEffectiveViewport();
        var g, h;
        var i = this.y3.f(a, d, e, f, g, h);
        g = i.p4;
        h = i.p5;
        if (g == -1 || h == -1) {
            return;
        }
        var j = h - g + 1;
        if (g > h) {
            j = this.yu.li - g + h + 1;
        }
        if (j > 0 && (c == 7 || c == 6)) {
            b.add(((function () {
                var $ret = new ChartSelection();
                $ret.series = _this;
                return $ret;
            })()));
            return;
        }
        var _loop_1 = function (k) {
            var l = (k + g) % (this_1.yu.li);
            if (c == 2 || c == 1) {
                b.add(((function () {
                    var $ret = new ChartSelection();
                    $ret.item = _this.yu.kt.item(l);
                    return $ret;
                })()));
            }
            else {
                b.add(((function () {
                    var $ret = new ChartSelection();
                    $ret.item = _this.yu.kt.item(l);
                    $ret.series = _this;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var k = 0; k < j; k++) {
            _loop_1(k);
        }
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:yu:aa8', [CategoryAngleAxis.$, null], 'AutoCalloutLabelPrecision:zz:aa9', [1, -1], 'AutoCalloutLabelValueSeparator:z8:aba', [2, " - "], 'AutoCalloutOthersLabelFormat:aaa:abb', [2, null], 'AutoCalloutOthersLabelFormatSpecifiers:yh:abc', [Array_$type, null], 'AutoCalloutPercentagePrecision:z0:abd', [1, 2], 'AutoCalloutRadialLabelMode:y9:abe', [RadialLabelMode_$type, enumGetBox(RadialLabelMode_$type, 0)], 'CategoryCollisionMode:yv:abf', [CategoryCollisionMode_$type, enumGetBox(CategoryCollisionMode_$type, 1)], 'ClipSeriesToBounds:zl:abg', [0, false], 'IsCustomRadialMarkerStyleAllowed:zm:abh', [0, false], 'IsCustomRadialStyleAllowed:zn:abi', [0, false], 'IsTransitionInEnabled:zo:abj', [0, false], 'LegendProportionalRadialLabelFormat:aan:abk', [2, null], 'LegendProportionalRadialLabelFormatSpecifiers:yj:abl', [Array_$type, null], 'LegendRadialLabelMode:za:abm', [RadialLabelMode_$type, enumGetBox(RadialLabelMode_$type, 0)], 'OthersLegendProportionalRadialLabelFormat:aar:abn', [2, null], 'OthersLegendProportionalRadialLabelFormatSpecifiers:yk:abo', [Array_$type, null], 'OthersProportionalRadialLabelFormat:aau:abp', [2, null], 'OthersProportionalRadialLabelFormatSpecifiers:yl:abq', [Array_$type, null], 'ProportionalRadialLabelFormat:aax:abr', [2, null], 'ProportionalRadialLabelFormatSpecifiers:ym:abs', [Array_$type, null], 'TransitionInMode:yy:abt', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'ValueAxis:y0:abu', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cx = null;
        _this.cw = null;
        _this.cy = null;
        _this.cz = 0;
        _this.c0 = null;
        _this.cw = a;
        _this.cy = new Pool$1(Marker.$);
        _this.cn(_this.cy);
        return _this;
    }
    RadialBaseView.prototype.cj = function (a) {
        this.cy.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
