import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private aau;
    get aav(): IAnchoredCategorySeriesInteractionManager;
    aaq: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    md(): string;
    protected cr(): SeriesView;
    qz(a: SeriesView): void;
    aa1: boolean;
    constructor();
    abi: string;
    kp(a: any, b: string): any;
    mc(a: string): string;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private aaw;
    aba: string;
    abe: string;
    abg: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ab5(): Brush;
    set ab5(a: Brush);
    static readonly abr: DependencyProperty;
    trendLineThickness: number;
    ab7: PenLineCap;
    ab6: DoubleCollection;
    trendLinePeriod: number;
    aa5: number;
    gc(a: any): boolean;
    protected aan(a: number, b: number, c: Axis): any[];
    protected q7(a: any, b: string, c: any, d: any): void;
    ay(a: Axis): AxisRange;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected zp(): number;
    aa4(a: CategorySeriesView): number;
    abo(a: PointCollection, b: number, c: CategorySeriesView): void;
    aao(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    aap(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected ga(): boolean;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    private abk;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    o4(a: boolean, b: SeriesView): void;
    aac(a: CategoryFrame, b: CategorySeriesView): void;
    aaf(a: CategoryFrame, b: CategorySeriesView): void;
    aar: CategoryFrame;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abl(a: CategoryFrame, b: CategorySeriesView): void;
    protected sd(): void;
    kw(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected aa8: string;
    protected aa7: string;
    abstract abm(a: Axis): void;
    abstract abn(a: Axis): void;
    protected pw(a: any): void;
    aas: CategorySeriesMarkerCollisionAvoidance;
    km(a: Point): any;
    aat: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    ix(): number;
    protected get_aa6(): number;
    protected get aa6(): number;
    az(a: Rect): AxisRange;
    private abq;
    private aay;
    private aa2;
    aa3: number;
    private abp;
    i7(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wb(a: ValueLayerValueMode): Point;
    wc(a: number[]): Point;
    z8(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    aa0(a: number, b: number, c: number): boolean;
    aaz(a: number, b: number, c: number): boolean;
    z2(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c5: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c6;
    get c7(): ITrendLineManager;
    set c7(a: ITrendLineManager);
    get c8(): boolean;
    dc(): void;
    da(): void;
    c9(): void;
    cx(): CategoryBucketCalculator;
    db(): void;
    dd(): void;
    de(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
