import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Type, Point } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { Axis } from "./Axis";
import { RadialFrame } from "./RadialFrame";
import { SeriesView } from "./SeriesView";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { AxisRange } from "./AxisRange";
import { IFastItemsSource } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { Clipper } from "igniteui-react-core";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { PointCollection } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
    static $t: Type;
    private f;
    constructor(a: AnchoredRadialSeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare abstract class AnchoredRadialSeries extends RadialBase {
    static $t: Type;
    protected cr(): SeriesView;
    o1(): void;
    md(): string;
    kp(a: any, b: string): any;
    mc(a: string): string;
    jb(a: any): number;
    protected ks(a: number): any;
    qz(a: SeriesView): void;
    abx: AnchoredRadialSeriesView;
    constructor();
    aby: CategoryLineRasterizer;
    j9(a: Point, b: boolean): number;
    j7(a: Point, b: boolean): number;
    io(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected ab8: boolean;
    i4(a: Point, b: boolean, c: boolean): number;
    v8(a: Point, b: boolean, c: boolean): Point;
    acc: boolean;
    acs: string;
    ack: string;
    protected ga(): boolean;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    private acy;
    get ab3(): IFastItemColumn$1<number>;
    set ab3(a: IFastItemColumn$1<number>);
    private ab2;
    aco: string;
    acq: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    ab1: TrendLineType;
    adg: Brush;
    get adf(): Brush;
    set adf(a: Brush);
    static readonly ac2: DependencyProperty;
    ach: number;
    adi: PenLineCap;
    adh: DoubleCollection;
    aci: number;
    acj: number;
    ay(a: Axis): AxisRange;
    protected z4(a: number, b: any): any;
    protected dj(a: string): IFastItemColumn$1<number>;
    protected acw(a: IFastItemsSource, b: IFastItemColumn$1<number>): void;
    protected q7(a: any, b: string, c: any, d: any): void;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_ab9(): boolean;
    protected get ab9(): boolean;
    protected get_ej(): boolean;
    protected get_f4(): boolean;
    protected ace(a: CategoryAngleAxis, b: Rect, c: Rect, d: Rect): number;
    protected acd(a: number, b: CategoryAngleAxis, c: Rect, d: Rect, e: Rect): number;
    acx(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: CategoryCollisionMode): void;
    protected get_acb(): boolean;
    protected get acb(): boolean;
    protected get_ab5(): boolean;
    protected get ab5(): boolean;
    aa4(a: RadialFrame, b: RadialBaseView): void;
    private acf;
    private acg;
    private aca;
    abw(a: List$1<number[]>, b: number, c: SeriesView): Clipper;
    protected adj: Point;
    ac1(a: PointCollection, b: PointCollection, c: PointCollection, d: PointCollection, e: boolean): void;
    private ab7;
    private ab6;
    o4(a: boolean, b: SeriesView): void;
    aa7(a: RadialFrame, b: RadialBaseView): void;
    protected abv(a: number, b: number, c: Axis): any[];
    protected acz(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected ac0(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    acv(a: RadialBaseView, b: RadialFrame): void;
    private acu;
    protected sd(): void;
    kw(a: any, b: Point): any;
    gc(a: any): boolean;
    ab0: RadialFrame;
    rr(a: Rect, b: RenderSurface): void;
    private abz;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected pw(a: any): void;
    private ab4;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredRadialSeriesView extends RadialBaseView {
    static $t: Type;
    c1: AnchoredRadialSeries;
    constructor(a: AnchoredRadialSeries);
    c2: RadialTrendLineManager;
    c3(a: Rect, b: Rect, c: Rect, d: Rect): void;
    c4(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
