import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Point, Type, IList$1 } from "igniteui-react-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-react-core";
import { AxisAngleLabelMode } from "./AxisAngleLabelMode";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-react-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { Geometry } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { GeometryGroup } from "igniteui-react-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export declare class AngleAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: AngleAxisLabelPanelView;
    constructor();
    da: boolean;
    di: (arg1: number, arg2: number, arg3: number) => Point;
    at(a: number, b: Rect): boolean;
    df: number;
    dc: number;
    de: number;
    dd: number;
    db: number;
    a5(): List$1<Rect>;
    private dk;
    private dj;
    private dh;
    private dg;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxis extends CategoryAxisBase implements IAngleScaler {
    static $t: Type;
    a4(): AxisView;
    ht(a: AxisView): void;
    mm: CategoryAngleAxisView;
    protected get_b9(): boolean;
    private mr;
    constructor();
    av(): AxisLabelPanelBase;
    mo: CategoryAxisRenderer;
    private ms;
    protected mv(a: number): boolean;
    protected ni(): string;
    private nb;
    private mz;
    private mn;
    protected mw(a: number): boolean;
    private nv;
    private nu;
    m3(): number;
    ml(a: Rect, b: Rect, c: Rect, d: Rect): AxisRenderingParametersBase;
    private nf;
    getMinMaxAngle(a: Rect, b: Rect, c: Rect, d: number, e: number): {
        p3: number;
        p4: number;
    };
    ac(): void;
    private mp;
    get mq(): NumericRadiusAxis;
    set mq(a: NumericRadiusAxis);
    ak(): Axis;
    nc: number;
    protected m0: number;
    mj: AxisAngleLabelMode;
    mk(): AxisAngleLabelMode;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    protected get_mt(): boolean;
    get mt(): boolean;
    m5(a: number, b: Rect, c: Rect, d: Rect): number;
    k6(a: Rect, b: Rect, c: Rect): number;
    m4(a: number, b: number, c: Rect, d: Rect, e: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    m8(a: number): number;
    protected ia(a: boolean): void;
    m7(a: Rect, b: Rect, c: Rect): number;
    m6(a: Rect, b: Rect, c: Rect): number;
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    ek(a: number, b: ScalerParams): number;
    en(a: number, b: ScalerParams): number;
    d4(a: Point): number;
    protected hx(a: any, b: string, c: any, d: any): void;
    private nn;
    np(a: NumericRadiusAxis): void;
    static readonly nq: DependencyProperty;
    get m9(): number;
    set m9(a: number);
    private mx;
    get m1(): number;
    set m1(a: number);
    ew(): number;
    static readonly ns: DependencyProperty;
    get na(): number;
    set na(a: number);
    private my;
    get m2(): number;
    set m2(a: number);
    protected mu(): boolean;
    protected get_a2(): AxisOrientation;
    get a2(): AxisOrientation;
    c3(): boolean;
    private nd;
    get ne(): number;
    set ne(a: number);
    j6(a: number, b: Rect, c: Rect, d: Rect, e: Rect): Geometry;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericAngleAxis extends NumericAxisBase implements IAngleScaler {
    static $t: Type;
    a4(): AxisView;
    ht(a: AxisView): void;
    n1: NumericAngleAxisView;
    n4: PolarAxisRenderingManager;
    protected get_b9(): boolean;
    constructor();
    av(): AxisLabelPanelBase;
    n8(): number;
    private oa;
    private n5;
    private n6;
    k0(): NumericAxisRenderer;
    private oj;
    ek(a: number, b: ScalerParams): number;
    getScaledAngle1(a: number, b: boolean, c: boolean): number;
    getScaledAngle(a: number): number;
    en(a: number, b: ScalerParams): number;
    getUnscaledAngle(a: number): number;
    ob: number;
    private n7;
    nz: AxisAngleLabelMode;
    n0(): AxisAngleLabelMode;
    protected hx(a: any, b: string, c: any, d: any): void;
    private oe;
    k4(): NumericAxisRenderingParameters;
    k3(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    getMinMaxAngle(a: Rect, b: Rect, c: Rect, d: number, e: number): {
        p3: number;
        p4: number;
    };
    protected ia(a: boolean): void;
    private n2;
    get n3(): NumericRadiusAxis;
    set n3(a: NumericRadiusAxis);
    ak(): Axis;
    og(a: NumericRadiusAxis): void;
    protected iq(a: Rect, b: Rect): void;
    protected get_a2(): AxisOrientation;
    get a2(): AxisOrientation;
    j6(a: number, b: Rect, c: Rect, d: Rect, e: Rect): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericRadiusAxis extends NumericAxisBase {
    static $t: Type;
    a4(): AxisView;
    ht(a: AxisView): void;
    n1: NumericRadiusAxisView;
    protected get_cm(): boolean;
    ej(): number;
    private oa;
    private n9;
    private n2;
    constructor();
    av(): AxisLabelPanelBase;
    n3: boolean;
    private n7;
    private n4;
    k0(): NumericAxisRenderer;
    ek(a: number, b: ScalerParams): number;
    od(a: number, b: boolean, c: boolean, d: number, e: number): number;
    oc(a: number): number;
    oe(a: number): number;
    en(a: number, b: ScalerParams): number;
    og: number;
    n6: number;
    of: number;
    n5: number;
    protected hx(a: any, b: string, c: any, d: any): void;
    protected n8: number;
    ol(a: Axis): void;
    private nz;
    get n0(): Axis;
    set n0(a: Axis);
    ak(): Axis;
    k4(): NumericAxisRenderingParameters;
    k3(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    private om;
    private oh;
    ob(): number;
    ni(a: AxisRangeChangedEventArgs): void;
    protected ia(a: boolean): void;
    protected iq(a: Rect, b: Rect): void;
    ok(a: GeometryGroup, b: Rect, c: Rect, d: Rect, e: Rect): void;
    protected get_a2(): AxisOrientation;
    get a2(): AxisOrientation;
    j6(a: number, b: Rect, c: Rect, d: Rect, e: Rect): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: AngleAxisLabelPanel;
    constructor(a: AngleAxisLabelPanel);
    an(): void;
    a1(a: List$1<Rect>, b: List$1<boolean>): void;
    a0(a: List$1<Rect>, b: List$1<boolean>): void;
    o(): number;
    p(): number;
    q(): number;
    r(): number;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bm: CategoryAngleAxis;
    constructor(a: CategoryAngleAxis);
    al(): void;
}
/**
 * @hidden
 */
export declare class NumericAngleAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bm: NumericAngleAxis;
    constructor(a: NumericAngleAxis);
    al(): void;
}
/**
 * @hidden
 */
export declare class NumericRadiusAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bm: NumericRadiusAxis;
    constructor(a: NumericRadiusAxis);
    al(): void;
}
