import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-react-core";
import { ISupportsSizeScale } from "./ISupportsSizeScale";
import { ISupportsFillScale } from "./ISupportsFillScale";
import { Rect } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { Series } from "./Series";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { MarkerFillMode } from "./MarkerFillMode";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Marker } from "./Marker";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries, ISupportsSizeScale, ISupportsFillScale {
    static $t: Type;
    protected bj(): Series;
    protected get_eh(): boolean;
    protected cr(): SeriesView;
    qz(a: SeriesView): void;
    acl: BubbleSeriesView;
    protected jk(): number;
    ww(): MarkerFillMode;
    constructor();
    private aec;
    private aeb;
    isAttachedTo(a: IChartLegend): boolean;
    protected eg(): boolean;
    protected pz(a: (arg1: any) => void): void;
    get act(): IFastItemColumn$1<number>;
    protected get_isColoredItemwise(): boolean;
    acz: List$1<UIElement>;
    private aea;
    get legendReady(): boolean;
    get minScaleText(): string;
    get maxScaleText(): string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    ado: string;
    kp(a: any, b: string): any;
    mc(a: string): string;
    get acv(): IFastItemColumn$1<number>;
    set acv(a: IFastItemColumn$1<number>);
    private acq;
    acn: SizeScale;
    ade: string;
    private acp;
    get acu(): IFastItemColumn$1<any>;
    set acu(a: IFastItemColumn$1<any>);
    ac9: string;
    ack: BrushScale;
    private aco;
    get acr(): IFastItemColumn$1<number>;
    set acr(a: IFastItemColumn$1<number>);
    acw: boolean;
    acx: boolean;
    ac3: number;
    ac2: number;
    acy: boolean;
    aaz(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    aba(a: ScatterFrame, b: ScatterBaseView): void;
    private adt;
    static ac0(a: number, b: number, c: number, d: number, e: number): number;
    static ac1(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    protected zm(a: string, b: FastItemsSourceEventAction): boolean;
    private ads;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    qb(): void;
    qi(): void;
    protected q7(a: any, b: string, c: any, d: any): void;
    updateSizeScaleGlobals(): void;
    updateFillScaleGlobals(): void;
    acj(a: SizeScale): ActualRange;
    aci(): ActualRange;
    acm: SizeScale;
    adv(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    adu(a: List$1<Marker>): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p1(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    private acs;
    adk: string;
    ac5: string;
    adm: string;
    ac7: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    get actualMarkerBrush(): Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected dk: BubbleSeries;
    constructor(a: BubbleSeries);
    au(): void;
    protected cz(): MarkerManagerBase;
    dm(): void;
    dn(): void;
    dl(): void;
    getDefaultTooltipTemplate(): string;
}
