import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Base, Type, Point } from "igniteui-react-core";
import { Series } from "./Series";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { LabelCollisionPlacementPositions } from "igniteui-react-core";
import { HighlightedValueLabelMode } from "igniteui-react-core";
import { AutoCalloutVisibilityMode } from "./AutoCalloutVisibilityMode";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CalloutCollisionMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Size } from "igniteui-react-core";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    protected bj(): Series;
    protected get_en(): boolean;
    constructor();
    private add;
    private adm;
    private ade;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ge(a: boolean): boolean;
    private aa9;
    private adr;
    private ads;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    acu: string;
    kp(a: any, b: string): any;
    mc(a: string): string;
    get aak(): IFastItemColumn$1<any>;
    set aak(a: IFastItemColumn$1<any>);
    private aaf;
    ac8: string;
    get aal(): IFastItemColumn$1<any>;
    set aal(a: IFastItemColumn$1<any>);
    private aag;
    adb: string;
    get aam(): IFastItemColumn$1<any>;
    set aam(a: IFastItemColumn$1<any>);
    private aah;
    aco: string;
    get aaj(): IFastItemColumn$1<any>;
    set aaj(a: IFastItemColumn$1<any>);
    private aae;
    aaz: boolean;
    acr: string;
    zt: any[];
    acg: string;
    get aai(): IFastItemColumn$1<any>;
    set aai(a: IFastItemColumn$1<any>);
    private aad;
    private aba;
    private abd;
    private adg;
    protected cr(): SeriesView;
    qz(a: SeriesView): void;
    protected z3: CalloutLayerView;
    private abe;
    acw: string;
    aaa: Series;
    acd: string;
    private z4;
    get z5(): CalloutPlacementPositionsCollection;
    set z5(a: CalloutPlacementPositionsCollection);
    zs: LabelCollisionPlacementPositions[];
    aay: boolean;
    aa3: boolean;
    aa6: boolean;
    gt(a: Series): boolean;
    aa2: boolean;
    aa4: boolean;
    aa5: boolean;
    aa7: boolean;
    z9: HighlightedValueLabelMode;
    get zy(): AutoCalloutVisibilityMode;
    set zy(a: AutoCalloutVisibilityMode);
    get zx(): AutoCalloutVisibilityMode;
    set zx(a: AutoCalloutVisibilityMode);
    static readonly ad9: DependencyProperty;
    abh: number;
    aa1: boolean;
    aa0: boolean;
    abq: number;
    ae1: Brush;
    aez: Brush;
    aex: Brush;
    aew: Brush;
    abr: number;
    ae0: Brush;
    aey: Brush;
    get ae5(): Thickness;
    abj: number;
    abl: number;
    abk: number;
    abi: number;
    z0: CalloutCollisionMode;
    abm: number;
    abn: number;
    acz: string;
    private aab;
    get aac(): FontInfo;
    protected yk(a: Series, b: boolean): void;
    protected ym(a: Frame, b: SeriesView): void;
    private abb;
    private aa8;
    private aan;
    private ae3;
    protected sn(a: Rect, b: Rect): void;
    protected sm(a: Rect, b: Rect): void;
    private aau;
    private abp;
    private ae2;
    get ae4(): Rect;
    set ae4(a: Rect);
    private aas;
    private adn;
    private adi;
    private aao;
    private abs;
    private abt;
    private aap;
    private adf;
    private aaq;
    private abo;
    private abf;
    private abu;
    protected xd(a: Series): boolean;
    qn(): void;
    private aat;
    adl(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private abc;
    private ado;
    private aaw;
    private aax;
    private abg;
    private aav;
    protected b1(): SeriesHitTestMode;
    a2(a: Point, b: boolean): DataContext;
    gv(a: Point, b: boolean): boolean;
    protected adq(a: CalloutLayerFrame, b: boolean): void;
    protected yp(a: Frame, b: SeriesView): void;
    protected f9(): boolean;
    private zv;
    protected q7(a: any, b: string, c: any, d: any): void;
    private zz;
    private zu;
    private adp;
    private aar;
    private zw;
    private adj;
    private adh;
    private adk;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected b7: CalloutLayer;
    private cc;
    au(): void;
    private b9;
    private cf;
    private ch;
    private cg;
    cb: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    cq(a: Brush): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    protected ca(): FontInfo;
    an(a: any): void;
    private cd;
    cs(a: TextBlock): Size;
    private ce;
    private b8;
    cr(a: any, b: Thickness): Size;
    cj(a: CalloutView, b: number, c: number): void;
    ck(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    cl(a: Series, b: Brush): Brush;
    co(): Brush;
    cm(): Brush;
    cp(a: Series, b: Brush): Brush;
    cn(a: Series, b: Brush): Brush;
    ci(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    y: Visibility;
    j(a: RenderingContext): void;
    private l;
    private t;
    private q;
    private s;
    get r(): Point;
    set r(a: Point);
    get p(): Brush;
    set p(a: Brush);
    get o(): Brush;
    set o(a: Brush);
    get n(): Brush;
    set n(a: Brush);
    get m(): Brush;
    set m(a: Brush);
    get e(): number;
    set e(a: number);
    private w;
    private v;
    get x(): Thickness;
    set x(a: Thickness);
    private c;
    get d(): number;
    set d(a: number);
    get h(): any;
    set h(a: any);
    f: number;
    g: number;
    u(): Size;
    private b;
    k(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    i(a: CalloutLayer, b: FontInfo, c: any): void;
}
