import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    private z4;
    private z2;
    private z3;
    private z1;
    private z5;
    ku(): any;
    qz(a: SeriesView): void;
    xi: FinancialSeriesView;
    protected get_e5(): boolean;
    ai(): Axis[];
    kp(a: any, b: string): any;
    mc(a: string): string;
    protected y1(): number;
    private yz;
    aj(a: Point): Point[][];
    al(a: Point): Point[][];
    constructor();
    aar: Brush;
    vs(): Brush;
    vt(): Brush;
    o1(): void;
    protected get_ej(): boolean;
    protected get_f4(): boolean;
    w1: CategoryAxisBase;
    xk: NumericYAxis;
    zr: string;
    get xx(): IFastItemColumn$1<number>;
    set xx(a: IFastItemColumn$1<number>);
    private xs;
    zi: string;
    get xv(): IFastItemColumn$1<number>;
    set xv(a: IFastItemColumn$1<number>);
    private xq;
    zn: string;
    get xw(): IFastItemColumn$1<number>;
    set xw(a: IFastItemColumn$1<number>);
    private xr;
    y5: string;
    get xu(): IFastItemColumn$1<number>;
    set xu(a: IFastItemColumn$1<number>);
    private xp;
    zv: string;
    get xz(): IFastItemColumn$1<number>;
    set xz(a: IFastItemColumn$1<number>);
    private xt;
    ze: string;
    za: string;
    zc: string;
    y8: string;
    zg: string;
    protected ga(): boolean;
    x7: boolean;
    protected x2: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    x9(): boolean;
    protected z8(a: AssigningCategoryStyleEventArgs): void;
    protected xa: CategorySeriesRenderManager;
    protected z6(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    yr(a: Point): number;
    j9(a: Point, b: boolean): number;
    j7(a: Point, b: boolean): number;
    io(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    v8(a: Point, b: boolean, c: boolean): Point;
    i4(a: Point, b: boolean, c: boolean): number;
    i0(a: Point, b: boolean, c: boolean): number;
    i2(a: Point, b: boolean, c: boolean): number;
    yt(a: Point, b: boolean, c: boolean): number;
    yu(a: Point, b: boolean, c: boolean): number;
    yv(a: Point, b: boolean, c: boolean): number;
    v4(a: Point, b: boolean, c: boolean): Point;
    v6(a: Point, b: boolean, c: boolean): Point;
    aat(a: Point, b: boolean, c: boolean): Point;
    aas(a: Point, b: boolean, c: boolean): Point;
    aau(a: Point, b: boolean, c: boolean): Point;
    p8(): void;
    protected sn(a: Rect, b: Rect): void;
    protected sm(a: Rect, b: Rect): void;
    protected yc: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected yd: Dictionary$2<string, string>;
    private xy;
    private z0;
    private x1;
    protected q7(a: any, b: string, c: any, d: any): void;
    x4(a: any): boolean;
    x3(a: any): boolean;
    protected wu(a: number, b: number, c: Axis): any[];
    protected yy(a: SeriesView): number;
    protected y0(a: SeriesView): number;
    wt(a: number, b: number): any[];
    private xo;
    protected get_fd(): boolean;
    o2(): void;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    y2(a: Point): number;
    protected xn(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected xm(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected x5(): boolean;
    iq(a: Point): number;
    j2(a: Point): number;
    protected get_fr(): boolean;
    a0(): CategoryAxisBase;
    j4(a: Point): number;
    km(a: Point): any;
    w5: CategoryFrame;
    w7: CategoryFrame;
    w3: CategoryFrame;
    w4(): CategoryFrame;
    protected ys(a: Rect, b: Rect, c: Rect): number;
    xc: CategoryTransitionInMode;
    x8: boolean;
    protected gm(): boolean;
    protected xb(): CategoryTransitionInMode;
    protected c3(): TransitionInSpeedType;
    protected c6(): TransitionOutSpeedType;
    z9(a: CategoryFrame, b: FinancialSeriesView): void;
    z7(a: CategoryFrame, b: FinancialSeriesView): void;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    xd: CategoryTransitionSourceFramePreparer;
    yw(a: FinancialSeriesView): number;
    protected o5(): void;
    rq(a: boolean): void;
    protected gn(): boolean;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected ya(a: IList$1<string>): boolean;
    get yb(): boolean;
    protected x6(): boolean;
    protected zz(a: FinancialEventArgs): void;
    protected get yj(): IEnumerable$1<number>;
    private _yg;
    private yg;
    protected get yi(): IEnumerable$1<number>;
    private _yf;
    private yf;
    protected get yh(): IEnumerable$1<number>;
    private _ye;
    private ye;
    yl(a: IList$1<number>): IList$1<number>;
    private x0;
    protected yk(): IList$1<string>;
    private yp;
    getOpenColumnAsArray(): number[];
    private yn;
    getHighColumnAsArray(): number[];
    private yo;
    getLowColumnAsArray(): number[];
    private ym;
    getCloseColumnAsArray(): number[];
    private yq;
    getVolumeColumnAsArray(): number[];
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected xe(a: number, b: number): FinancialCalculationDataSource;
    yx(a: number): number;
    protected xf(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private w6;
    rr(a: Rect, b: RenderSurface): void;
    private w2;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aw(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private w8;
    get w9(): CategoryMode;
    set w9(a: CategoryMode);
    protected get_fl(): boolean;
    rz(a: Brush, b: Brush): void;
    private aaa;
    private xj;
    private xl;
    ko(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    b2: FinancialSeries;
    b0: FinancialBucketCalculator;
    b4: number;
    b3(a: CategoryFrame): boolean;
    b5(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract b1(): FinancialBucketCalculator;
    au(): void;
    getDefaultTooltipTemplate(): string;
    protected af(): void;
}
