import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Clipper } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class FinancialIndicator extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_e6(): boolean;
    protected cr(): SeriesView;
    qz(a: SeriesView): void;
    aaw: FinancialIndicatorView;
    constructor();
    aa9(a: boolean): void;
    protected aa1(a: Point, b: Point, c: boolean): boolean;
    protected b1(): SeriesHitTestMode;
    wj(a: Point): Rect;
    gv(a: Point, b: boolean): boolean;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aay: IndicatorDisplayType;
    protected get_aax(): IndicatorDisplayType;
    get aax(): IndicatorDisplayType;
    aa4: number;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get abm(): Brush;
    set abm(a: Brush);
    static readonly abc: DependencyProperty;
    trendLineThickness: number;
    abo: PenLineCap;
    abn: DoubleCollection;
    trendLinePeriod: number;
    protected aa6(): number;
    aa5: number;
    private _indicatorColumn;
    get indicatorColumn(): List$1<number>;
    set indicatorColumn(a: List$1<number>);
    protected aav: AxisRange;
    protected abstract aaz(a: number, b: number): boolean;
    protected abstract aa2(a: number, b: number): IList$1<string>;
    protected q7(a: any, b: string, c: any, d: any): void;
    i4(a: Point, b: boolean, c: boolean): number;
    j9(a: Point, b: boolean): number;
    j7(a: Point, b: boolean): number;
    protected get_hc(): boolean;
    private aa0;
    private abb;
    ay(a: Axis): AxisRange;
    gc(a: any): boolean;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    z7(a: CategoryFrame, b: FinancialSeriesView): void;
    o4(a: boolean, b: SeriesView): void;
    protected xb(): CategoryTransitionInMode;
    z9(a: CategoryFrame, b: FinancialSeriesView): void;
    protected sd(): void;
    protected aba(): void;
    protected pw(a: any): void;
    protected be(a: LegendItemBadgeShape): LegendItemBadgeShape;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: FinancialIndicatorView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorView extends FinancialSeriesView {
    static $t: Type;
    b6: FinancialIndicator;
    constructor(a: FinancialIndicator);
    protected b1(): FinancialBucketCalculator;
    au(): void;
    private readonly b9;
    private cj;
    private cc;
    cx: Path;
    ct: Path;
    cy: Path;
    cu: Path;
    cz: Path;
    cv: Path;
    cw: Path;
    cs: Path;
    private b7;
    get b8(): ITrendLineManager;
    set b8(a: ITrendLineManager);
    get ca(): boolean;
    cb(a: boolean): void;
    ch(): void;
    cf(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: Clipper): void;
    cd(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number, f: Clipper): void;
    ce(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number): void;
    ci(): void;
    private cp;
    private cr;
    private cq;
    private co;
    private cl;
    private cn;
    private cm;
    private ck;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    protected a7(a: RenderingContext, b: boolean): void;
    an(a: any): void;
    cg(): void;
}
