import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PriceDisplayType } from "./PriceDisplayType";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { Series } from "./Series";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { GeometryGroup } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { NumericAxisBase } from "./NumericAxisBase";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected bj(): Series;
    protected get_e8(): boolean;
    protected jj(): number;
    protected cr(): SeriesView;
    qz(a: SeriesView): void;
    aax: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get acg(): Brush;
    set acg(a: Brush);
    static readonly abx: DependencyProperty;
    trendLineThickness: number;
    acj: PenLineCap;
    aci: DoubleCollection;
    trendLinePeriod: number;
    aa4: number;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aay: PriceDisplayType;
    aaw: CategoryCollisionMode;
    protected b1(): SeriesHitTestMode;
    wj(a: Point): Rect;
    private aav;
    ao(a: Point): Rect[];
    gv(a: Point, b: boolean): boolean;
    protected gy(a: Point, b: boolean): boolean;
    protected q7(a: any, b: string, c: any, d: any): void;
    private abw;
    ay(a: Axis): AxisRange;
    az(a: Rect): AxisRange;
    ix(): number;
    gc(a: any): boolean;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    z7(a: CategoryFrame, b: FinancialSeriesView): void;
    o4(a: boolean, b: SeriesView): void;
    protected sm(a: Rect, b: Rect): void;
    wq(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected get_ec(): boolean;
    z9(a: CategoryFrame, b: FinancialSeriesView): void;
    iv(): number;
    private abu;
    private aa2;
    private abt;
    kw(a: any, b: Point): any;
    protected sd(): void;
    protected pw(a: any): void;
    ach: Brush;
    vt(): Brush;
    rz(a: Brush, b: Brush): void;
    protected be(a: LegendItemBadgeShape): LegendItemBadgeShape;
    abf: string;
    abb: string;
    aa6: string;
    abk: string;
    abh: string;
    abd: string;
    aa8: string;
    abm: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private aaz;
    private aa0;
    aa1: number;
    private abv;
    aq(a: ValueLayerValueMode): number[];
    wb(a: ValueLayerValueMode): Point;
    wc(a: number[]): Point;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p1(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    abq(a: Rect, b: CategoryAxisBase, c: boolean, d: Rect, e: number, f: number): {
        p4: number;
        p5: number;
    };
    abp(a: Rect, b: NumericAxisBase, c: boolean, d: Rect, e: number, f: number): {
        p4: number;
        p5: number;
    };
    abo(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    abs(a: List$1<ChartSelection>, b: number, c: number, d: SeriesSelectionBehavior): void;
    abr(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    static $t: Type;
    protected b6: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b9: Pool$1<Path>;
    cr(): Path;
    protected cc: List$1<Path>;
    ch(a: Path): void;
    cj(a: Path): void;
    ci(a: Path): void;
    protected b1(): FinancialBucketCalculator;
    au(): void;
    private cq;
    private cp;
    private b7;
    get b8(): ITrendLineManager;
    set b8(a: ITrendLineManager);
    get ca(): boolean;
    ck(): void;
    ce(): void;
    cd(): void;
    cn(): GeometryGroup;
    cm(): GeometryGroup;
    cl(): void;
    protected bd(): void;
    protected be(): void;
    protected ac(a: number): any;
    private co;
    protected ab(a: number): any;
    protected a8(a: RenderingContext, b: boolean): void;
    protected a7(a: RenderingContext, b: boolean): void;
    an(a: any): void;
    cf(): void;
    cb: boolean;
    cg(): void;
}
