import { MarkerSeries } from "./MarkerSeries";
import { Point, Type } from "igniteui-react-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { HighlightingInfo } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Axis } from "./Axis";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { OwnedPoint } from "./OwnedPoint";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { AssigningPolarStyleEventArgs } from "./AssigningPolarStyleEventArgs";
import { AssigningPolarMarkerStyleEventArgs } from "./AssigningPolarMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class PolarBase extends MarkerSeries {
    static $t: Type;
    protected cr(): SeriesView;
    qz(a: SeriesView): void;
    ys: PolarBaseView;
    private yt;
    o1(): void;
    protected get_fo(): boolean;
    ea(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    constructor();
    private aa1;
    private aa3;
    private yk;
    yr: PolarAxisInfoCache;
    private aca;
    private ab9;
    private ab8;
    y5: SeriesRenderer$2<PolarFrame, PolarBaseView>;
    aae: string;
    aaw: string;
    aaj: string;
    aah: string;
    protected ga(): boolean;
    protected zt(): boolean;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    private aa5;
    private aa4;
    protected get ze(): IFastItemColumn$1<number>;
    protected set ze(a: IFastItemColumn$1<number>);
    private zc;
    protected get zf(): IFastItemColumn$1<number>;
    protected set zf(a: IFastItemColumn$1<number>);
    private zd;
    yo: NumericAngleAxis;
    yp: NumericRadiusAxis;
    zu: boolean;
    z4: number;
    y6: TrendLineType;
    ab3: Brush;
    get ab2(): Brush;
    set ab2(a: Brush);
    static readonly abd: DependencyProperty;
    z2: number;
    ab5: PenLineCap;
    ab4: DoubleCollection;
    z5: number;
    z6: number;
    zk: boolean;
    yx: PolarFrame;
    yz: PolarFrame;
    yv: PolarFrame;
    yw(): PolarFrame;
    yq: PolarAxes;
    p8(): void;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected sm(a: Rect, b: Rect): void;
    protected sn(a: Rect, b: Rect): void;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    rq(a: boolean): void;
    private ab7;
    ay(a: Axis): AxisRange;
    gc(a: any): boolean;
    km(a: Point): any;
    j2(a: Point): number;
    iq(a: Point): number;
    protected zy(a: Point): number;
    protected zx(a: Point): number;
    private zl;
    private zv;
    private z1;
    protected z0(a: Point): number;
    protected zz(a: Point): number;
    v8(a: Point, b: boolean, c: boolean): Point;
    ai(): Axis[];
    kp(a: any, b: string): any;
    mc(a: string): string;
    protected q7(a: any, b: string, c: any, d: any): void;
    private y1;
    get y2(): ScatterItemSearchMode;
    set y2(a: ScatterItemSearchMode);
    protected y3(): ScatterItemSearchMode;
    protected get_zo(): boolean;
    protected get zo(): boolean;
    protected zq(): boolean;
    protected zp(): boolean;
    y4: ScatterItemSearchMode;
    z3: number;
    zj(a: any): boolean;
    zi(a: any): boolean;
    o4(a: boolean, b: SeriesView): void;
    private yl;
    aa0(a: PolarFrame, b: number, c: Rect, d: Rect): void;
    aa8(a: PolarFrame, b: PolarBaseView): void;
    zn: boolean;
    zm: boolean;
    protected zh: boolean;
    protected zg: boolean;
    protected get_fd(): boolean;
    private za;
    private zb;
    protected y8(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected y9(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected y7(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    dg(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningPolarStyle: (sender: any, args: AssigningPolarStyleEventArgs) => void;
    assigningPolarMarkerStyle: (sender: any, args: AssigningPolarMarkerStyleEventArgs) => void;
    protected zs(): boolean;
    protected zr(): boolean;
    abc(a: PolarFrame, b: PolarBaseView): void;
    yi(a: number, b: number): any[];
    protected yj(a: number, b: number): any[];
    protected y0: PolarSeriesRenderManager;
    aa2(a: PolarBaseView, b: PolarFrame): void;
    protected aa7(a: number, b: number, c: boolean): void;
    protected aa6(a: number, b: number, c: boolean): void;
    protected aba(a: AssigningPolarStyleEventArgs): void;
    protected aa9(a: AssigningPolarMarkerStyleEventArgs): void;
    private aaz;
    protected sd(): void;
    yy: PolarFrame;
    rr(a: Rect, b: RenderSurface): void;
    private yu;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abb(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    yh(a: HashPool$2<any, Marker>, b: Rect, c: Rect): Point[];
    zw(a: HashPool$2<any, Marker>): List$1<number>;
    ab6(a: number): Point;
    protected pw(a: any): void;
    aas: string;
    aaa: string;
    aau: string;
    aac: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p1(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PolarSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningPolarMarkerStyleEventArgs;
    ax: AssigningPolarStyleEventArgs;
    ay(a: PolarBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class PolarBaseView extends MarkerSeriesView {
    static $t: Type;
    protected cz: PolarBase;
    cy: MarkerManagerBase;
    constructor(a: PolarBase);
    c0: PolarTrendLineManager;
    au(): void;
    c4(a: (arg1: Marker) => void): void;
    protected cx(): MarkerManagerBase;
    protected c5(a: IDictionary$2<any, OwnedPoint>): void;
    protected cw(): Point[];
    protected c2(): List$1<number>;
    c3(a: Rect, b: Rect, c: Rect, d: Rect): void;
    c6(): void;
    c1: HashPool$2<any, Marker>;
    cj(a: (arg1: Marker) => void): void;
    protected a7(a: RenderingContext, b: boolean): void;
    protected c7(): Rect;
    getDefaultTooltipTemplate(): string;
}
