import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { RadialLabelMode } from "igniteui-react-core";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { OthersCategoryContext } from "./OthersCategoryContext";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { RadialFrame } from "./RadialFrame";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { AssigningRadialStyleEventArgs } from "./AssigningRadialStyleEventArgs";
import { AssigningRadialMarkerStyleEventArgs } from "./AssigningRadialMarkerStyleEventArgs";
import { RadialAxes } from "./RadialAxes";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class RadialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: RadialBaseView;
    constructor(a: RadialBaseView);
    c: number;
    d: number;
    b: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RadialBase extends MarkerSeries implements IHasCategoryModePreference {
    static $t: Type;
    qz(a: SeriesView): void;
    y4: RadialBaseView;
    constructor();
    private aa3;
    get categoryAxis(): CategoryAxisBase;
    a0(): CategoryAxisBase;
    yi(a: number, b: number): any[];
    zz: number;
    z0: number;
    z8: string;
    za: RadialLabelMode;
    yv: CategoryCollisionMode;
    y9: RadialLabelMode;
    aaa: string;
    yh: any[];
    aax: string;
    ym: any[];
    aan: string;
    yj: any[];
    aau: string;
    yl: any[];
    aar: string;
    yk: any[];
    protected zb: RadialSeriesRenderManager;
    pq(a: any): void;
    ed(a: any): boolean;
    po(a: any): void;
    ea(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    protected kr(a: number, b: boolean): any;
    protected aa0(a: any, b: any, c: number, d: number, e: number, f: boolean, g: boolean, h: boolean): string;
    private aah;
    private aai;
    private zw;
    private aaj;
    private zx;
    protected z4(a: number, b: any): any;
    private z6;
    protected get_fs(): boolean;
    zn: boolean;
    zm: boolean;
    yy: CategoryTransitionInMode;
    zo: boolean;
    protected zi: boolean;
    protected zh: boolean;
    protected get_fd(): boolean;
    private zf;
    private zg;
    protected zc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zt(): boolean;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    ku(): any;
    protected zd(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected ze(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    dg(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningRadialStyle: (sender: any, args: AssigningRadialStyleEventArgs) => void;
    assigningRadialMarkerStyle: (sender: any, args: AssigningRadialMarkerStyleEventArgs) => void;
    protected zs(): boolean;
    protected zr(): boolean;
    protected aa6(a: AssigningRadialStyleEventArgs): void;
    protected aa5(a: AssigningRadialMarkerStyleEventArgs): void;
    z1(a: SeriesView): number;
    z2(a: SeriesView): number;
    yu: CategoryAngleAxis;
    y0: NumericRadiusAxis;
    ai(): Axis[];
    zl: boolean;
    protected sn(a: Rect, b: Rect): void;
    protected sm(a: Rect, b: Rect): void;
    abstract preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private yn;
    private yr;
    private yo;
    private yq;
    private yp;
    protected q7(a: any, b: string, c: any, d: any): void;
    protected zq(): boolean;
    protected zp(): boolean;
    zk(a: any): boolean;
    zj(a: any): boolean;
    private y1;
    protected get_y2(): OthersCategoryContext;
    get y2(): OthersCategoryContext;
    km(a: Point): any;
    zu(a: Point): number;
    iq(a: Point): number;
    zv(a: number, b: Rect, c: Rect, d: Rect): number;
    j2(a: Point): number;
    gc(a: any): boolean;
    y7: RadialFrame;
    y8: RadialFrame;
    y5: RadialFrame;
    y6(): RadialFrame;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    abstract aa4(a: RadialFrame, b: RadialBaseView): void;
    abstract aa7(a: RadialFrame, b: RadialBaseView): void;
    y3: RadialAxes;
    p8(): void;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    yz: CategoryTransitionSourceFramePreparer;
    protected yx(): CategoryTransitionInMode;
    protected zy(): number;
    protected gm(): boolean;
    protected gn(): boolean;
    rq(a: boolean): void;
    z3(): number;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p1(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialBaseView extends MarkerSeriesView {
    static $t: Type;
    cx: RadialBucketCalculator;
    cw: RadialBase;
    constructor(a: RadialBase);
    cy: Pool$1<Marker>;
    cj(a: (arg1: Marker) => void): void;
    cz: number;
    c0: Point;
}
