import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { MarkerCollisionMode } from "./MarkerCollisionMode";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected cr(): SeriesView;
    o1(): void;
    qz(a: SeriesView): void;
    ys: ScatterBaseView;
    protected get_fv(): boolean;
    ai(): Axis[];
    kp(a: any, b: string): any;
    mc(a: string): string;
    ea(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    protected b1(): SeriesHitTestMode;
    wl(a: Point): Rect;
    gv(a: Point, b: boolean): boolean;
    constructor();
    yr: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    aao: string;
    get zc(): IFastItemColumn$1<number>;
    set zc(a: IFastItemColumn$1<number>);
    private za;
    aaw: string;
    get zd(): IFastItemColumn$1<number>;
    set zd(a: IFastItemColumn$1<number>);
    private zb;
    z8: string;
    aaa: string;
    protected ga(): boolean;
    protected zr(): boolean;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    private aa3;
    private aa4;
    aak: string;
    aas: string;
    aam: string;
    aau: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get acd(): Brush;
    set acd(a: Brush);
    static readonly abo: DependencyProperty;
    trendLineThickness: number;
    acf: PenLineCap;
    ace: DoubleCollection;
    trendLinePeriod: number;
    yo: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    z5: number;
    z4: number;
    y3: ScatterItemSearchMode;
    z3: number;
    p8(): void;
    yt: ScatterErrorBarSettings;
    protected q7(a: any, b: string, c: any, d: any): void;
    protected zo(): boolean;
    protected zn(): boolean;
    zi(a: any): boolean;
    zh(a: any): boolean;
    private abm;
    private acg;
    private ach;
    private aay;
    protected zm(a: string, b: FastItemsSourceEventAction): boolean;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    abd(a: ScatterFrame): void;
    abe(a: ScatterFrame, b: Clipper): void;
    ay(a: Axis): AxisRange;
    km(a: Point): any;
    private y0;
    get y1(): ScatterItemSearchMode;
    set y1(a: ScatterItemSearchMode);
    protected y2(): ScatterItemSearchMode;
    j2(a: Point): number;
    iq(a: Point): number;
    protected zz(a: Point): number;
    private yh;
    private yi;
    protected zy(a: Point): number;
    private aa1;
    protected get_zl(): boolean;
    protected get zl(): boolean;
    private z2;
    protected z1(a: Point): number;
    protected zx(a: Point): number;
    protected z0(a: Point): number;
    v8(a: Point, b: boolean, c: boolean): Point;
    gc(a: any): boolean;
    protected sm(a: Rect, b: Rect): void;
    protected sn(a: Rect, b: Rect): void;
    yx: ScatterFrame;
    yz: ScatterFrame;
    yv: ScatterFrame;
    yw(): ScatterFrame;
    aaz(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    aba(a: ScatterFrame, b: ScatterBaseView): void;
    o4(a: boolean, b: SeriesView): void;
    zk: boolean;
    zj: boolean;
    protected zg: boolean;
    protected zf: boolean;
    protected get_fd(): boolean;
    private y8;
    private y9;
    protected y6(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected y7(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    wq(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected y5(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    dg(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected zq(): boolean;
    protected zp(): boolean;
    abl(a: ScatterFrame, b: ScatterBaseView): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p1(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    aa2(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: MarkerCollisionMode, e: IFastItemColumn$1<number>): void;
    yk(a: number, b: number): any[];
    protected yl(a: number, b: number): any[];
    protected y4: ScatterSeriesRenderManager;
    aa0(a: ScatterBaseView, b: ScatterFrame): void;
    protected aa6(a: number, b: number, c: boolean): void;
    protected aa5(a: number, b: number, c: boolean): void;
    protected abg(a: AssigningScatterStyleEventArgs): void;
    protected abf(a: AssigningScatterMarkerStyleEventArgs): void;
    aa8(a: ScatterFrame, b: ScatterBaseView): void;
    abb(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    aa9(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    aa7(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    abc(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    abi(a: ScatterFrame, b: ScatterBaseView): void;
    private abj;
    private abk;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    rq(a: boolean): void;
    protected sd(): void;
    yy: ScatterFrame;
    rr(a: Rect, b: RenderSurface): void;
    private yu;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abh(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    yj(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    zs(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected pw(a: any): void;
    ix(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private ze;
    private zt;
    private zu;
    zv: number;
    zw: number;
    private abn;
    i7(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wc(a: number[]): Point;
    wb(a: ValueLayerValueMode): Point;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    c0: MarkerManagerBase;
    protected cy: Point[];
    protected c1: ScatterBase;
    protected c6: List$1<number>;
    constructor(a: ScatterBase);
    private dh;
    private di;
    c2: ScatterTrendLineManager;
    au(): void;
    private dg;
    dj(a: Marker): Size;
    protected cz(): MarkerManagerBase;
    protected de(a: IDictionary$2<any, OwnedPoint>): void;
    c5(): List$1<Marker>;
    cx(): Point[];
    protected cw(): Point[];
    protected c4(): List$1<number>;
    c7(): void;
    dc(a: PathGeometry): void;
    c8(): void;
    dd(a: PathGeometry): void;
    df(): void;
    c3: HashPool$2<any, Marker>;
    cj(a: (arg1: Marker) => void): void;
    da(a: (arg1: Marker) => void): void;
    db(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    c9(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
