import { Control } from "igniteui-react-core";
import { INotifyPropertyChanged, Base, Type, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-react-core";
import { ILegendOwner } from "igniteui-react-core";
import { IInternalLegendOwner } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { ISupportsAnimation } from "igniteui-react-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-react-core";
import { ToolCommand } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { IHighlightingManager } from "igniteui-react-core";
import { DoubleAnimator } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { IChartLegend } from "igniteui-react-core";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesSelectionMode } from "./SeriesSelectionMode";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Brush } from "igniteui-react-core";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-react-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-react-core";
import { IOverviewPlusDetailPane } from "igniteui-react-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { ZoomCoercionMode } from "./ZoomCoercionMode";
import { ModifierKeys } from "igniteui-react-core";
import { SeriesHighlightedValuesDisplayMode } from "./SeriesHighlightedValuesDisplayMode";
import { DataTemplate } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { CanvasRenderScheduler } from "igniteui-react-core";
import { SyncSettings } from "./SyncSettings";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolCommandExecutionState } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { FrameworkElement } from "igniteui-react-core";
import { EventProxy } from "igniteui-react-core";
import { MouseEventArgs } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewerManipulationEventArgs } from "./SeriesViewerManipulationEventArgs";
import { IFastItemsSource } from "igniteui-react-core";
import { Key } from "igniteui-react-core";
import { RectChangedEventArgs } from "igniteui-react-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-react-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-react-core";
import { CoercionInfo } from "./CoercionInfo";
import { IDataLegendSeries } from "igniteui-react-core";
import { CaptureImageSettings } from "igniteui-react-core";
import { CultureInfo } from "igniteui-react-core";
import { ImageCapturedEventArgs } from "igniteui-react-core";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { IExecutionContext } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-react-core";
import { Geometry } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { ActualLegendItemBadgeShape } from "./ActualLegendItemBadgeShape";
import { StandardLegendItems } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-react-core";
import { Canvas } from "igniteui-react-core";
import { IFastItemsSourceProvider } from "igniteui-react-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-react-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-react-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-react-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-react-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { AutomaticSeriesPurpose } from "./AutomaticSeriesPurpose";
import { SeriesMatcher } from "./SeriesMatcher";
import { Stack$1 } from "igniteui-react-core";
import { RenderValidEventArgs } from "./RenderValidEventArgs";
import { SeriesLayerPropertyOverlayValueResolvingEventArgs } from "./SeriesLayerPropertyOverlayValueResolvingEventArgs";
import { HighlightingInfo } from "igniteui-react-core";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AutoMarginsAndAngleUpdateMode } from "./AutoMarginsAndAngleUpdateMode";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { ILegendSeries } from "igniteui-react-core";
import { ILegendSeriesInternal } from "igniteui-react-core";
import { ILegendTemplateProvider } from "igniteui-react-core";
import { PenLineJoin } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { CollisionGeometry } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { TransitionOutCompletedEventArgs } from "./TransitionOutCompletedEventArgs";
import { ISortingAxis } from "./ISortingAxis";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner, IDataLegendTarget, IToolbarTarget, ISupportsAnimation {
    static $t: Type;
    private _widget;
    get widget(): ISeriesViewerWidget;
    set widget(a: ISeriesViewerWidget);
    c9: SeriesViewerView;
    static staticInit(): void;
    private ds;
    private get dt();
    private an;
    ao(a: SeriesViewer): AutomaticSeriesManager;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private gk;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private nz;
    private a8;
    get a9(): IDataChartToolbarProvider;
    get fh(): boolean;
    private ba;
    get bb(): ISeriesViewerInteractionManager;
    get e9(): boolean;
    constructor();
    private q4;
    private nn;
    private eb;
    protected pn(a: any, b: NotifyCollectionChangedEventArgs): void;
    private ea;
    protected o0(a: any, b: NotifyCollectionChangedEventArgs): void;
    private o7;
    private o5;
    np(a: (arg1: Series) => void): void;
    private o8;
    private o6;
    private c1;
    nu(): void;
    private p8;
    protected get_fs(): boolean;
    get fs(): boolean;
    protected get_fr(): boolean;
    get fr(): boolean;
    nv(): void;
    get series(): SeriesCollection;
    private br;
    private iv;
    private q6;
    private bz;
    get b0(): SeriesPlotAreaMarginHorizontalMode;
    set b0(a: SeriesPlotAreaMarginHorizontalMode);
    private b1;
    get b2(): SeriesPlotAreaMarginVerticalMode;
    set b2(a: SeriesPlotAreaMarginVerticalMode);
    nx(): void;
    protected ol(): void;
    private _skipDataCleanup;
    get skipDataCleanup(): boolean;
    set skipDataCleanup(a: boolean);
    protected qy(a: any): void;
    get ev(): boolean;
    private q7;
    n1(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    eu(): boolean;
    get f5(): boolean;
    protected get e5(): boolean;
    protected get en(): boolean;
    protected get em(): boolean;
    get el(): boolean;
    get dk(): IHighlightingManager;
    get dl(): IHighlightingManager;
    get dj(): IHighlightingManager;
    get bc(): ISeriesViewerScrollbarManager;
    private nj;
    private nk;
    private ni;
    db: DoubleAnimator;
    dd: DoubleAnimator;
    da: DoubleAnimator;
    dc: DoubleAnimator;
    private nt;
    private q5;
    private no;
    gb(a: number): boolean;
    gc(a: number): boolean;
    ga(a: number): boolean;
    ns(): void;
    u3(a: number): Brush;
    u9(a: number): Brush;
    u7(a: number): Brush;
    u8(a: number): Brush;
    private u2;
    ag: BrushCollection;
    aj: BrushCollection;
    ah: BrushCollection;
    ai: BrushCollection;
    bg: MarkerAutomaticBehavior;
    ar: ChartContentManager;
    get vo(): Point;
    set vo(a: Point);
    private vn;
    qu(): void;
    get e8(): boolean;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly s8: DependencyProperty;
    get ej(): boolean;
    set ej(a: boolean);
    plotAreaMouseLeftButtonDown: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseLeftButtonUp: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaClicked: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseEnter: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseLeave: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseOver: (sender: any, e: PlotAreaMouseEventArgs) => void;
    pi(a: Point, b: boolean): void;
    private bh;
    private bl;
    pj(a: Point, b: boolean, c: boolean): void;
    static readonly r8: DependencyProperty;
    get fi(): boolean;
    set fi(a: boolean);
    static readonly s4: DependencyProperty;
    get f4(): boolean;
    set f4(a: boolean);
    static readonly tw: DependencyProperty;
    get by(): SeriesHighlightingMode;
    set by(a: SeriesHighlightingMode);
    static readonly sm: DependencyProperty;
    get cb(): SeriesSelectionMode;
    set cb(a: SeriesSelectionMode);
    static readonly ts: DependencyProperty;
    get b6(): SeriesSelectionBehavior;
    set b6(a: SeriesSelectionBehavior);
    static readonly tq: DependencyProperty;
    get b9(): SeriesSelectionMode;
    set b9(a: SeriesSelectionMode);
    static readonly sg: DependencyProperty;
    get ch(): SeriesViewerScrollbarMode;
    set ch(a: SeriesViewerScrollbarMode);
    protected cf: SeriesViewerScrollbarMode;
    static readonly su: DependencyProperty;
    get ci(): SeriesViewerScrollbarMode;
    set ci(a: SeriesViewerScrollbarMode);
    protected cg: SeriesViewerScrollbarMode;
    static readonly ua: DependencyProperty;
    get ce(): SeriesViewerHorizontalScrollbarPosition;
    set ce(a: SeriesViewerHorizontalScrollbarPosition);
    static readonly sw: DependencyProperty;
    get cl(): SeriesViewerVerticalScrollbarPosition;
    set cl(a: SeriesViewerVerticalScrollbarPosition);
    static readonly uc: DependencyProperty;
    get vb(): Brush;
    set vb(a: Brush);
    static readonly sq: DependencyProperty;
    get vc(): Brush;
    set vc(a: Brush);
    static readonly sv: DependencyProperty;
    get hv(): number;
    set hv(a: number);
    static readonly sy: DependencyProperty;
    get hu(): number;
    set hu(a: number);
    static readonly st: DependencyProperty;
    get hr(): number;
    set hr(a: number);
    static readonly sp: DependencyProperty;
    get hs(): number;
    set hs(a: number);
    static readonly sr: DependencyProperty;
    get ht(): number;
    set ht(a: number);
    static readonly ss: DependencyProperty;
    get hx(): number;
    set hx(a: number);
    static readonly s0: DependencyProperty;
    get hw(): number;
    set hw(a: number);
    static readonly sz: DependencyProperty;
    get ex(): boolean;
    set ex(a: boolean);
    static readonly kg: string;
    static readonly sx: DependencyProperty;
    get vl(): Brush;
    set vl(a: Brush);
    static readonly t7: DependencyProperty;
    get vm(): Brush;
    set vm(a: Brush);
    static readonly ub: DependencyProperty;
    get ii(): number;
    set ii(a: number);
    static readonly ue: DependencyProperty;
    get ih(): number;
    set ih(a: number);
    static readonly t9: DependencyProperty;
    get ie(): number;
    set ie(a: number);
    static readonly t6: DependencyProperty;
    get il(): number;
    set il(a: number);
    m9(): void;
    private pl;
    static readonly uh: DependencyProperty;
    get ig(): number;
    set ig(a: number);
    static readonly t8: DependencyProperty;
    get ik(): number;
    set ik(a: number);
    static readonly ug: DependencyProperty;
    get ij(): number;
    set ij(a: number);
    static readonly uf: DependencyProperty;
    get gg(): boolean;
    set gg(a: boolean);
    static readonly mj: string;
    static readonly ud: DependencyProperty;
    private ca;
    private b5;
    private bx;
    private bu;
    get bv(): SeriesHighlightingBehavior;
    private b7;
    get b8(): SeriesSelectionMode;
    private b3;
    get b4(): SeriesSelectionBehavior;
    get bw(): SeriesHighlightingBehavior;
    set bw(a: SeriesHighlightingBehavior);
    static readonly sl: DependencyProperty;
    get bd(): LegendHighlightingMode;
    set bd(a: LegendHighlightingMode);
    static readonly s5: DependencyProperty;
    get bf(): LegendItemBadgeShape;
    set bf(a: LegendItemBadgeShape);
    static readonly s7: DependencyProperty;
    get be(): LegendItemBadgeMode;
    set be(a: LegendItemBadgeMode);
    static readonly s6: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected qh(a: string, b: any, c: any): void;
    i7: any;
    o9(): void;
    pa(a: IEnumerable): void;
    pq(a: Series, b: any, c: any, d: Point): void;
    pu(a: Series, b: any, c: any, d: Point): void;
    pr(a: Series, b: any, c: any, d: Point): void;
    ps(a: Series, b: any, c: any, d: Point): void;
    pt(a: Series, b: any, c: any, d: Point): void;
    mz(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    get fo(): boolean;
    private d6;
    ok(a: boolean): void;
    oi(a: boolean): void;
    pv(a: Series, b: any, c: any, d: Point): void;
    pw(a: Series, b: any, c: any, d: Point): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    ql(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    qp(a: Series, b: any, c: MouseButtonEventArgs, d: Point): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    seriesClick: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    qq(a: Series, b: any, c: MouseButtonEventArgs, d: Point): void;
    qk(a: Series, b: any, c: MouseButtonEventArgs, d: Point): void;
    po(a: Series, b: any): void;
    private gp;
    private gq;
    private fb;
    private gm;
    private nq;
    private gn;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    rb(a: Point): void;
    rc(a: Point): void;
    qr(a: Series, b: any, c: MouseEventArgs, d: Point): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    qn(a: Series, b: any, c: MouseEventArgs, d: Point): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    qo(a: Series, b: any, c: MouseEventArgs, d: Point): void;
    private d0;
    oj(): void;
    private dz;
    oh(): void;
    private vw;
    protected get_wc(): Rect;
    get wc(): Rect;
    private vu;
    get v1(): Rect;
    set v1(a: Rect);
    protected get_ew(): boolean;
    get ew(): boolean;
    v6(a: Rect, b: Rect, c: Rect): Rect;
    private dx;
    private vt;
    protected get_v0(): Rect;
    get v0(): Rect;
    v4(a: Rect, b: Rect, c: Rect): Rect;
    protected vz(a: Rect): Rect;
    v5(): Rect;
    protected rg(a: Axis): void;
    wd: Rect;
    gf: boolean;
    eg: boolean;
    fy: boolean;
    i5: number;
    private iu;
    get iy(): number;
    set iy(a: number);
    i2: number;
    i4: number;
    i0: number;
    i3: number;
    protected fp: boolean;
    protected ei: boolean;
    qb(a: Rect, b: Rect): void;
    private cc;
    cd(): SeriesViewerComponentsForView;
    private d4;
    m8(a: Point, b: boolean): void;
    fd: boolean;
    private at;
    get av(): ChartHitTestMode;
    set av(a: ChartHitTestMode);
    qt(): void;
    protected aw(): ChartHitTestMode;
    private as;
    get au(): ChartHitTestMode;
    set au(a: ChartHitTestMode);
    fe: boolean;
    seriesAnimating: (series: Series) => void;
    private du;
    queueForAnimationIdle(a: () => void, b: number): void;
    getAnimationIdleVersionNumber(): number;
    isAnimationActive(): boolean;
    pp(a: Series): void;
    o2(): void;
    protected px(): void;
    qj(a: Series): void;
    abstract fk(): boolean;
    abstract fl(): boolean;
    fj(): boolean;
    private d3;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    get c0(): InteractionState;
    set c0(a: InteractionState);
    private d1;
    private cv;
    pc(a: Point): void;
    pd(a: Point, b: boolean): void;
    fw(a: Point, b: number): boolean;
    ov(a: Point): void;
    fv(a: Key): boolean;
    private d8;
    eq: boolean;
    private dy;
    get ek(): boolean;
    set ek(a: boolean);
    protected get_fa(): boolean;
    get fa(): boolean;
    ox(a: Point): void;
    get et(): boolean;
    l8: string;
    ph(a: Point): void;
    oy(a: Point, b: boolean): void;
    ow(a: Point): void;
    get fx(): boolean;
    set fx(a: boolean);
    private p6;
    pg(a: Point): void;
    p7(a: Point, b: number, c: number, d: number): void;
    pf(a: number): void;
    p3(a: Point, b: number, c: number, d: number): void;
    pb(a: Point): void;
    pe(a: number): void;
    o1(a: Point): void;
    p2(a: Point, b: number, c: number, d: number): void;
    pz(): void;
    o4(a: Size): void;
    nr(): void;
    oo(a: Point, b: boolean): void;
    cy(a: boolean): InteractionState;
    viewerManipulationStarting: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    viewerManipulationEnding: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    private ee;
    p5(a: boolean): void;
    p4(): void;
    rd(): void;
    ng(): void;
    nb(): void;
    na(): void;
    p9(): void;
    qx(): void;
    qv(): void;
    on(a: Point, b: boolean): void;
    f2(): boolean;
    private d9;
    get f7(): boolean;
    set f7(a: boolean);
    om(a: Point, b: boolean, c: boolean): void;
    rp(a: any, b: PropertyUpdatedEventArgs): void;
    ro(a: SyncLink, b: SyncLink): void;
    nc(a: Point): void;
    rs(a: Rect, b: boolean): void;
    rt(a: Rect, b: boolean, c: boolean): void;
    qa(a: Rect, b: boolean): void;
    get ff(): boolean;
    private _gj;
    gj(): IEnumerable$1<SeriesViewer>;
    vr(a: Point): Point;
    vp(a: Point): Point;
    wb(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private qs;
    p1(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    py(a: Size, b: Size): void;
    e0: boolean;
    fz(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private qe;
    ru(a: number): void;
    rv(a: number): void;
    q3(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private qf;
    protected get_fc(): boolean;
    get fc(): boolean;
    pk(a: Rect, b: Rect): void;
    cp: WindowResponse;
    n0(): void;
    es: boolean;
    iq: number;
    ip: number;
    private gx;
    get hj(): number;
    set hj(a: number);
    private gw;
    get hi(): number;
    set hi(a: number);
    is: number;
    ir: number;
    private _syncChannel;
    get syncChannel(): string;
    set syncChannel(a: string);
    private cm;
    get actualSyncLink(): SyncLink;
    set actualSyncLink(a: SyncLink);
    f8: boolean;
    ny(): void;
    wi: Visibility;
    private ed;
    ot(): void;
    or(): void;
    os(): void;
    get c2(): IOverviewPlusDetailPane;
    protected rl(a: boolean): void;
    wh: Visibility;
    ez: boolean;
    ge: boolean;
    va: Brush;
    vk: Brush;
    private cq;
    get cr(): ZoomCoercionMode;
    set cr(a: ZoomCoercionMode);
    cs(): ZoomCoercionMode;
    ct: ZoomCoercionMode;
    ve: Brush;
    uz: Brush;
    vd: Brush;
    ep(): boolean;
    eh(): boolean;
    we: Rect;
    m5(): void;
    private ix;
    private notifyCrosshairUpdate;
    rq(a: number, b: number): void;
    rr(a: number, b: number, c: number, d: number): void;
    hp(): number;
    hq(): number;
    private h3;
    private h2;
    protected qc(a: any, b: string, c: any, d: any): void;
    get e6(): boolean;
    protected get fu(): boolean;
    bq: Series;
    rk(a: Point): void;
    private my;
    rn(): void;
    protected oe(): void;
    rm(): void;
    private ec;
    protected f9: boolean;
    cw: InteractionState;
    cx: InteractionState;
    cz: InteractionState;
    uu: ModifierKeys;
    uv: ModifierKeys;
    uw: ModifierKeys;
    private vv;
    get v7(): Rect;
    set v7(a: Rect);
    bt: SeriesHighlightedValuesDisplayMode;
    private _selectedSeriesItems;
    get selectedSeriesItems(): ChartSelectedItemCollection;
    set selectedSeriesItems(a: ChartSelectedItemCollection);
    private _focusedSeriesItems;
    get focusedSeriesItems(): ChartSelectedItemCollection;
    set focusedSeriesItems(a: ChartSelectedItemCollection);
    selectedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    pm(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    focusedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    oz(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    gr: Date;
    gh: boolean;
    protected rf(): void;
    m0(a: Rect, b: Rect): void;
    f0(): boolean;
    protected of(a: Rect, b: Rect): void;
    im: number;
    io: number;
    private wa;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    qi(): void;
    protected abstract c8(): SeriesViewerView;
    protected p0(a: SeriesViewerView): void;
    vh: Brush;
    u0: Brush;
    static v9: Rect;
    rw: DataTemplate;
    r5: DataTemplate;
    r2: DataTemplate;
    r3: DataTemplate;
    rx: DataTemplate;
    r0: DataTemplate;
    ry: DataTemplate;
    r4: DataTemplate;
    r1: DataTemplate;
    rz: DataTemplate;
    ly: string;
    ut: HorizontalAlignment;
    us: HorizontalAlignment;
    private jc;
    get l5(): string;
    set l5(a: string);
    private jb;
    get lt(): string;
    set lt(a: string);
    private uy;
    get vj(): Brush;
    set vj(a: Brush);
    private ux;
    get vi(): Brush;
    set vi(a: Brush);
    private hc;
    get ic(): number;
    set ic(a: number);
    private ha;
    get ia(): number;
    set ia(a: number);
    private hb;
    get ib(): number;
    set ib(a: number);
    private g9;
    get h9(): number;
    set h9(a: number);
    private g8;
    get h8(): number;
    set h8(a: number);
    private g6;
    get h6(): number;
    set h6(a: number);
    private g7;
    get h7(): number;
    set h7(a: number);
    private g5;
    get h5(): number;
    set h5(a: number);
    lm: string;
    wf(): Thickness;
    wg(): Thickness;
    ap(a: Axis): AxisTitlePosition;
    aq(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    protected get_ft(): boolean;
    get ft(): boolean;
    oq(): void;
    abstract getFontBrush(): Brush;
    abstract u1(): Brush;
    i9: any;
    provideContainer(a: any): void;
    op(a: number, b: number): void;
    notifyContainerResized(): void;
    v2(): Rect;
    nh(): void;
    vq(): Point;
    df(): FontInfo;
    de(): FontInfo;
    u4(): Brush;
    u5(): Brush;
    m3(a: Series): void;
    qz(a: Series): void;
    al: CanvasRenderScheduler;
    am: CanvasRenderScheduler;
    ak: CanvasRenderScheduler;
    private d7;
    get fq(): boolean;
    set fq(a: boolean);
    private dw;
    get ef(): boolean;
    set ef(a: boolean);
    private _syncSettings;
    get syncSettings(): SyncSettings;
    set syncSettings(a: SyncSettings);
    m2(a: any): void;
    q1(a: any): void;
    ob(source_: any, a: number, b: any, c: any): void;
    n2(source_: any): void;
    n9(source_: any, a: number, b: any): void;
    oa(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected i6: any;
    protected gi: Dictionary$2<string, any>;
    fn: boolean;
    destroy(): void;
    protected nf(): void;
    ra(source_: any): void;
    q2(): void;
    q9(a: string, source_: any): void;
    q0(a: string, b: boolean): void;
    protected q8(a: Series, b: any): void;
    protected ri(a: any): void;
    protected rj(): void;
    private hd;
    get id(): number;
    set id(a: number);
    private g2;
    get hz(): number;
    set hz(a: number);
    private g4;
    get h4(): number;
    set h4(a: number);
    private g0;
    get hm(): number;
    set hm(a: number);
    private gz;
    get hl(): number;
    set hl(a: number);
    private gy;
    get hk(): number;
    set hk(a: number);
    f1(): boolean;
    private d2;
    get e2(): boolean;
    set e2(a: boolean);
    private g3;
    get h0(): number;
    set h0(a: number);
    private g1;
    get hy(): number;
    set hy(a: number);
    static cu(a: string, b: any): CoercionInfo;
    private ja;
    get ky(): string;
    set ky(a: string);
    private gt;
    get hf(): number;
    set hf(a: number);
    private gs;
    get he(): number;
    set he(a: number);
    f3: boolean;
    private vs;
    get vx(): Rect;
    set vx(a: Rect);
    v3(): Rect;
    ey: boolean;
    private nw;
    v8(): Rect;
    protected vy(): Rect;
    i8(a: number, b: number): any;
    private gu;
    get hg(): number;
    set hg(a: number);
    private gv;
    get hh(): number;
    set hh(a: number);
    od(): void;
    oc(): void;
    flush(): void;
    nm(a: boolean, b: boolean, c: boolean): void;
    gd(): boolean;
    private r6;
    private az;
    protected qw(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected re(a: DependencyObject): void;
    nd(): void;
    e3: boolean;
    e4: boolean;
    e1: boolean;
    o3(): void;
    private d5;
    get fg(): boolean;
    m4(): void;
    fm(): boolean;
    private iw;
    i1(): number;
    di(): FontInfo;
    dh(): FontInfo;
    rh(): void;
    protected eo: boolean;
    vg: Brush;
    vf: Brush;
    h1: number;
    e7: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    qm(): void;
    n6(): void;
    n7(): void;
    private n8;
    n5(a: Point): void;
    private gl;
    attachDataLegend(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    get isDetached(): boolean;
    dv: () => void;
    getDataLegendSeries(): IDataLegendSeries[];
    m1(a: Rect): void;
    protected go: List$1<CaptureImageSettings>;
    m6(a: CaptureImageSettings): void;
    private m7;
    protected jp(a: CaptureImageSettings, b: (arg1: string, arg2: any) => void): string;
    imageCaptured: (sender: any, args: ImageCapturedEventArgs) => void;
    protected qg(a: CaptureImageSettings, b: string, c?: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    l(): IExecutionContext;
    co(): void;
    p: SeriesViewer;
    c4(): void;
    e(): Series;
    private cn;
    a: CanvasRenderScheduler;
    n: IOverviewPlusDetailPane;
    private dn;
    private dm;
    em(): void;
    private ct;
    private cs;
    o: OverviewPlusDetailViewportHost;
    cb(a: number, b: number, c: RenderSurface): void;
    d5(): void;
    cd(): void;
    d7(): void;
    ck(): void;
    cc(): void;
    ce(): void;
    dy(a: Series): void;
    dc(): void;
    private er;
    aq(a: Series): boolean;
    protected g: SeriesCollection;
    protected b: AxisCollection;
    private ai;
    get au(): boolean;
    set au(a: boolean);
    bp(a: Series): void;
    dt(a: RenderingContext): void;
    bx(): void;
    bt(): void;
    cf(): void;
    ca(): void;
    dr(): void;
    protected fi: Rectangle;
    protected ff: Path;
    d8(): void;
    eg(a: Rect): void;
    bw(): void;
    df(): void;
    eo(a: number, b: number, c: number, d: number): void;
    protected fe: Line;
    protected fd: Line;
    ed(): void;
    cl(): void;
    eh(a: number, b: number, c: number, d: number): void;
    d9(): void;
    cg(): void;
    cj(): void;
    private e6;
    private e7;
    en(a: Rect, b: Rect): void;
    ec(): void;
    ep(a: Rect): void;
    dw(a: Axis): void;
    dx(a: Axis): void;
    bo(a: Axis): void;
    bl(a: Axis): void;
    private h;
    i(): SeriesViewerComponentsFromView;
    static aw(a: Series): List$1<Series>;
    d2(): void;
    j: SeriesViewerViewManager;
    protected w: RenderingContext;
    z: RenderingContext;
    y: RenderingContext;
    x: RenderingContext;
    an: boolean;
    ao: boolean;
    bi: any;
    c0(a: any): void;
    private al;
    protected cy(a: Point, b: boolean): void;
    protected cz(a: Point, b: boolean): void;
    protected c3(a: Point): void;
    protected cx(a: Point, b: boolean, c: boolean): void;
    du(a: RenderingContext): void;
    protected get_ap(): boolean;
    get ap(): boolean;
    k: EventProxy;
    ef(): void;
    a9: number;
    f(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bd(): number;
    bc(): number;
    a8: number;
    a7: number;
    private e9;
    private aj;
    cu(): void;
    c1(a: number, b: number): void;
    private fg;
    private fh;
    b6(a: Rectangle): void;
    b9(a: Rectangle): void;
    b8(): void;
    d3(): void;
    private a1;
    private az;
    private a0;
    private ay;
    private ak;
    private aa;
    private b2;
    private ek;
    v(): FontInfo;
    u(): FontInfo;
    private e5;
    private e4;
    private bf;
    private a2;
    private be;
    fm(): Thickness;
    fl(): Thickness;
    protected dv(a: Rect): void;
    cq(): void;
    private fa;
    protected d0(): void;
    isValid(): boolean;
    preRender(): void;
    protected ds(): void;
    protected ab: boolean;
    protected d1(): void;
    c2(): void;
    cw(): void;
    fb(): Rect;
    e8(): Point;
    private d6;
    ee(): void;
    dp(): void;
    protected as(a: Point): boolean;
    c8(a: Point, b: boolean, c: boolean): void;
    protected c7(a: Point): void;
    protected c6(a: Point): void;
    protected c9(a: Point): void;
    d4(): void;
    get ez(): ModifierKeys;
    eq(a: Rect): void;
    cr(a: boolean): void;
    bk(a: boolean): void;
    protected el(): void;
    private af;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    undirty(a: boolean): void;
    get index(): number;
    postRender(): void;
    b7(): void;
    protected ae: boolean;
    ch(): void;
    ea(): void;
    bv(a: boolean): void;
    bm(a: any): void;
    ei(a: number): void;
    ej(a: number): void;
    bn(a: any): void;
    dz(a: any): void;
    da(a: Brush): void;
    bu(a: Point): void;
    av: boolean;
    m(a: boolean): InteractionState;
    c5(): void;
    private et;
    private es;
    bb(a: TextBlock, b: FontInfo): number;
    ba(a: string, b: FontInfo): number;
    dj(): void;
    private eu;
    di(): void;
    de(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    dk(): void;
    dl(): void;
    t(): FontInfo;
    e3(): Brush;
    q(): FontInfo;
    e0(): Brush;
    s(): FontInfo;
    r(): FontInfo;
    e2(): Brush;
    e1(): Brush;
    get a4(): number;
    get a5(): number;
    get a6(): number;
    get a3(): number;
    get ew(): TextBlock;
    get ev(): TextBlock;
    fc(): Rect;
    fk(): Thickness;
    fj(): Thickness;
    private ad;
    private ac;
    dd(a: any, b: any): void;
    dh(a: any, b: any): void;
    ey(): HorizontalAlignment;
    ex(): HorizontalAlignment;
    private ag;
    bq(): void;
    am(): boolean;
    b5(): void;
    cp(): void;
    at(a: Point): boolean;
    dq(): void;
    private ax;
    b3(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bh(a: Rect, b: ITileZoomTile, c: number): any;
    b0(): void;
    b1(a: ITileZoomTile): void;
    cm(): void;
    ar: boolean;
    private bg;
    by(): void;
    br(): void;
    bz(a: number): void;
    bs(): void;
    private ah;
    ci(): void;
    eb(): void;
    dg(): void;
    cv(): void;
    db(): void;
    b4(a: any): void;
    bj(a: number, b: number, c: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
    getMainContentViewport(): Rect;
}
/**
 * @hidden
 */
export declare class LegendTemplates extends Base {
    static $t: Type;
    private static readonly z;
    private static readonly ae;
    private static readonly ad;
    private static readonly ah;
    private static readonly ab;
    private static readonly y;
    private static readonly aa;
    private static readonly ac;
    static af(a: Series): DataTemplate;
    static a(a: DataTemplateRenderInfo): RenderingContext;
    static v(a: DataContext): void;
    private static b;
    private static c;
    static u(a: DataTemplateRenderInfo, b: number, c: Brush, d: Brush, e: number, f: number, g: number, h: number): void;
    static s(a: DataTemplateRenderInfo): void;
    static r(a: DataTemplateRenderInfo, b: number, c: number): void;
    static t(a: DataTemplateRenderInfo, b?: number): void;
    static j(a: DataTemplateRenderInfo): void;
    static n(a: DataTemplateRenderInfo): void;
    static o(a: DataTemplateRenderInfo): void;
    static q(a: DataTemplateRenderInfo): void;
    static p(a: DataTemplateRenderInfo): void;
    static i(a: DataTemplateRenderInfo): void;
    static l(a: DataTemplateRenderInfo): void;
    static m(a: DataTemplateRenderInfo): void;
    static k(a: DataTemplateRenderInfo): void;
    static g(a: DataTemplateRenderInfo): void;
    private static readonly w;
    private static readonly x;
    static resolveLegendItemTemplate(a: StandardLegendItems): DataTemplate;
    static e(a: DataTemplateRenderInfo): void;
    static f(a: DataTemplateMeasureInfo): void;
    static d(a: DataTemplateMeasureInfo): void;
    static h(a: DataTemplateMeasureInfo): void;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bj(): void;
    bg(a: any): void;
    static by(a: DomRenderer, b: () => void): void;
    private bi;
    ba(): void;
    g(): IOverviewPlusDetailPane;
    bm(): void;
    bn(): void;
    b3(): Brush;
    private ab;
    private aa;
    private ac;
    az(a: number, b: number, c: number): void;
    b8(): Point;
    y(): boolean;
    bc(a: boolean): void;
    a8(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a7(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ay(): void;
    bu(x_: number): void;
    private ad;
    bv(y_: number): void;
    au(a: any): void;
    a9(): void;
    bo(): void;
    av(a: any): void;
    bk(a: any): void;
    bd(): void;
    private l;
    p(): FontInfo;
    private ca;
    ce(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b9;
    cd(): Thickness;
    private b0;
    b5(): Brush;
    private bz;
    b4(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b2;
    b7(): Brush;
    private m;
    q(): FontInfo;
    private b1;
    b6(): Brush;
    private cb;
    cf(): Thickness;
    private cc;
    cg(): Thickness;
    bp(): void;
    private bx;
    private br;
    private bq;
    private bs;
    private bt;
    a6(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    bb(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a3(a: ITileZoomTile): void;
    a2(): void;
    bl(a: List$1<ITileZoomTile>): void;
    private al;
    a0(): void;
    aw(): void;
    private am;
    a1(a: number): void;
    ax(): void;
    private s;
    be(): void;
    bw(a: boolean): void;
    a4(): void;
    a5(): void;
    bh(): void;
    bf(): void;
    ao(a: number, b: number, c: number): any;
    at(a: number, b: number, c: number, d: string, e?: (arg1: string, arg2: any) => void): string;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private ab;
    get textStyle(): string;
    set textStyle(a: string);
    private ay;
    get textColor(): Brush;
    set textColor(a: Brush);
    get location(): AxisLabelsLocation;
    set location(a: AxisLabelsLocation);
    private b;
    get visibility(): Visibility;
    set visibility(a: Visibility);
    private a3;
    get showFirstLabel(): boolean;
    set showFirstLabel(a: boolean);
    private i;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    get angle(): number;
    set angle(a: number);
    private n;
    get extent(): number;
    set extent(a: number);
    private p;
    set margin(a: number);
    get leftMargin(): number;
    set leftMargin(a: number);
    private q;
    get rightMargin(): number;
    set rightMargin(a: number);
    private r;
    get topMargin(): number;
    set topMargin(a: number);
    private s;
    get bottomMargin(): number;
    set bottomMargin(a: number);
    private o;
    private av;
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(a: HorizontalAlignment);
    private a0;
    get verticalAlignment(): VerticalAlignment;
    set verticalAlignment(a: VerticalAlignment);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    as(a: string, b: any, c: any): void;
    protected ar(a: any, b: string, c: any, d: any): void;
    k(): boolean;
    l(): boolean;
    static readonly extentPropertyDefault: number;
    get j(): boolean;
    private f;
    get g(): FontInfo;
    set g(a: FontInfo);
    h(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private a5;
    get position(): AxisTitlePosition;
    set position(a: AxisTitlePosition);
    protected ar(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a4(): AxisView;
    a5: AxisView;
    ht(a: AxisView): void;
    abstract ag(): number[];
    hg(): void;
    private bt;
    get bu(): SRProvider;
    private a9;
    get ba(): IAxisVisualDataManager;
    ej(): number;
    f3(): any;
    f2(): any;
    protected get_cb(): boolean;
    get cb(): boolean;
    protected get_cj(): boolean;
    get cj(): boolean;
    protected get_b9(): boolean;
    get b9(): boolean;
    protected get_cm(): boolean;
    get cm(): boolean;
    protected get_cp(): boolean;
    get cp(): boolean;
    protected get_cn(): boolean;
    get cn(): boolean;
    d4(a: Point): number;
    protected get_ce(): boolean;
    get ce(): boolean;
    protected get_ck(): boolean;
    get ck(): boolean;
    protected get_cl(): boolean;
    get cl(): boolean;
    protected get_cc(): boolean;
    get cc(): boolean;
    protected get_cd(): boolean;
    get cd(): boolean;
    ak(): Axis;
    constructor();
    private a7;
    get a8(): IAxisAnnotationManager;
    get ca(): boolean;
    private he;
    private hf;
    private hc;
    private hd;
    provideRenderer(a: DomRenderer): void;
    au: (item: any) => string;
    hq(a: Rect, b: Rect): void;
    abstract av(): AxisLabelPanelBase;
    ac(): void;
    is: Canvas;
    get bo(): IFastItemsSourceProvider;
    set bo(a: IFastItemsSourceProvider);
    private bn;
    get bi(): SeriesViewer;
    set bi(a: SeriesViewer);
    private bh;
    get bg(): XamDataChart;
    set bg(a: XamDataChart);
    readonly bs: (sender: any, e: RectChangedEventArgs) => void;
    private by;
    get c6(): boolean;
    set c6(a: boolean);
    private dl;
    get e7(): number;
    set e7(a: number);
    private df;
    get dx(): number;
    set dx(a: number);
    private ds;
    get fd(): number;
    set fd(a: number);
    private dp;
    get fa(): number;
    set fa(a: number);
    private as;
    get at(): AxisExtentType;
    set at(a: AxisExtentType);
    private dk;
    get e6(): number;
    set e6(a: number);
    dw: number;
    private dr;
    get fc(): number;
    set fc(a: number);
    private dn;
    get e9(): number;
    set e9(a: number);
    private bk;
    private bj;
    get bm(): FontInfo;
    set bm(a: FontInfo);
    private f4;
    get gy(): string;
    set gy(a: string);
    private dm;
    get e8(): number;
    set e8(a: number);
    dy: number;
    private dt;
    get fe(): number;
    set fe(a: number);
    private dq;
    get fb(): number;
    set fb(a: number);
    private fp;
    get fu(): number;
    set fu(a: number);
    private fo;
    get ft(): number;
    set ft(a: number);
    private fn;
    get fs(): number;
    set fs(a: number);
    fq: number;
    private kl;
    get ko(): VerticalAlignment;
    set ko(a: VerticalAlignment);
    private dv;
    get fg(): number;
    set fg(a: number);
    private du;
    get ff(): number;
    set ff(a: number);
    ii(): void;
    private h6;
    private h7;
    it: TextBlock;
    g7: string;
    j0: Brush;
    jw: Brush;
    fh: number;
    j4: DoubleCollection;
    jz: Brush;
    jx: Brush;
    ju: Brush;
    es: number;
    j2: DoubleCollection;
    jy: Brush;
    jv: Brush;
    ev: number;
    j3: DoubleCollection;
    j1: Brush;
    fj: number;
    j5: DoubleCollection;
    fi: number;
    dz: number;
    private il;
    cf: boolean;
    ch: boolean;
    ci: boolean;
    cu: boolean;
    private bw;
    private dg;
    get b4(): boolean;
    get b7(): boolean;
    ih(a: number): void;
    ib(): void;
    eg(): number;
    ex(): number;
    cv: boolean;
    cw: boolean;
    cx: boolean;
    bz: boolean;
    c5: boolean;
    get c4(): boolean;
    set c4(a: boolean);
    static readonly jq: DependencyProperty;
    fr: number;
    b1: boolean;
    az: AxisLabelSettings;
    d6(): number;
    js(): HorizontalAlignment;
    km(): VerticalAlignment;
    jt(): HorizontalAlignment;
    kn(): VerticalAlignment;
    d8(): number;
    ea(): number;
    d9(): number;
    d7(): number;
    ed(): number;
    ef(): number;
    ee(): number;
    ec(): number;
    a0(): AxisLabelsLocation;
    a1(): AxisLabelsLocation;
    aj: Axis;
    fw: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected h4(a: AxisRangeChangedEventArgs): void;
    bf: TitleSettings;
    eb(): number;
    d5(): number;
    get an(): AxisAnnotationCollection;
    private al;
    get ao(): AxisAnnotationCollection;
    private am;
    private j7;
    get kf(): Rect;
    set kf(a: Rect);
    ke: Rect;
    im(): void;
    c8(a: Rect, b: Rect, c: AxisView): boolean;
    co(): boolean;
    dc: List$1<any>;
    dd: List$1<LabelPosition>;
    aw: AxisLabelPanelBase;
    protected iq(a: Rect, b: Rect): void;
    private bx;
    get cq(): boolean;
    set cq(a: boolean);
    protected kc(): Rect;
    j8: Rect;
    protected ir(a: Rect, b: Rect): void;
    h5(): void;
    a6: ContentInfo;
    fm: DomRenderer;
    ai: BindingFormatter;
    protected hx(a: any, b: string, c: any, d: any): void;
    hv(): void;
    hw(): void;
    private _coercionMethods;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private bv;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    cy: boolean;
    private id;
    c7: boolean;
    protected hs(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected hr(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected ip(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected io(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private cg;
    protected ig(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    d0(a: number, b: number, c: number, d: PathRenderingInfo): number;
    hj(a: GeometryCollection): void;
    protected hi(): void;
    h8(): void;
    h9(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    bc: LabelFontHeuristics;
    static eu: number;
    e0(): number;
    e4(): number;
    e2(): number;
    e3(): number;
    e1(): number;
    ey(): number;
    d2(a: number, b: boolean, c: Rect, d: Rect, e: Rect): number;
    private er;
    private ei;
    cz(a: number, b: number, c: Rect, d: Rect, e: Rect): boolean;
    protected eh(a: number, b: Rect, c: Rect, d: Rect): number;
    ez(): number;
    protected get c0(): boolean;
    cr: boolean;
    hl(a: boolean): void;
    private di;
    private b2;
    ic(): void;
    protected b6(): boolean;
    d1(a: number, b: ScalerParams): number;
    protected ie(): void;
    private dj;
    bb(): LabelFontHeuristics;
    bl(): FontInfo;
    private hm;
    cs: boolean;
    c1(): boolean;
    c2(a: boolean): boolean;
    c3(): boolean;
    protected ia(a: boolean): void;
    ik(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected h3(a: string, b: any, c: any): void;
    de: List$1<Series>;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    f1: any;
    gh: string;
    ah: any[];
    fy(a: any, b: string): any;
    private da;
    protected gt(a: string): string;
    private c9;
    protected fz(a: any, b: string, c: string): any;
    f0(a: any): any;
    ge(a: number): string;
    ew(): number;
    ek(a: number, b: ScalerParams): number;
    el(a: number, b: ScalerParams, c: CategoryMode): number;
    kb(a: Rect): Rect;
    ka(): Rect;
    j9(): Rect;
    protected kd(a: Rect, b: Rect): Rect;
    em(a: number, b: Rect, c: Rect): number;
    ho(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    hn(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    en(a: number, b: ScalerParams): number;
    eo(a: number, b: ScalerParams, c: CategoryMode): number;
    ep(a: number, b: Rect, c: Rect): number;
    hp(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    e5(a: number): number;
    abstract get a2(): AxisOrientation;
    kk: Size;
    hu(a: Size): void;
    ij(): void;
    ap: AxisComponentsForView;
    aq(): AxisComponentsForView;
    d3: number;
    private dh;
    get et(): number;
    set et(a: number);
    b8(): boolean;
    eq(): number;
    protected hh(): void;
    hk(a: AxisRangeChangedEventArgs): void;
    br: Pool$1<TextBlock>;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<Rectangle>;
    get kg(): Path;
    get kh(): Path;
    get kj(): Path;
    get ki(): Path;
    be(): SyncSettings;
    ar(): AxisComponentsFromView;
    private ax;
    get ay(): AxisLabelSettings;
    hy(a: RenderingContext, b: RenderingContext): void;
    b5(): boolean;
    fx(): any;
    private _db;
    db(): IEnumerable$1<Series>;
    hz(a: string): void;
    h2(a: any): void;
    h1(a: any): void;
    fl: CultureInfo;
    j6(a: number, b: Rect, c: Rect, d: Rect, e: Rect): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    n(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    t(): void;
    static j(a: FrameworkElement, b: AxisLabelSettings): void;
    private static k;
    private static l;
    static m(a: FrameworkElement, b: TitleSettings): void;
    h(a: FrameworkElement): void;
    r(a: number): void;
    o(a: number): void;
    u(a: number): FrameworkElement;
    s(a: number): void;
    get d(): boolean;
    q(): void;
    p(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    af: AxisLabelPanelBaseView;
    cx: Rect;
    b8(): void;
    cp(): void;
    co(): void;
    constructor();
    bw: number;
    ad: Axis;
    private ak;
    get az(): boolean;
    set az(a: boolean);
    private a3;
    get a9(): List$1<any>;
    set a9(a: List$1<any>);
    ba: List$1<LabelPosition>;
    c4: Rect;
    private cw;
    get c5(): Rect;
    set c5(a: Rect);
    private cv;
    get c1(): Rect;
    set c1(a: Rect);
    c2: Rect;
    private bc;
    get bg(): number;
    set bg(a: number);
    bx: () => boolean;
    bb: List$1<FrameworkElement>;
    a8: List$1<Rect>;
    ag: AxisLabelSettings;
    bn(): number;
    ao: boolean;
    c3: Rect;
    cl(): void;
    ar: boolean;
    av: boolean;
    aw: boolean;
    ax: boolean;
    bz: any;
    al: boolean;
    protected an(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    a5(): List$1<Rect>;
    b6(): void;
    b2(a: Size): void;
    get ap(): boolean;
    bl(): number;
    bq(): number;
    at(a: number, b: Rect): boolean;
    bk(a: any): number;
    bv(a: any): number;
    bm(a: any): number;
    bj(a: any): number;
    aq(): boolean;
    protected ct(a: Rect, b: Rect): void;
    protected cd(a: Rect, b: Rect): void;
    a7(): List$1<Rect>;
    a6(a: List$1<Rect>): List$1<Rect>;
    protected cy(a: number, b: Rect, c: Thickness): Rect;
    protected as(a: List$1<Rect>, b: List$1<number>, c: Thickness): boolean;
    protected a4(a: List$1<Rect>): List$1<number>;
    bp(a: number, b: Size): number;
    bo(a: number, b: Size): number;
    bt(): number;
    br(): number;
    bs(): number;
    bu(): number;
    c6(a: Size): Size;
    protected get am(): boolean;
    c0(): Rect;
    protected b5(a: Size): void;
    protected b4(a: Size): void;
    protected b9(): void;
    protected a2(): IEnumerable$1<number>;
    get ah(): AxisLabelsLocation;
    cs(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cc(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cm(a: FrameworkElement, b: number): void;
    protected get_au(): boolean;
    get au(): boolean;
    ac(a: Rect, b: number): Point[];
    cz(a: Rect, b: number): Rect;
    cn(a: FrameworkElement): void;
    cb(a: FrameworkElement, b: number): void;
    c8(a: Size): Size;
    static readonly cu: DependencyProperty;
    get bh(): number;
    set bh(a: number);
    bd: number;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    private _a0;
    a0(): IEnumerable$1<any>;
    b1(a: number, b: TextBlock, c: number, d: number, e: number): string;
    b7(a: any): void;
    cg(a: FrameworkElement): void;
    private _a1;
    a1(): IEnumerable$1<any>;
    protected be: number;
    protected bf: number;
    ca(): void;
    cr(): void;
    ce(): void;
    bi(a: Rect): number;
    c7: Size;
    ci(): void;
    cq(): void;
    cf(): void;
    cj(a: RenderingContext): void;
    b3(): void;
    ck(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a4(): AxisView;
    ag(): number[];
    protected get_cd(): boolean;
    ht(a: AxisView): void;
    kp: CategoryAxisBaseView;
    protected eh(a: number, b: Rect, c: Rect, d: Rect): number;
    constructor();
    c8(a: Rect, b: Rect, c: AxisView): boolean;
    l4(): void;
    l3(): void;
    k0: List$1<number>;
    protected get_cb(): boolean;
    mh(a: Point, b: boolean, c: number): Rect;
    mi(a: Point, b: boolean, c: number, d: boolean): Rect;
    kt: IFastItemsSource;
    private ks;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly mc: DependencyProperty;
    private lf;
    lh: number;
    get li(): number;
    set li(a: number);
    get categoryMode(): CategoryMode;
    set categoryMode(a: CategoryMode);
    private kq;
    k3: number;
    protected ld(a: Rect, b: Rect, c: Rect): number;
    la: number;
    k2: number;
    lb: number;
    lc: number;
    kx: boolean;
    get lj(): number;
    set lj(a: number);
    private lg;
    en(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    k6(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    le(a: number): number;
    private _kz;
    private kz;
    private kv;
    kw(a: SeriesViewer): boolean;
    private _ky;
    private ky;
    private ku;
    l8(a: boolean): void;
    protected lk(): number;
    protected hx(a: any, b: string, c: any, d: any): void;
    protected lw(): void;
    ly(a: any, b: FastItemsSourceEventArgs): void;
    protected l5(a: FastItemsSourceEventArgs): void;
    private l9;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    private l6;
    lv(): void;
    l7(): void;
    lx(a: NotifyCollectionChangedEventArgs): void;
    l2(a: number, b: any, c: any): void;
    lz(): void;
    l0(a: number, b: any): void;
    l1(a: number, b: any): void;
    k7(a: Rect, b: Rect, c: Rect, d: number): number;
    k8(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: HorizontalAxisLabelPanelBaseView;
    dl: number;
    di: number;
    dk: number;
    dj: number;
    b6(): void;
    db(): boolean;
    dc(): boolean;
    aq(): boolean;
    a5(): List$1<Rect>;
    dn(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private dm;
    private dp;
    protected dq(a: List$1<Rect>, b: List$1<boolean>): void;
    protected dr(): void;
    protected get_au(): boolean;
    cm(a: FrameworkElement, b: number): void;
    protected dd(): boolean;
    protected da(): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    c0(): Rect;
    dh(): number;
    de(): number;
    dg(): number;
    df(): number;
    protected b9(): void;
    a6(a: List$1<Rect>): List$1<Rect>;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a4(): AxisView;
    ag(): number[];
    ht(a: AxisView): void;
    d1(a: number, b: ScalerParams): number;
    kz: NumericAxisBaseView;
    protected get_cj(): boolean;
    constructor();
    get kw(): AxisRangeBufferMode;
    set kw(a: AxisRangeBufferMode);
    private ku;
    get kx(): AxisRangeBufferMode;
    set kx(a: AxisRangeBufferMode);
    static readonly nv: DependencyProperty;
    ma: number;
    get l2(): number;
    set l2(a: number);
    private lu;
    l8: number;
    f3(): any;
    get l5(): number;
    set l5(a: number);
    private lx;
    l9: number;
    get l1(): number;
    set l1(a: number);
    private lt;
    f2(): any;
    l7: number;
    private lw;
    get l4(): number;
    set l4(a: number);
    l6: number;
    private ls;
    get l0(): number;
    set l0(a: number);
    ew(): number;
    private mf;
    get mi(): number;
    set mi(a: number);
    private me;
    get mh(): number;
    set mh(a: number);
    private mg;
    get mj(): number;
    set mj(a: number);
    mm: number;
    private lc;
    get lg(): boolean;
    set lg(a: boolean);
    lq: boolean;
    mb: number;
    private lv;
    get l3(): number;
    set l3(a: number);
    mc: number;
    lm: boolean;
    private la;
    get le(): boolean;
    set le(a: boolean);
    lh: boolean;
    private lb;
    get lf(): boolean;
    set lf(a: boolean);
    get ln(): boolean;
    mk: number;
    ml: number;
    k2: NumericAxisRenderer;
    protected lo: boolean;
    protected lp: boolean;
    protected ia(a: boolean): void;
    protected ir(a: Rect, b: Rect): void;
    h2(a: any): void;
    h1(a: any): void;
    kq: BindingFormatter;
    protected hx(a: any, b: string, c: any, d: any): void;
    protected nh(): void;
    ks: AxisRange;
    kt(): AxisRange;
    lz: number;
    ly: number;
    private lr;
    private ky;
    ne(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    private kv;
    c3(): boolean;
    private nf;
    ni(a: AxisRangeChangedEventArgs): void;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    k1(a: AxisLabelManager): NumericAxisRenderer;
    k0(): NumericAxisRenderer;
    kr: (item: any) => string;
    mo: string;
    kp: any[];
    ll: boolean;
    k4(): NumericAxisRenderingParameters;
    ng(): void;
    k5(): NumericScaler;
    mn(): number;
    k3(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    md(a: number): number;
    li(): boolean;
    get lk(): boolean;
    get lj(): boolean;
    private nj;
    static readonly ny: DependencyProperty;
    get k8(): TickmarkValues;
    set k8(a: TickmarkValues);
    private k6;
    get k7(): TickmarkValues;
    set k7(a: TickmarkValues);
    private k9;
    get ld(): boolean;
    set ld(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any, fromAbbreviator: boolean) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: VerticalAxisLabelPanelView;
    di: number;
    df: number;
    dh: number;
    dg: number;
    b6(): void;
    bq(): number;
    db(): number;
    dd(): number;
    de(): number;
    dc(): number;
    a5(): List$1<Rect>;
    private dj;
    private dk;
    cm(a: FrameworkElement, b: number): void;
    protected da(): boolean;
    c0(): Rect;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    protected b9(): void;
}
/**
 * @hidden
 */
export declare class ViewportUtils extends Base {
    static $t: Type;
    static e(a: number, b: Rect, c: Rect, d: Rect): number;
    static b(a: number, b: Rect, c: Rect, d: Rect): number;
    static i(a: number, b: Rect, c: Rect, d: Rect): number;
    static g(a: number, b: Rect, c: Rect, d: Rect): number;
    static d(a: number, b: Rect, c: Rect, d: Rect): number;
    static a(a: number, b: Rect, c: Rect, d: Rect): number;
    static h(a: number, b: Rect, c: Rect, d: Rect): number;
    static f(a: number, b: Rect, c: Rect): number;
    static c(a: number, b: Rect, c: Rect): number;
    static j(a: number, b: Rect, c: Rect): number;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export declare class AutomaticSeriesManager extends Base {
    static $t: Type;
    private g;
    private c;
    e(a: AutomaticSeriesPurpose): boolean;
    constructor(a: SeriesViewer);
    private i;
    private n;
    private m;
    protected f: boolean;
    private j;
    private k;
    l(a: AutomaticSeriesPurpose): void;
    private h;
    private d;
    private a;
    get b(): AutomaticSeriesRequestCollection;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequest extends Base {
    static $t: Type;
    a: AutomaticSeriesPurpose;
    d: Series;
    b: Series;
    c: Series;
    e: boolean;
    f: boolean;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequestCollection extends ObservableCollection$1<AutomaticSeriesRequest> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ChartSelection extends Base {
    static $t: Type;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private b;
    get c(): SeriesMatcher;
    set c(a: SeriesMatcher);
    equals(a: any): boolean;
    getHashCode(): number;
    g(a: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare class ChartSelectedItemCollection extends ObservableCollection$1<ChartSelection> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesMatcherHelper extends Base {
    static $t: Type;
    static a(a: SeriesViewer, b: SeriesMatcher): Series[];
    private static b;
}
/**
 * @hidden
 */
export declare class SeriesLayer extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    private _source;
    get source(): Series;
    set source(a: Series);
    private _target;
    get target(): Series;
    set target(a: Series);
    private z;
    constructor();
    private ak;
    au(): void;
    at(): void;
    get t(): boolean;
    private a3;
    private a4;
    private a5;
    private a2;
    private ah;
    private an;
    private ag;
    private ao;
    n: IExecutionContext;
    private u;
    private ar;
    private as;
    private y;
    az(a: Series, b: DependencyProperty): void;
    a0(a: Series, b: DependencyProperty): void;
    private r;
    private af;
    private al;
    private p;
    private aa;
    private ab;
    private v;
    private w;
    private x;
    private av;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private ax;
    protected q: boolean;
    am(a: Series, b: Series): void;
    private ay;
    private a1;
    ap(a: Series): void;
    private aq;
    private aw;
    ai(a: Series, b: Series, c: DependencyProperty, d: any): any;
    private s;
    private ad;
    private ae;
    ac: number;
    get m(): SeriesLayerPropertyOverlayCollection;
    private l;
    private o;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SeriesLayerCollection extends ObservableCollection$1<SeriesLayer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesLayerManager extends Base {
    static $t: Type;
    a: Series;
    private b;
    private i;
    private n;
    private m;
    h(a: Series, b: SeriesLayerCollection, c: NotifyCollectionChangedEventArgs): void;
    j(a: Series, b: SeriesLayerCollection, c: EventArgs): void;
    e(a: Series, b: SeriesLayerCollection, c: NotifyCollectionChangedEventArgs): void;
    f(a: Series, b: SeriesLayerCollection, c: EventArgs): void;
    c(a: Series, b: SeriesLayerCollection, c: NotifyCollectionChangedEventArgs): void;
    private g;
    private l;
    private k;
    d(a: Series, b: SeriesLayerCollection, c: EventArgs): void;
}
/**
 * @hidden
 */
export declare class SeriesLayerPropertyOverlay extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    o: boolean;
    k: SeriesLayerPropertyOverlay;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    private ah;
    q: boolean;
    protected n: boolean;
    private ag;
    private m;
    w: any;
    s: any;
    t(a: any, b: any, c: Series): any;
    private aj;
    private v;
    private ai;
    private u;
    r: boolean;
    p: boolean;
    get aa(): string;
    ad: string;
    y: string;
    x: any;
    valueResolving: (sender: any, e: SeriesLayerPropertyOverlayValueResolvingEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SeriesLayerPropertyOverlayCollection extends ObservableCollection$1<SeriesLayerPropertyOverlay> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export interface IDataChartToolbarProvider {
    container: any;
    getDesiredToolbarActions(a: SeriesViewer): ToolActionInfo[];
    onToolCommandExecuting(a: SeriesViewer, b: ToolCommand): ToolCommandExecutionState;
}
/**
 * @hidden
 */
export declare let IDataChartToolbarProvider_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerScrollbarManager {
    executionContext: IExecutionContext;
    animator: DoubleAnimator;
    owner: SeriesViewer;
    onHorizontalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    onVerticalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    updateScrollbars(a: SeriesViewer, b: Rect, c: Rect, d: Rect, e: Rect): void;
    updateBarDimensions(a: SeriesViewer, b: number, c: number, d: number, e: boolean, f: number, g: number, h: number, i: number, j: number, k: boolean, l: number, m: number): void;
    updateBarAppearance(a: SeriesViewer, b: Brush, c: Brush, d: Brush, e: Brush, f: number, g: number, h: number, i: number): void;
    onCrosshairMoved(a: Point): void;
    shouldHandleInteraction(a: Point, b: boolean): boolean;
    onScrollbarDrag(a: Point, b: boolean): void;
    onScrollbarDragComplete(a: Point, b: boolean): void;
    onScrollbarDragCancel(): void;
    updateVerticalScrollbarPosition(a: SeriesViewerVerticalScrollbarPosition): void;
    updateHorizontalScrollbarPosition(a: SeriesViewerHorizontalScrollbarPosition): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerScrollbarManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$m(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$p(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$o(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$r(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$f(a: Series, b: Point, c: boolean): boolean;
    a$b(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[];
    a$g(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$h(a: Series, b: Point, c: PathGeometry): boolean;
    a$q(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$n(a: Series, b: Point, c: Axis): number;
    a$i(a: Series, b: Point, c: boolean): boolean;
    a$au(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$ab(a: Series, b: any, c: Point, d: boolean, e: boolean, f: boolean, g: boolean, h: boolean, i: boolean): void;
    a$y(): void;
    a$at(a: Series, b: HighlightingInfo, c: HighlightingInfo, d: HighlightingInfo, e: number, f: number, g: number, h: number, i: number, j: number, k: Brush, l: boolean): Brush;
    a$l(a: Series, b: HighlightingInfo, c: HighlightingInfo, d: HighlightingInfo, e: number): number;
    a$k(a: Series, b: HighlightingInfo, c: HighlightingInfo, d: HighlightingInfo, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: boolean): number;
    a$ae(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ar(a: Series, b: Point): void;
    a$ah(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$af(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ac(a: Series, b: Point, c: any, d: any): void;
    a$ag(a: Series, b: Point, c: any, d: any): void;
    a$ad(a: Series, b: Point, c: any, d: any): void;
    a$ai(a: Series, b: Point, c: any, d: any): void;
    a$aj(a: Series, b: Point, c: any, d: any): void;
    a$t(a: Series): string;
    a$u(a: Series): string;
    readonly a$c: boolean;
    readonly a$s: any;
    a$as(a: Series, b: any): void;
    a$aq(a: Series, b: Point, c: (arg1: any) => void): void;
    a$aa(a: Series): void;
    a$ap(a: Series): void;
    readonly a$e: boolean;
    readonly a$j: Dictionary$2<string, SeriesView>;
    readonly a$d: boolean;
    a$z(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ak(a: Series, b: SeriesViewer): void;
    a$al(a: Series, b: string, c: SeriesViewer): void;
    a$x(a: Series, b: any, c: number): void;
    a$v(a: Series): void;
    a$an(a: Series, b: any, c: number): void;
    a$ao(a: Series): void;
    a$w(a: Series, b: any, c: number): void;
    a$am(a: Series, b: any, c: number): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$aj(a: SeriesViewer): void;
    f$t(a: SeriesViewer, b: Point): void;
    f$ah(a: SeriesViewer, b: Point): void;
    f$u(a: SeriesViewer, b: Point, c: boolean): void;
    f$s(a: SeriesViewer, b: Point): void;
    f$ao(a: SeriesViewer): void;
    f$ag(a: SeriesViewer, b: Point): void;
    f$ap(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$af(a: SeriesViewer, b: number): void;
    f$al(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$ac(a: SeriesViewer, b: Point): void;
    f$ae(a: SeriesViewer, b: number): void;
    f$v(a: SeriesViewer, b: Point): void;
    f$ab(a: SeriesViewer, b: Point): void;
    f$ak(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$q(a: SeriesViewer, b: Point, c: boolean): void;
    f$an(a: SeriesViewer): void;
    f$am(a: SeriesViewer): void;
    f$at(a: SeriesViewer): void;
    f$n(a: SeriesViewer): void;
    f$k(a: SeriesViewer): void;
    f$p(a: SeriesViewer, b: Point, c: boolean): void;
    f$o(a: SeriesViewer, b: Point, c: boolean, d: boolean): void;
    f$ar(a: SeriesViewer): void;
    f$ai(a: SeriesViewer): void;
    f$g(a: SeriesViewer, b: Key): boolean;
    f$h(a: SeriesViewer, b: Point, c: number): boolean;
    f$r(a: SeriesViewer, b: Point): void;
    f$m(a: SeriesViewer): void;
    f$l(a: SeriesViewer): void;
    readonly f$e: IHighlightingManager;
    readonly f$f: IHighlightingManager;
    readonly f$d: IHighlightingManager;
    readonly f$b: ISeriesViewerScrollbarManager;
    f$as(a: SeriesViewer, b: Point): void;
    f$j(a: Series, b: any, c: number): void;
    f$aq(a: Series, b: any, c: number): void;
    f$c(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$i(a: SeriesViewer, b: Point): boolean;
    f$z(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$y(a: SeriesViewer, b: Point): void;
    f$x(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$aa(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$w(a: SeriesViewer, b: Point, c: boolean): void;
    f$ad(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    addSubSeriesLayerVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    addPointerTooltipWithDataLegend(a: any, b: any, c: number, d: number, e: any): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
    exportLayerVisualData(a: Series, b: any): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static x7: number;
    static x6: number;
    private _xsr;
    private get XSRP();
    private wp;
    get wq(): IDataChartVisualDataManager;
    static staticInit(): void;
    static yj(a: Series): number;
    constructor();
    protected qc(a: any, b: string, c: any, d: any): void;
    qu(): void;
    oq(): void;
    protected of(a: Rect, b: Rect): void;
    protected ol(): void;
    zq(): void;
    private zl;
    private aal;
    private zs;
    private wv;
    private wu;
    private ws;
    private wr;
    private aam;
    private aan;
    protected get_ew(): boolean;
    xa: boolean;
    hp(): number;
    hq(): number;
    protected rf(): void;
    yh: number;
    yi: number;
    private xq;
    get x2(): number;
    set x2(a: number);
    private xr;
    get x3(): number;
    set x3(a: number);
    fk(): boolean;
    fl(): boolean;
    w7: boolean;
    xk: boolean;
    w8: boolean;
    xb: boolean;
    wo: GridMode;
    w4: boolean;
    xf: boolean;
    xg: boolean;
    x9: number;
    x5: number;
    x4: number;
    get w2(): boolean;
    protected get_ft(): boolean;
    get w3(): boolean;
    xi: boolean;
    xe: boolean;
    xh: boolean;
    xj: boolean;
    wj: AutoMarginsAndAngleUpdateMode;
    w9: boolean;
    xd: boolean;
    xc: boolean;
    private xs;
    private xt;
    private ya;
    private yb;
    protected get_fs(): boolean;
    protected get_fr(): boolean;
    zp(): void;
    zo(): void;
    zn(a: AxisLabelPanelBase, b: Rect, c: Rect, d: Rect): void;
    private yg;
    private x8;
    private zk;
    aak: Brush;
    aai: Brush;
    aaj: Brush;
    get axes(): AxisCollection;
    private wk;
    private zh;
    private zi;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private zj;
    private static zm;
    ro(a: SyncLink, b: SyncLink): void;
    private wy;
    getFontInfo(): FontInfo;
    zr(): void;
    getFontBrush(): Brush;
    protected nf(): void;
    u1(): Brush;
    f1(): boolean;
    protected rj(): void;
    eu(): boolean;
    private w6;
    protected c8(): SeriesViewerView;
    protected p0(a: SeriesViewerView): void;
    wx: XamDataChartView;
    qv(): void;
    private w1;
    static ym: string;
    private xn;
    get xz(): number;
    set xz(a: number);
    static yo: string;
    private xp;
    get x1(): number;
    set x1(a: number);
    static yn: string;
    private xo;
    get x0(): number;
    set x0(a: number);
    static yl: string;
    private xm;
    get xy(): number;
    set xy(a: number);
    wm: ComputedPlotAreaMarginMode;
    wt: SeriesPlotAreaMarginHorizontalMode;
    ww: SeriesPlotAreaMarginVerticalMode;
    private xv;
    get yd(): number;
    set yd(a: number);
    private xx;
    get yf(): number;
    set yf(a: number);
    private xw;
    get ye(): number;
    set ye(a: number);
    private xu;
    get yc(): number;
    set yc(a: number);
    protected vz(a: Rect): Rect;
    v5(): Rect;
    yk(): any;
    yz(): string;
    p9(): void;
    qx(): void;
    xl(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private r;
    private t;
    private get u();
    private set u(value);
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ad(a: ChartContentType, b: DependencyObject): void;
    private m;
    private v;
    aa(a: DomRenderer): void;
    z(): void;
    ac(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private q;
    private j;
    y(): void;
    private w;
    private _s;
    private s;
    x(a: Size): void;
    o: boolean;
    n: boolean;
    p: boolean;
    ae(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    ab(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    get d(): boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendSeriesInternal, ILegendOwner, ILegendTemplateProvider, IDataLegendSeries {
    static $t: Type;
    cu: SeriesView;
    private static jz;
    kf: number;
    we: Rect;
    gb(): boolean;
    protected get_dataLegendKey(): string;
    get dataLegendKey(): string;
    l2: string;
    mi: string;
    get group(): string;
    get parentKey(): string;
    get parentTitle(): string;
    ev: boolean;
    private jx;
    get jy(): DomRenderer;
    set jy(a: DomRenderer);
    provideRenderer(a: DomRenderer): void;
    nd(): string;
    constructor();
    j5(): number;
    cb: SeriesLayerManager;
    private os;
    private ot;
    private oo;
    private op;
    private om;
    private on;
    private oq;
    private qo;
    private qu;
    private qt;
    private or;
    sh(a: MarkerOutlineMode): void;
    sg(a: MarkerFillMode): void;
    si(a: number): void;
    private static readonly uz;
    protected ou(a: any, b: PropertyChangedEventArgs): void;
    private dp;
    get dq(): SRProvider;
    private bb;
    get bc(): ISeriesVisualDataManager;
    protected get hm(): Dictionary$2<string, SeriesView>;
    private a9;
    get ba(): ISeriesInteractionManager;
    get fh(): boolean;
    db: DoubleAnimator;
    qz(a: SeriesView): void;
    qw(): void;
    qx(): void;
    cs(): SeriesView;
    protected cr(): SeriesView;
    sr: Canvas;
    ha(): boolean;
    kp(a: any, b: string): any;
    mc(a: string): string;
    onLegendItemOver(a: any): void;
    onLegendItemPointerUp(a: any): void;
    onLegendItemPointerDown(a: any): void;
    onLegendItemEnter(a: any): void;
    onLegendItemLeave(a: any): void;
    private hg;
    protected nc(a: string): string;
    private hf;
    protected kq(a: any, b: string, c: string): any;
    iq(a: Point): number;
    j4(a: Point): number;
    protected get_fr(): boolean;
    get fr(): boolean;
    a0(): CategoryAxisBase;
    j2(a: Point): number;
    wp(): Thickness;
    wr(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    wq(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    cj(): SeriesPlotAreaMarginHorizontalMode;
    ck(): SeriesPlotAreaMarginVerticalMode;
    km(a: Point): any;
    p1(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    protected kv(a: Series, b: Point): any;
    protected dh(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    protected di(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    j1(): number;
    j6(): number;
    kb(): number;
    get container(): ILegendOwner;
    get hasSubItems(): boolean;
    protected eg(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected pz(a: (arg1: any) => void): void;
    p0(a: (arg1: Series) => boolean): void;
    get ef(): boolean;
    py(a: (arg1: Series) => boolean): void;
    nb(): string;
    vs(): Brush;
    vt(): Brush;
    resolveLegendIndex(): number;
    bo(): Series;
    protected get_er(): boolean;
    get er(): boolean;
    protected get_eo(): boolean;
    get eo(): boolean;
    protected get_en(): boolean;
    get en(): boolean;
    protected get_eq(): boolean;
    get eq(): boolean;
    protected get_ep(): boolean;
    get ep(): boolean;
    protected get_es(): boolean;
    get es(): boolean;
    protected get_isVertical(): boolean;
    get isVertical(): boolean;
    protected get_fa(): boolean;
    get fa(): boolean;
    protected get_eu(): boolean;
    get eu(): boolean;
    protected get_et(): boolean;
    get et(): boolean;
    protected get_ej(): boolean;
    get ej(): boolean;
    protected get_f4(): boolean;
    get f4(): boolean;
    protected get_fj(): boolean;
    get fj(): boolean;
    protected get_fi(): boolean;
    get fi(): boolean;
    protected get_fz(): boolean;
    get fz(): boolean;
    protected get_ey(): boolean;
    get ey(): boolean;
    protected get_ew(): boolean;
    get ew(): boolean;
    protected get_f5(): boolean;
    get f5(): boolean;
    protected get_fq(): boolean;
    get fq(): boolean;
    protected get_fp(): boolean;
    get fp(): boolean;
    protected get_fn(): boolean;
    get fn(): boolean;
    protected get_fm(): boolean;
    get fm(): boolean;
    protected get_f2(): boolean;
    get f2(): boolean;
    protected get_f0(): boolean;
    get f0(): boolean;
    protected get_fx(): boolean;
    get fx(): boolean;
    protected get_fo(): boolean;
    get fo(): boolean;
    protected get_fv(): boolean;
    get fv(): boolean;
    protected get_fs(): boolean;
    get fs(): boolean;
    protected get_isStacked(): boolean;
    get isStacked(): boolean;
    protected get_e5(): boolean;
    get e5(): boolean;
    protected get_ft(): boolean;
    get ft(): boolean;
    protected get_ex(): boolean;
    get ex(): boolean;
    protected get_fb(): boolean;
    get fb(): boolean;
    protected get_fw(): boolean;
    get fw(): boolean;
    protected get_isValueOverlay(): boolean;
    get isValueOverlay(): boolean;
    protected get_fe(): boolean;
    get fe(): boolean;
    protected get_isSummarizationSupported(): boolean;
    get isSummarizationSupported(): boolean;
    get isLayer(): boolean;
    bn(): Series;
    protected get_eh(): boolean;
    get eh(): boolean;
    protected get_e8(): boolean;
    get e8(): boolean;
    protected get_e7(): boolean;
    get e7(): boolean;
    protected get_e6(): boolean;
    get e6(): boolean;
    protected get_e9(): boolean;
    get e9(): boolean;
    protected get_e0(): boolean;
    get e0(): boolean;
    protected get_e1(): boolean;
    get e1(): boolean;
    io(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected ip(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_hc(): boolean;
    get hc(): boolean;
    protected i6(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    iu(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    ka(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    it(a: boolean): number;
    aj(a: Point): Point[][];
    al(a: Point): Point[][];
    protected gu(a: Point, b: boolean): boolean;
    an(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    am(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[];
    protected gw(a: Point, b: boolean, c: PathGeometry): boolean;
    protected gx(a: Point, b: PathGeometry): boolean;
    j8(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    is(a: Point, b: Axis): number;
    j9(a: Point, b: boolean): number;
    j7(a: Point, b: boolean): number;
    i4(a: Point, b: boolean, c: boolean): number;
    v8(a: Point, b: boolean, c: boolean): Point;
    wj(a: Point): Rect;
    ao(a: Point): Rect[];
    wk(a: Point): Rect;
    ap(a: Point): Rect[];
    ar(a: number, b: number): CollisionGeometry;
    wl(a: Point): Rect;
    wm(a: Point): Rect;
    protected gy(a: Point, b: boolean): boolean;
    protected wa(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    i0(a: Point, b: boolean, c: boolean): number;
    v4(a: Point, b: boolean, c: boolean): Point;
    i2(a: Point, b: boolean, c: boolean): number;
    v6(a: Point, b: boolean, c: boolean): Point;
    v9(a: Point, b: boolean, c: boolean): Point;
    i5(a: Point, b: boolean, c: boolean): number;
    v5(a: Point, b: boolean, c: boolean): Point;
    i1(a: Point, b: boolean, c: boolean): number;
    v7(a: Point, b: boolean, c: boolean): Point;
    i3(a: Point, b: boolean, c: boolean): number;
    j3(a: Point): number;
    iv(): number;
    static pl(a: Series, b: SeriesViewer, c: boolean): void;
    ir(a: Point): number;
    kn(a: Point): any;
    kh: any;
    protected oy(a: Series, b: any): void;
    protected kz(a: Series): any;
    au(a: boolean): BindingFormatter;
    ea(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    jc(a: Marker): number;
    jb(a: any): number;
    md(): string;
    i7(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wb(a: ValueLayerValueMode): Point;
    wc(a: number[]): Point;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    private k2;
    private kx;
    private static he;
    ti(a: string): DependencyProperty;
    protected get_hasMarkers(): boolean;
    get hasMarkers(): boolean;
    protected get_ek(): boolean;
    get ek(): boolean;
    p4(): void;
    p5(): void;
    protected vj(a: number): Brush;
    protected vp(a: Brush): Brush;
    protected vm(a: number): Brush;
    protected vk(a: number): Brush;
    protected vl(a: number): Brush;
    vh(): Brush;
    vi(): Brush;
    sv(): DataTemplate;
    im(): number;
    wd(a: Point): Point;
    wn(a: Rect): Rect;
    v3(a: Point): Point;
    kw(a: any, b: Point): any;
    gc(a: any): boolean;
    ay(a: Axis): AxisRange;
    az(a: Rect): AxisRange;
    ax(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    protected pv(): void;
    protected d6: boolean;
    rp(a: boolean): void;
    transitionOutCompleted: (sender: any, e: TransitionOutCompletedEventArgs) => void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private ph;
    private bs;
    protected get bt(): SeriesHighlightedValuesDisplayMode;
    protected set bt(a: SeriesHighlightedValuesDisplayMode);
    rq(a: boolean): void;
    private cc;
    get cd(): SeriesLayerPropertyOverlayCollection;
    protected get_el(): boolean;
    protected get el(): boolean;
    protected ga(): boolean;
    private rc;
    private pf;
    private b3;
    private static hi;
    private static hj;
    static pm(): void;
    static nu(a: string): string;
    static nv(a: string): string;
    static o8(a: Dictionary$2<string, string>, b: Dictionary$2<string, string>): void;
    protected rx(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected rv(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected ru(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected rw(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected get_gs(): boolean;
    protected get gs(): boolean;
    private pj;
    protected hr(): List$1<SeriesLayerPropertyOverlay>;
    private p6;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    get fu(): boolean;
    private du;
    protected qv(): void;
    renderValid: (sender: any, e: RenderValidEventArgs) => void;
    g0: boolean;
    g3: boolean;
    protected o0(): void;
    gj: boolean;
    protected qm(): void;
    protected qy(): void;
    private rm;
    protected o5(): void;
    ct: SeriesView;
    rr(a: Rect, b: RenderSurface): void;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    getMainContentViewport(): Rect;
    wf(a: SeriesView): Rect;
    wi(a: Rect): Rect;
    wh(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    ri(): void;
    protected get_ec(): boolean;
    get ec(): boolean;
    protected get_ei(): boolean;
    get ei(): boolean;
    private rj;
    rk(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    o4(a: boolean, b: SeriesView): void;
    protected d3(): boolean;
    d4(a: SeriesView): boolean;
    q0(a: Rect, b: Rect): void;
    protected sn(a: Rect, b: Rect): void;
    protected sm(a: Rect, b: Rect): void;
    a1: ContentInfo;
    private dx;
    get gz(): boolean;
    set gz(a: boolean);
    protected px(a: Series): void;
    protected qk(): void;
    protected hu: Stack$1<string>;
    rd(a: string): void;
    qe(): void;
    qj(): void;
    protected get_ff(): boolean;
    get ff(): boolean;
    protected get_isUsableInLegend(): boolean;
    get isUsableInLegend(): boolean;
    protected qr(): void;
    ql(): void;
    protected q1(): void;
    q2(): void;
    protected gq: boolean;
    protected gr: boolean;
    protected f9(): boolean;
    protected q3(a: boolean): void;
    private dy;
    protected get g1(): boolean;
    protected set g1(a: boolean);
    private dz;
    protected get g4(): boolean;
    protected set g4(a: boolean);
    protected get g2(): boolean;
    protected get g5(): boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected qq(): void;
    protected qd(): void;
    as: BindingFormatter;
    at: BindingFormatter;
    protected q7(a: any, b: string, c: any, d: any): void;
    private vn;
    private vo;
    private vq;
    protected sc(): void;
    sk(a: Point): void;
    pq(a: any): void;
    pu(): void;
    pt(): void;
    pp(a: any): void;
    po(a: any): void;
    ed(a: any): boolean;
    pn(a: any): void;
    pk(): void;
    protected get_fd(): boolean;
    protected get fd(): boolean;
    d5: boolean;
    protected pe(a: Series): void;
    get c2(): SyncLink;
    set c2(a: SyncLink);
    private c1;
    get da(): SeriesViewer;
    set da(a: SeriesViewer);
    private c9;
    get c8(): XamDataChart;
    set c8(a: XamDataChart);
    readonly hx: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly bh: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly dn: (sender: any, e: RectChangedEventArgs) => void;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly tv: DependencyProperty;
    highlightedItemsSource: IEnumerable;
    dm: IFastItemsSource;
    ju: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly t1: DependencyProperty;
    get sq(): Control;
    set sq(a: Control);
    private so;
    ky(): any;
    protected sp(): Control;
    get a5(): IChartLegend;
    set a5(a: IChartLegend);
    private a4;
    legendItemVisibility: Visibility;
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    static readonly ty: DependencyProperty;
    ss: DataTemplate;
    private su;
    u8: Brush;
    u7: Brush;
    c0: StandardLegendItems;
    cz: StandardLegendItems;
    legendItemBadgeShape: LegendItemBadgeShape;
    bd: LegendItemBadgeMode;
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    static readonly tz: DependencyProperty;
    get st(): DataTemplate;
    set st(a: DataTemplate);
    static readonly tf: DependencyProperty;
    get index(): number;
    set index(a: number);
    static readonly tq: DependencyProperty;
    sl(): void;
    pi(a: string): void;
    protected fg(a: string, b: string, c: Brush, d: Brush): boolean;
    protected sd(): void;
    dc: (time: number) => number;
    dd: (time: number) => number;
    de: (time: number) => number;
    d9: boolean;
    kc: number;
    jp: number;
    d2(): boolean;
    r3(): void;
    private dw;
    private h1;
    get ic(): number;
    set ic(a: number);
    protected jj(): number;
    ji: number;
    private h5;
    protected get ii(): number;
    protected set ii(a: number);
    jt: number;
    private h2;
    protected get ie(): number;
    protected set ie(a: number);
    jq: number;
    private h3;
    protected get ig(): number;
    protected set ig(a: number);
    jr: number;
    private h4;
    protected get ih(): number;
    protected set ih(a: number);
    js: number;
    title: any;
    mg: string;
    ws: Visibility;
    vb: Brush;
    u5: Brush;
    vc: Brush;
    ve: Brush;
    vv: Brush;
    vg: Brush;
    va: Brush;
    vf: Brush;
    u6: Brush;
    vd: Brush;
    safeActualBrush: Brush;
    vr: Brush;
    u9: Brush;
    v1: PenLineJoin;
    bu: SeriesHighlightedValuesDisplayMode;
    gf: boolean;
    jg: number;
    jo: number;
    id: number;
    ik: number;
    vz: PenLineCap;
    vy: DoubleCollection;
    toolTip: any;
    private bv;
    get bw(): SeriesHighlightingMode;
    set bw(a: SeriesHighlightingMode);
    private cm;
    get co(): SeriesSelectionMode;
    set co(a: SeriesSelectionMode);
    private cl;
    get cn(): SeriesSelectionMode;
    set cn(a: SeriesSelectionMode);
    protected get_gd(): boolean;
    get gd(): boolean;
    ps(): void;
    protected bx(): SeriesHighlightingMode;
    protected cq(): SeriesSelectionMode;
    protected cp(): SeriesSelectionMode;
    protected fy(a: SeriesHighlightingMode): boolean;
    private hz;
    get h9(): number;
    set h9(a: number);
    jd: number;
    private h0;
    get ia(): number;
    set ia(a: number);
    je: number;
    em: boolean;
    ez: boolean;
    fc: boolean;
    g8: boolean;
    protected d1: boolean;
    private dv;
    protected pd(): void;
    private ee;
    protected pr(): void;
    private re;
    ht: List$1<UIElement>;
    gt(a: Series): boolean;
    private o9;
    protected ks(a: number): any;
    protected kr(a: number, b: boolean): any;
    protected kt(a: number): any;
    protected get_isColoredItemwise(): boolean;
    get isColoredItemwise(): boolean;
    gk: boolean;
    gi: boolean;
    gh: boolean;
    e3: boolean;
    protected get_e4(): boolean;
    get e4(): boolean;
    jl: number;
    vx: Color;
    hb: boolean;
    jm: number;
    jn: number;
    ij: number;
    h8: number;
    r9(): void;
    jf: number;
    ib: number;
    sb(): void;
    sa(): void;
    protected jk(): number;
    private dt;
    get e2(): boolean;
    set e2(a: boolean);
    go: boolean;
    private cv;
    get cw(): SeriesVisibleRangeMode;
    set cw(a: SeriesVisibleRangeMode);
    cx(): SeriesVisibleRangeMode;
    cy: SeriesVisibleRangeMode;
    private cf;
    get cg(): SeriesOutlineMode;
    set cg(a: SeriesOutlineMode);
    ci(): SeriesOutlineMode;
    ch: SeriesOutlineMode;
    a3(a: any): DataContext;
    kd: number;
    ke: number;
    c4: TransitionInSpeedType;
    c7: TransitionOutSpeedType;
    protected c3(): TransitionInSpeedType;
    protected c6(): TransitionOutSpeedType;
    kk: any;
    rn(): void;
    protected d8: boolean;
    rt(): void;
    q5(): void;
    q4(): void;
    q6(): void;
    rl(): void;
    o1(): void;
    p8(): void;
    private static _hp;
    static hp(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static ho(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    v0: PenLineCap;
    private bp;
    bq(): SeriesComponentsForView;
    lt: string;
    ag: any[];
    lw: string;
    ah: any[];
    ry(a: Canvas): void;
    i8(): number;
    i9(): number;
    ja(): number;
    private d0;
    protected get_g6(): boolean;
    protected set_g6(a: boolean): void;
    protected get g6(): boolean;
    protected set g6(a: boolean);
    get gg(): boolean;
    f7: boolean;
    o2(): void;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    dg(a: any, b: Point, c: boolean): HighlightingInfo;
    qs(a: Point, b: any, c: any, d: boolean): void;
    r2(a: Point): void;
    private ow;
    private o3;
    ov(a: IChartLegend, b: IChartLegend): void;
    private ox;
    rh(a: IFastItemsSourceProvider): void;
    rg(a: IFastItemsSourceProvider): void;
    protected a6(): IChartLegend;
    protected gm(): boolean;
    protected gn(): boolean;
    ge(a: boolean): boolean;
    protected pb(a: Axis): void;
    protected rf(a: Axis): void;
    br(): SeriesComponentsFromView;
    sf(a: Canvas): void;
    r1(a: Point, b: (arg1: any) => void): void;
    protected get_g9(): boolean;
    get g9(): boolean;
    q8(a: RenderingContext, b: RenderingContext): void;
    ra(a: Rect): void;
    p3(a: NotifyCollectionChangedEventArgs): void;
    qh(a: number, b: any, c: any): void;
    qc(): void;
    qf(a: number, b: any): void;
    qg(a: number, b: any): void;
    r8(): void;
    k1: any;
    jw: (arg1: any) => any;
    gv(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private ds;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    a2(a: Point, b: boolean): DataContext;
    private bz;
    get b2(): SeriesHitTestMode;
    set b2(a: SeriesHitTestMode);
    protected b1(): SeriesHitTestMode;
    private by;
    get b0(): SeriesHitTestMode;
    set b0(a: SeriesHitTestMode);
    protected dj(a: string): IFastItemColumn$1<number>;
    protected dk(a: string): IFastItemColumn$1<number>;
    protected dl(a: string): IFastItemColumn$1<any>;
    protected get wo(): Rect;
    protected get_fl(): boolean;
    get fl(): boolean;
    protected get_fk(): boolean;
    get fk(): boolean;
    r0(a: boolean): void;
    rz(a: Brush, b: Brush): void;
    dr: (arg1: SeriesViewer) => void;
    protected o7(a: any, b: any): void;
    kl(): any;
    protected pw(a: any): void;
    private v2;
    qa(a: Point): void;
    protected qp(a: Point): void;
    qb(): void;
    qi(): void;
    aw(a: Axis): Axis;
    ai(): Axis[];
    ix(): number;
    static iy(a: IFastItemColumn$1<number>, b: ISortingAxis): number;
    static iz(a: IList$1<number>, b: ISortingAxis): number;
    qn(): void;
    private h6;
    get il(): number;
    set il(a: number);
    private h7;
    get jh(): number;
    set jh(a: number);
    protected sj(): void;
    ko(a: any): any;
    get lj(): string;
    get k5(): string;
    get k8(): string;
    get lh(): string;
    get lr(): string;
    get lq(): string;
    get ll(): string;
    protected se(): void;
    av(): ActualLegendItemBadgeShape;
    protected be(a: LegendItemBadgeShape): LegendItemBadgeShape;
    private bf;
    private hk;
    private hq;
    protected bj(): Series;
    protected bk(): Series;
    b4: SeriesLayer;
    get ca(): SeriesLayerCollection;
    private b7;
    get b9(): SeriesLayerCollection;
    private b6;
    get actualLayers(): SeriesLayerCollection;
    private b5;
    private hn;
    protected get eb(): boolean;
    bm: Series;
    private hl;
    r5(a: string): void;
    r7(a: string): void;
    f3(a: string): boolean;
    private hh;
    r4(a: string): void;
    r6(a: string, b: boolean): void;
    gl(a: string): boolean;
    f1(): boolean;
    ku(): any;
    bl(a: number, b: SeriesLayer): Series;
    protected p7(a: Series): void;
    private oz;
    private pc;
    protected rs(a: Series): void;
    f8(a: DependencyProperty): boolean;
    gp(a: DependencyProperty): boolean;
    private o6;
    private ki;
    pg(a: SeriesLayer): void;
    getDataLegendBadge(): DataTemplate;
    private a8;
    getDataLegendBadgeContext(): any;
    getDataLegendBadgeContextAtPosition(a: number, b: number): any;
    getDataLegendBadgeShapeAndMarker(): string;
    l9(): string;
    ma(a: Series, b: DataTemplate): string;
    getDataLegendSeriesTitle(): string;
    iw(a: any, b: string): number;
    getDataLegendResolvedWorldPositionX(a: number): number;
    getDataLegendResolvedWorldPositionY(a: number): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    mb(): string;
    getDataLegendAxisLabelFromCursorPosition(a: number, b: number): any;
    private p9;
    private hy;
    vw(a: Brush): Brush;
    ce(): SeriesMatcher;
    private f6;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    w1: MarkerSeriesView;
    constructor();
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    wq(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    qz(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    protected get_ek(): boolean;
    vh(): Brush;
    vi(): Brush;
    sv(): DataTemplate;
    l9(): string;
    w5: MarkerType;
    private w2;
    get w3(): MarkerType;
    set w3(a: MarkerType);
    private w4;
    private xa;
    private w9;
    ps(): void;
    w8: boolean;
    get w7(): boolean;
    private wx;
    get wy(): MarkerOutlineMode;
    set wy(a: MarkerOutlineMode);
    w0(): MarkerOutlineMode;
    sh(a: MarkerOutlineMode): void;
    wz: MarkerOutlineMode;
    private wt;
    get wu(): MarkerFillMode;
    set wu(a: MarkerFillMode);
    ww(): MarkerFillMode;
    sg(a: MarkerFillMode): void;
    si(a: number): void;
    wv: MarkerFillMode;
    xx: DataTemplate;
    xe: number;
    im(): number;
    xv: DataTemplate;
    xw: DataTemplate;
    private static xu;
    static get xy(): DataTemplate;
    get ye(): Brush;
    set ye(a: Brush);
    static readonly x3: DependencyProperty;
    yc: Brush;
    yf: Brush;
    yd: Brush;
    yg: Style;
    xd: boolean;
    xb(): boolean;
    protected qq(): void;
    protected q7(a: any, b: string, c: any, d: any): void;
    static xj(a: MarkerType): string;
    static w6(a: Series, b: MarkerType): MarkerType;
    protected vk(a: number): Brush;
    protected vl(a: number): Brush;
    protected sd(): void;
    protected pw(a: any): void;
    protected xc(a: Point, b: boolean): boolean;
    a2(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ak: string;
    protected aq(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static aj: (arg1: IEnumerable) => IFastItemsSource;
    private static af;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ag(a: IEnumerable): IFastItemsSource;
    private ah;
    av: Rect;
    private aw;
    private ax;
    private ab;
    private ac;
    get ai(): IList$1<SeriesViewer>;
    private ad;
    al(a: SeriesViewer): void;
    as(a: SeriesViewer): void;
    private ao;
    private am;
    an(a: SeriesViewer, b: Point): void;
    ap(a: SeriesViewer, b: Rect): void;
    at(a: SeriesViewer, b: Rect): void;
    au(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected ar(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    get e(): number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _isDuringManipulation;
    get isDuringManipulation(): boolean;
    set isDuringManipulation(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class PlotAreaMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _manipulationOccurred;
    get manipulationOccurred(): boolean;
    set manipulationOccurred(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _seriesViewer;
    get seriesViewer(): SeriesViewer;
    set seriesViewer(a: SeriesViewer);
    get chart(): XamDataChart;
}
/**
 * @hidden
 */
export declare class SeriesViewerSelectedSeriesItemsChangedEventArgs extends EventArgs {
    static $t: Type;
    private _oldItems;
    get oldItems(): ChartSelectedItemCollection;
    set oldItems(a: ChartSelectedItemCollection);
    private _newItems;
    get newItems(): ChartSelectedItemCollection;
    set newItems(a: ChartSelectedItemCollection);
    private _currentItems;
    get currentItems(): ChartSelectedItemCollection;
    set currentItems(a: ChartSelectedItemCollection);
    constructor(a: ChartSelectedItemCollection, b: ChartSelectedItemCollection, c: ChartSelectedItemCollection);
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    private j;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs, e: Point);
    toString(): string;
    protected i: MouseButtonEventArgs;
    get handled(): boolean;
    set handled(a: boolean);
    private d;
    get cancelSelection(): boolean;
    set cancelSelection(a: boolean);
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    get chartPosition(): Point;
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs, e: Point);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private g;
    get chartPosition(): Point;
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    aw: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ae(a: FrameworkElement): void;
    ah(a: any): void;
    ai(a: any, b: Size): void;
    aj(a: FrameworkElement, b: number): void;
    ar(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    ad(a: Rectangle): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    af(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    an(): void;
    m(a: any): number;
    w(a: any): number;
    ax(a: any): Size;
    ac(): void;
    ak(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    al(a: RenderingContext): void;
    y(): void;
    protected am(): void;
    private av;
    protected ap(a: TextBlock): void;
    ao(): void;
    d(): FontInfo;
    at(): Brush;
    private c;
    ag(): void;
    private h;
    private as;
    private i;
    j(): number;
    k(): number;
    protected aq(): void;
    ab(a: Size): void;
    protected ay(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    au(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    al(): void;
    an(a: any): void;
    bd: Path;
    be: Path;
    bg: Path;
    bf: Path;
    a3(): TextBlock;
    aw(a: TextBlock): void;
    ay(a: TextBlock): void;
    ax(a: TextBlock): void;
    bi(): Rectangle;
    t(a: Rectangle): void;
    v(a: Rectangle): void;
    u(a: Rectangle): void;
    ao(): void;
    p(): boolean;
    get index(): number;
    ai(): void;
    ag(): void;
    ac(): void;
    a1(a: Visibility): void;
    at(): void;
    ab(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    ae(a: GeometryCollection): void;
    a4(): GeometryCollection;
    e(): PathRenderingInfo;
    a7(): GeometryCollection;
    a5(): GeometryCollection;
    f(): PathRenderingInfo;
    a6(): GeometryCollection;
    g(): PathRenderingInfo;
    protected get d(): AxisLabelPanelBase;
    az(a: Axis, b: Rect, c: Rect): void;
    ad(): void;
    av(a: number): void;
    a0(a: List$1<any>, b: List$1<LabelPosition>): void;
    au(a: number): void;
    aa(): void;
    private h;
    s(a: number): string;
    z(): void;
    aq(): void;
    l(): boolean;
    protected o(): boolean;
    m(): boolean;
    protected r(dataItem_: any): string;
    q(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    ak(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected aj(): void;
    undirty(a: boolean): void;
    private bh;
    protected ar(a: boolean): void;
    postRender(): void;
    private bb;
    protected as(): void;
    ah(): void;
    af(a: SeriesViewer): void;
    y(a: SeriesViewer): void;
    i(): FontInfo;
    n(): boolean;
    ap(): void;
    x(): void;
    a2(): void;
    w(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a8(a: TextBlock): Point;
    a9(): Point;
    bc(): Rect;
    ba(a: TextBlock): Point;
    bj(a: TextBlock): Thickness;
    am(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected bk: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    s(a: number): string;
    bl(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    a1(): void;
    a0(): boolean;
    a2(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected bk: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bl(): void;
    protected o(): boolean;
    m(): boolean;
    protected r(dataItem_: any): string;
    s(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    a0(): void;
    d(): FontInfo;
    protected ay(): Thickness;
    at(): Brush;
    a1(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected fn: XamDataChart;
    fr(a: any): void;
    protected ds(): void;
    d4(): void;
    fw: Brush;
    fs: Brush;
    ft: Brush;
    fv: Brush;
    fu: Brush;
    fp: number;
    fq: number;
    protected d1(): void;
    fo: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected e: Series;
    s: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    ar(): void;
    j(): IExecutionContext;
    private h;
    protected get i(): IExecutionContext;
    ah(a: number, b: Series): void;
    am(a: Series): void;
    d: DataContext;
    au(): void;
    getEffectiveViewport(): Rect;
    a1(): void;
    ak(): void;
    getMainContentViewport(): Rect;
    get w(): DomRenderer;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected get_index(): number;
    get index(): number;
    protected as(): void;
    undirty(a: boolean): void;
    private bz;
    aw(): void;
    private bp;
    bt(): Brush;
    bq(a: Brush): Brush;
    v: number;
    private u;
    protected a6(a: boolean): void;
    private bu;
    protected bf(a: any, b: number, c: boolean): void;
    protected bi(a: any, b: number, c: boolean): void;
    protected aa(a: number, b: boolean): any;
    protected ab(a: number): any;
    protected ac(a: number): any;
    protected bg(a: any, b: number): void;
    protected bj(a: any, b: number): void;
    protected bh(a: any, b: number): void;
    protected bk(a: any, b: number): void;
    protected bc(a: boolean): void;
    protected bd(): void;
    protected be(): void;
    private bo;
    protected bs(a: number): Brush;
    protected br(): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    protected a7(a: RenderingContext, b: boolean): void;
    az(): void;
    ao(): void;
    ap(): void;
    private f;
    g(): SeriesComponentsFromView;
    bb(a: Canvas): void;
    t(): boolean;
    ay(): void;
    ax(): void;
    a9(): void;
    ai(): void;
    ba(): void;
    aj(): void;
    c(a: any): DataContext;
    protected k: RenderingContext;
    protected l: RenderingContext;
    at(a: RenderingContext, b: RenderingContext): void;
    private bv;
    get bx(): Rect;
    set bx(a: Rect);
    bw: Rect;
    protected get_by(): Rect;
    get by(): Rect;
    private m;
    get q(): boolean;
    set q(a: boolean);
    al(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ag(a: SeriesViewer): void;
    postRender(): void;
    protected a2(): void;
    b(a: number): DataContext;
    a4(a: RenderSurface): void;
    an(a: any): void;
    bl(): void;
    av(): void;
    a0(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    o(): boolean;
    protected r: boolean;
    bm(): void;
    a5(): void;
    protected af(): void;
    aq(): void;
    preRender(): void;
    isValid(): boolean;
    n: boolean;
    p: boolean;
    a3(a: RenderSurface): void;
    ad: string;
    bn(type_: StandardLegendItems): DataTemplate;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected b4: MarkerSeries;
    private b9;
    private cb;
    private ca;
    constructor(a: MarkerSeries);
    au(): void;
    cl(): void;
    cv(): Size;
    cs(a: boolean): void;
    protected b8: List$1<Marker>;
    b3(): Marker;
    abstract cj(a: (arg1: Marker) => void): void;
    ck(a: (arg1: Marker) => void): void;
    co(a: Marker): void;
    cq(a: Marker): void;
    cp(a: Marker): void;
    b5(): boolean;
    ci(): void;
    cc(): void;
    cu(a: Marker): Rect;
    cf(a: string): void;
    cg(): void;
    cd(): void;
    ch(): void;
    ce(): void;
    cr(): void;
    b7: boolean;
    protected bj(a: any, b: number): void;
    private b0;
    protected bk(a: any, b: number): void;
    b(a: number): DataContext;
    private ct;
    protected a7(a: RenderingContext, b: boolean): void;
    cm(a: HashPool$2<any, Marker>): void;
    cn(a: Pool$1<Marker>): void;
    b1(a: Point): Marker;
    private b2;
    private b6;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
    private _axis;
    get axis(): Axis;
    set axis(a: Axis);
    private _oldMinimumValue;
    get oldMinimumValue(): number;
    set oldMinimumValue(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _oldMaximumValue;
    get oldMaximumValue(): number;
    set oldMaximumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
}
