import { Series } from "./Series";
import { DependencyProperty } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { HighlightingInfo } from "igniteui-react-core";
import { ShapeItemSearchMode } from "./ShapeItemSearchMode";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Point, Type } from "igniteui-react-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { Axis } from "./Axis";
import { FrameworkElement } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { Marker } from "./Marker";
import { Tuple$2 } from "igniteui-react-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { Clipper } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { RenderSurface } from "./RenderSurface";
import { Dictionary$2 } from "igniteui-react-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { Shape } from "igniteui-react-core";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-react-core";
import { StyleSelector } from "./StyleSelector";
import { Path } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ShapeSeriesBase extends Series {
    static $t: Type;
    constructor();
    o1(): void;
    ai(): Axis[];
    kp(a: any, b: string): any;
    mc(a: string): string;
    xv: boolean;
    xu: boolean;
    protected xm: boolean;
    protected xl: boolean;
    protected get_fd(): boolean;
    private xh;
    private xi;
    protected get_ec(): boolean;
    protected xf(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected xg(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    private w8;
    get w9(): ShapeItemSearchMode;
    set w9(a: ShapeItemSearchMode);
    protected xa(): ShapeItemSearchMode;
    xb: ShapeItemSearchMode;
    yd: number;
    yc: number;
    iq(a: Point): number;
    private wx;
    private wy;
    protected yv(a: Point): Tuple$2<number, Point>;
    private yu;
    protected get_xo(): boolean;
    protected get xo(): boolean;
    private yt;
    protected x8(a: Point): number;
    v8(a: Point, b: boolean, c: boolean): Point;
    km(a: Point): any;
    protected xe(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    dg(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningShapeStyle: (sender: any, args: AssigningShapeStyleEventArgs) => void;
    assigningShapeMarkerStyle: (sender: any, args: AssigningShapeMarkerStyleEventArgs) => void;
    protected x1(): boolean;
    protected x0(): boolean;
    protected xc: ShapeSeriesRenderManager;
    yp: string;
    get yg(): string;
    set yg(a: string);
    static readonly y9: DependencyProperty;
    protected ga(): boolean;
    protected hs(): List$1<SeriesLayerPropertyOverlay>;
    private yy;
    private xj;
    get xk(): IFastItemColumn$1<any>;
    set xk(a: IFastItemColumn$1<any>);
    w5: NumericXAxis;
    w7: NumericYAxis;
    private xs;
    private static xw;
    private convertToListList;
    protected dl(a: string): IFastItemColumn$1<any>;
    protected q7(a: any, b: string, c: any, d: any): void;
    protected xz(): boolean;
    protected xy(): boolean;
    xq(a: any): boolean;
    xp(a: any): boolean;
    private w4;
    private w6;
    private x7;
    x3: List$1<Rect>;
    private y6;
    private zk;
    protected x5(a: SeriesView, b: Clipper, c: any, d: ScalerParams, e: ScalerParams, f: number, g: number): List$1<FlattenedShape>;
    private wu;
    private ww;
    private wv;
    private wt;
    protected get_xt(): boolean;
    protected get xt(): boolean;
    protected x2(): boolean;
    rq(a: boolean): void;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected y5(a: SeriesView): void;
    protected y1(a: FrameworkElement, b: boolean, c: number, d: number, e: boolean, f: boolean): void;
    protected y0(a: number, b: number, c: boolean): void;
    protected y3(a: AssigningShapeStyleEventArgs): void;
    protected y2(a: AssigningShapeMarkerStyleEventArgs): void;
    wz(a: number, b: number): any[];
    protected w0(a: number, b: number): any[];
    private static y4;
    p8(): void;
    protected sn(a: Rect, b: Rect): void;
    protected sm(a: Rect, b: Rect): void;
    protected pa(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    hd(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_xx(): boolean;
    protected get xx(): boolean;
    qz(a: SeriesView): void;
    private xd;
    private x6;
    private w3;
    private yw;
    zj: Rect;
    private y8;
    o4(a: boolean, b: SeriesView): void;
    private yz;
    private y7;
    yx(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    xn(a: List$1<ChartSelection>, b: SeriesSelectionBehavior, c: number): boolean;
    a2(a: Point, b: boolean): DataContext;
    ye(a: number): any;
    protected get_g6(): boolean;
    protected set_g6(a: boolean): void;
    x9: number;
    ya: number;
    ay(a: Axis): AxisRange;
    protected get_fw(): boolean;
    protected get_fk(): boolean;
    get xr(): boolean;
    zl(a: any, b: DependencyObject, c: Style): Style;
    styleShape: (sender: any, e: StyleShapeEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ShapeSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningShapeMarkerStyleEventArgs;
    ax: AssigningShapeStyleEventArgs;
    a1(a: Shape, b: number, c: boolean): void;
    ay(a: ShapeSeriesBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare abstract class ShapeSeriesViewBase extends SeriesView {
    static $t: Type;
    constructor(a: ShapeSeriesBase);
    cc: Dictionary$2<number, FlattenedShape>;
    b4(a: Point): Marker;
    get ce(): List$1<ShapeHitRegion>;
    protected b8(): Pool$1<FrameworkElement>;
    cb(a: Rect): boolean;
    static cf(a: List$1<FlattenedShape>): List$1<PointCollection>;
    get ca(): boolean;
    protected b6: ShapeSeriesBase;
    private cd;
    ci(a: number, b: any, c: Rect, d: List$1<FlattenedShape>): void;
    protected c4(a: number, b: any): FrameworkElement;
    protected abstract ck(a: FrameworkElement, b: PathGeometry): void;
    static cl(a: ShapeSeriesViewBase, b: Path, c: any): void;
    cp(a: (arg1: FrameworkElement) => void): void;
    cm(a: FrameworkElement, b: any, c: boolean): void;
    protected co(a: FrameworkElement, b: boolean): void;
    private cj;
    private cx;
    protected abstract c5(a: number, b: List$1<PointCollection>): PathGeometry;
    cu(): void;
    ct(): void;
    private ch;
    cw(a: number, b: number): void;
    cn(): void;
    protected cg: List$1<Path>;
    c1(): FrameworkElement;
    cq(a: FrameworkElement): void;
    cr(a: FrameworkElement): void;
    cs(a: FrameworkElement): void;
    protected b9: Pool$1<FrameworkElement>;
    c6(a: number, b: List$1<PointCollection>, c: boolean): PathGeometry;
    protected ac(a: number): any;
    private c7;
    protected ab(a: number): any;
    protected a8(a: RenderingContext, b: boolean): void;
    private b7;
    private c8;
    get c9(): Style;
    cz(a: StyleSelector): void;
    cy(a: Style): void;
    c2(a: Point, b: boolean): FrameworkElement;
    c3(a: Point, b: boolean, c: boolean): FrameworkElement;
    b5(a: Point, b: boolean, c: boolean): ShapeHitRegion;
    private b1;
    private b3;
    private b2;
    private b0;
    cv(a: number[], b: number[], c: number[], d: number[]): void;
    c0(): void;
    an(a: any): void;
}
